/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","fs","os","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ee=function(q){for(var e=[],v=0,t=q.length;v<t;v++)e[v]=Z[q[v]];return e};define(Z[119],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(M){return M?M.replace(/\$\((.*?)\)/g,(C,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(C,l,m){this.id=C,this.definition=l,this.description=m,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(M,C){const l=["codicon","codicon-"+M];return C&&l.push("codicon-modifier-"+C),l}e.getClassNamesArray=k;var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function l(b){if(b instanceof t)return["codicon","codicon-"+b.id];const S=C.exec(b.id);if(!S)return l(t.error);const[,f,d]=S,y=["codicon","codicon-"+f];return d&&y.push("codicon-modifier-"+d.substr(1)),y}M.asClassNameArray=l;function m(b){return l(b).join(" ")}M.asClassName=m;function I(b){return"."+l(b).join(".")}M.asCSSSelector=I})(R=e.CSSIcon||(e.CSSIcon={}))}),define(Z[120],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function v(C,l){const m=Math.pow(10,l);return Math.round(C*m)/m}class t{constructor(l,m,I,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,I))|0,this.a=v(Math.max(Math.min(1,b),0),3)}static equals(l,m){return l.r===m.r&&l.g===m.g&&l.b===m.b&&l.a===m.a}}e.RGBA=t;class k{constructor(l,m,I,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.l=v(Math.max(Math.min(1,I),0),3),this.a=v(Math.max(Math.min(1,b),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.l===m.l&&l.a===m.a}static fromRGBA(l){const m=l.r/255,I=l.g/255,b=l.b/255,S=l.a,f=Math.max(m,I,b),d=Math.min(m,I,b);let y=0,E=0;const w=(d+f)/2,g=f-d;if(g>0){switch(E=Math.min(w<=.5?g/(2*w):g/(2-2*w),1),f){case m:y=(I-b)/g+(I<b?6:0);break;case I:y=(b-m)/g+2;break;case b:y=(m-I)/g+4;break}y*=60,y=Math.round(y)}return new k(y,E,w,S)}static _hue2rgb(l,m,I){return I<0&&(I+=1),I>1&&(I-=1),I<1/6?l+(m-l)*6*I:I<1/2?m:I<2/3?l+(m-l)*(2/3-I)*6:l}static toRGBA(l){const m=l.h/360,{s:I,l:b,a:S}=l;let f,d,y;if(I===0)f=d=y=b;else{const E=b<.5?b*(1+I):b+I-b*I,w=2*b-E;f=k._hue2rgb(w,E,m+1/3),d=k._hue2rgb(w,E,m),y=k._hue2rgb(w,E,m-1/3)}return new t(Math.round(f*255),Math.round(d*255),Math.round(y*255),S)}}e.HSLA=k;class R{constructor(l,m,I,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.v=v(Math.max(Math.min(1,I),0),3),this.a=v(Math.max(Math.min(1,b),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.v===m.v&&l.a===m.a}static fromRGBA(l){const m=l.r/255,I=l.g/255,b=l.b/255,S=Math.max(m,I,b),f=Math.min(m,I,b),d=S-f,y=S===0?0:d/S;let E;return d===0?E=0:S===m?E=((I-b)/d%6+6)%6:S===I?E=(b-m)/d+2:E=(m-I)/d+4,new R(Math.round(E*60),y,S,l.a)}static toRGBA(l){const{h:m,s:I,v:b,a:S}=l,f=b*I,d=f*(1-Math.abs(m/60%2-1)),y=b-f;let[E,w,g]=[0,0,0];return m<60?(E=f,w=d):m<120?(E=d,w=f):m<180?(w=f,g=d):m<240?(w=d,g=f):m<300?(E=d,g=f):m<=360&&(E=f,g=d),E=Math.round((E+y)*255),w=Math.round((w+y)*255),g=Math.round((g+y)*255),new t(E,w,g,S)}}e.HSVA=R;class M{constructor(l){if(l)if(l instanceof t)this.rgba=l;else if(l instanceof k)this._hsla=l,this.rgba=k.toRGBA(l);else if(l instanceof R)this._hsva=l,this.rgba=R.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(l){return M.Format.CSS.parseHex(l)||M.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(l){return!!l&&t.equals(this.rgba,l.rgba)&&k.equals(this.hsla,l.hsla)&&R.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=M._relativeLuminanceForComponent(this.rgba.r),m=M._relativeLuminanceForComponent(this.rgba.g),I=M._relativeLuminanceForComponent(this.rgba.b),b=.2126*l+.7152*m+.0722*I;return v(b,4)}static _relativeLuminanceForComponent(l){const m=l/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(l){const m=this.getRelativeLuminance(),I=l.getRelativeLuminance();return m>I?(m+.05)/(I+.05):(I+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const m=this.getRelativeLuminance(),I=l.getRelativeLuminance();return m>I}isDarkerThan(l){const m=this.getRelativeLuminance(),I=l.getRelativeLuminance();return m<I}lighten(l){return new M(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new M(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:m,g:I,b,a:S}=this.rgba;return new M(new t(m,I,b,S*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const m=l.rgba,I=this.rgba.a,b=m.a,S=I+b*(1-I);if(S<1e-6)return M.transparent;const f=this.rgba.r*I/S+m.r*b*(1-I)/S,d=this.rgba.g*I/S+m.g*b*(1-I)/S,y=this.rgba.b*I/S+m.b*b*(1-I)/S;return new M(new t(f,d,y,S))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:m,g:I,b,a:S}=this.rgba;return new M(new t(l.rgba.r-S*(l.rgba.r-m),l.rgba.g-S*(l.rgba.g-I),l.rgba.b-S*(l.rgba.b-b),1))}flatten(...l){const m=l.reduceRight((I,b)=>M._flatten(b,I));return M._flatten(this,m)}static _flatten(l,m){const I=1-l.rgba.a;return new M(new t(I*m.rgba.r+l.rgba.a*l.rgba.r,I*m.rgba.g+l.rgba.a*l.rgba.g,I*m.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(l,m,I){if(l.isLighterThan(m))return l;I=I||.5;const b=l.getRelativeLuminance(),S=m.getRelativeLuminance();return I=I*(S-b)/S,l.lighten(I)}static getDarkerColor(l,m,I){if(l.isDarkerThan(m))return l;I=I||.5;const b=l.getRelativeLuminance(),S=m.getRelativeLuminance();return I=I*(b-S)/b,l.darken(I)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(C){let l;(function(m){let I;(function(b){function S(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:C.Format.CSS.formatRGBA(n)}b.formatRGB=S;function f(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}b.formatRGBA=f;function d(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:C.Format.CSS.formatHSLA(n)}b.formatHSL=d;function y(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}b.formatHSLA=y;function E(n){const o=n.toString(16);return o.length!==2?"0"+o:o}function w(n){return`#${E(n.rgba.r)}${E(n.rgba.g)}${E(n.rgba.b)}`}b.formatHex=w;function g(n,o=!1){return o&&n.rgba.a===1?C.Format.CSS.formatHex(n):`#${E(n.rgba.r)}${E(n.rgba.g)}${E(n.rgba.b)}${E(Math.round(n.rgba.a*255))}`}b.formatHexA=g;function h(n){return n.isOpaque()?C.Format.CSS.formatHex(n):C.Format.CSS.formatRGBA(n)}b.format=h;function p(n){const o=n.length;if(o===0||n.charCodeAt(0)!==35)return null;if(o===7){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),r=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),s=16*c(n.charCodeAt(5))+c(n.charCodeAt(6));return new C(new t(i,r,s,1))}if(o===9){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),r=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),s=16*c(n.charCodeAt(5))+c(n.charCodeAt(6)),a=16*c(n.charCodeAt(7))+c(n.charCodeAt(8));return new C(new t(i,r,s,a/255))}if(o===4){const i=c(n.charCodeAt(1)),r=c(n.charCodeAt(2)),s=c(n.charCodeAt(3));return new C(new t(16*i+i,16*r+r,16*s+s))}if(o===5){const i=c(n.charCodeAt(1)),r=c(n.charCodeAt(2)),s=c(n.charCodeAt(3)),a=c(n.charCodeAt(4));return new C(new t(16*i+i,16*r+r,16*s+s,(16*a+a)/255))}return null}b.parseHex=p;function c(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(I=m.CSS||(m.CSS={}))})(l=C.Format||(C.Format={}))}(M=e.Color||(e.Color={}))}),define(Z[53],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(M){return(C,l,m)=>{let I=null,b=null;if(typeof m.value=="function"?(I="value",b=m.value):typeof m.get=="function"&&(I="get",b=m.get),!b)throw new Error("not supported");m[I]=M(b,l)}}e.createDecorator=v;function t(M,C,l){let m=null,I=null;if(typeof l.value=="function"?(m="value",I=l.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(m="get",I=l.get),!I)throw new Error("not supported");const b=`$memoize$${C}`;l[m]=function(...S){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,S)}),this[b]}}e.memoize=t;function k(M,C,l){return v((m,I)=>{const b=`$debounce$${I}`,S=`$debounce$result$${I}`;return function(...f){this[S]||(this[S]=l?l():void 0),clearTimeout(this[b]),C&&(this[S]=C(this[S],...f),f=[this[S]]),this[b]=setTimeout(()=>{m.apply(this,f),this[S]=l?l():void 0},M)}})}e.debounce=k;function R(M,C,l){return v((m,I)=>{const b=`$throttle$timer$${I}`,S=`$throttle$result$${I}`,f=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...y){if(this[S]||(this[S]=l?l():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[S]=C(this[S],...y)),this[d])return;const E=this[f]+M;E<=Date.now()?(this[f]=Date.now(),m.apply(this,[this[S]]),this[S]=l?l():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[f]=Date.now(),m.apply(this,[this[S]]),this[S]=l?l():void 0},E-Date.now()))}})}e.throttle=R}),define(Z[17],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?h.isErrorNoTelemetry(n)?new h(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=v,e.errorHandler=new v;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function k(c){l(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function R(c){l(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function M(c){if(c instanceof Error){const{name:n,message:o}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:n,message:o,stack:i,noTelemetry:h.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=M;const C="Canceled";function l(c){return c instanceof m?!0:c instanceof Error&&c.name===C&&c.message===C}e.isCancellationError=l;class m extends Error{constructor(){super(C),this.name=this.message}}e.CancellationError=m;function I(){const c=new Error(C);return c.name=c.message,c}e.canceled=I;function b(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=b;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=S;function f(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function d(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=d;function y(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=y;class E extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=E;class w extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=w;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class h extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof h)return n;const o=new h;return o.message=n.message,o.stack=n.stack,o}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=h;class p extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(Z[24],ee([0,1,17]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,ie=0){return j[j.length-(1+ie)]}e.tail=t;function k(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=k;function R(j,ie,ne=(ae,ge)=>ae===ge){if(j===ie)return!0;if(!j||!ie||j.length!==ie.length)return!1;for(let ae=0,ge=j.length;ae<ge;ae++)if(!ne(j[ae],ie[ae]))return!1;return!0}e.equals=R;function M(j,ie){const ne=j.length-1;ie<ne&&(j[ie]=j[ne]),j.pop()}e.removeFastWithoutKeepingOrder=M;function C(j,ie,ne){return l(j.length,ae=>ne(j[ae],ie))}e.binarySearch=C;function l(j,ie){let ne=0,ae=j-1;for(;ne<=ae;){const ge=(ne+ae)/2|0,Me=ie(ge);if(Me<0)ne=ge+1;else if(Me>0)ae=ge-1;else return ge}return-(ne+1)}e.binarySearch2=l;function m(j,ie){let ne=0,ae=j.length;if(ae===0)return 0;for(;ne<ae;){const ge=Math.floor((ne+ae)/2);ie(j[ge])?ae=ge:ne=ge+1}return ne}e.findFirstInSorted=m;function I(j,ie,ne){if(j=j|0,j>=ie.length)throw new TypeError("invalid index");const ae=ie[Math.floor(ie.length*Math.random())],ge=[],Me=[],Le=[];for(const ke of ie){const Ae=ne(ke,ae);Ae<0?ge.push(ke):Ae>0?Me.push(ke):Le.push(ke)}return j<ge.length?I(j,ge,ne):j<ge.length+Le.length?Le[0]:I(j-(ge.length+Le.length),Me,ne)}e.quickSelect=I;function b(j,ie){const ne=[];let ae;for(const ge of j.slice(0).sort(ie))!ae||ie(ae[0],ge)!==0?(ae=[ge],ne.push(ae)):ae.push(ge);return ne}e.groupBy=b;function S(j,ie,ne){const ae=[];function ge(ke,Ae,Ve){if(Ae===0&&Ve.length===0)return;const me=ae[ae.length-1];me&&me.start+me.deleteCount===ke?(me.deleteCount+=Ae,me.toInsert.push(...Ve)):ae.push({start:ke,deleteCount:Ae,toInsert:Ve})}let Me=0,Le=0;for(;;){if(Me===j.length){ge(Me,0,ie.slice(Le));break}if(Le===ie.length){ge(Me,j.length-Me,[]);break}const ke=j[Me],Ae=ie[Le],Ve=ne(ke,Ae);Ve===0?(Me+=1,Le+=1):Ve<0?(ge(Me,1,[]),Me+=1):Ve>0&&(ge(Me,0,[Ae]),Le+=1)}return ae}e.sortedDiff=S;function f(j,ie,ne){const ae=S(j,ie,ne),ge=[],Me=[];for(const Le of ae)ge.push(...j.slice(Le.start,Le.start+Le.deleteCount)),Me.push(...Le.toInsert);return{removed:ge,added:Me}}e.delta=f;function d(j,ie,ne){if(ne===0)return[];const ae=j.slice(0,ne).sort(ie);return E(j,ie,ae,ne,j.length),ae}e.top=d;function y(j,ie,ne,ae,ge){return ne===0?Promise.resolve([]):new Promise((Me,Le)=>{(async()=>{const ke=j.length,Ae=j.slice(0,ne).sort(ie);for(let Ve=ne,me=Math.min(ne+ae,ke);Ve<ke;Ve=me,me=Math.min(me+ae,ke)){if(Ve>ne&&await new Promise(we=>setTimeout(we)),ge&&ge.isCancellationRequested)throw new v.CancellationError;E(j,ie,Ae,Ve,me)}return Ae})().then(Me,Le)})}e.topAsync=y;function E(j,ie,ne,ae,ge){for(const Me=ne.length;ae<ge;ae++){const Le=j[ae];if(ie(Le,ne[Me-1])<0){ne.pop();const ke=m(ne,Ae=>ie(Le,Ae)<0);ne.splice(ke,0,Le)}}}function w(j){return j.filter(ie=>!!ie)}e.coalesce=w;function g(j){let ie=0;for(let ne=0;ne<j.length;ne++)j[ne]&&(j[ie]=j[ne],ie+=1);j.length=ie}e.coalesceInPlace=g;function h(j,ie,ne){j.splice(ne,0,j.splice(ie,1)[0])}e.move=h;function p(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=p;function c(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=c;function n(j,ie=ne=>ne){const ne=new Set;return j.filter(ae=>{const ge=ie(ae);return ne.has(ge)?!1:(ne.add(ge),!0)})}e.distinct=n;function o(j){const ie=new Set;return ne=>{const ae=j(ne);return ie.has(ae)?!1:(ie.add(ae),!0)}}e.uniqueFilter=o;function i(j,ie){const ne=r(j,ie);if(ne!==-1)return j[ne]}e.findLast=i;function r(j,ie){for(let ne=j.length-1;ne>=0;ne--){const ae=j[ne];if(ie(ae))return ne}return-1}e.lastIndex=r;function s(j,ie){return j.length>0?j[0]:ie}e.firstOrDefault=s;function a(j,ie){return j.length>0?j[j.length-1]:ie}e.lastOrDefault=a;function u(j,ie,ne=(ae,ge)=>ae===ge){let ae=0;for(let ge=0,Me=Math.min(j.length,ie.length);ge<Me&&ne(j[ge],ie[ge]);ge++)ae++;return ae}e.commonPrefixLength=u;function P(j){return[].concat(...j)}e.flatten=P;function D(j,ie){let ne=typeof ie=="number"?j:0;typeof ie=="number"?ne=j:(ne=0,ie=j);const ae=[];if(ne<=ie)for(let ge=ne;ge<ie;ge++)ae.push(ge);else for(let ge=ne;ge>ie;ge--)ae.push(ge);return ae}e.range=D;function T(j,ie,ne){return j.reduce((ae,ge)=>(ae[ie(ge)]=ne?ne(ge):ge,ae),Object.create(null))}e.index=T;function N(j,ie){return j.push(ie),()=>U(j,ie)}e.insert=N;function U(j,ie){const ne=j.indexOf(ie);if(ne>-1)return j.splice(ne,1),ie}e.remove=U;function $(j,ie,ne){const ae=j.slice(0,ie),ge=j.slice(ie);return ae.concat(ne,ge)}e.arrayInsert=$;function Y(j,ie){let ne;if(typeof ie=="number"){let ae=ie;ne=()=>{const ge=Math.sin(ae++)*179426549;return ge-Math.floor(ge)}}else ne=Math.random;for(let ae=j.length-1;ae>0;ae-=1){const ge=Math.floor(ne()*(ae+1)),Me=j[ae];j[ae]=j[ge],j[ge]=Me}}e.shuffle=Y;function oe(j,ie){const ne=j.indexOf(ie);ne>-1&&(j.splice(ne,1),j.unshift(ie))}e.pushToStart=oe;function ue(j,ie){const ne=j.indexOf(ie);ne>-1&&(j.splice(ne,1),j.push(ie))}e.pushToEnd=ue;function se(j,ie){for(const ne of ie)j.push(ne)}e.pushMany=se;function de(j,ie){return Array.isArray(j)?j.map(ie):ie(j)}e.mapArrayOrNot=de;function G(j){return Array.isArray(j)?j:[j]}e.asArray=G;function K(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=K;function F(j,ie){for(const ne of j){const ae=ie(ne);if(ae!==void 0)return ae}}e.mapFind=F;function A(j,ie,ne){const ae=z(j,ie),ge=j.length,Me=ne.length;j.length=ge+Me;for(let Le=ge-1;Le>=ae;Le--)j[Le+Me]=j[Le];for(let Le=0;Le<Me;Le++)j[Le+ae]=ne[Le]}e.insertInto=A;function W(j,ie,ne,ae){const ge=z(j,ie),Me=j.splice(ge,ne);return A(j,ge,ae),Me}e.splice=W;function z(j,ie){return ie<0?Math.max(ie+j.length,0):Math.min(ie,j.length)}var te;(function(j){function ie(ge){return ge<0}j.isLessThan=ie;function ne(ge){return ge>0}j.isGreaterThan=ne;function ae(ge){return ge===0}j.isNeitherLessOrGreaterThan=ae,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(te=e.CompareResult||(e.CompareResult={}));function B(j,ie){return(ne,ae)=>ie(j(ne),j(ae))}e.compareBy=B;function H(...j){return(ie,ne)=>{for(const ae of j){const ge=ae(ie,ne);if(!te.isNeitherLessOrGreaterThan(ge))return ge}return te.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const L=(j,ie)=>j-ie;e.numberComparator=L;function O(j,ie){if(j.length===0)return;let ne=j[0];for(let ae=1;ae<j.length;ae++){const ge=j[ae];ie(ge,ne)>0&&(ne=ge)}return ne}e.findMaxBy=O;function _(j,ie){if(j.length===0)return;let ne=j[0];for(let ae=1;ae<j.length;ae++){const ge=j[ae];ie(ge,ne)>=0&&(ne=ge)}return ne}e.findLastMaxBy=_;function V(j,ie){return O(j,(ne,ae)=>-ie(ne,ae))}e.findMinBy=V;class x{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let ne=this.firstIdx;for(;ne<this.items.length&&ie(this.items[ne]);)ne++;const ae=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ae}takeFromEndWhile(ie){let ne=this.lastIdx;for(;ne>=0&&ie(this.items[ne]);)ne--;const ae=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ae}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const ne=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,ne}}e.ArrayQueue=x;class re{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(ne=>(ie(ne),!0))}toArray(){const ie=[];return this.iterate(ne=>(ie.push(ne),!0)),ie}filter(ie){return new re(ne=>this.iterate(ae=>ie(ae)?ne(ae):!0))}map(ie){return new re(ne=>this.iterate(ae=>ne(ie(ae))))}some(ie){let ne=!1;return this.iterate(ae=>(ne=ie(ae),!ne)),ne}findFirst(ie){let ne;return this.iterate(ae=>ie(ae)?(ne=ae,!1):!0),ne}findLast(ie){let ne;return this.iterate(ae=>(ie(ae)&&(ne=ae),!0)),ne}findLastMaxBy(ie){let ne,ae=!0;return this.iterate(ge=>((ae||te.isGreaterThan(ie(ge,ne)))&&(ae=!1,ne=ge),!0)),ne}}e.CallbackIterable=re,re.empty=new re(j=>{})}),define(Z[121],ee([0,1,17]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(l,m){if(!l)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=t;function k(l,m="Unreachable"){throw new Error(m)}e.assertNever=k;function R(l){if(!l)throw new v.BugIndicatingError("Assertion Failed")}e.assert=R;function M(l){if(!l()){debugger;l(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function C(l,m){let I=0;for(;I<l.length-1;){const b=l[I],S=l[I+1];if(!m(b,S))return!1;I++}return!0}e.checkAdjacentItems=C}),define(Z[49],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const k=this;let R=!1,M;return function(){return R||(R=!0,M=t.apply(k,arguments)),M}}e.once=v}),define(Z[57],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function k(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function M(){return R}t.empty=M;function*C(o){yield o}t.single=C;function l(o){return o||R}t.from=l;function m(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=m;function I(o){return o[Symbol.iterator]().next().value}t.first=I;function b(o,i){for(const r of o)if(i(r))return!0;return!1}t.some=b;function S(o,i){for(const r of o)if(i(r))return r}t.find=S;function*f(o,i){for(const r of o)i(r)&&(yield r)}t.filter=f;function*d(o,i){let r=0;for(const s of o)yield i(s,r++)}t.map=d;function*y(...o){for(const i of o)for(const r of i)yield r}t.concat=y;function*E(o){for(const i of o)for(const r of i)yield r}t.concatNested=E;function w(o,i,r){let s=r;for(const a of o)s=i(s,a);return s}t.reduce=w;function g(o,i){let r=0;for(const s of o)i(s,r++)}t.forEach=g;function*h(o,i,r=o.length){for(i<0&&(i+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);i<r;i++)yield o[i]}t.slice=h;function p(o,i=Number.POSITIVE_INFINITY){const r=[];if(i===0)return[r,o];const s=o[Symbol.iterator]();for(let a=0;a<i;a++){const u=s.next();if(u.done)return[r,t.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return s}}]}t.consume=p;function c(o){return p(o)[0]}t.collect=c;function n(o,i,r=(s,a)=>s===a){const s=o[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const u=s.next(),P=a.next();if(u.done!==P.done)return!1;if(u.done)return!0;if(!r(u.value,P.value))return!1}}t.equals=n})(v=e.Iterable||(e.Iterable={}))}),define(Z[43],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function M(n,o=!1){let i=0;const r=n.length;let s="",a=0,u=16,P=0;function D(ue){let se=0,de=0;for(;se<ue;){const G=n.charCodeAt(i);if(G>=48&&G<=57)de=de*16+G-48;else if(G>=65&&G<=70)de=de*16+G-65+10;else if(G>=97&&G<=102)de=de*16+G-97+10;else break;i++,se++}return se<ue&&(de=-1),de}function T(ue){i=ue,s="",a=0,u=16,P=0}function N(){const ue=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&m(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&m(n.charCodeAt(i)))for(i++;i<n.length&&m(n.charCodeAt(i));)i++;else return P=3,n.substring(ue,i);let se=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&m(n.charCodeAt(i))){for(i++;i<n.length&&m(n.charCodeAt(i));)i++;se=i}else P=3;return n.substring(ue,se)}function U(){let ue="",se=i;for(;;){if(i>=r){ue+=n.substring(se,i),P=2;break}const de=n.charCodeAt(i);if(de===34){ue+=n.substring(se,i),i++;break}if(de===92){if(ue+=n.substring(se,i),i++,i>=r){P=2;break}switch(n.charCodeAt(i++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const K=D(4);K>=0?ue+=String.fromCharCode(K):P=4;break}default:P=5}se=i;continue}if(de>=0&&de<=31)if(l(de)){ue+=n.substring(se,i),P=2;break}else P=6;i++}return ue}function $(){if(s="",P=0,a=i,i>=r)return a=r,u=17;let ue=n.charCodeAt(i);if(C(ue)){do i++,s+=String.fromCharCode(ue),ue=n.charCodeAt(i);while(C(ue));return u=15}if(l(ue))return i++,s+=String.fromCharCode(ue),ue===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),u=14;switch(ue){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,s=U(),u=10;case 47:{const se=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<r&&!l(n.charCodeAt(i));)i++;return s=n.substring(se,i),u=12}if(n.charCodeAt(i+1)===42){i+=2;const de=r-1;let G=!1;for(;i<de;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,P=1),s=n.substring(se,i),u=13}return s+=String.fromCharCode(ue),i++,u=16}case 45:if(s+=String.fromCharCode(ue),i++,i===r||!m(n.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),u=11;default:for(;i<r&&Y(ue);)i++,ue=n.charCodeAt(i);if(a!==i){switch(s=n.substring(a,i),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(ue),i++,u=16}}function Y(ue){if(C(ue)||l(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ue;do ue=$();while(ue>=12&&ue<=15);return ue}return{setPosition:T,getPosition:()=>i,scan:o?oe:$,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>P}}e.createScanner=M;function C(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function b(n,o){const i=[],r=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function P(D,T,N,U){a.value=D,a.offset=T,a.length=N,a.type=U,a.colonOffset=void 0,s=a}try{h(n,{onObjectBegin:(D,T)=>{if(o<=D)throw r;s=void 0,u=o>D,i.push("")},onObjectProperty:(D,T,N)=>{if(o<T||(P(D,T,N,"property"),i[i.length-1]=D,o<=T+N))throw r},onObjectEnd:(D,T)=>{if(o<=D)throw r;s=void 0,i.pop()},onArrayBegin:(D,T)=>{if(o<=D)throw r;s=void 0,i.push(0)},onArrayEnd:(D,T)=>{if(o<=D)throw r;s=void 0,i.pop()},onLiteralValue:(D,T,N)=>{if(o<T||(P(D,T,N,c(D)),o<=T+N))throw r},onSeparator:(D,T,N)=>{if(o<=T)throw r;if(D===":"&&s&&s.type==="property")s.colonOffset=T,u=!1,s=void 0;else if(D===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(u=!0,i[i.length-1]=""),s=void 0}}})}catch(D){if(D!==r)throw D}return{path:i,previousNode:s,isAtPropertyKey:u,matches:D=>{let T=0;for(let N=0;T<D.length&&N<i.length;N++)if(D[T]===i[N]||D[T]==="*")T++;else if(D[T]!=="**")return!1;return T===D.length}}}e.getLocation=b;function S(n,o=[],i=R.DEFAULT){let r=null,s=[];const a=[];function u(D){Array.isArray(s)?s.push(D):r!==null&&(s[r]=D)}return h(n,{onObjectBegin:()=>{const D={};u(D),a.push(s),s=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const D=[];u(D),a.push(s),s=D,r=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:u,onError:(D,T,N)=>{o.push({error:D,offset:T,length:N})}},i),s[0]}e.parse=S;function f(n,o=[],i=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){r.type==="property"&&(r.length=D-r.offset,r=r.parent)}function a(D){return r.children.push(D),D}h(n,{onObjectBegin:D=>{r=a({type:"object",offset:D,length:-1,parent:r,children:[]})},onObjectProperty:(D,T,N)=>{r=a({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:D,offset:T,length:N,parent:r})},onObjectEnd:(D,T)=>{r.length=D+T-r.offset,r=r.parent,s(D+T)},onArrayBegin:(D,T)=>{r=a({type:"array",offset:D,length:-1,parent:r,children:[]})},onArrayEnd:(D,T)=>{r.length=D+T-r.offset,r=r.parent,s(D+T)},onLiteralValue:(D,T,N)=>{a({type:c(D),offset:T,length:N,parent:r,value:D}),s(T+N)},onSeparator:(D,T,N)=>{r.type==="property"&&(D===":"?r.colonOffset=T:D===","&&s(T))},onError:(D,T,N)=>{o.push({error:D,offset:T,length:N})}},i);const P=r.children[0];return P&&delete P.parent,P}e.parseTree=f;function d(n,o){if(!n)return;let i=n;for(const r of o)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===r){i=a.children[1],s=!0;break}if(!s)return}else{const s=r;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=d;function y(n){if(!n.parent||!n.parent.children)return[];const o=y(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;o.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&o.push(i)}return o}e.getNodePath=y;function E(n){switch(n.type){case"array":return n.children.map(E);case"object":{const o=Object.create(null);for(const i of n.children){const r=i.children[1];r&&(o[i.children[0].value]=E(r))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=E;function w(n,o,i=!1){return o>=n.offset&&o<n.offset+n.length||i&&o===n.offset+n.length}e.contains=w;function g(n,o,i=!1){if(w(n,o,i)){const r=n.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=o;s++){const a=g(r[s],o,i);if(a)return a}return n}}e.findNodeAtOffset=g;function h(n,o,i=R.DEFAULT){const r=M(n,!1);function s(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function a(B){return B?H=>B(H,r.getTokenOffset(),r.getTokenLength()):()=>!0}const u=s(o.onObjectBegin),P=a(o.onObjectProperty),D=s(o.onObjectEnd),T=s(o.onArrayBegin),N=s(o.onArrayEnd),U=a(o.onLiteralValue),$=a(o.onSeparator),Y=s(o.onComment),oe=a(o.onError),ue=i&&i.disallowComments,se=i&&i.allowTrailingComma;function de(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:ue||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(B){case 12:case 13:ue?G(10):Y();break;case 16:G(1);break;case 15:case 14:break;default:return B}}}function G(B,H=[],L=[]){if(oe(B),H.length+L.length>0){let O=r.getToken();for(;O!==17;){if(H.indexOf(O)!==-1){de();break}else if(L.indexOf(O)!==-1)break;O=de()}}}function K(B){const H=r.getTokenValue();return B?U(H):P(H),de(),!0}function F(){switch(r.getToken()){case 11:{let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(G(2),B=0)}catch{G(2)}U(B);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return de(),!0}function A(){return r.getToken()!==10?(G(3,[],[2,5]),!1):(K(!1),r.getToken()===6?($(":"),de(),te()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function W(){u(),de();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),$(","),de(),r.getToken()===2&&se)break}else B&&G(6,[],[]);A()||G(4,[],[2,5]),B=!0}return D(),r.getToken()!==2?G(7,[2],[]):de(),!0}function z(){T(),de();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),$(","),de(),r.getToken()===4&&se)break}else B&&G(6,[],[]);te()||G(4,[],[4,5]),B=!0}return N(),r.getToken()!==4?G(8,[4],[]):de(),!0}function te(){switch(r.getToken()){case 3:return z();case 1:return W();case 10:return K(!0);default:return F()}}return de(),r.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):te()?(r.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=h;function p(n,o){const i=M(n),r=[];let s,a=0,u;do switch(u=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:a!==u&&r.push(n.substring(a,u)),o!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,o)),a=i.getPosition();break}while(s!==17);return r.join("")}e.stripComments=p;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[122],ee([0,1,43]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,I,b){let S,f,d,y,E;if(I){for(y=I.offset,E=y+I.length,d=y;d>0&&!l(m,d-1);)d--;let u=E;for(;u<m.length&&!l(m,u);)u++;f=m.substring(d,u),S=M(f,b)}else f=m,S=0,d=0,y=0,E=m.length;const w=C(b,m);let g=!1,h=0,p;b.insertSpaces?p=R(" ",b.tabSize||4):p="	";const c=(0,v.createScanner)(f,!1);let n=!1;function o(){return w+R(p,S+h)}function i(){let u=c.scan();for(g=!1;u===15||u===14;)g=g||u===14,u=c.scan();return n=u===16||c.getTokenError()!==0,u}const r=[];function s(u,P,D){!n&&P<E&&D>y&&m.substring(P,D)!==u&&r.push({offset:P,length:D-P,content:u})}let a=i();if(a!==17){const u=c.getTokenOffset()+d,P=R(p,S);s(P,d,u)}for(;a!==17;){let u=c.getTokenOffset()+c.getTokenLength()+d,P=i(),D="";for(;!g&&(P===12||P===13);){const N=c.getTokenOffset()+d;s(" ",u,N),u=c.getTokenOffset()+c.getTokenLength()+d,D=P===12?o():"",P=i()}if(P===2)a!==1&&(h--,D=o());else if(P===4)a!==3&&(h--,D=o());else{switch(a){case 3:case 1:h++,D=o();break;case 5:case 12:D=o();break;case 13:g?D=o():D=" ";break;case 6:D=" ";break;case 10:if(P===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?D=" ":P!==5&&P!==17&&(n=!0);break;case 16:n=!0;break}g&&(P===12||P===13)&&(D=o())}const T=c.getTokenOffset()+d;s(D,u,T),a=P}return r}e.format=t;function k(m,I){const b=JSON.stringify(m,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?b.replace(/\r\n|\r|\n/g,I.eol):b}e.toFormattedString=k;function R(m,I){let b="";for(let S=0;S<I;S++)b+=m;return b}function M(m,I){let b=0,S=0;const f=I.tabSize||4;for(;b<m.length;){const d=m.charAt(b);if(d===" ")S++;else if(d==="	")S+=f;else break;b++}return Math.floor(S/f)}function C(m,I){for(let b=0;b<I.length;b++){const S=I.charAt(b);if(S==="\r")return b+1<I.length&&I.charAt(b+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=C;function l(m,I){return`\r
`.indexOf(m.charAt(I))!==-1}e.isEOL=l}),define(Z[123],ee([0,1,43,122]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,I,b){return R(m,I,void 0,b)}e.removeProperty=k;function R(m,I,b,S,f){const d=I.slice(),y=[],E=(0,v.parseTree)(m,y);let w,g;for(;d.length>0&&(g=d.pop(),w=(0,v.findNodeAtLocation)(E,d),w===void 0&&b!==void 0);)typeof g=="string"?b={[g]:b}:b=[b];if(w)if(w.type==="object"&&typeof g=="string"&&Array.isArray(w.children)){const h=(0,v.findNodeAtLocation)(w,[g]);if(h!==void 0)if(b===void 0){if(!h.parent)throw new Error("Malformed AST");const p=w.children.indexOf(h.parent);let c,n=h.parent.offset+h.parent.length;if(p>0){const o=w.children[p-1];c=o.offset+o.length}else c=w.offset+1,w.children.length>1&&(n=w.children[1].offset);return M(m,{offset:c,length:n-c,content:""},S)}else return M(m,{offset:h.offset,length:h.length,content:JSON.stringify(b)},S);else{if(b===void 0)return[];const p=`${JSON.stringify(g)}: ${JSON.stringify(b)}`,c=f?f(w.children.map(o=>o.children[0].value)):w.children.length;let n;if(c>0){const o=w.children[c-1];n={offset:o.offset+o.length,length:0,content:","+p}}else w.children.length===0?n={offset:w.offset+1,length:0,content:p}:n={offset:w.offset+1,length:0,content:p+","};return M(m,n,S)}}else if(w.type==="array"&&typeof g=="number"&&Array.isArray(w.children))if(b!==void 0){const h=`${JSON.stringify(b)}`;let p;if(w.children.length===0||g===0)p={offset:w.offset+1,length:0,content:w.children.length===0?h:h+","};else{const c=g===-1||g>w.children.length?w.children.length:g,n=w.children[c-1];p={offset:n.offset+n.length,length:0,content:","+h}}return M(m,p,S)}else{const h=g,p=w.children[h];let c;if(w.children.length===1)c={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===h){const n=w.children[h-1],o=n.offset+n.length,i=w.offset+w.length;c={offset:o,length:i-2-o,content:""}}else c={offset:p.offset,length:w.children[h+1].offset-p.offset,content:""};return M(m,c,S)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${w.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return M(m,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(b)},S)}}e.setProperty=R;function M(m,I,b){let S=C(m,I),f=I.offset,d=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;f>0&&!(0,t.isEOL)(S,f-1);)f--;for(;d<S.length&&!(0,t.isEOL)(S,d);)d++}const y=(0,t.format)(S,{offset:f,length:d-f},b);for(let w=y.length-1;w>=0;w--){const g=y[w];S=C(S,g),f=Math.min(f,g.offset),d=Math.max(d,g.offset+g.length),d+=g.content.length-g.length}const E=m.length-(S.length-d)-f;return[{offset:f,length:E,content:S.substring(f,d)}]}e.withFormatting=M;function C(m,I){return m.substring(0,I.offset)+I.content+m.substring(I.offset+I.length)}e.applyEdit=C;function l(m,I){const b=I.slice(0).sort((f,d)=>{const y=f.offset-d.offset;return y===0?f.length-d.length:y});let S=m.length;for(let f=b.length-1;f>=0;f--){const d=b[f];if(d.offset+d.length<=S)m=C(m,d);else throw new Error("Overlapping edit");S=d.offset}return m}e.applyEdits=l}),define(Z[124],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new v(()=>k(this.getValue()))}}e.Lazy=v}),define(Z[2],ee([0,1,49,57]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function M(s){R=s}if(e.setDisposableTracker=M,k){const s="__is_disposable_tracked__";M(new class{trackDisposable(a){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(u)},3e3)}setParent(a,u){if(a&&a!==g.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==g.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function C(s){return R?.trackDisposable(s),s}function l(s){R?.markAsDisposed(s)}function m(s,a){R?.setParent(s,a)}function I(s,a){if(!!R)for(const u of s)R.setParent(u,a)}function b(s){return R?.markAsSingleton(s),s}e.markAsSingleton=b;function S(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=S;function f(s){if(t.Iterable.is(s)){const a=[];for(const u of s)if(u)try{u.dispose()}catch(P){a.push(P)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=f;function d(s){for(const a of s)S(a)&&a.dispose();return[]}e.disposeIfDisposable=d;function y(...s){const a=E(()=>f(s));return I(s,a),a}e.combinedDisposable=y;function E(s){const a=C({dispose:(0,v.once)(()=>{l(a),s()})});return a}e.toDisposable=E;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return m(a,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new w,C(this),m(this._store,this)}dispose(){l(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&m(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,l(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&m(a,null),a}}e.MutableDisposable=h;class p{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(a){let u=a;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,l(this))},this}}e.SafeDisposable=c;class n{constructor(){this.references=new Map}acquire(a,...u){let P=this.references.get(a);P||(P={counter:0,object:this.createReferencedObject(a,...u)},this.references.set(a,P));const{object:D}=P,T=(0,v.once)(()=>{--P.counter===0&&(this.destroyReferencedObject(a,P.object),this.references.delete(a))});return P.counter++,{object:D,dispose:T}}}e.ReferenceCollection=n;class o{constructor(a){this.referenceCollection=a}async acquire(a,...u){const P=this.referenceCollection.acquire(a,...u);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(D){throw P.dispose(),D}}}e.AsyncReferenceCollection=o;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function r(s){const a=new w;try{s(a)}finally{a.dispose()}}e.disposeOnReturn=r}),define(Z[125],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let R=this._first;for(;R!==v.Undefined;){const M=R.next;R.prev=v.Undefined,R.next=v.Undefined,R=M}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,M){const C=new v(R);if(this._first===v.Undefined)this._first=C,this._last=C;else if(M){const m=this._last;this._last=C,C.prev=m,m.next=C}else{const m=this._first;this._first=C,C.next=m,m.prev=C}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(C))}}shift(){if(this._first!==v.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==v.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===v.Undefined&&R.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):R.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):R.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==v.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function q(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function M(l){R.push(l,Date.now())}function C(){const l=[];for(let m=0;m<R.length;m+=2)l.push({name:R[m],startTime:R[m+1]});return l}return{mark:M,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(k+M.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var t in v)(typeof exports=="object"?exports:q)[t]=v[t]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function v(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return q[t].call(k.exports,k,k.exports,v),k.l=!0,k.exports}return v.m=q,v.c=e,v.d=function(t,k,R){v.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},v.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},v.t=function(t,k){if(1&k&&(t=v(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(v.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var M in t)v.d(R,M,function(C){return t[C]}.bind(null,M));return R},v.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return v.d(k,"a",k),k},v.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},v.p="",v(v.s=0)}([function(q,e,v){(function(t){var k;e=q.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],l=e.src=[],m=0,I=m++;l[I]="0|[1-9]\\d*";var b=m++;l[b]="[0-9]+";var S=m++;l[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=m++;l[f]="("+l[I]+")\\.("+l[I]+")\\.("+l[I]+")";var d=m++;l[d]="("+l[b]+")\\.("+l[b]+")\\.("+l[b]+")";var y=m++;l[y]="(?:"+l[I]+"|"+l[S]+")";var E=m++;l[E]="(?:"+l[b]+"|"+l[S]+")";var w=m++;l[w]="(?:-("+l[y]+"(?:\\."+l[y]+")*))";var g=m++;l[g]="(?:-?("+l[E]+"(?:\\."+l[E]+")*))";var h=m++;l[h]="[0-9A-Za-z-]+";var p=m++;l[p]="(?:\\+("+l[h]+"(?:\\."+l[h]+")*))";var c=m++,n="v?"+l[f]+l[w]+"?"+l[p]+"?";l[c]="^"+n+"$";var o="[v=\\s]*"+l[d]+l[g]+"?"+l[p]+"?",i=m++;l[i]="^"+o+"$";var r=m++;l[r]="((?:<|>)?=?)";var s=m++;l[s]=l[b]+"|x|X|\\*";var a=m++;l[a]=l[I]+"|x|X|\\*";var u=m++;l[u]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[w]+")?"+l[p]+"?)?)?";var P=m++;l[P]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[g]+")?"+l[p]+"?)?)?";var D=m++;l[D]="^"+l[r]+"\\s*"+l[u]+"$";var T=m++;l[T]="^"+l[r]+"\\s*"+l[P]+"$";var N=m++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=m++;l[U]="(?:~>?)";var $=m++;l[$]="(\\s*)"+l[U]+"\\s+",C[$]=new RegExp(l[$],"g");var Y=m++;l[Y]="^"+l[U]+l[u]+"$";var oe=m++;l[oe]="^"+l[U]+l[P]+"$";var ue=m++;l[ue]="(?:\\^)";var se=m++;l[se]="(\\s*)"+l[ue]+"\\s+",C[se]=new RegExp(l[se],"g");var de=m++;l[de]="^"+l[ue]+l[u]+"$";var G=m++;l[G]="^"+l[ue]+l[P]+"$";var K=m++;l[K]="^"+l[r]+"\\s*("+o+")$|^$";var F=m++;l[F]="^"+l[r]+"\\s*("+n+")$|^$";var A=m++;l[A]="(\\s*)"+l[r]+"\\s*("+o+"|"+l[u]+")",C[A]=new RegExp(l[A],"g");var W=m++;l[W]="^\\s*("+l[u]+")\\s+-\\s+("+l[u]+")\\s*$";var z=m++;l[z]="^\\s*("+l[P]+")\\s+-\\s+("+l[P]+")\\s*$";var te=m++;l[te]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,l[B]),C[B]||(C[B]=new RegExp(l[B]));function H(X,ce){if(X instanceof L)return X;if(typeof X!="string"||X.length>R||!(ce?C[i]:C[c]).test(X))return null;try{return new L(X,ce)}catch{return null}}function L(X,ce){if(X instanceof L){if(X.loose===ce)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(X,ce);k("SemVer",X,ce),this.loose=ce;var he=X.trim().match(ce?C[i]:C[c]);if(!he)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ce=+be;if(Ce>=0&&Ce<M)return Ce}return be}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=H,e.valid=function(X,ce){var he=H(X,ce);return he?he.version:null},e.clean=function(X,ce){var he=H(X.trim().replace(/^[=v]+/,""),ce);return he?he.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(X){return k("SemVer.compare",this.version,this.loose,X),X instanceof L||(X=new L(X,this.loose)),this.compareMain(X)||this.comparePre(X)},L.prototype.compareMain=function(X){return X instanceof L||(X=new L(X,this.loose)),_(this.major,X.major)||_(this.minor,X.minor)||_(this.patch,X.patch)},L.prototype.comparePre=function(X){if(X instanceof L||(X=new L(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var ce=0;do{var he=this.prerelease[ce],be=X.prerelease[ce];if(k("prerelease compare",ce,he,be),he===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(he===void 0)return-1;if(he!==be)return _(he,be)}while(++ce)},L.prototype.inc=function(X,ce){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,ce,he,be){typeof he=="string"&&(be=he,he=void 0);try{return new L(X,he).inc(ce,be).version}catch{return null}},e.diff=function(X,ce){if(j(X,ce))return null;var he=H(X),be=H(ce);if(he.prerelease.length||be.prerelease.length){for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==be[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==be[Ce])return Ce},e.compareIdentifiers=_;var O=/^[0-9]+$/;function _(X,ce){var he=O.test(X),be=O.test(ce);return he&&be&&(X=+X,ce=+ce),he&&!be?-1:be&&!he?1:X<ce?-1:X>ce?1:0}function V(X,ce,he){return new L(X,he).compare(new L(ce,he))}function x(X,ce,he){return V(X,ce,he)>0}function re(X,ce,he){return V(X,ce,he)<0}function j(X,ce,he){return V(X,ce,he)===0}function ie(X,ce,he){return V(X,ce,he)!==0}function ne(X,ce,he){return V(X,ce,he)>=0}function ae(X,ce,he){return V(X,ce,he)<=0}function ge(X,ce,he,be){var Ce;switch(ce){case"===":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ce=X===he;break;case"!==":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ce=X!==he;break;case"":case"=":case"==":Ce=j(X,he,be);break;case"!=":Ce=ie(X,he,be);break;case">":Ce=x(X,he,be);break;case">=":Ce=ne(X,he,be);break;case"<":Ce=re(X,he,be);break;case"<=":Ce=ae(X,he,be);break;default:throw new TypeError("Invalid operator: "+ce)}return Ce}function Me(X,ce){if(X instanceof Me){if(X.loose===ce)return X;X=X.value}if(!(this instanceof Me))return new Me(X,ce);k("comparator",X,ce),this.loose=ce,this.parse(X),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(X,ce){return _(ce,X)},e.major=function(X,ce){return new L(X,ce).major},e.minor=function(X,ce){return new L(X,ce).minor},e.patch=function(X,ce){return new L(X,ce).patch},e.compare=V,e.compareLoose=function(X,ce){return V(X,ce,!0)},e.rcompare=function(X,ce,he){return V(ce,X,he)},e.sort=function(X,ce){return X.sort(function(he,be){return e.compare(he,be,ce)})},e.rsort=function(X,ce){return X.sort(function(he,be){return e.rcompare(he,be,ce)})},e.gt=x,e.lt=re,e.eq=j,e.neq=ie,e.gte=ne,e.lte=ae,e.cmp=ge,e.Comparator=Me;var Le={};function ke(X,ce){if(X instanceof ke)return X.loose===ce?X:new ke(X.raw,ce);if(X instanceof Me)return new ke(X.value,ce);if(!(this instanceof ke))return new ke(X,ce);if(this.loose=ce,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ae(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ve(X,ce,he,be,Ce,Te,We,Ne,_e,ze,Be,He,Q){return((ce=Ae(he)?"":Ae(be)?">="+he+".0.0":Ae(Ce)?">="+he+"."+be+".0":">="+ce)+" "+(Ne=Ae(_e)?"":Ae(ze)?"<"+(+_e+1)+".0.0":Ae(Be)?"<"+_e+"."+(+ze+1)+".0":He?"<="+_e+"."+ze+"."+Be+"-"+He:"<="+Ne)).trim()}function me(X,ce){for(var he=0;he<X.length;he++)if(!X[he].test(ce))return!1;if(ce.prerelease.length){for(he=0;he<X.length;he++)if(k(X[he].semver),X[he].semver!==Le&&X[he].semver.prerelease.length>0){var be=X[he].semver;if(be.major===ce.major&&be.minor===ce.minor&&be.patch===ce.patch)return!0}return!1}return!0}function we(X,ce,he){try{ce=new ke(ce,he)}catch{return!1}return ce.test(X)}function Ee(X,ce,he,be){var Ce,Te,We,Ne,_e;switch(X=new L(X,be),ce=new ke(ce,be),he){case">":Ce=x,Te=ae,We=re,Ne=">",_e=">=";break;case"<":Ce=re,Te=ne,We=x,Ne="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(X,ce,be))return!1;for(var ze=0;ze<ce.set.length;++ze){var Be=ce.set[ze],He=null,Q=null;if(Be.forEach(function(le){le.semver===Le&&(le=new Me(">=0.0.0")),He=He||le,Q=Q||le,Ce(le.semver,He.semver,be)?He=le:We(le.semver,Q.semver,be)&&(Q=le)}),He.operator===Ne||He.operator===_e||(!Q.operator||Q.operator===Ne)&&Te(X,Q.semver)||Q.operator===_e&&We(X,Q.semver))return!1}return!0}Me.prototype.parse=function(X){var ce=this.loose?C[K]:C[F],he=X.match(ce);if(!he)throw new TypeError("Invalid comparator: "+X);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new L(he[2],this.loose):this.semver=Le},Me.prototype.toString=function(){return this.value},Me.prototype.test=function(X){return k("Comparator.test",X,this.loose),this.semver===Le||(typeof X=="string"&&(X=new L(X,this.loose)),ge(X,this.operator,this.semver,this.loose))},Me.prototype.intersects=function(X,ce){if(!(X instanceof Me))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new ke(X.value,ce),we(this.value,he,ce);if(X.operator==="")return he=new ke(this.value,ce),we(X.semver,he,ce);var be=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Te=this.semver.version===X.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Ne=ge(this.semver,"<",X.semver,ce)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),_e=ge(this.semver,">",X.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return be||Ce||Te&&We||Ne||_e},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(X){var ce=this.loose;X=X.trim(),k("range",X,ce);var he=ce?C[z]:C[W];X=X.replace(he,Ve),k("hyphen replace",X),X=X.replace(C[A],"$1$2$3"),k("comparator trim",X,C[A]),X=(X=(X=X.replace(C[$],"$1~")).replace(C[se],"$1^")).split(/\s+/).join(" ");var be=ce?C[K]:C[F],Ce=X.split(" ").map(function(Te){return function(We,Ne){return k("comp",We),We=function(_e,ze){return _e.trim().split(/\s+/).map(function(Be){return function(He,Q){k("caret",He,Q);var le=Q?C[G]:C[de];return He.replace(le,function(pe,fe,Se,De,Fe){var Ge;return k("caret",He,pe,fe,Se,De,Fe),Ae(fe)?Ge="":Ae(Se)?Ge=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ae(De)?Ge=fe==="0"?">="+fe+"."+Se+".0 <"+fe+"."+(+Se+1)+".0":">="+fe+"."+Se+".0 <"+(+fe+1)+".0.0":Fe?(k("replaceCaret pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Ge=fe==="0"?Se==="0"?">="+fe+"."+Se+"."+De+Fe+" <"+fe+"."+Se+"."+(+De+1):">="+fe+"."+Se+"."+De+Fe+" <"+fe+"."+(+Se+1)+".0":">="+fe+"."+Se+"."+De+Fe+" <"+(+fe+1)+".0.0"):(k("no pr"),Ge=fe==="0"?Se==="0"?">="+fe+"."+Se+"."+De+" <"+fe+"."+Se+"."+(+De+1):">="+fe+"."+Se+"."+De+" <"+fe+"."+(+Se+1)+".0":">="+fe+"."+Se+"."+De+" <"+(+fe+1)+".0.0"),k("caret return",Ge),Ge})}(Be,ze)}).join(" ")}(We,Ne),k("caret",We),We=function(_e,ze){return _e.trim().split(/\s+/).map(function(Be){return function(He,Q){var le=Q?C[oe]:C[Y];return He.replace(le,function(pe,fe,Se,De,Fe){var Ge;return k("tilde",He,pe,fe,Se,De,Fe),Ae(fe)?Ge="":Ae(Se)?Ge=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ae(De)?Ge=">="+fe+"."+Se+".0 <"+fe+"."+(+Se+1)+".0":Fe?(k("replaceTilde pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Ge=">="+fe+"."+Se+"."+De+Fe+" <"+fe+"."+(+Se+1)+".0"):Ge=">="+fe+"."+Se+"."+De+" <"+fe+"."+(+Se+1)+".0",k("tilde return",Ge),Ge})}(Be,ze)}).join(" ")}(We,Ne),k("tildes",We),We=function(_e,ze){return k("replaceXRanges",_e,ze),_e.split(/\s+/).map(function(Be){return function(He,Q){He=He.trim();var le=Q?C[T]:C[D];return He.replace(le,function(pe,fe,Se,De,Fe,Ge){k("xRange",He,pe,fe,Se,De,Fe,Ge);var et=Ae(Se),Ke=et||Ae(De),xe=Ke||Ae(Fe);return fe==="="&&xe&&(fe=""),et?pe=fe===">"||fe==="<"?"<0.0.0":"*":fe&&xe?(Ke&&(De=0),xe&&(Fe=0),fe===">"?(fe=">=",Ke?(Se=+Se+1,De=0,Fe=0):xe&&(De=+De+1,Fe=0)):fe==="<="&&(fe="<",Ke?Se=+Se+1:De=+De+1),pe=fe+Se+"."+De+"."+Fe):Ke?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":xe&&(pe=">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0"),k("xRange return",pe),pe})}(Be,ze)}).join(" ")}(We,Ne),k("xrange",We),We=function(_e,ze){return k("replaceStars",_e,ze),_e.trim().replace(C[te],"")}(We,Ne),k("stars",We),We}(Te,ce)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Te){return!!Te.match(be)})),Ce=Ce.map(function(Te){return new Me(Te,ce)})},ke.prototype.intersects=function(X,ce){if(!(X instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(be){return X.set.some(function(Ce){return Ce.every(function(Te){return be.intersects(Te,ce)})})})})},e.toComparators=function(X,ce){return new ke(X,ce).set.map(function(he){return he.map(function(be){return be.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new L(X,this.loose));for(var ce=0;ce<this.set.length;ce++)if(me(this.set[ce],X))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(X,ce,he){var be=null,Ce=null;try{var Te=new ke(ce,he)}catch{return null}return X.forEach(function(We){Te.test(We)&&(be&&Ce.compare(We)!==-1||(Ce=new L(be=We,he)))}),be},e.minSatisfying=function(X,ce,he){var be=null,Ce=null;try{var Te=new ke(ce,he)}catch{return null}return X.forEach(function(We){Te.test(We)&&(be&&Ce.compare(We)!==1||(Ce=new L(be=We,he)))}),be},e.validRange=function(X,ce){try{return new ke(X,ce).range||"*"}catch{return null}},e.ltr=function(X,ce,he){return Ee(X,ce,"<",he)},e.gtr=function(X,ce,he){return Ee(X,ce,">",he)},e.outside=Ee,e.prerelease=function(X,ce){var he=H(X,ce);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(X,ce,he){return X=new ke(X,he),ce=new ke(ce,he),X.intersects(ce)},e.coerce=function(X){if(X instanceof L)return X;if(typeof X!="string")return null;var ce=X.match(C[N]);return ce==null?null:H((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,v(1))},function(q,e){var v,t,k=q.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function C(E){if(v===setTimeout)return setTimeout(E,0);if((v===R||!v)&&setTimeout)return v=setTimeout,setTimeout(E,0);try{return v(E,0)}catch{try{return v.call(null,E,0)}catch{return v.call(this,E,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:R}catch{v=R}try{t=typeof clearTimeout=="function"?clearTimeout:M}catch{t=M}})();var l,m=[],I=!1,b=-1;function S(){I&&l&&(I=!1,l.length?m=l.concat(m):b=-1,m.length&&f())}function f(){if(!I){var E=C(S);I=!0;for(var w=m.length;w;){for(l=m,m=[];++b<w;)l&&l[b].run();b=-1,w=m.length}l=null,I=!1,function(g){if(t===clearTimeout)return clearTimeout(g);if((t===M||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(g);try{t(g)}catch{try{return t.call(null,g)}catch{return t.call(this,g)}}}(E)}}function d(E,w){this.fun=E,this.array=w}function y(){}k.nextTick=function(E){var w=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)w[g-1]=arguments[g];m.push(new d(E,w)),m.length!==1||I||C(f)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=y,k.addListener=y,k.once=y,k.off=y,k.removeListener=y,k.removeAllListeners=y,k.emit=y,k.prependListener=y,k.prependOnceListener=y,k.listeners=function(E){return[]},k.binding=function(E){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(E){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[126],ee([0,1]),function(q,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(C,l,m){this.level=C,this.key=l,this.value=m,this.forward=[]}}const k=void 0;class R{constructor(C,l=2**16){this.comparator=C,this[v]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(C){return Boolean(R._search(this,C,this.comparator))}get(C){return R._search(this,C,this.comparator)?.value}set(C,l){return R._insert(this,C,l,this.comparator)&&(this._size+=1),this}delete(C){const l=R._delete(this,C,this.comparator);return l&&(this._size-=1),l}forEach(C,l){let m=this._header.forward[0];for(;m;)C.call(l,m.value,m.key,this),m=m.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",l=this._header.forward[0];for(;l;)C+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return C}static _search(C,l,m){let I=C._header;for(let b=C._level-1;b>=0;b--)for(;I.forward[b]&&m(I.forward[b].key,l)<0;)I=I.forward[b];if(I=I.forward[0],I&&m(I.key,l)===0)return I}static _insert(C,l,m,I){const b=[];let S=C._header;for(let f=C._level-1;f>=0;f--){for(;S.forward[f]&&I(S.forward[f].key,l)<0;)S=S.forward[f];b[f]=S}if(S=S.forward[0],S&&I(S.key,l)===0)return S.value=m,!1;{const f=R._randomLevel(C);if(f>C._level){for(let d=C._level;d<f;d++)b[d]=C._header;C._level=f}S=new t(f,l,m);for(let d=0;d<f;d++)S.forward[d]=b[d].forward[d],b[d].forward[d]=S;return!0}}static _randomLevel(C,l=.5){let m=1;for(;Math.random()<l&&m<C._maxLevel;)m+=1;return m}static _delete(C,l,m){const I=[];let b=C._header;for(let S=C._level-1;S>=0;S--){for(;b.forward[S]&&m(b.forward[S].key,l)<0;)b=b.forward[S];I[S]=b}if(b=b.forward[0],!b||m(b.key,l)!==0)return!1;for(let S=0;S<C._level&&I[S].forward[S]===b;S++)I[S].forward[S]=b.forward[S];for(;C._level>0&&C._header.forward[C._level-1]===k;)C._level-=1;return!0}}e.SkipList=R}),define(Z[58],ee([0,1,17,2]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(p){const c=p;return c?typeof c.read=="function":!1}e.isReadable=k;function R(p){const c=p;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=R;function M(p){const c=p;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=M;function C(p,c){return new l(p,c)}e.newWriteableStream=C;class l{constructor(c,n){this.reducer=c,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(n=>n(c))}emitError(c){this.listeners.error.length===0?(0,v.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(n=>n(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,n){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(c,n){if(this.state.destroyed)return;let o;switch(c){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const i=o.indexOf(n);i>=0&&o.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(p,c){const n=[];let o;for(;(o=p.read())!==null;)n.push(o);return c(n)}e.consumeReadable=m;function I(p,c,n){const o=[];let i;for(;(i=p.read())!==null&&o.length<n;)o.push(i);return i===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return p.read()}}}e.peekReadable=I;function b(p,c){return new Promise((n,o)=>{const i=[];S(p,{onData:r=>{c&&i.push(r)},onError:r=>{c?o(r):n(void 0)},onEnd:()=>{n(c?c(i):void 0)}})})}e.consumeStream=b;function S(p,c){let n=!1;return p.on("error",o=>{n||c.onError(o)}),p.on("end",()=>{n||c.onEnd()}),p.on("data",o=>{n||c.onData(o)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=S;function f(p,c){return new Promise((n,o)=>{const i=new t.DisposableStore,r=[],s=P=>{if(r.push(P),r.length>c)return i.dispose(),p.pause(),n({stream:p,buffer:r,ended:!1})},a=P=>o(P),u=()=>n({stream:p,buffer:r,ended:!0});i.add((0,t.toDisposable)(()=>p.removeListener("error",a))),p.on("error",a),i.add((0,t.toDisposable)(()=>p.removeListener("end",u))),p.on("end",u),i.add((0,t.toDisposable)(()=>p.removeListener("data",s))),p.on("data",s)})}e.peekStream=f;function d(p,c){const n=C(c);return n.end(p),n}e.toStream=d;function y(){const p=C(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=y;function E(p){let c=!1;return{read:()=>c?null:(c=!0,p)}}e.toReadable=E;function w(p,c,n){const o=C(n);return S(p,{onData:i=>o.write(c.data(i)),onError:i=>o.error(c.error?c.error(i):i),onEnd:()=>o.end()}),o}e.transform=w;function g(p,c,n){let o=!1;return{read:()=>{const i=c.read();return o?i:(o=!0,i!==null?n([p,i]):p)}}}e.prefixedReadable=g;function h(p,c,n){let o=!1;const i=C(n);return S(c,{onData:r=>o?i.write(r):(o=!0,i.write(n([p,r]))),onError:r=>i.error(r),onEnd:()=>{o||(o=!0,i.write(p)),i.end()}}),i}e.prefixedStream=h}),define(Z[18],ee([0,1,58]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class M{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return t?new M(Buffer.allocUnsafe(P)):new M(new Uint8Array(P))}static wrap(P){return t&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new M(P)}static fromString(P,D){return!(D?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(P)):(k||(k=new TextEncoder),new M(k.encode(P)))}static fromByteArray(P){const D=M.alloc(P.length);for(let T=0,N=P.length;T<N;T++)D.buffer[T]=P[T];return D}static concat(P,D){if(typeof D>"u"){D=0;for(let U=0,$=P.length;U<$;U++)D+=P[U].byteLength}const T=M.alloc(D);let N=0;for(let U=0,$=P.length;U<$;U++){const Y=P[U];T.set(Y,N),N+=Y.byteLength}return T}clone(){const P=M.alloc(this.byteLength);return P.set(this),P}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(P,D){return new M(this.buffer.subarray(P,D))}set(P,D){if(P instanceof M)this.buffer.set(P.buffer,D);else if(P instanceof Uint8Array)this.buffer.set(P,D);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),D);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return m(this.buffer,P)}writeUInt32BE(P,D){I(this.buffer,P,D)}readUInt32LE(P){return b(this.buffer,P)}writeUInt32LE(P,D){S(this.buffer,P,D)}readUInt8(P){return f(this.buffer,P)}writeUInt8(P,D){d(this.buffer,P,D)}}e.VSBuffer=M;function C(u,P){return u[P+0]<<0>>>0|u[P+1]<<8>>>0}e.readUInt16LE=C;function l(u,P,D){u[D+0]=P&255,P=P>>>8,u[D+1]=P&255}e.writeUInt16LE=l;function m(u,P){return u[P]*2**24+u[P+1]*2**16+u[P+2]*2**8+u[P+3]}e.readUInt32BE=m;function I(u,P,D){u[D+3]=P,P=P>>>8,u[D+2]=P,P=P>>>8,u[D+1]=P,P=P>>>8,u[D]=P}e.writeUInt32BE=I;function b(u,P){return u[P+0]<<0>>>0|u[P+1]<<8>>>0|u[P+2]<<16>>>0|u[P+3]<<24>>>0}e.readUInt32LE=b;function S(u,P,D){u[D+0]=P&255,P=P>>>8,u[D+1]=P&255,P=P>>>8,u[D+2]=P&255,P=P>>>8,u[D+3]=P&255}e.writeUInt32LE=S;function f(u,P){return u[P]}e.readUInt8=f;function d(u,P,D){u[D]=P}e.writeUInt8=d;function y(u){return v.consumeReadable(u,P=>M.concat(P))}e.readableToBuffer=y;function E(u){return v.toReadable(u)}e.bufferToReadable=E;function w(u){return v.consumeStream(u,P=>M.concat(P))}e.streamToBuffer=w;async function g(u){return u.ended?M.concat(u.buffer):M.concat([...u.buffer,await w(u.stream)])}e.bufferedStreamToBuffer=g;function h(u){return v.toStream(u,P=>M.concat(P))}e.bufferToStream=h;function p(u){return v.transform(u,{data:P=>typeof P=="string"?M.fromString(P):M.wrap(P)},P=>M.concat(P))}e.streamToBufferReadableStream=p;function c(u){return v.newWriteableStream(P=>M.concat(P),u)}e.newWriteableBufferStream=c;function n(u,P){return v.prefixedReadable(u,P,D=>M.concat(D))}e.prefixedBufferReadable=n;function o(u,P){return v.prefixedStream(u,P,D=>M.concat(D))}e.prefixedBufferStream=o;function i(u){let P=0,D=0,T=0;const N=new Uint8Array(Math.floor(u.length/4*3)),U=Y=>{switch(D){case 3:N[T++]=P|Y,D=0;break;case 2:N[T++]=P|Y>>>2,P=Y<<6,D=3;break;case 1:N[T++]=P|Y>>>4,P=Y<<4,D=2;break;default:P=Y<<2,D=1}};for(let Y=0;Y<u.length;Y++){const oe=u.charCodeAt(Y);if(oe>=65&&oe<=90)U(oe-65);else if(oe>=97&&oe<=122)U(oe-97+26);else if(oe>=48&&oe<=57)U(oe-48+52);else if(oe===43||oe===45)U(62);else if(oe===47||oe===95)U(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Y]}`)}}const $=T;for(;D>0;)U(0);return M.wrap(N).slice(0,$)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:u},P=!0,D=!1){const T=D?s:r;let N="";const U=u.byteLength%3;let $=0;for(;$<u.byteLength-U;$+=3){const Y=u[$+0],oe=u[$+1],ue=u[$+2];N+=T[Y>>>2],N+=T[(Y<<4|oe>>>4)&63],N+=T[(oe<<2|ue>>>6)&63],N+=T[ue&63]}if(U===1){const Y=u[$+0];N+=T[Y>>>2],N+=T[Y<<4&63],P&&(N+="==")}else if(U===2){const Y=u[$+0],oe=u[$+1];N+=T[Y>>>2],N+=T[(Y<<4|oe>>>4)&63],N+=T[oe<<2&63],P&&(N+="=")}return N}e.encodeBase64=a}),define(Z[12],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(o){return typeof o=="string"}e.isString=v;function t(o){return Array.isArray(o)&&o.every(i=>v(i))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function R(o){const i=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof i}e.isTypedArray=R;function M(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=M;function C(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=C;function l(o){return o===!0||o===!1}e.isBoolean=l;function m(o){return typeof o>"u"}e.isUndefined=m;function I(o){return!b(o)}e.isDefined=I;function b(o){return m(o)||o===null}e.isUndefinedOrNull=b;function S(o,i){if(!o)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=S;function f(o){if(b(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=f;function d(...o){const i=[];for(let r=0;r<o.length;r++){const s=o[r];if(b(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);i.push(s)}return i}e.assertAllDefined=d;const y=Object.prototype.hasOwnProperty;function E(o){if(!k(o))return!1;for(const i in o)if(y.call(o,i))return!1;return!0}e.isEmptyObject=E;function w(o){return typeof o=="function"}e.isFunction=w;function g(...o){return o.length>0&&o.every(w)}e.areFunctions=g;function h(o,i){const r=Math.min(o.length,i.length);for(let s=0;s<r;s++)p(o[s],i[s])}e.validateConstraints=h;function p(o,i){if(v(i)){if(typeof o!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(w(i)){try{if(o instanceof i)return}catch{}if(!b(o)&&o.constructor===i||i.length===1&&i.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function c(o){return o===null?void 0:o}e.withNullAsUndefined=c;function n(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=n}),define(Z[50],ee([0,1,12]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const g=Array.isArray(w)?[]:{};return Object.keys(w).forEach(h=>{w[h]&&typeof w[h]=="object"?g[h]=t(w[h]):g[h]=w[h]}),g}e.deepClone=t;function k(w){if(!w||typeof w!="object")return w;const g=[w];for(;g.length>0;){const h=g.shift();Object.freeze(h);for(const p in h)if(R.call(h,p)){const c=h[p];typeof c=="object"&&!Object.isFrozen(c)&&!(0,v.isTypedArray)(c)&&g.push(c)}}return w}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function M(w,g){return C(w,g,new Set)}e.cloneAndChange=M;function C(w,g,h){if((0,v.isUndefinedOrNull)(w))return w;const p=g(w);if(typeof p<"u")return p;if(Array.isArray(w)){const c=[];for(const n of w)c.push(C(n,g,h));return c}if((0,v.isObject)(w)){if(h.has(w))throw new Error("Cannot clone recursive data-structure");h.add(w);const c={};for(const n in w)R.call(w,n)&&(c[n]=C(w[n],g,h));return h.delete(w),c}return w}function l(w,g,h=!0){return(0,v.isObject)(w)?((0,v.isObject)(g)&&Object.keys(g).forEach(p=>{p in w?h&&((0,v.isObject)(w[p])&&(0,v.isObject)(g[p])?l(w[p],g[p],h):w[p]=g[p]):w[p]=g[p]}),w):g}e.mixin=l;function m(w,g){if(w===g)return!0;if(w==null||g===null||g===void 0||typeof w!=typeof g||typeof w!="object"||Array.isArray(w)!==Array.isArray(g))return!1;let h,p;if(Array.isArray(w)){if(w.length!==g.length)return!1;for(h=0;h<w.length;h++)if(!m(w[h],g[h]))return!1}else{const c=[];for(p in w)c.push(p);c.sort();const n=[];for(p in g)n.push(p);if(n.sort(),!m(c,n))return!1;for(h=0;h<c.length;h++)if(!m(w[c[h]],g[c[h]]))return!1}return!0}e.equals=m;function I(w){const g=new Set;return JSON.stringify(w,(h,p)=>{if((0,v.isObject)(p)||Array.isArray(p)){if(g.has(p))return"[Circular]";g.add(p)}return p})}e.safeStringify=I;function b(w,g){const h=Object.create(null);return!w||!g||Object.keys(g).forEach(c=>{const n=w[c],o=g[c];m(n,o)||(h[c]=o)}),h}e.distinct=b;function S(w,g){const h=g.toLowerCase(),p=Object.keys(w).find(c=>c.toLowerCase()===h);return p?w[p]:w[g]}e.getCaseInsensitive=S;function f(w,g){const h=Object.create(null);for(const[p,c]of Object.entries(w))g(p,c)&&(h[p]=c);return h}e.filter=f;function d(w){let g=[],h=Object.getPrototypeOf(w);for(;Object.prototype!==h;)g=g.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return g}e.getAllPropertyNames=d;function y(w){const g=[];for(const h of d(w))typeof w[h]=="function"&&g.push(h);return g}e.getAllMethodNames=y;function E(w,g){const h=c=>function(){const n=Array.prototype.slice.call(arguments,0);return g(c,n)},p={};for(const c of w)p[c]=h(c);return p}e.createProxyObject=E}),define(Z[30],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return v.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let l=0;l<C.length;l++)C[l]=Math.floor(Math.random()*256);return C};const R=new Uint8Array(16),M=[];for(let C=0;C<256;C++)M.push(C.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let l=0,m="";return m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m}}()}),define(Z[127],ee([0,1,76,28,49]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(M,C){if(await new Promise((I,b)=>{const S=t.createReadStream(M),f=v.createHash("sha1");S.pipe(f);const d=(0,k.once)((y,E)=>{S.removeAllListeners(),f.removeAllListeners(),y?b(y):I(E)});S.once("error",d),S.once("end",d),f.once("error",d),f.once("data",y=>d(void 0,y.toString("hex")))})!==C)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[128],ee([0,1,29]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(M){const C=M.replace(/\-/g,":").toLowerCase();return!t.has(C)}function R(){const M=(0,v.networkInterfaces)();for(const C in M){const l=M[C];if(l){for(const{mac:m}of l)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[93],ee([0,1,77]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(C,l,m,I=1){let b=!1;return new Promise(S=>{const f=setTimeout(()=>{if(!b)return b=!0,S(0)},m);k(C,l,I,d=>{if(!b)return b=!0,clearTimeout(f),S(d)})})}e.findFreePort=t;function k(C,l,m,I){if(l===0)return I(0);const b=new v.Socket;b.once("connect",()=>(M(b),k(C+m,l-1,m,I))),b.once("data",()=>{}),b.once("error",S=>(M(b),S.code!=="ECONNREFUSED"?k(C+m,l-1,m,I):I(C))),b.connect(C,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(C,l,m){let I=!1,b,S=1;const f=v.createServer({pauseOnConnect:!0});function d(y,E){I||(I=!0,f.removeAllListeners(),f.close(),b&&clearTimeout(b),E(y))}return new Promise(y=>{b=setTimeout(()=>{d(0,y)},m),f.on("listening",()=>{d(C,y)}),f.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&S<l?(C++,S++,f.listen(C,"127.0.0.1")):d(0,y)}),f.on("close",()=>{d(0,y)}),f.listen(C,"127.0.0.1")})}e.findFreePortFaster=R;function M(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(l){console.error(l)}}}),define(Z[129],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[130],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Z[41],ee([0,1,15,17]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,C){const l=(m,...I)=>{this.validateEvent(M,m)&&C(m,...I)};return this.mapListenerToWrapper.set(C,l),v.ipcMain.on(M,l),this}once(M,C){return v.ipcMain.once(M,(l,...m)=>{this.validateEvent(M,l)&&C(l,...m)}),this}handle(M,C){return v.ipcMain.handle(M,(l,...m)=>this.validateEvent(M,l)?C(l,...m):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return v.ipcMain.removeHandler(M),this}removeListener(M,C){const l=this.mapListenerToWrapper.get(C);return l&&(v.ipcMain.removeListener(M,l),this.mapListenerToWrapper.delete(C)),this}validateEvent(M,C){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const l=C.senderFrame,m=l.url;if(!m)return!0;let I="unknown";try{I=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${m}'.`),!1}return I!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${I}'.`),!1):l.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${I}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(Z[131],ee([0,1,15,41,12,129]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(l,m,I,b,S)=>{const f=C(l,b,I);f.popup({window:(0,k.withNullAsUndefined)(v.BrowserWindow.fromWebContents(l.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{f&&l.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=M;function C(l,m,I){const b=new v.Menu;return I.forEach(S=>{let f;S.type==="separator"?f=new v.MenuItem({type:S.type}):Array.isArray(S.submenu)?f=new v.MenuItem({submenu:C(l,m,S.submenu),label:S.label}):f=new v.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(d,y,E)=>l.sender.send(m,S.id,E)}),b.append(f)}),b}}),define(Z[132],ee([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(Z[133],ee([0,1,132]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,M=R*7,C=R*30,l=R*365;function m(b,S,f){typeof b!="number"&&(b=b.getTime());const d=Math.round((new Date().getTime()-b)/1e3);if(d<-30)return(0,v.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(d<30)return(0,v.localize)(1,null);let y;return d<t?(y=d,S?y===1?f?(0,v.localize)(2,null,y):(0,v.localize)(3,null,y):f?(0,v.localize)(4,null,y):(0,v.localize)(5,null,y):y===1?f?(0,v.localize)(6,null,y):(0,v.localize)(7,null,y):f?(0,v.localize)(8,null,y):(0,v.localize)(9,null,y)):d<k?(y=Math.floor(d/t),S?y===1?f?(0,v.localize)(10,null,y):(0,v.localize)(11,null,y):f?(0,v.localize)(12,null,y):(0,v.localize)(13,null,y):y===1?f?(0,v.localize)(14,null,y):(0,v.localize)(15,null,y):f?(0,v.localize)(16,null,y):(0,v.localize)(17,null,y)):d<R?(y=Math.floor(d/k),S?y===1?f?(0,v.localize)(18,null,y):(0,v.localize)(19,null,y):f?(0,v.localize)(20,null,y):(0,v.localize)(21,null,y):y===1?f?(0,v.localize)(22,null,y):(0,v.localize)(23,null,y):f?(0,v.localize)(24,null,y):(0,v.localize)(25,null,y)):d<M?(y=Math.floor(d/R),S?y===1?(0,v.localize)(26,null,y):(0,v.localize)(27,null,y):y===1?(0,v.localize)(28,null,y):(0,v.localize)(29,null,y)):d<C?(y=Math.floor(d/M),S?y===1?f?(0,v.localize)(30,null,y):(0,v.localize)(31,null,y):f?(0,v.localize)(32,null,y):(0,v.localize)(33,null,y):y===1?f?(0,v.localize)(34,null,y):(0,v.localize)(35,null,y):f?(0,v.localize)(36,null,y):(0,v.localize)(37,null,y)):d<l?(y=Math.floor(d/C),S?y===1?f?(0,v.localize)(38,null,y):(0,v.localize)(39,null,y):f?(0,v.localize)(40,null,y):(0,v.localize)(41,null,y):y===1?f?(0,v.localize)(42,null,y):(0,v.localize)(43,null,y):f?(0,v.localize)(44,null,y):(0,v.localize)(45,null,y)):(y=Math.floor(d/l),S?y===1?f?(0,v.localize)(46,null,y):(0,v.localize)(47,null,y):f?(0,v.localize)(48,null,y):(0,v.localize)(49,null,y):y===1?f?(0,v.localize)(50,null,y):(0,v.localize)(51,null,y):f?(0,v.localize)(52,null,y):(0,v.localize)(53,null,y))}e.fromNow=m;function I(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Z[134],ee([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(Z[44],ee([0,1,24,12,134]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(b,S){return S&&(b.stack||b.stacktrace)?k.localize(0,null,C(b),M(b.stack)||M(b.stacktrace)):C(b)}function M(b){return Array.isArray(b)?b.join(`
`):b}function C(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?k.localize(1,null,b.message):b.message||k.localize(2,null)}function l(b=null,S=!1){if(!b)return k.localize(3,null);if(Array.isArray(b)){const f=v.coalesce(b),d=l(f[0],S);return f.length>1?k.localize(4,null,d,f.length):d}if(t.isString(b))return b;if(b.detail){const f=b.detail;if(f.error)return R(f.error,S);if(f.exception)return R(f.exception,S)}return b.stack?R(b,S):b.message?b.message:k.localize(5,null)}e.toErrorMessage=l;function m(b){const S=b;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=m;function I(b,S){let f;return typeof b=="string"?f=new Error(b):f=b,f.actions=S,f}e.createErrorWithActions=I}),define(Z[135],ee([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(Z[136],ee([0,1,135]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,v.localize)(0,null);case 2:return(0,v.localize)(1,null);case 3:return(0,v.localize)(2,null);case 4:return(0,v.localize)(3,null);case 5:return(0,v.localize)(4,null);case 6:return(0,v.localize)(5,null);case 7:return(0,v.localize)(6,null);case 8:return(0,v.localize)(7,null);case 9:return(0,v.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(Z[137],ee([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(Z[4],ee([0,1,137]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let k=!1,R=!1,M=!1,C=!1,l=!1,m=!1,I=!1,b=!1,S=!1,f,d=t,y,E;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?w=e.globals.vscode.process:typeof process<"u"&&(w=process);const g=typeof w?.versions?.electron=="string",h=g&&w?.type==="renderer";if(typeof navigator=="object"&&!h)E=navigator.userAgent,k=E.indexOf("Windows")>=0,R=E.indexOf("Macintosh")>=0,b=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=E.indexOf("Linux")>=0,m=!0,f=v.getConfiguredDefaultLocale(v.localize(0,null))||t,d=f;else if(typeof w=="object"){k=w.platform==="win32",R=w.platform==="darwin",M=w.platform==="linux",C=M&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,I=g,S=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t,d=t;const u=w.env.VSCODE_NLS_CONFIG;if(u)try{const P=JSON.parse(u),D=P.availableLanguages["*"];f=P.locale,d=D||t,y=P._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");var p;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function c(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let n=0;R?n=1:k?n=3:M&&(n=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=M,e.isLinuxSnap=C,e.isNative=l,e.isElectron=I,e.isWeb=m,e.isWebWorker=m&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isCI=S,e.platform=n,e.userAgent=E,e.language=d;var o;(function(u){function P(){return e.language}u.value=P;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=D;function T(){return e.language==="en"}u.isDefault=T})(o=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let T=0,N=u.length;T<N;T++){const U=u[T];if(U.id===D.data.vscodeScheduleAsyncWork){u.splice(T,1),U.callback();return}}});let P=0;return D=>{const T=++P;u.push({id:T,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return u=>setTimeout(u)})();var i;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:k?1:3;let r=!0,s=!1;function a(){if(!s){s=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[34],ee([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const k=v.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Z[9],ee([0,1,34]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,M=122,C=46,l=47,m=92,I=58,b=63;class S extends Error{constructor(p,c,n){let o;typeof c=="string"&&c.indexOf("not ")===0?(o="must not be",c=c.replace(/^not /,"")):o="must be";const i=p.indexOf(".")!==-1?"property":"argument";let r=`The "${p}" ${i} ${o} of type ${c}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function f(h,p){if(typeof h!="string")throw new S(p,"string",h)}function d(h){return h===l||h===m}function y(h){return h===l}function E(h){return h>=t&&h<=R||h>=k&&h<=M}function w(h,p,c,n){let o="",i=0,r=-1,s=0,a=0;for(let u=0;u<=h.length;++u){if(u<h.length)a=h.charCodeAt(u);else{if(n(a))break;a=l}if(n(a)){if(!(r===u-1||s===1))if(s===2){if(o.length<2||i!==2||o.charCodeAt(o.length-1)!==C||o.charCodeAt(o.length-2)!==C){if(o.length>2){const P=o.lastIndexOf(c);P===-1?(o="",i=0):(o=o.slice(0,P),i=o.length-1-o.lastIndexOf(c)),r=u,s=0;continue}else if(o.length!==0){o="",i=0,r=u,s=0;continue}}p&&(o+=o.length>0?`${c}..`:"..",i=2)}else o.length>0?o+=`${c}${h.slice(r+1,u)}`:o=h.slice(r+1,u),i=u-r-1;r=u,s=0}else a===C&&s!==-1?++s:s=-1}return o}function g(h,p){if(p===null||typeof p!="object")throw new S("pathObject","Object",p);const c=p.dir||p.root,n=p.base||`${p.name||""}${p.ext||""}`;return c?c===p.root?`${c}${n}`:`${c}${h}${n}`:n}e.win32={resolve(...h){let p="",c="",n=!1;for(let o=h.length-1;o>=-1;o--){let i;if(o>=0){if(i=h[o],f(i,"path"),i.length===0)continue}else p.length===0?i=v.cwd():(i=v.env[`=${p}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==p.toLowerCase()&&i.charCodeAt(2)===m)&&(i=`${p}\\`));const r=i.length;let s=0,a="",u=!1;const P=i.charCodeAt(0);if(r===1)d(P)&&(s=1,u=!0);else if(d(P))if(u=!0,d(i.charCodeAt(1))){let D=2,T=D;for(;D<r&&!d(i.charCodeAt(D));)D++;if(D<r&&D!==T){const N=i.slice(T,D);for(T=D;D<r&&d(i.charCodeAt(D));)D++;if(D<r&&D!==T){for(T=D;D<r&&!d(i.charCodeAt(D));)D++;(D===r||D!==T)&&(a=`\\\\${N}\\${i.slice(T,D)}`,s=D)}}}else s=1;else E(P)&&i.charCodeAt(1)===I&&(a=i.slice(0,2),s=2,r>2&&d(i.charCodeAt(2))&&(u=!0,s=3));if(a.length>0)if(p.length>0){if(a.toLowerCase()!==p.toLowerCase())continue}else p=a;if(n){if(p.length>0)break}else if(c=`${i.slice(s)}\\${c}`,n=u,u&&p.length>0)break}return c=w(c,!n,"\\",d),n?`${p}\\${c}`:`${p}${c}`||"."},normalize(h){f(h,"path");const p=h.length;if(p===0)return".";let c=0,n,o=!1;const i=h.charCodeAt(0);if(p===1)return y(i)?"\\":h;if(d(i))if(o=!0,d(h.charCodeAt(1))){let s=2,a=s;for(;s<p&&!d(h.charCodeAt(s));)s++;if(s<p&&s!==a){const u=h.slice(a,s);for(a=s;s<p&&d(h.charCodeAt(s));)s++;if(s<p&&s!==a){for(a=s;s<p&&!d(h.charCodeAt(s));)s++;if(s===p)return`\\\\${u}\\${h.slice(a)}\\`;s!==a&&(n=`\\\\${u}\\${h.slice(a,s)}`,c=s)}}}else c=1;else E(i)&&h.charCodeAt(1)===I&&(n=h.slice(0,2),c=2,p>2&&d(h.charCodeAt(2))&&(o=!0,c=3));let r=c<p?w(h.slice(c),!o,"\\",d):"";return r.length===0&&!o&&(r="."),r.length>0&&d(h.charCodeAt(p-1))&&(r+="\\"),n===void 0?o?`\\${r}`:r:o?`${n}\\${r}`:`${n}${r}`},isAbsolute(h){f(h,"path");const p=h.length;if(p===0)return!1;const c=h.charCodeAt(0);return d(c)||p>2&&E(c)&&h.charCodeAt(1)===I&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let p,c;for(let i=0;i<h.length;++i){const r=h[i];f(r,"path"),r.length>0&&(p===void 0?p=c=r:p+=`\\${r}`)}if(p===void 0)return".";let n=!0,o=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++o;const i=c.length;i>1&&d(c.charCodeAt(1))&&(++o,i>2&&(d(c.charCodeAt(2))?++o:n=!1))}if(n){for(;o<p.length&&d(p.charCodeAt(o));)o++;o>=2&&(p=`\\${p.slice(o)}`)}return e.win32.normalize(p)},relative(h,p){if(f(h,"from"),f(p,"to"),h===p)return"";const c=e.win32.resolve(h),n=e.win32.resolve(p);if(c===n||(h=c.toLowerCase(),p=n.toLowerCase(),h===p))return"";let o=0;for(;o<h.length&&h.charCodeAt(o)===m;)o++;let i=h.length;for(;i-1>o&&h.charCodeAt(i-1)===m;)i--;const r=i-o;let s=0;for(;s<p.length&&p.charCodeAt(s)===m;)s++;let a=p.length;for(;a-1>s&&p.charCodeAt(a-1)===m;)a--;const u=a-s,P=r<u?r:u;let D=-1,T=0;for(;T<P;T++){const U=h.charCodeAt(o+T);if(U!==p.charCodeAt(s+T))break;U===m&&(D=T)}if(T!==P){if(D===-1)return n}else{if(u>P){if(p.charCodeAt(s+T)===m)return n.slice(s+T+1);if(T===2)return n.slice(s+T)}r>P&&(h.charCodeAt(o+T)===m?D=T:T===2&&(D=3)),D===-1&&(D=0)}let N="";for(T=o+D+1;T<=i;++T)(T===i||h.charCodeAt(T)===m)&&(N+=N.length===0?"..":"\\..");return s+=D,N.length>0?`${N}${n.slice(s,a)}`:(n.charCodeAt(s)===m&&++s,n.slice(s,a))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const p=e.win32.resolve(h);if(p.length<=2)return h;if(p.charCodeAt(0)===m){if(p.charCodeAt(1)===m){const c=p.charCodeAt(2);if(c!==b&&c!==C)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(E(p.charCodeAt(0))&&p.charCodeAt(1)===I&&p.charCodeAt(2)===m)return`\\\\?\\${p}`;return h},dirname(h){f(h,"path");const p=h.length;if(p===0)return".";let c=-1,n=0;const o=h.charCodeAt(0);if(p===1)return d(o)?h:".";if(d(o)){if(c=n=1,d(h.charCodeAt(1))){let s=2,a=s;for(;s<p&&!d(h.charCodeAt(s));)s++;if(s<p&&s!==a){for(a=s;s<p&&d(h.charCodeAt(s));)s++;if(s<p&&s!==a){for(a=s;s<p&&!d(h.charCodeAt(s));)s++;if(s===p)return h;s!==a&&(c=n=s+1)}}}}else E(o)&&h.charCodeAt(1)===I&&(c=p>2&&d(h.charCodeAt(2))?3:2,n=c);let i=-1,r=!0;for(let s=p-1;s>=n;--s)if(d(h.charCodeAt(s))){if(!r){i=s;break}}else r=!1;if(i===-1){if(c===-1)return".";i=c}return h.slice(0,i)},basename(h,p){p!==void 0&&f(p,"ext"),f(h,"path");let c=0,n=-1,o=!0,i;if(h.length>=2&&E(h.charCodeAt(0))&&h.charCodeAt(1)===I&&(c=2),p!==void 0&&p.length>0&&p.length<=h.length){if(p===h)return"";let r=p.length-1,s=-1;for(i=h.length-1;i>=c;--i){const a=h.charCodeAt(i);if(d(a)){if(!o){c=i+1;break}}else s===-1&&(o=!1,s=i+1),r>=0&&(a===p.charCodeAt(r)?--r===-1&&(n=i):(r=-1,n=s))}return c===n?n=s:n===-1&&(n=h.length),h.slice(c,n)}for(i=h.length-1;i>=c;--i)if(d(h.charCodeAt(i))){if(!o){c=i+1;break}}else n===-1&&(o=!1,n=i+1);return n===-1?"":h.slice(c,n)},extname(h){f(h,"path");let p=0,c=-1,n=0,o=-1,i=!0,r=0;h.length>=2&&h.charCodeAt(1)===I&&E(h.charCodeAt(0))&&(p=n=2);for(let s=h.length-1;s>=p;--s){const a=h.charCodeAt(s);if(d(a)){if(!i){n=s+1;break}continue}o===-1&&(i=!1,o=s+1),a===C?c===-1?c=s:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||o===-1||r===0||r===1&&c===o-1&&c===n+1?"":h.slice(c,o)},format:g.bind(null,"\\"),parse(h){f(h,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return p;const c=h.length;let n=0,o=h.charCodeAt(0);if(c===1)return d(o)?(p.root=p.dir=h,p):(p.base=p.name=h,p);if(d(o)){if(n=1,d(h.charCodeAt(1))){let D=2,T=D;for(;D<c&&!d(h.charCodeAt(D));)D++;if(D<c&&D!==T){for(T=D;D<c&&d(h.charCodeAt(D));)D++;if(D<c&&D!==T){for(T=D;D<c&&!d(h.charCodeAt(D));)D++;D===c?n=D:D!==T&&(n=D+1)}}}}else if(E(o)&&h.charCodeAt(1)===I){if(c<=2)return p.root=p.dir=h,p;if(n=2,d(h.charCodeAt(2))){if(c===3)return p.root=p.dir=h,p;n=3}}n>0&&(p.root=h.slice(0,n));let i=-1,r=n,s=-1,a=!0,u=h.length-1,P=0;for(;u>=n;--u){if(o=h.charCodeAt(u),d(o)){if(!a){r=u+1;break}continue}s===-1&&(a=!1,s=u+1),o===C?i===-1?i=u:P!==1&&(P=1):i!==-1&&(P=-1)}return s!==-1&&(i===-1||P===0||P===1&&i===s-1&&i===r+1?p.base=p.name=h.slice(r,s):(p.name=h.slice(r,i),p.base=h.slice(r,s),p.ext=h.slice(i,s))),r>0&&r!==n?p.dir=h.slice(0,r-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let p="",c=!1;for(let n=h.length-1;n>=-1&&!c;n--){const o=n>=0?h[n]:v.cwd();f(o,"path"),o.length!==0&&(p=`${o}/${p}`,c=o.charCodeAt(0)===l)}return p=w(p,!c,"/",y),c?`/${p}`:p.length>0?p:"."},normalize(h){if(f(h,"path"),h.length===0)return".";const p=h.charCodeAt(0)===l,c=h.charCodeAt(h.length-1)===l;return h=w(h,!p,"/",y),h.length===0?p?"/":c?"./":".":(c&&(h+="/"),p?`/${h}`:h)},isAbsolute(h){return f(h,"path"),h.length>0&&h.charCodeAt(0)===l},join(...h){if(h.length===0)return".";let p;for(let c=0;c<h.length;++c){const n=h[c];f(n,"path"),n.length>0&&(p===void 0?p=n:p+=`/${n}`)}return p===void 0?".":e.posix.normalize(p)},relative(h,p){if(f(h,"from"),f(p,"to"),h===p||(h=e.posix.resolve(h),p=e.posix.resolve(p),h===p))return"";const c=1,n=h.length,o=n-c,i=1,r=p.length-i,s=o<r?o:r;let a=-1,u=0;for(;u<s;u++){const D=h.charCodeAt(c+u);if(D!==p.charCodeAt(i+u))break;D===l&&(a=u)}if(u===s)if(r>s){if(p.charCodeAt(i+u)===l)return p.slice(i+u+1);if(u===0)return p.slice(i+u)}else o>s&&(h.charCodeAt(c+u)===l?a=u:u===0&&(a=0));let P="";for(u=c+a+1;u<=n;++u)(u===n||h.charCodeAt(u)===l)&&(P+=P.length===0?"..":"/..");return`${P}${p.slice(i+a)}`},toNamespacedPath(h){return h},dirname(h){if(f(h,"path"),h.length===0)return".";const p=h.charCodeAt(0)===l;let c=-1,n=!0;for(let o=h.length-1;o>=1;--o)if(h.charCodeAt(o)===l){if(!n){c=o;break}}else n=!1;return c===-1?p?"/":".":p&&c===1?"//":h.slice(0,c)},basename(h,p){p!==void 0&&f(p,"ext"),f(h,"path");let c=0,n=-1,o=!0,i;if(p!==void 0&&p.length>0&&p.length<=h.length){if(p===h)return"";let r=p.length-1,s=-1;for(i=h.length-1;i>=0;--i){const a=h.charCodeAt(i);if(a===l){if(!o){c=i+1;break}}else s===-1&&(o=!1,s=i+1),r>=0&&(a===p.charCodeAt(r)?--r===-1&&(n=i):(r=-1,n=s))}return c===n?n=s:n===-1&&(n=h.length),h.slice(c,n)}for(i=h.length-1;i>=0;--i)if(h.charCodeAt(i)===l){if(!o){c=i+1;break}}else n===-1&&(o=!1,n=i+1);return n===-1?"":h.slice(c,n)},extname(h){f(h,"path");let p=-1,c=0,n=-1,o=!0,i=0;for(let r=h.length-1;r>=0;--r){const s=h.charCodeAt(r);if(s===l){if(!o){c=r+1;break}continue}n===-1&&(o=!1,n=r+1),s===C?p===-1?p=r:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||n===-1||i===0||i===1&&p===n-1&&p===c+1?"":h.slice(p,n)},format:g.bind(null,"/"),parse(h){f(h,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return p;const c=h.charCodeAt(0)===l;let n;c?(p.root="/",n=1):n=0;let o=-1,i=0,r=-1,s=!0,a=h.length-1,u=0;for(;a>=n;--a){const P=h.charCodeAt(a);if(P===l){if(!s){i=a+1;break}continue}r===-1&&(s=!1,r=a+1),P===C?o===-1?o=a:u!==1&&(u=1):o!==-1&&(u=-1)}if(r!==-1){const P=i===0&&c?1:i;o===-1||u===0||u===1&&o===r-1&&o===i+1?p.base=p.name=h.slice(P,r):(p.name=h.slice(P,o),p.base=h.slice(P,r),p.ext=h.slice(o,r))}return i>0?p.dir=h.slice(0,i-1):c&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[78],ee([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(C,...l){const m=l.reduce((S,f)=>(S[f]=!0,S),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(S=>!m[S]).forEach(S=>{for(let f=0;f<I.length;f++)if(S.search(I[f])!==-1){delete C[S];break}})}e.sanitizeProcessEnvironment=R;function M(C){!C||(delete C.DEBUG,v.isMacintosh&&delete C.DYLD_LIBRARY_PATH,v.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(Z[79],ee([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(M){this._highResolution=t&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new k(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[3],ee([0,1,17,49,2,125,79]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const C=!1,l=!1;var m;(function(a){a.None=()=>k.Disposable.None;function u(O){if(l){const{onListenerDidAdd:_}=O,V=d.create();let x=0;O.onListenerDidAdd=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),_?.()}}}function P(O){return(_,V=null,x)=>{let re=!1,j;return j=O(ie=>{if(!re)return j?j.dispose():re=!0,_.call(V,ie)},null,x),re&&j.dispose(),j}}a.once=P;function D(O,_,V){return oe((x,re=null,j)=>O(ie=>x.call(re,_(ie)),null,j),V)}a.map=D;function T(O,_,V){return oe((x,re=null,j)=>O(ie=>{_(ie),x.call(re,ie)},null,j),V)}a.forEach=T;function N(O,_,V){return oe((x,re=null,j)=>O(ie=>_(ie)&&x.call(re,ie),null,j),V)}a.filter=N;function U(O){return O}a.signal=U;function $(...O){return(_,V=null,x)=>(0,k.combinedDisposable)(...O.map(re=>re(j=>_.call(V,j),null,x)))}a.any=$;function Y(O,_,V,x){let re=V;return D(O,j=>(re=_(re,j),re),x)}a.reduce=Y;function oe(O,_){let V;const x={onFirstListenerAdd(){V=O(re.fire,re)},onLastListenerRemove(){V?.dispose()}};_||u(x);const re=new E(x);return _?.add(re),re.event}function ue(O,_,V=100,x=!1,re,j){let ie,ne,ae,ge=0;const Me={leakWarningThreshold:re,onFirstListenerAdd(){ie=O(ke=>{ge++,ne=_(ne,ke),x&&!ae&&(Le.fire(ne),ne=void 0),clearTimeout(ae),ae=setTimeout(()=>{const Ae=ne;ne=void 0,ae=void 0,(!x||ge>1)&&Le.fire(Ae),ge=0},V)})},onLastListenerRemove(){ie.dispose()}};j||u(Me);const Le=new E(Me);return j?.add(Le),Le.event}a.debounce=ue;function se(O,_=(x,re)=>x===re,V){let x=!0,re;return N(O,j=>{const ie=x||!_(j,re);return x=!1,re=j,ie},V)}a.latch=se;function de(O,_,V){return[a.filter(O,_,V),a.filter(O,x=>!_(x),V)]}a.split=de;function G(O,_=!1,V=[]){let x=V.slice(),re=O(ne=>{x?x.push(ne):ie.fire(ne)});const j=()=>{x?.forEach(ne=>ie.fire(ne)),x=null},ie=new E({onFirstListenerAdd(){re||(re=O(ne=>ie.fire(ne)))},onFirstListenerDidAdd(){x&&(_?setTimeout(j):j())},onLastListenerRemove(){re&&re.dispose(),re=null}});return ie.event}a.buffer=G;class K{constructor(_){this.event=_,this.disposables=new k.DisposableStore}map(_){return new K(D(this.event,_,this.disposables))}forEach(_){return new K(T(this.event,_,this.disposables))}filter(_){return new K(N(this.event,_,this.disposables))}reduce(_,V){return new K(Y(this.event,_,V,this.disposables))}latch(){return new K(se(this.event,void 0,this.disposables))}debounce(_,V=100,x=!1,re){return new K(ue(this.event,_,V,x,re,this.disposables))}on(_,V,x){return this.event(_,V,x)}once(_,V,x){return P(this.event)(_,V,x)}dispose(){this.disposables.dispose()}}function F(O){return new K(O)}a.chain=F;function A(O,_,V=x=>x){const x=(...ne)=>ie.fire(V(...ne)),re=()=>O.on(_,x),j=()=>O.removeListener(_,x),ie=new E({onFirstListenerAdd:re,onLastListenerRemove:j});return ie.event}a.fromNodeEventEmitter=A;function W(O,_,V=x=>x){const x=(...ne)=>ie.fire(V(...ne)),re=()=>O.addEventListener(_,x),j=()=>O.removeEventListener(_,x),ie=new E({onFirstListenerAdd:re,onLastListenerRemove:j});return ie.event}a.fromDOMEventEmitter=W;function z(O){return new Promise(_=>P(O)(_))}a.toPromise=z;function te(O,_){return _(void 0),O(V=>_(V))}a.runAndSubscribe=te;function B(O,_){let V=null;function x(j){V?.dispose(),V=new k.DisposableStore,_(j,V)}x(void 0);const re=O(j=>x(j));return(0,k.toDisposable)(()=>{re.dispose(),V?.dispose()})}a.runAndSubscribeWithStore=B;class H{constructor(_,V){this.obs=_,this._counter=0,this._hasChanged=!1;const x={onFirstListenerAdd:()=>{_.addObserver(this)},onLastListenerRemove:()=>{_.removeObserver(this)}};V||u(x),this.emitter=new E(x),V&&V.add(this.emitter)}beginUpdate(_){this._counter++}handleChange(_,V){this._hasChanged=!0}endUpdate(_){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,_){return new H(O,_).emitter.event}a.fromObservable=L})(m=e.Event||(e.Event={}));class I{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${I._idPool++}`}start(u){this._stopWatch=new M.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}I._idPool=0;let b=-1;function S(a){const u=b;return b=a,{dispose(){b=u}}}e.setGlobalLeakWarningThreshold=S;class f{constructor(u,P=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=P,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,P){let D=b;if(typeof this.customThreshold=="number"&&(D=this.customThreshold),D<=0||P<D)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let N,U=0;for(const[$,Y]of this._stacks)(!N||U<Y)&&(N=$,U=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${U}):`),console.warn(N)}return()=>{const N=this._stacks.get(u.value)||0;this._stacks.set(u.value,N-1)}}}class d{constructor(u){this.value=u}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(u,P,D){this.callback=u,this.callbackThis=P,this.stack=D,this.subscription=new k.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class E{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=b>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(C){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const P of u)P.subscription.isset()&&(P.subscription.unset(),P.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,P,D)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let N,U;this._leakageMon&&this._listeners.size>=30&&(U=d.create(),N=this._leakageMon.check(U,this._listeners.size+1)),C&&(U=U??d.create());const $=new y(u,P,U),Y=this._listeners.push($);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,P);const oe=$.subscription.set(()=>{N?.(),this._disposed||(Y(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return D instanceof k.DisposableStore?D.add(oe):Array.isArray(D)&&D.push(oe),oe}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const P of this._listeners)this._deliveryQueue.push(this,P,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=E;class w{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(u,P,D){this._queue.push(new h(u,P,D))}clear(u){const P=new R.LinkedList;for(const D of this._queue)D.emitter!==u&&P.push(D);this._queue=P}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(P){(0,v.onUnexpectedError)(P)}}}}e.EventDeliveryQueue=w;class g extends w{clear(u){this._queue.clear()}}class h{constructor(u,P,D){this.emitter=u,this.listener=P,this.event=D}}class p extends E{async fireAsync(u,P,D){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,u]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[T,N]=this._asyncDeliveryQueue.shift(),U=[],$={...N,token:P,waitUntil:Y=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");D&&(Y=D(Y,T.callback)),U.push(Y)}};try{T.invoke($)}catch(Y){(0,v.onUnexpectedError)(Y);continue}Object.freeze(U),await Promise.allSettled(U).then(Y=>{for(const oe of Y)oe.status==="rejected"&&(0,v.onUnexpectedError)(oe.reason)})}}}}e.AsyncEmitter=p;class c extends E{constructor(u){super(u),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=c;class n extends c{constructor(u){super(u),this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=n;class o extends E{constructor(u){super(u),this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){!this.hasListeners()||(this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const P={event:u,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const D=()=>{this.hasListeners&&this.unhook(P);const T=this.events.indexOf(P);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(P=>this.emitter.fire(P))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class r{constructor(){this.buffers=[]}wrapEvent(u){return(P,D,T)=>u(N=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>P.call(D,N)):P.call(D,N)},void 0,T)}bufferEvents(u){const P=[];this.buffers.push(P);const D=u();return this.buffers.pop(),P.forEach(T=>T()),D}}e.EventBufferer=r;class s{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=k.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(Z[22],ee([0,1,3]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(C,l){const m=setTimeout(C.bind(l),0);return{dispose(){clearTimeout(m)}}});var k;(function(C){function l(m){return m===C.None||m===C.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}C.isCancellationToken=l,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=M}),define(Z[138],ee([0,1,22]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new v.CancellationTokenSource,l=this.task(C.token);return this.result={promise:l,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=t;class k{constructor(C){this.fn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const l=JSON.stringify(C);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=k;class R{constructor(C){this.fn=C,this._map=new Map}get cachedValues(){return this._map}get(C){if(this._map.has(C))return this._map.get(C);const l=this.fn(C);return this._map.set(C,l),l}}e.CachedFunction=R}),define(Z[94],ee([0,1,3,2]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=M=>({onDidChange:v.Event.None,value:M});e.staticObservableValue=k;class R extends t.Disposable{constructor(C){super(),this._value=C,this.changeEmitter=this._register(new v.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(C){C!==this._value&&(this._value=C,this.changeEmitter.fire(C))}}e.MutableObservableValue=R}),define(Z[25],ee([0,1,138,124]),function(q,e,v,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=R;const M=/{(\d+)}/g;function C(Q,...le){return le.length===0?Q:Q.replace(M,function(pe,fe){const Se=parseInt(fe,10);return isNaN(Se)||Se<0||Se>=le.length?pe:le[Se]})}e.format=C;const l=/{([^}]+)}/g;function m(Q,le){return Q.replace(l,(pe,fe)=>le[fe]??pe)}e.format2=m;function I(Q){return Q.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=I;function b(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function S(Q,le){let pe=0;const fe=le.charCodeAt(0);for(let Se=Q.length-1;Se>=0;Se--)Q.charCodeAt(Se)===fe&&pe++;return pe}e.count=S;function f(Q,le,pe="\u2026"){return Q.length<=le?Q:`${Q.substr(0,le)}${pe}`}e.truncate=f;function d(Q,le=" "){const pe=y(Q,le);return E(pe,le)}e.trim=d;function y(Q,le){if(!Q||!le)return Q;const pe=le.length;if(pe===0||Q.length===0)return Q;let fe=0;for(;Q.indexOf(le,fe)===fe;)fe=fe+pe;return Q.substring(fe)}e.ltrim=y;function E(Q,le){if(!Q||!le)return Q;const pe=le.length,fe=Q.length;if(pe===0||fe===0)return Q;let Se=fe,De=-1;for(;De=Q.lastIndexOf(le,Se-1),!(De===-1||De+pe!==Se);){if(De===0)return"";Se=De}return Q.substring(0,Se)}e.rtrim=E;function w(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function g(Q){return Q.replace(/\*/g,"")}e.stripWildcards=g;function h(Q,le,pe={}){if(!Q)throw new Error("Cannot create regex from empty string");le||(Q=b(Q)),pe.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let fe="";return pe.global&&(fe+="g"),pe.matchCase||(fe+="i"),pe.multiline&&(fe+="m"),pe.unicode&&(fe+="u"),new RegExp(Q,fe)}e.createRegExp=h;function p(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function c(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function n(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=n;function o(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=o;function i(Q){for(let le=0,pe=Q.length;le<pe;le++){const fe=Q.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function r(Q,le=0,pe=Q.length){for(let fe=le;fe<pe;fe++){const Se=Q.charCodeAt(fe);if(Se!==32&&Se!==9)return Q.substring(le,fe)}return Q.substring(le,pe)}e.getLeadingWhitespace=r;function s(Q,le=Q.length-1){for(let pe=le;pe>=0;pe--){const fe=Q.charCodeAt(pe);if(fe!==32&&fe!==9)return pe}return-1}e.lastNonWhitespaceIndex=s;function a(Q,le,pe){const fe=[];let Se=0;for(const De of Q.matchAll(le)){if(fe.push(Q.slice(Se,De.index)),De.index===void 0)throw new Error("match.index should be defined");Se=De.index+De[0].length,fe.push(pe(De[0],...De.slice(1),De.index,Q,De.groups))}return fe.push(Q.slice(Se)),Promise.all(fe).then(De=>De.join(""))}e.replaceAsync=a;function u(Q,le){return Q<le?-1:Q>le?1:0}e.compare=u;function P(Q,le,pe=0,fe=Q.length,Se=0,De=le.length){for(;pe<fe&&Se<De;pe++,Se++){const et=Q.charCodeAt(pe),Ke=le.charCodeAt(Se);if(et<Ke)return-1;if(et>Ke)return 1}const Fe=fe-pe,Ge=De-Se;return Fe<Ge?-1:Fe>Ge?1:0}e.compareSubstring=P;function D(Q,le){return T(Q,le,0,Q.length,0,le.length)}e.compareIgnoreCase=D;function T(Q,le,pe=0,fe=Q.length,Se=0,De=le.length){for(;pe<fe&&Se<De;pe++,Se++){let et=Q.charCodeAt(pe),Ke=le.charCodeAt(Se);if(et===Ke)continue;if(et>=128||Ke>=128)return P(Q.toLowerCase(),le.toLowerCase(),pe,fe,Se,De);U(et)&&(et-=32),U(Ke)&&(Ke-=32);const xe=et-Ke;if(xe!==0)return xe}const Fe=fe-pe,Ge=De-Se;return Fe<Ge?-1:Fe>Ge?1:0}e.compareSubstringIgnoreCase=T;function N(Q){return Q>=48&&Q<=57}e.isAsciiDigit=N;function U(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=U;function $(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=$;function Y(Q,le){return Q.length===le.length&&T(Q,le)===0}e.equalsIgnoreCase=Y;function oe(Q,le){const pe=le.length;return le.length>Q.length?!1:T(Q,le,0,pe)===0}e.startsWithIgnoreCase=oe;function ue(Q,le){const pe=Math.min(Q.length,le.length);let fe;for(fe=0;fe<pe;fe++)if(Q.charCodeAt(fe)!==le.charCodeAt(fe))return fe;return pe}e.commonPrefixLength=ue;function se(Q,le){const pe=Math.min(Q.length,le.length);let fe;const Se=Q.length-1,De=le.length-1;for(fe=0;fe<pe;fe++)if(Q.charCodeAt(Se-fe)!==le.charCodeAt(De-fe))return fe;return pe}e.commonSuffixLength=se;function de(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=de;function G(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=G;function K(Q,le){return(Q-55296<<10)+(le-56320)+65536}e.computeCodePoint=K;function F(Q,le,pe){const fe=Q.charCodeAt(pe);if(de(fe)&&pe+1<le){const Se=Q.charCodeAt(pe+1);if(G(Se))return K(fe,Se)}return fe}e.getNextCodePoint=F;function A(Q,le){const pe=Q.charCodeAt(le-1);if(G(pe)&&le>1){const fe=Q.charCodeAt(le-2);if(de(fe))return K(fe,pe)}return pe}class W{constructor(le,pe=0){this._str=le,this._len=le.length,this._offset=pe}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=A(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=F(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class z{constructor(le,pe=0){this._iterator=new W(le,pe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=Ce.getInstance(),pe=this._iterator,fe=pe.offset;let Se=le.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const De=pe.offset,Fe=le.getGraphemeBreakType(pe.nextCodePoint());if(he(Se,Fe)){pe.setOffset(De);break}Se=Fe}return pe.offset-fe}prevGraphemeLength(){const le=Ce.getInstance(),pe=this._iterator,fe=pe.offset;let Se=le.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const De=pe.offset,Fe=le.getGraphemeBreakType(pe.prevCodePoint());if(he(Fe,Se)){pe.setOffset(De);break}Se=Fe}return fe-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function te(Q,le){return new z(Q,le).nextGraphemeLength()}e.nextCharLength=te;function B(Q,le){return new z(Q,le).prevGraphemeLength()}e.prevCharLength=B;function H(Q,le){le>0&&G(Q.charCodeAt(le))&&le--;const pe=le+te(Q,le);return[pe-B(Q,pe),pe]}e.getCharContainingOffset=H;let L;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Q){return L||(L=O()),L.test(Q)}e.containsRTL=_;const V=/^[\t\n\r\x20-\x7E]*$/;function x(Q){return V.test(Q)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function re(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=re;function j(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=j;function ie(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=ie;function ne(Q,le){if(Q.length<le)return Q;const pe=/\b/g;let fe=0;for(;pe.test(Q)&&!(Q.length-pe.lastIndex<le);)fe=pe.lastIndex,pe.lastIndex+=1;return Q.substring(fe).replace(/^\s/,"")}e.lcut=ne;const ae=/\x1B\x5B[12]?K/g,ge=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function Le(Q){return Q&&(Q=Q.replace(ae,""),Q=Q.replace(ge,""),Q=Q.replace(Me,"")),Q}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Ae(Q){return ke(Q)?Q.substr(1):Q}e.stripUTF8BOM=Ae;function Ve(Q,le){if(!Q||!le||Q.length<le.length)return!1;const pe=le.length,fe=Q.toLowerCase();let Se=0,De=-1;for(;Se<pe;){const Fe=fe.indexOf(le[Se],De+1);if(Fe<0)return!1;De=Fe,Se++}return!0}e.fuzzyContains=Ve;function me(Q,le=!1){return Q?(le&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=me;function we(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=we;function Ee(Q,le=1){if(le===0)return"";let pe=-1;do pe=Q.indexOf(`
`,pe+1),le--;while(le>0&&pe>=0);return pe===-1?Q:(Q[pe-1]==="\r"&&pe--,Q.substr(0,pe))}e.getNLines=Ee;function X(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.singleLetterHash=X;function ce(Q){return Ce.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=ce;function he(Q,le){return Q===0?le!==5&&le!==7:Q===2&&le===3?!1:Q===4||Q===2||Q===3||le===4||le===2||le===3?!0:!(Q===8&&(le===8||le===9||le===11||le===12)||(Q===11||Q===9)&&(le===9||le===10)||(Q===12||Q===10)&&le===10||le===5||le===13||le===7||Q===1||Q===13&&le===14||Q===6&&le===6)}var be;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(be=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=Te()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const pe=this._data,fe=pe.length/3;let Se=1;for(;Se<=fe;)if(le<pe[3*Se])Se=2*Se;else if(le>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}Ce._INSTANCE=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(Q,le){if(Q===0)return 0;const pe=Ne(Q,le);if(pe!==void 0)return pe;const fe=new W(le,Q);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=We;function Ne(Q,le){const pe=new W(le,Q);let fe=pe.prevCodePoint();for(;_e(fe)||fe===65039||fe===8419;){if(pe.offset===0)return;fe=pe.prevCodePoint()}if(!ie(fe))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function _e(Q){return 127995<=Q&&Q<=127999}var ze;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class Be{constructor(le){this.confusableDictionary=le}static getInstance(le){return Be.cache.get(Array.from(le))}static getLocales(){return Be._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be,k=Be,Be.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.cache=new v.LRUCachedFunction(Q=>{function le(Ke){const xe=new Map;for(let it=0;it<Ke.length;it+=2)xe.set(Ke[it],Ke[it+1]);return xe}function pe(Ke,xe){const it=new Map(Ke);for(const[st,dt]of xe)it.set(st,dt);return it}function fe(Ke,xe){if(!Ke)return xe;const it=new Map;for(const[st,dt]of Ke)xe.has(st)&&it.set(st,dt);return it}const Se=k.ambiguousCharacterData.getValue();let De=Q.filter(Ke=>!Ke.startsWith("_")&&Ke in Se);De.length===0&&(De=["_default"]);let Fe;for(const Ke of De){const xe=le(Se[Ke]);Fe=fe(Fe,xe)}const Ge=le(Se._common),et=pe(Ge,Fe);return new Be(et)}),Be._locales=new t.Lazy(()=>Object.keys(Be.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(le){return He.getData().has(le)}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He,He._data=void 0}),define(Z[31],ee([0,1,9,4,25,12]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(s){return s===47||s===92}e.isPathSeparator=M;function C(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=C;function l(s){return s.indexOf("/")===-1&&(s=C(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=l;function m(s,a=v.posix.sep){if(!s)return"";const u=s.length,P=s.charCodeAt(0);if(M(P)){if(M(s.charCodeAt(1))&&!M(s.charCodeAt(2))){let T=3;const N=T;for(;T<u&&!M(s.charCodeAt(T));T++);if(N!==T&&!M(s.charCodeAt(T+1))){for(T+=1;T<u;T++)if(M(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,a)}}return a}else if(w(P)&&s.charCodeAt(1)===58)return M(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let D=s.indexOf("://");if(D!==-1){for(D+=3;D<u;D++)if(M(s.charCodeAt(D)))return s.slice(0,D+1)}return""}e.getRoot=m;function I(s){if(!t.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let u=2;const P=u;for(;u<s.length&&(a=s.charCodeAt(u),a!==92);u++);return!(P===u||(a=s.charCodeAt(u+1),isNaN(a)||a===92))}e.isUNC=I;const b=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,a=t.isWindows){const u=a?b:S;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||a&&f.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function y(s,a,u){const P=s===a;return!u||P?P:!s||!a?!1:(0,k.equalsIgnoreCase)(s,a)}e.isEqual=y;function E(s,a,u,P=v.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(u){if(!(0,k.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let T=a.length;return a.charAt(a.length-1)===P&&T--,s.charAt(T)===P}return a.charAt(a.length-1)!==P&&(a+=P),s.indexOf(a)===0}e.isEqualOrParent=E;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function g(s,a){return t.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(a,s)),s=(0,v.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,k.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=g;function h(s){const a=(0,v.normalize)(s);return t.isWindows?s.length>3?!1:p(a)&&(s.length===2||a.charCodeAt(2)===92):a===v.posix.sep}e.isRootOrDriveLetter=h;function p(s,a=t.isWindows){return a?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function c(s){return p(s)?s[0]:void 0}e.getDriveLetter=c;function n(s,a,u){return a.length>s.length?-1:s===a?0:(u&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=n;function o(s){const a=s.split(":");let u,P,D;for(const T of a){const N=Number(T);(0,R.isNumber)(N)?P===void 0?P=N:D===void 0&&(D=N):u=u?[u,T].join(":"):T}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:P!==void 0?P:void 0,column:D!==void 0?D:P!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,a,u=8){let P="";for(let T=0;T<u;T++)P+=i.charAt(Math.floor(Math.random()*i.length));let D;return a?D=`${a}-${P}`:D=P,s?(0,v.join)(s,D):D}e.randomPath=r}),define(Z[66],ee([0,1,25]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(w){return k(w,0)}e.hash=t;function k(w,g){switch(typeof w){case"object":return w===null?R(349,g):Array.isArray(w)?l(w,g):m(w,g);case"string":return C(w,g);case"boolean":return M(w,g);case"number":return R(w,g);case"undefined":return R(937,g);default:return R(617,g)}}e.doHash=k;function R(w,g){return(g<<5)-g+w|0}e.numberHash=R;function M(w,g){return R(w?433:863,g)}function C(w,g){g=R(149417,g);for(let h=0,p=w.length;h<p;h++)g=R(w.charCodeAt(h),g);return g}e.stringHash=C;function l(w,g){return g=R(104579,g),w.reduce((h,p)=>k(p,h),g)}function m(w,g){return g=R(181387,g),Object.keys(w).sort().reduce((h,p)=>(h=C(p,h),k(w[p],h)),g)}class I{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=k(g,this._value),this._value}}e.Hasher=I;var b;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function S(w,g,h=32){const p=h-g,c=~((1<<p)-1);return(w<<g|(c&w)>>>p)>>>0}function f(w,g=0,h=w.byteLength,p=0){for(let c=0;c<h;c++)w[g+c]=p}function d(w,g,h="0"){for(;w.length<g;)w=h+w;return w}function y(w,g=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((w>>>0).toString(16),g/4)}e.toHexString=y;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const h=g.length;if(h===0)return;const p=this._buff;let c=this._buffLen,n=this._leftoverHighSurrogate,o,i;for(n!==0?(o=n,i=-1,n=0):(o=g.charCodeAt(0),i=0);;){let r=o;if(v.isHighSurrogate(o))if(i+1<h){const s=g.charCodeAt(i+1);v.isLowSurrogate(s)?(i++,r=v.computeCodePoint(o,s)):r=65533}else{n=o;break}else v.isLowSurrogate(o)&&(r=65533);if(c=this._push(p,c,r),i++,i<h)o=g.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=n}_push(g,h,p){return p<128?g[h++]=p:p<2048?(g[h++]=192|(p&1984)>>>6,g[h++]=128|(p&63)>>>0):p<65536?(g[h++]=224|(p&61440)>>>12,g[h++]=128|(p&4032)>>>6,g[h++]=128|(p&63)>>>0):(g[h++]=240|(p&1835008)>>>18,g[h++]=128|(p&258048)>>>12,g[h++]=128|(p&4032)>>>6,g[h++]=128|(p&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=E._bigBlock32,h=this._buffDV;for(let u=0;u<64;u+=4)g.setUint32(u,h.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)g.setUint32(u,S(g.getUint32(u-12,!1)^g.getUint32(u-32,!1)^g.getUint32(u-56,!1)^g.getUint32(u-64,!1),1),!1);let p=this._h0,c=this._h1,n=this._h2,o=this._h3,i=this._h4,r,s,a;for(let u=0;u<80;u++)u<20?(r=c&n|~c&o,s=1518500249):u<40?(r=c^n^o,s=1859775393):u<60?(r=c&n|c&o|n&o,s=2400959708):(r=c^n^o,s=3395469782),a=S(p,5)+r+i+s+g.getUint32(u*4,!1)&4294967295,i=o,o=n,n=S(c,30),c=p,p=a;this._h0=this._h0+p&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[32],ee([0,1,24,25]),function(q,e,v,t){"use strict";var k,R,M;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(i,r,s){let a=i.get(r);return a===void 0&&(a=s,i.set(r,a)),a}e.getOrSet=C;function l(i){const r=[];return i.forEach((s,a)=>{r.push(`${a} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}e.mapToString=l;function m(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}e.setToString=m;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=I;class b{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class S{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var f;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(f||(f={}));class d{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(E||(E={}));class w{constructor(r){this._iter=r}static forUris(r=()=>!1,s=()=>!1){return new w(new d(r,s))}static forPaths(r=!1){return new w(new S(void 0,!r))}static forStrings(){return new w(new I)}static forConfigKeys(){return new w(new b)}clear(){this._root=void 0}fill(r,s){if(s){const a=s.slice(0);(0,v.shuffle)(a);for(const u of a)this.set(u,r)}else{const a=r.slice(0);(0,v.shuffle)(a);for(const u of a)this.set(u[0],u[1])}}set(r,s){const a=this._iter.reset(r);let u;this._root||(this._root=new y,this._root.segment=a.value());const P=[];for(u=this._root;;){const T=a.cmp(u.segment);if(T>0)u.left||(u.left=new y,u.left.segment=a.value()),P.push([-1,u]),u=u.left;else if(T<0)u.right||(u.right=new y,u.right.segment=a.value()),P.push([1,u]),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new y,u.mid.segment=a.value()),P.push([0,u]),u=u.mid;else break}const D=u.value;u.value=s,u.key=r;for(let T=P.length-1;T>=0;T--){const N=P[T][1];N.updateHeight();const U=N.balanceFactor();if(U<-1||U>1){const $=P[T][0],Y=P[T+1][0];if($===1&&Y===1)P[T][1]=N.rotateLeft();else if($===-1&&Y===-1)P[T][1]=N.rotateRight();else if($===1&&Y===-1)N.right=P[T+1][1]=P[T+1][1].rotateRight(),P[T][1]=N.rotateLeft();else if($===-1&&Y===1)N.left=P[T+1][1]=P[T+1][1].rotateLeft(),P[T][1]=N.rotateRight();else throw new Error;if(T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}return D}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const u=s.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const a=this._iter.reset(r),u=[];let P=this._root;for(;P;){const D=a.cmp(P.segment);if(D>0)u.push([-1,P]),P=P.left;else if(D<0)u.push([1,P]),P=P.right;else if(a.hasNext())a.next(),u.push([0,P]),P=P.mid;else break}if(!!P){if(s?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const D=this._min(P.right),{key:T,value:N,segment:U}=D;this._delete(D.key,!1),P.key=T,P.value=N,P.segment=U}else{const D=P.left??P.right;if(u.length>0){const[T,N]=u[u.length-1];switch(T){case-1:N.left=D;break;case 0:N.mid=D;break;case 1:N.right=D;break}}else this._root=D}for(let D=u.length-1;D>=0;D--){const T=u[D][1];T.updateHeight();const N=T.balanceFactor();if(N>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),u[D][1]=T.rotateLeft()):N<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),u[D][1]=T.rotateRight()),D>0)switch(u[D-1][0]){case-1:u[D-1][1].left=u[D][1];break;case 1:u[D-1][1].right=u[D][1];break;case 0:u[D-1][1].mid=u[D][1];break}else this._root=u[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let a=this._root,u;for(;a;){const P=s.cmp(a.segment);if(P>0)a=a.left;else if(P<0)a=a.right;else if(s.hasNext())s.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const u=s.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[s,a]of this)r(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const s=[];return this._dfsEntries(r,s),s[Symbol.iterator]()}_dfsEntries(r,s){!r||(r.left&&this._dfsEntries(r.left,s),r.value&&s.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,s),r.right&&this._dfsEntries(r.right,s))}_isBalanced(){const r=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=w;class g{constructor(r,s){this.uri=r,this.value=s}}class h{constructor(r,s){this[k]="ResourceMap",r instanceof h?(this.map=new Map(r.map),this.toKey=s??h.defaultToKey):(this.map=new Map,this.toKey=r??h.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new g(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[a,u]of this.map)r(u.value,u.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=h,h.defaultToKey=i=>i.toString();class p{constructor(r,s){this[R]="ResourceSet",!r||typeof r=="function"?this._map=new h(r):(this._map=new h(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((a,u)=>r.call(s,u,u,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var c;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class n{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const a=this._map.get(r);if(!!a)return s!==0&&this.touch(a,s),a.value}set(r,s,a=0){let u=this._map.get(r);if(u)u.value=s,a!==0&&this.touch(u,a);else{switch(u={key:r,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const a=this._state;let u=this._head;for(;u;){if(s?r.bind(s)(u.value,u.key,this):r(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.key,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return u}values(){const r=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.value,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return u}entries(){const r=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:[a.key,a.value],done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return u}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>r;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,a=r.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const a=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const a=r.next,u=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,a)=>{r.push([a,s])}),r}fromJSON(r){this.clear();for(const[s,a]of r)this.set(s,a)}}e.LinkedMap=n;class o extends n{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(Z[80],ee([0,1,32]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function k(m){return l(m,"NFC",t)}e.normalizeNFC=k;const R=new v.LRUCache(1e4);function M(m){return l(m,"NFD",R)}e.normalizeNFD=M;const C=/[^\u0000-\u0080]/;function l(m,I,b){if(!m)return m;const S=b.get(m);if(S)return S;let f;return C.test(m)?f=m.normalize(I):f=m,b.set(m,f),f}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(I){return M(I).replace(m,"")}}()}),define(Z[95],ee([0,1,25]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",M="warning",C="warn",l="info",m="ignore";function I(S){return S?v.equalsIgnoreCase(R,S)?k.Error:v.equalsIgnoreCase(M,S)||v.equalsIgnoreCase(C,S)?k.Warning:v.equalsIgnoreCase(l,S)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function b(S){switch(S){case k.Error:return R;case k.Warning:return M;case k.Info:return l;default:return m}}k.toString=b}(t||(t={})),e.default=t}),define(Z[7],ee([0,1,9,4]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function C(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(i,r){return!i&&!r?"file":i}function m(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==b&&(r=b+r):r=b;break}return r}const I="",b="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(r,s,a,u,P,D=!1){typeof r=="object"?(this.scheme=r.scheme||I,this.authority=r.authority||I,this.path=r.path||I,this.query=r.query||I,this.fragment=r.fragment||I):(this.scheme=l(r,D),this.authority=s||I,this.path=m(this.scheme,a||I),this.query=u||I,this.fragment=P||I,C(this,D))}static isUri(r){return r instanceof f?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return h(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:a,path:u,query:P,fragment:D}=r;return s===void 0?s=this.scheme:s===null&&(s=I),a===void 0?a=this.authority:a===null&&(a=I),u===void 0?u=this.path:u===null&&(u=I),P===void 0?P=this.query:P===null&&(P=I),D===void 0?D=this.fragment:D===null&&(D=I),s===this.scheme&&a===this.authority&&u===this.path&&P===this.query&&D===this.fragment?this:new y(s,a,u,P,D)}static parse(r,s=!1){const a=S.exec(r);return a?new y(a[2]||I,o(a[4]||I),o(a[5]||I),o(a[7]||I),o(a[9]||I),s):new y(I,I,I,I,I)}static file(r){let s=I;if(t.isWindows&&(r=r.replace(/\\/g,b)),r[0]===b&&r[1]===b){const a=r.indexOf(b,2);a===-1?(s=r.substring(2),r=b):(s=r.substring(2,a),r=r.substring(a)||b)}return new y("file",s,r,I,I)}static from(r){const s=new y(r.scheme,r.authority,r.path,r.query,r.fragment);return C(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&r.scheme==="file"?a=f.file(v.win32.join(h(r,!0),...s)).path:a=v.posix.join(r.path,...s),r.with({path:a})}toString(r=!1){return p(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof f)return r;{const s=new y(r);return s._formatted=r.external,s._fsPath=r._sep===d?r.fsPath:null,s}}else return r}}e.URI=f;const d=t.isWindows?1:void 0;class y extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(r=!1){return r?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=d),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(i,r){let s,a=-1;for(let u=0;u<i.length;u++){const P=i.charCodeAt(u);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47)a!==-1&&(s+=encodeURIComponent(i.substring(a,u)),a=-1),s!==void 0&&(s+=i.charAt(u));else{s===void 0&&(s=i.substr(0,u));const D=E[P];D!==void 0?(a!==-1&&(s+=encodeURIComponent(i.substring(a,u)),a=-1),s+=D):a===-1&&(a=u)}}return a!==-1&&(s+=encodeURIComponent(i.substring(a))),s!==void 0?s:i}function g(i){let r;for(let s=0;s<i.length;s++){const a=i.charCodeAt(s);a===35||a===63?(r===void 0&&(r=i.substr(0,s)),r+=E[a]):r!==void 0&&(r+=i[s])}return r!==void 0?r:i}function h(i,r){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=h;function p(i,r){const s=r?g:w;let a="",{scheme:u,authority:P,path:D,query:T,fragment:N}=i;if(u&&(a+=u,a+=":"),(P||u==="file")&&(a+=b,a+=b),P){let U=P.indexOf("@");if(U!==-1){const $=P.substr(0,U);P=P.substr(U+1),U=$.indexOf(":"),U===-1?a+=s($,!1):(a+=s($.substr(0,U),!1),a+=":",a+=s($.substr(U+1),!1)),a+="@"}P=P.toLowerCase(),U=P.indexOf(":"),U===-1?a+=s(P,!1):(a+=s(P.substr(0,U),!1),a+=P.substr(U))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const U=D.charCodeAt(1);U>=65&&U<=90&&(D=`/${String.fromCharCode(U+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const U=D.charCodeAt(0);U>=65&&U<=90&&(D=`${String.fromCharCode(U+32)}:${D.substr(2)}`)}a+=s(D,!0)}return T&&(a+="?",a+=s(T,!1)),N&&(a+="#",a+=r?N:w(N,!1)),a}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(n)?i.replace(n,r=>c(r)):i}}),define(Z[139],ee([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const I=m;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const I=[];let b;try{const S=JSON.parse(m.arguments),f=S[S.length-1];f&&f.__$stack&&(S.pop(),b=f.__$stack),I.push(...S)}catch{I.push("Unable to log remote console arguments",m.arguments)}return{args:I,stack:b}}e.parse=k;function R(m){if(typeof m!="string")return R(k(m).stack);const I=m;if(I){const b=M(I),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(S&&S.length===4)return{uri:v.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=R;function M(m){if(!m)return m;const I=m.indexOf(`
`);return I===-1?m:m.substring(0,I)}function C(m,I){const{args:b,stack:S}=k(m),f=typeof b[0]=="string"&&b.length===1;let d=M(S);d&&(d=`(${d.trim()})`);let y=[];if(typeof b[0]=="string"?d&&f?y=[`%c[${I}] %c${b[0]} %c${d}`,l("blue"),l(""),l("grey")]:y=[`%c[${I}] %c${b[0]}`,l("blue"),l(""),...b.slice(1)]:y=[`%c[${I}]%`,l("blue"),...b],d&&!f&&y.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,y)}e.log=C;function l(m){return`color: ${m}`}}),define(Z[67],ee([0,1,18,25,7]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,C)}e.stringify=R;function M(m){let I=JSON.parse(m);return I=l(I),I}e.parse=M;function C(m,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function l(m,I=0){if(!m||I>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof v.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let b=0;b<m.length;++b)m[b]=l(m[b],I+1);else for(const b in m)Object.hasOwnProperty.call(m,b)&&(m[b]=l(m[b],I+1))}return m}e.revive=l}),define(Z[13],ee([0,1,4,7]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebook="vscode-notebook",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${k.vscodeRemoteResource}`}set(m,I,b){this._hosts[m]=I,this._ports[m]=b}setConnectionToken(m,I){this._connectionTokens[m]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)return this._delegate(m);const I=m.authority;let b=this._hosts[I];b&&b.indexOf(":")!==-1&&(b=`[${b}]`);const S=this._ports[I],f=this._connectionTokens[I];let d=`path=${encodeURIComponent(m.path)}`;return typeof f=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),t.URI.from({scheme:v.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${b}:${S}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new R;class M{asBrowserUri(m,I){const b=this.toUri(m,I);return b.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===k.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${k.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?b.with({scheme:k.vscodeFileResource,authority:b.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(m,I){const b=this.toUri(m,I);return b.scheme===k.vscodeFileResource?b.with({scheme:k.file,authority:b.authority!==M.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(m,I){return t.URI.isUri(m)?m:t.URI.parse(I.toUrl(m))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M;var C;(function(l){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(m.get("3"));const I="vscode-coi";function b(f){let d;typeof f=="string"?d=new URL(f).searchParams:f instanceof URL?d=f.searchParams:t.URI.isUri(f)&&(d=new URL(f.toString(!0)).searchParams);const y=d?.get(I);if(!!y)return m.get(y)}l.getHeadersFromQuery=b;function S(f,d,y){if(!globalThis.crossOriginIsolated)return;const E=d&&y?"3":y?"2":"1";f instanceof URLSearchParams?f.set(I,E):f[I]=E}l.addSearchParam=S})(C=e.COI||(e.COI={}))}),define(Z[16],ee([0,1,31,13,9,4,25,7]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function l(f){return(0,C.uriToFsPath)(f,!0)}e.originalFSPath=l;class m{constructor(d){this._ignorePathCasing=d}compare(d,y,E=!1){return d===y?0:(0,M.compare)(this.getComparisonKey(d,E),this.getComparisonKey(y,E))}isEqual(d,y,E=!1){return d===y?!0:!d||!y?!1:this.getComparisonKey(d,E)===this.getComparisonKey(y,E)}getComparisonKey(d,y=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,y,E=!1){if(d.scheme===y.scheme){if(d.scheme===t.Schemas.file)return v.isEqualOrParent(l(d),l(y),this._ignorePathCasing(d))&&d.query===y.query&&(E||d.fragment===y.fragment);if((0,e.isEqualAuthority)(d.authority,y.authority))return v.isEqualOrParent(d.path,y.path,this._ignorePathCasing(d),"/")&&d.query===y.query&&(E||d.fragment===y.fragment)}return!1}joinPath(d,...y){return C.URI.joinPath(d,...y)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let y;return d.scheme===t.Schemas.file?y=C.URI.file(k.dirname(l(d))).path:(y=k.posix.dirname(d.path),d.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),y="/")),d.with({path:y})}normalizePath(d){if(!d.path.length)return d;let y;return d.scheme===t.Schemas.file?y=C.URI.file(k.normalize(l(d))).path:y=k.posix.normalize(d.path),d.with({path:y})}relativePath(d,y){if(d.scheme!==y.scheme||!(0,e.isEqualAuthority)(d.authority,y.authority))return;if(d.scheme===t.Schemas.file){const g=k.relative(l(d),l(y));return R.isWindows?v.toSlashes(g):g}let E=d.path||"/";const w=y.path||"/";if(this._ignorePathCasing(d)){let g=0;for(const h=Math.min(E.length,w.length);g<h&&!(E.charCodeAt(g)!==w.charCodeAt(g)&&E.charAt(g).toLowerCase()!==w.charAt(g).toLowerCase());g++);E=w.substr(0,g)+E.substr(g)}return k.posix.relative(E,w)}resolvePath(d,y){if(d.scheme===t.Schemas.file){const E=C.URI.file(k.resolve(l(d),y));return d.with({authority:E.authority,path:E.path})}return y=v.toPosixPath(y),d.with({path:k.posix.resolve(d.path,y)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,y){return d===y||d!==void 0&&y!==void 0&&(0,M.equalsIgnoreCase)(d,y)}hasTrailingPathSeparator(d,y=k.sep){if(d.scheme===t.Schemas.file){const E=l(d);return E.length>v.getRoot(E).length&&E[E.length-1]===y}else{const E=d.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,y=k.sep){return(0,e.hasTrailingPathSeparator)(d,y)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,y=k.sep){let E=!1;if(d.scheme===t.Schemas.file){const w=l(d);E=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===y}else{y="/";const w=d.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(d,y)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(f=>f.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(f,d){const y=[];for(let E=0;E<f.length;E++){const w=d(f[E]);f.some((g,h)=>h===E?!1:(0,e.isEqualOrParent)(w,d(g)))||y.push(f[E])}return y}e.distinctParents=I;var b;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(y){const E=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(h=>{const[p,c]=h.split(":");p&&c&&E.set(p,c)});const g=y.path.substring(0,y.path.indexOf(";"));return g&&E.set(f.META_DATA_MIME,g),E}f.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function S(f,d,y){if(d){let E=f.path;return E&&E[0]!==k.posix.sep&&(E=k.posix.sep+E),f.with({scheme:y,authority:d,path:E})}return f.with({scheme:y})}e.toLocalResource=S}),define(Z[8],ee([0,1,22,17,3,2,16,4]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function l(H){return!!H&&typeof H.then=="function"}e.isThenable=l;function m(H){const L=new v.CancellationTokenSource,O=H(L.token),_=new Promise((V,x)=>{const re=L.token.onCancellationRequested(()=>{re.dispose(),L.dispose(),x(new t.CancellationError)});Promise.resolve(O).then(j=>{re.dispose(),L.dispose(),V(j)},j=>{re.dispose(),L.dispose(),x(j)})});return new class{cancel(){L.cancel()}then(V,x){return _.then(V,x)}catch(V){return this.then(void 0,V)}finally(V){return _.finally(V)}}}e.createCancelablePromise=m;function I(H,L,O){return new Promise((_,V)=>{const x=L.onCancellationRequested(()=>{x.dispose(),_(O)});H.then(_,V).finally(()=>x.dispose())})}e.raceCancellation=I;function b(H,L){return new Promise((O,_)=>{const V=L.onCancellationRequested(()=>{V.dispose(),_(new t.CancellationError)});H.then(O,_).finally(()=>V.dispose())})}e.raceCancellationError=b;async function S(H){let L=-1;const O=H.map((V,x)=>V.then(re=>(L=x,re))),_=await Promise.race(O);return H.forEach((V,x)=>{x!==L&&V.cancel()}),_}e.raceCancellablePromises=S;function f(H,L,O){let _;const V=setTimeout(()=>{_?.(void 0),O?.()},L);return Promise.race([H.finally(()=>clearTimeout(V)),new Promise(x=>_=x)])}e.raceTimeout=f;function d(H){return new Promise((L,O)=>{const _=H();l(_)?_.then(L,O):L(_)})}e.asPromise=d;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=L(),new Promise((O,_)=>{this.activePromise.then(V=>{this.activePromise=null,O(V)},V=>{this.activePromise=null,_(V)})})}}e.Throttler=y;class E{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=E;class w{constructor(){this.promiseMap=new Map}queue(L,O){const V=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===V&&this.promiseMap.delete(L)});return this.promiseMap.set(L,V),V}}e.SequencerByKey=w;const g=(H,L)=>{let O=!0;const _=setTimeout(()=>{O=!1,L()},H);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},h=H=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,H())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,x)=>{this.doResolve=V,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?h(_):g(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class c{constructor(L){this.delayer=new p(L),this.throttler=new y}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class n{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class o extends n{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function i(H,L){return L?new Promise((O,_)=>{const V=setTimeout(()=>{x.dispose(),O()},H),x=L.onCancellationRequested(()=>{clearTimeout(V),x.dispose(),_(new t.CancellationError)})}):m(O=>i(H,O))}e.timeout=i;function r(H,L=0){const O=setTimeout(H,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=r;function s(H){const L=[];let O=0;const _=H.length;function V(){return O<_?H[O++]():null}function x(re){re!=null&&L.push(re);const j=V();return j?j.then(x):Promise.resolve(L)}return Promise.resolve(null).then(x)}e.sequence=s;function a(H,L=_=>!!_,O=null){let _=0;const V=H.length,x=()=>{if(_>=V)return Promise.resolve(O);const re=H[_++];return Promise.resolve(re()).then(ie=>L(ie)?Promise.resolve(ie):x())};return x()}e.first=a;function u(H,L=_=>!!_,O=null){if(H.length===0)return Promise.resolve(O);let _=H.length;const V=()=>{_=-1;for(const x of H)x.cancel?.()};return new Promise((x,re)=>{for(const j of H)j.then(ie=>{--_>=0&&L(ie)?(V(),x(ie)):_===0&&x(O)}).catch(ie=>{--_>=0&&(V(),re(ie))})})}e.firstParallel=u;class P{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:L,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=P;class D extends P{constructor(){super(1)}}e.Queue=D;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new F;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=M.extUri){const _=O.getComparisonKey(L);let V=this.queues.get(_);return V||(V=new D,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class N{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=N;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=U;class ${constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class Y{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=Y;class oe extends ${constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=oe;class ue extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,C.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(H,L)=>{const O=requestIdleCallback(H,typeof L=="number"?{timeout:L}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function de(H,L,O){let _;for(let V=0;V<O;V++)try{return await H()}catch(x){_=x,await i(L)}throw _}e.retry=de;class G{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,O,_){return this._pending={taskId:L,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,_;const V=new Promise((x,re)=>{O=x,_=re});this._next={run:L,promise:V,promiseResolve:O,promiseReject:_}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=G;class K{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=F;var A;(function(H){async function L(_){let V;const x=await Promise.all(_.map(re=>re.then(j=>j,j=>{V||(V=j)})));if(typeof V<"u")throw V;return x}H.settled=L;function O(_){return new Promise(async(V,x)=>{try{await _(V,x)}catch(re){x(re)}})}H.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var W;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(W||(W={}));class z{constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(L(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(L){return new z(O=>{O.emitMany(L)})}static fromPromise(L){return new z(async O=>{O.emitMany(await L)})}static fromPromises(L){return new z(async O=>{await Promise.all(L.map(async _=>O.emitOne(await _)))})}static merge(L){return new z(async O=>{await Promise.all(L.map(async _=>{for await(const V of _)O.emitOne(V)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new z(async _=>{for await(const V of L)_.emitOne(O(V))})}map(L){return z.map(this,L)}static filter(L,O){return new z(async _=>{for await(const V of L)O(V)&&_.emitOne(V)})}filter(L){return z.filter(this,L)}static coalesce(L){return z.filter(L,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(L){const O=[];for await(const _ of L)O.push(_);return O}toPromise(){return z.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class te extends z{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function B(H){const L=new v.CancellationTokenSource,O=H(L.token);return new te(L,async _=>{const V=L.token.onCancellationRequested(()=>{V.dispose(),L.dispose(),_.reject(new t.CancellationError)});try{for await(const x of O){if(L.token.isCancellationRequested)return;_.emitOne(x)}V.dispose(),L.dispose()}catch(x){V.dispose(),L.dispose(),_.reject(x)}})}e.createCancelableAsyncIterable=B}),define(Z[96],ee([0,1,24,8,31,32,9,4,25]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",b="[^/\\\\]",S=/\//g;function f(F,A){switch(F){case 0:return"";case 1:return`${b}*?`;default:return`(?:${I}|${b}+${I}${A?`|${I}${b}+`:""})*?`}}function d(F,A){if(!F)return[];const W=[];let z=!1,te=!1,B="";for(const H of F){switch(H){case A:if(!z&&!te){W.push(B),B="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":te=!0;break;case"]":te=!1;break}B+=H}return B&&W.push(B),W}e.splitGlobAware=d;function y(F){if(!F)return"";let A="";const W=d(F,e.GLOB_SPLIT);if(W.every(z=>z===e.GLOBSTAR))A=".*";else{let z=!1;W.forEach((te,B)=>{if(te===e.GLOBSTAR){if(z)return;A+=f(2,B===W.length-1)}else{let H=!1,L="",O=!1,_="";for(const V of te){if(V!=="}"&&H){L+=V;continue}if(O&&(V!=="]"||!_)){let x;V==="-"?x=V:(V==="^"||V==="!")&&!_?x="^":V===e.GLOB_SPLIT?x="":x=(0,l.escapeRegExpCharacters)(V),_+=x;continue}switch(V){case"{":H=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${d(L,",").map(j=>y(j)).join("|")})`,H=!1,L="";break}case"]":{A+="["+_+"]",O=!1,_="";break}case"?":A+=b;continue;case"*":A+=f(1);continue;default:A+=(0,l.escapeRegExpCharacters)(V)}}B<W.length-1&&(W[B+1]!==e.GLOBSTAR||B+2<W.length)&&(A+=I)}z=te===e.GLOBSTAR})}return A}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),o=function(){return!1},i=function(){return null};function r(F,A){if(!F)return i;let W;typeof F!="string"?W=F.pattern:W=F,W=W.trim();const z=`${W}_${!!A.trimForExclusions}`;let te=n.get(z);if(te)return s(te,F);let B;return E.test(W)?te=u(W.substr(4),W):(B=w.exec(a(W,A)))?te=P(B[1],W):(A.trimForExclusions?h:g).test(W)?te=D(W,A):(B=p.exec(a(W,A)))?te=T(B[1].substr(1),W,!0):(B=c.exec(a(W,A)))?te=T(B[1],W,!1):te=N(W),n.set(z,te),s(te,F)}function s(F,A){if(typeof A=="string")return F;const W=function(z,te){return(0,k.isEqualOrParent)(z,A.base,!C.isLinux)?F(z.substr(A.base.length+1),te):null};return W.allBasenames=F.allBasenames,W.allPaths=F.allPaths,W.basenames=F.basenames,W.patterns=F.patterns,W}function a(F,A){return A.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function u(F,A){return function(W,z){return typeof W=="string"&&W.endsWith(F)?A:null}}function P(F,A){const W=`/${F}`,z=`\\${F}`,te=function(H,L){return typeof H!="string"?null:L?L===F?A:null:H===F||H.endsWith(W)||H.endsWith(z)?A:null},B=[F];return te.basenames=B,te.patterns=[A],te.allBasenames=B,te}function D(F,A){const W=G(F.slice(1,-1).split(",").map(L=>r(L,A)).filter(L=>L!==i),F),z=W.length;if(!z)return i;if(z===1)return W[0];const te=function(L,O){for(let _=0,V=W.length;_<V;_++)if(W[_](L,O))return F;return null},B=W.find(L=>!!L.allBasenames);B&&(te.allBasenames=B.allBasenames);const H=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return H.length&&(te.allPaths=H),te}function T(F,A,W){const z=M.sep===M.posix.sep,te=z?F:F.replace(S,M.sep),B=M.sep+te,H=M.posix.sep+F;let L;return W?L=function(O,_){return typeof O=="string"&&(O===te||O.endsWith(B)||!z&&(O===F||O.endsWith(H)))?A:null}:L=function(O,_){return typeof O=="string"&&(O===te||!z&&O===F)?A:null},L.allPaths=[(W?"*/":"./")+F],L}function N(F){try{const A=new RegExp(`^${y(F)}$`);return function(W){return A.lastIndex=0,typeof W=="string"&&A.test(W)?F:null}}catch{return i}}function U(F,A,W){return!F||typeof A!="string"?!1:$(F)(A,void 0,W)}e.match=U;function $(F,A={}){if(!F)return o;if(typeof F=="string"||Y(F)){const W=r(F,A);if(W===i)return o;const z=function(te,B){return!!W(te,B)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return se(F,A)}e.parse=$;function Y(F){const A=F;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=Y;function oe(F){return F.allBasenames||[]}e.getBasenameTerms=oe;function ue(F){return F.allPaths||[]}e.getPathTerms=ue;function se(F,A){const W=G(Object.getOwnPropertyNames(F).map(L=>de(L,F[L],A)).filter(L=>L!==i)),z=W.length;if(!z)return i;if(!W.some(L=>!!L.requiresSiblings)){if(z===1)return W[0];const L=function(V,x){let re;for(let j=0,ie=W.length;j<ie;j++){const ne=W[j](V,x);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(re||(re=[]),re.push(ne))}return re?(async()=>{for(const j of re){const ie=await j;if(typeof ie=="string")return ie}return null})():null},O=W.find(V=>!!V.allBasenames);O&&(L.allBasenames=O.allBasenames);const _=W.reduce((V,x)=>x.allPaths?V.concat(x.allPaths):V,[]);return _.length&&(L.allPaths=_),L}const te=function(L,O,_){let V,x;for(let re=0,j=W.length;re<j;re++){const ie=W[re];ie.requiresSiblings&&_&&(O||(O=(0,M.basename)(L)),V||(V=O.substr(0,O.length-(0,M.extname)(L).length)));const ne=ie(L,O,V,_);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(x||(x=[]),x.push(ne))}return x?(async()=>{for(const re of x){const j=await re;if(typeof j=="string")return j}return null})():null},B=W.find(L=>!!L.allBasenames);B&&(te.allBasenames=B.allBasenames);const H=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return H.length&&(te.allPaths=H),te}function de(F,A,W){if(A===!1)return i;const z=r(F,W);if(z===i)return i;if(typeof A=="boolean")return z;if(A){const te=A.when;if(typeof te=="string"){const B=(H,L,O,_)=>{if(!_||!z(H,L))return null;const V=te.replace("$(basename)",O),x=_(V);return(0,t.isThenable)(x)?x.then(re=>re?F:null):x?F:null};return B.requiresSiblings=!0,B}}return z}function G(F,A){const W=F.filter(L=>!!L.basenames);if(W.length<2)return F;const z=W.reduce((L,O)=>{const _=O.basenames;return _?L.concat(_):L},[]);let te;if(A){te=[];for(let L=0,O=z.length;L<O;L++)te.push(A)}else te=W.reduce((L,O)=>{const _=O.patterns;return _?L.concat(_):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let V;for(V=L.length;V>0;V--){const x=L.charCodeAt(V-1);if(x===47||x===92)break}O=L.substr(V)}const _=z.indexOf(O);return _!==-1?te[_]:null};B.basenames=z,B.patterns=te,B.allBasenames=z;const H=F.filter(L=>!L.basenames);return H.push(B),H}function K(F,A){return(0,v.equals)(F,A,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}e.patternsEquals=K}),define(Z[35],ee([0,1,24,31,9,4,16,25]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function l(i,r){const{os:s,tildify:a,relative:u}=r;if(u){const T=m(i,u,s);if(typeof T=="string")return T}let P=i.fsPath;if(s===1&&!R.isWindows?P=P.replace(/\//g,"\\"):s!==1&&R.isWindows&&(P=P.replace(/\\/g,"/")),s!==1&&a?.userHome){const T=a.userHome.fsPath;let N;i.scheme!==a.userHome.scheme&&i.path.startsWith(k.posix.sep)?N=a.userHome.with({path:i.path}).fsPath:N=i.fsPath,P=S(N,T,s)}return(s===1?k.win32:k.posix).normalize(I(P,s===1))}e.getPathLabel=l;function m(i,r,s){const a=s===1?k.win32:k.posix,u=s===3?M.extUri:M.extUriIgnorePathCase,P=r.getWorkspace(),D=(0,v.firstOrDefault)(P.folders);if(!D)return;i.scheme!==D.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=D.uri.with({path:i.path}));const T=r.getWorkspaceFolder(i);if(!T)return;let N;if(u.isEqual(T.uri,i)?N="":N=u.relativePath(T.uri,i)??"",N&&(N=a.normalize(N)),P.folders.length>1&&!r.noPrefix){const U=T.name?T.name:u.basenameOrAuthority(T.uri);N=N?`${U} \u2022 ${N}`:U}return N}function I(i,r=R.isWindows){return(0,t.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let b=Object.create(null);function S(i,r,s=R.OS){if(s===1||!i||!r)return i;let a=b.original===r?b.normalized:void 0;a||(a=r,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,C.rtrim)(a,k.posix.sep)}${k.posix.sep}`,b={original:r,normalized:a});let u=i;return R.isWindows&&(u=(0,t.toSlashes)(u)),(s===3?u.startsWith(a):(0,C.startsWithIgnoreCase)(u,a))?`~/${u.substr(a.length)}`:i}e.tildify=S;function f(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=f;const d="\u2026",y="\\\\",E="~";function w(i,r=k.sep){const s=new Array(i.length);let a=!1;for(let u=0;u<i.length;u++){const P=i[u];if(P===""){s[u]=`.${r}`;continue}if(!P){s[u]=P;continue}a=!0;let D="",T=P;T.indexOf(y)===0?(D=T.substr(0,T.indexOf(y)+y.length),T=T.substr(T.indexOf(y)+y.length)):T.indexOf(r)===0?(D=T.substr(0,T.indexOf(r)+r.length),T=T.substr(T.indexOf(r)+r.length)):T.indexOf(E)===0&&(D=T.substr(0,T.indexOf(E)+E.length),T=T.substr(T.indexOf(E)+E.length));const N=T.split(r);for(let U=1;a&&U<=N.length;U++)for(let $=N.length-U;a&&$>=0;$--){a=!1;let Y=N.slice($,$+U).join(r);for(let oe=0;!a&&oe<i.length;oe++)if(oe!==u&&i[oe]&&i[oe].indexOf(Y)>-1){const ue=$+U===N.length,se=$>0&&i[oe].indexOf(r)>-1?r+Y:Y,de=i[oe].endsWith(se);a=!ue||de}if(!a){let oe="";(N[0].endsWith(":")||D!=="")&&($===1&&($=0,U++,Y=N[0]+r+Y),$>0&&(oe=N[0]+r),oe=D+oe),$>0&&(oe=oe+d+r),oe=oe+Y,$+U<N.length&&(oe=oe+r+d),s[u]=oe}}a&&(s[u]=P)}return s}e.shorten=w;var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function h(i,r=Object.create(null)){const s=[];let a=!1,u="";for(const P of i)if(P==="$"||a&&P==="{")u&&s.push({value:u,type:g.TEXT}),u="",a=!0;else if(P==="}"&&a){const D=r[u];if(typeof D=="string")D.length&&s.push({value:D,type:g.VARIABLE});else if(D){const T=s[s.length-1];(!T||T.type!==g.SEPARATOR)&&s.push({value:D.label,type:g.SEPARATOR})}u="",a=!1}else u+=P;return u&&!a&&s.push({value:u,type:g.TEXT}),s.filter((P,D)=>{if(P.type===g.SEPARATOR){const T=s[D-1],N=s[D+1];return[T,N].every(U=>U&&(U.type===g.VARIABLE||U.type===g.TEXT)&&U.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=h;function p(i,r){return R.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function c(i,r){return R.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(i){const r=i.indexOf("/")!==-1?k.posix:k.win32,s=r.basename(i),a=r.dirname(i);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=o}),define(Z[140],ee([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(I){return I.toJSON()}class k{constructor(b){this._uriTransformer=b}transformIncoming(b){const S=this._uriTransformer.transformIncoming(b);return S===b?b:t(v.URI.from(S))}transformOutgoing(b){const S=this._uriTransformer.transformOutgoing(b);return S===b?b:t(v.URI.from(S))}transformOutgoingURI(b){const S=this._uriTransformer.transformOutgoing(b);return S===b?b:v.URI.from(S)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,b,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof v.URI)return b.transformOutgoing(I);for(const f in I)if(Object.hasOwnProperty.call(I,f)){const d=R(I[f],b,S+1);d!==null&&(I[f]=d)}}return null}function M(I,b){const S=R(I,b,0);return S===null?I:S}e.transformOutgoingURIs=M;function C(I,b,S,f){if(!I||f>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?v.URI.revive(b.transformIncoming(I)):b.transformIncoming(I);for(const d in I)if(Object.hasOwnProperty.call(I,d)){const y=C(I[d],b,S,f+1);y!==null&&(I[d]=y)}}return null}function l(I,b){const S=C(I,b,!1,0);return S===null?I:S}e.transformIncomingURIs=l;function m(I,b){const S=C(I,b,!0,0);return S===null?I:S}e.transformAndReviveIncomingURIs=m}),define(Z[81],ee([0,1,29,17,32,30,128]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,b=0;const S=(0,v.networkInterfaces)();for(const f in S){const d=S[f];if(d)for(const{mac:y,internal:E}of d)E||(b+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(I+=1))}this._value=b>0?I/b:0}return this._value}};let C;async function l(){return C||(C=(async()=>await m()||R.generateUuid())()),C}e.getMachineId=l;async function m(){try{const I=await new Promise((S,f)=>{q(["crypto"],S,f)}),b=(0,M.getMac)();return I.createHash("sha256").update(b,"utf8").digest("hex")}catch(I){t.onUnexpectedError(I);return}}}),define(Z[23],ee([0,1,28,29,141,8,31,80,9,4,16,7]),function(q,e,v,t,k,R,M,C,l,m,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function f(se,de=S.UNLINK){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return de===S.UNLINK?y(se):d(se)}async function d(se){try{const de=(0,M.randomPath)((0,t.tmpdir)());try{await v.promises.rename(se,de)}catch(G){return G.code==="ENOENT"?void 0:y(se)}y(de).catch(G=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function y(se){return(0,k.promisify)(v.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function E(se){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=E;async function w(se,de){return p(await(de?g(se):(0,k.promisify)(v.readdir)(se)))}async function g(se){try{return await(0,k.promisify)(v.readdir)(se,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const de=[],G=await w(se);for(const K of G){let F=!1,A=!1,W=!1;try{const z=await e.Promises.lstat((0,l.join)(se,K));F=z.isFile(),A=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}de.push({name:K,isFile:()=>F,isDirectory:()=>A,isSymbolicLink:()=>W})}return de}function h(se){return p(v.readdirSync(se))}e.readdirSync=h;function p(se){return se.map(de=>typeof de=="string"?m.isMacintosh?(0,C.normalizeNFC)(de):de:(de.name=m.isMacintosh?(0,C.normalizeNFC)(de.name):de.name,de))}async function c(se){const de=await w(se),G=[];for(const K of de)await o.existsDirectory((0,l.join)(se,K))&&G.push(K);return G}function n(se,de=1e3){return new Promise(G=>{let K=!1;const F=setInterval(()=>{K||(K=!0,v.access(se,A=>{K=!1,A&&(clearInterval(F),G(void 0))}))},de)})}e.whenDeleted=n;var o;(function(se){async function de(F){let A;try{if(A=await e.Promises.lstat(F),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(m.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw z}throw W}}se.stat=de;async function G(F){try{const{stat:A,symbolicLink:W}=await se.stat(F);return A.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=G;async function K(F){try{const{stat:A,symbolicLink:W}=await se.stat(F);return A.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=K})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function r(se,de,G){return i.queueFor(b.URI.file(se),I.extUriBiasedIgnorePathCase).queue(()=>{const K=D(G);return new Promise((F,A)=>u(se,de,K,W=>W?A(W):F()))})}let s=!0;function a(se){s=se}e.configureFlushOnWrite=a;function u(se,de,G,K){if(!s)return v.writeFile(se,de,{mode:G.mode,flag:G.flag},K);v.open(se,G.flag,G.mode,(F,A)=>{if(F)return K(F);v.writeFile(A,de,W=>{if(W)return v.close(A,()=>K(W));v.fdatasync(A,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),a(!1)),v.close(A,te=>K(te))))})})}function P(se,de,G){const K=D(G);if(!s)return v.writeFileSync(se,de,{mode:K.mode,flag:K.flag});const F=v.openSync(se,K.flag,K.mode);try{v.writeFileSync(F,de);try{v.fdatasyncSync(F)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),a(!1)}}finally{v.closeSync(F)}}e.writeFileSync=P;function D(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,de){if(se!==de)try{await e.Promises.rename(se,de)}catch(G){if(se.toLowerCase()!==de.toLowerCase()&&G.code==="EXDEV"||se.endsWith("."))await N(se,de,{preserveSymlinks:!1}),await f(se,S.MOVE);else throw G}}async function N(se,de,G){return $(se,de,{root:{source:se,target:de},options:G,handledSourcePaths:new Set})}const U=511;async function $(se,de,G){if(G.handledSourcePaths.has(se))return;G.handledSourcePaths.add(se);const{stat:K,symbolicLink:F}=await o.stat(se);if(F){if(G.options.preserveSymlinks)try{return await ue(se,de,G)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(F.dangling)return}return K.isDirectory()?Y(se,de,K.mode&U,G):oe(se,de,K.mode&U)}async function Y(se,de,G,K){await e.Promises.mkdir(de,{recursive:!0,mode:G});const F=await w(se);for(const A of F)await $((0,l.join)(se,A),(0,l.join)(de,A),K)}async function oe(se,de,G){await e.Promises.copyFile(se,de),await e.Promises.chmod(de,G)}async function ue(se,de,G){let K=await e.Promises.readlink(se);(0,M.isEqualOrParent)(K,G.root.source,!m.isLinux)&&(K=(0,l.join)(G.root.target,K.substr(G.root.source.length+1))),await e.Promises.symlink(K,de)}e.Promises=new class{get access(){return(0,k.promisify)(v.access)}get stat(){return(0,k.promisify)(v.stat)}get lstat(){return(0,k.promisify)(v.lstat)}get utimes(){return(0,k.promisify)(v.utimes)}get read(){return(se,de,G,K,F)=>new Promise((A,W)=>{v.read(se,de,G,K,F,(z,te,B)=>z?W(z):A({bytesRead:te,buffer:B}))})}get readFile(){return(0,k.promisify)(v.readFile)}get write(){return(se,de,G,K,F)=>new Promise((A,W)=>{v.write(se,de,G,K,F,(z,te,B)=>z?W(z):A({bytesWritten:te,buffer:B}))})}get appendFile(){return(0,k.promisify)(v.appendFile)}get fdatasync(){return(0,k.promisify)(v.fdatasync)}get truncate(){return(0,k.promisify)(v.truncate)}get rename(){return(0,k.promisify)(v.rename)}get copyFile(){return(0,k.promisify)(v.copyFile)}get open(){return(0,k.promisify)(v.open)}get close(){return(0,k.promisify)(v.close)}get symlink(){return(0,k.promisify)(v.symlink)}get readlink(){return(0,k.promisify)(v.readlink)}get chmod(){return(0,k.promisify)(v.chmod)}get mkdir(){return(0,k.promisify)(v.mkdir)}get unlink(){return(0,k.promisify)(v.unlink)}get rmdir(){return(0,k.promisify)(v.rmdir)}get realpath(){return(0,k.promisify)(v.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return c}get writeFile(){return r}get rm(){return f}get move(){return T}get copy(){return N}}}),define(Z[97],ee([0,1,28,9,4,25,23]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(S){if(k.isLinux)return S;const f=(0,t.dirname)(S);if(S===f)return S;const d=((0,t.basename)(S)||S).toLowerCase();try{const E=(0,M.readdirSync)(f).filter(w=>w.toLowerCase()===d);if(E.length===1){const w=C(f);if(w)return(0,t.join)(w,E[0])}else if(E.length>1){const w=E.indexOf(d);if(w>=0){const g=C(f);if(g)return(0,t.join)(g,E[w])}}}catch{}return null}e.realcaseSync=C;async function l(S){if(k.isLinux)return S;const f=(0,t.dirname)(S);if(S===f)return S;const d=((0,t.basename)(S)||S).toLowerCase();try{const E=(await M.Promises.readdir(f)).filter(w=>w.toLowerCase()===d);if(E.length===1){const w=await l(f);if(w)return(0,t.join)(w,E[0])}else if(E.length>1){const w=E.indexOf(d);if(w>=0){const g=await l(f);if(g)return(0,t.join)(g,E[w])}}}catch{}return null}e.realcase=l;async function m(S){try{return await M.Promises.realpath(S)}catch{const d=b(S);return await M.Promises.access(d,v.constants.R_OK),d}}e.realpath=m;function I(S){try{return v.realpathSync(S)}catch{const d=b(S);return v.accessSync(d,v.constants.R_OK),d}}e.realpathSync=I;function b(S){return(0,R.rtrim)((0,t.normalize)(S),t.sep)}}),define(Z[142],ee([0,1,29,9,23]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,M=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var l;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(l||(l={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class b{constructor(c,n,o){this.exePath=c,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:p=!1}={}){return p?m===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:p=!1,findPreview:c=!1}={}){const n=S({useAlternateBitness:p});if(!n)return null;const o=t.join(n,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let i=-1,r=null;for(const u of await k.Promises.readdir(o)){let P=-1;if(c){const T=u.indexOf("-");if(T<0)continue;const N=u.substring(0,T);if(!R.test(N)||u.substring(T+1)!=="preview")continue;P=parseInt(N,10)}else{if(!R.test(u))continue;P=parseInt(u,10)}if(P<=i)continue;const D=t.join(o,u,"pwsh.exe");!await k.SymlinkSupport.existsFile(D)||(r=D,i=P)}if(!r)return null;const s=n.includes("x86")?" (x86)":"",a=c?" Preview":"";return new b(r,`PowerShell${a}${s}`,!0)}async function d({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=p?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(c))if(n.test(i)){const r=t.join(c,i,"pwsh.exe");return new b(r,o)}return null}function y(){const p=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new b(p,".NET Core PowerShell Global Tool")}function E(){const p=t.join(process.env.windir,m===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(p,"Windows PowerShell",!0)}async function*w(){let p=await f();p&&(yield p),p=await f({useAlternateBitness:!0}),p&&(yield p),p=await d(),p&&(yield p),p=y(),p&&(yield p),p=await f({findPreview:!0}),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await f({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=E(),p&&(yield p)}async function*g(){for await(const p of w())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=g;async function h(){for await(const p of g())return p;return null}e.getFirstAvailablePowerShellInstallation=h}),define(Z[82],ee([0,1,9,4,34,78,12,23]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function l(b=k.env){return b.comspec||"cmd.exe"}e.getWindowsShell=l;function m(b){let S=[],f=!1;const d=function(y){if(f){S.push(y);return}(!b.send(y,w=>{if(w&&console.error(w),f=!1,S.length>0){const g=S.slice(0);S=[],g.forEach(h=>d(h))}})||t.isWindows)&&(f=!0)};return{send:d}}e.createQueuedSender=m;var I;(function(b){async function S(f,d,y){if(v.isAbsolute(f))return f;if(d===void 0&&(d=k.cwd()),v.dirname(f)!=="."||(y===void 0&&M.isString(k.env.PATH)&&(y=k.env.PATH.split(v.delimiter)),y===void 0||y.length===0))return v.join(d,f);async function w(g){if(await C.Promises.exists(g)){let h;try{h=await C.Promises.stat(g)}catch(p){p.message.startsWith("EACCES")&&(h=await C.Promises.lstat(g))}return h?!h.isDirectory():!1}return!1}for(const g of y){let h;if(v.isAbsolute(g)?h=v.join(g,f):h=v.join(d,g,f),await w(h))return h;let p=h+".com";if(await w(p)||(p=h+".exe",await w(p)))return p}return v.join(d,f)}b.findExecutable=S})(I=e.win32||(e.win32={}))}),define(Z[98],ee([0,1,45,13]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(M){return new Promise((C,l)=>{let m;const I=new Map;function b(f,d,y,E,w){const g=I.get(d);if(f===M||g){const h={name:S(y),cmd:y,pid:f,ppid:d,load:E,mem:w};I.set(f,h),f===M&&(m=h),g&&(g.children||(g.children=[]),g.children.push(h),g.children.length>1&&(g.children=g.children.sort((p,c)=>p.pid-c.pid)))}}function S(f){const d=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,E=/--vscode-window-kind=process-explorer/,w=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,h=/--crashes-directory/,p=/\\pipe\\winpty-control/,c=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(h.exec(f))return"electron-crash-reporter";if(p.exec(f))return"winpty-process";if(c.exec(f))return"console-window-host (Windows internal process)";let o=n.exec(f);if(o&&o.length===2){if(o[1]==="renderer")return d.exec(f)?"shared-process":y.exec(f)?"issue-reporter":E.exec(f)?"process-explorer":"window";if(o[1]==="utility"){if(w.exec(f))return"utility-network-service";if(g.exec(f))return"extension-host"}return o[1]}const i=/[a-zA-Z-]+\.js/g;let r="";do o=i.exec(f),o&&(r+=o+" ");while(o);return r&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${r}`:f}if(process.platform==="win32"){const f=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,y)=>{q(["windows-process-tree"],d,y)}).then(d=>{d.getProcessList(M,y=>{if(!y){l(new Error(`Root process ${M} not found`));return}d.getProcessCpuUsage(y,E=>{const w=new Map;E.forEach(g=>{const h=f(g.commandLine||"");w.set(g.pid,{name:S(h),cmd:h,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),m=w.get(M),m?(w.forEach(g=>{const h=w.get(g.ppid);h&&(h.children||(h.children=[]),h.children.push(g))}),w.forEach(g=>{g.children&&(g.children=g.children.sort((h,p)=>h.pid-p.pid))}),C(m)):l(new Error(`Root process ${M} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let f=function(){let d=[m];const y=[];for(;d.length;){const w=d.shift();w&&(y.push(w.pid),w.children&&(d=d.concat(w.children)))}let E=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);E+=" "+y.join(" "),(0,v.exec)(E,{},(w,g,h)=>{if(w||h)l(w||new Error(h.toString()));else{const p=g.toString().split(`
`);for(let c=0;c<y.length;c++){const n=I.get(y[c]);n.load=parseFloat(p[c])}if(!m){l(new Error(`Root process ${M} not found`));return}C(m)}})};(0,v.exec)("which ps",{},(d,y,E)=>{if(d||E)if(process.platform!=="linux")l(d||new Error(E.toString()));else{const w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,v.exec)(w,{},(g,h,p)=>{g||p?l(g||new Error(p.toString())):(R(h,b),f())})}else{const w=y.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${w} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,p,c)=>{h||c&&!c.includes("screen size is bogus")?l(h||new Error(c.toString())):(R(p,b),process.platform==="linux"?f():m?C(m):l(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=k;function R(M,C){const l=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=M.toString().split(`
`);for(const I of m){const b=l.exec(I.trim());b&&b.length===6&&C(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(Z[143],ee([0,1,29,4,142,82]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(f,d){return f===1?t.isWindows?b():R.getWindowsShell(d):m(f,d)}e.getSystemShell=M;function C(f,d){return f===1?t.isWindows?S(d):R.getWindowsShell(d):m(f,d)}e.getSystemShellSync=C;let l=null;function m(f,d){if(t.isLinux&&f===2||t.isMacintosh&&f===3)return"/bin/bash";if(!l){let y;if(t.isWindows)y="/bin/bash";else{if(y=d.SHELL,!y)try{y=(0,v.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}l=y}return l}let I=null;async function b(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function S(f){if(I)return I;const d=t.isWindows&&parseFloat((0,v.release)())>=10,y=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${f.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?E:R.getWindowsShell(f)}});var ve=this&&this.__decorate||function(q,e,v,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(q,e,v,t);else for(var C=q.length-1;C>=0;C--)(M=q[C])&&(R=(k<3?M(R):k>3?M(e,v,R):M(e,v))||R);return k>3&&R&&Object.defineProperty(e,v,R),R};define(Z[46],ee([0,1,24,8,18,22,53,17,3,2,67,25,12]),function(q,e,v,t,k,R,M,C,l,m,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function d(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function E(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(w||(w={}));class g{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class h{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var p;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(p||(p={}));function c(F){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(F,0),A}function n(F){return F.read(4).readUInt32BE(0)}function o(F){const A=k.VSBuffer.alloc(1);return A.writeUInt8(F,0),A}const i={Undefined:o(p.Undefined),String:o(p.String),Buffer:o(p.Buffer),VSBuffer:o(p.VSBuffer),Array:o(p.Array),Object:o(p.Object)},r=typeof Buffer<"u";function s(F,A){if(typeof A>"u")F.write(i.Undefined);else if(typeof A=="string"){const W=k.VSBuffer.fromString(A);F.write(i.String),F.write(c(W.byteLength)),F.write(W)}else if(r&&Buffer.isBuffer(A)){const W=k.VSBuffer.wrap(A);F.write(i.Buffer),F.write(c(W.byteLength)),F.write(W)}else if(A instanceof k.VSBuffer)F.write(i.VSBuffer),F.write(c(A.byteLength)),F.write(A);else if(Array.isArray(A)){F.write(i.Array),F.write(c(A.length));for(const W of A)s(F,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(A));F.write(i.Object),F.write(c(W.byteLength)),F.write(W)}}function a(F){switch(F.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return F.read(n(F)).toString();case p.Buffer:return F.read(n(F)).buffer;case p.VSBuffer:return F.read(n(F));case p.Array:{const W=n(F),z=[];for(let te=0;te<W;te++)z.push(a(F));return z}case p.Object:return JSON.parse(F.read(n(F)).toString())}}class u{constructor(A,W,z=null,te=1e3){this.protocol=A,this.ctx=W,this.logger=z,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,E(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,E(A.type),A.data);return}}}send(A,W=void 0){const z=new h;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new g(A),z=a(W),te=a(W),B=z[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}: ${z[2]}.${z[3]}`,te),this.onPromise({type:B,id:z[1],channelName:z[2],name:z[3],arg:te});case 102:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}: ${z[2]}.${z[3]}`,te),this.onEventListen({type:B,id:z[1],channelName:z[2],name:z[3],arg:te});case 101:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:z[1]});case 103:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:z[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=new R.CancellationTokenSource;let te;try{te=W.call(this.ctx,A.name,A.arg,z.token)}catch(L){te=Promise.reject(L)}const B=A.id;te.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const H=(0,m.toDisposable)(()=>z.cancel());this.activeRequests.set(A.id,H)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=A.id,B=W.listen(this.ctx,A.name,A.arg)(H=>this.sendResponse({id:z,data:H,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const z=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:z})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const z of W)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var P;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=W}getChannel(A){const W=this;return{call(z,te,B){return W.isDisposed?Promise.reject(new C.CancellationError):W.requestPromise(A,z,te,B)},listen(z,te){return W.isDisposed?l.Event.None:W.requestEvent(A,z,te)}}}requestPromise(A,W,z,te=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:W,arg:z};if(te.isCancellationRequested)return Promise.reject(new C.CancellationError);let O;return new Promise((V,x)=>{if(te.isCancellationRequested)return x(new C.CancellationError);const re=()=>{const ae=ge=>{switch(ge.type){case 201:this.handlers.delete(B),V(ge.data);break;case 202:{this.handlers.delete(B);const Me=new Error(ge.data.message);Me.stack=ge.data.stack,Me.name=ge.data.name,x(Me);break}case 203:this.handlers.delete(B),x(ge.data);break}};this.handlers.set(B,ae),this.sendRequest(L)};let j=null;this.state===w.Idle?re():(j=(0,t.createCancelablePromise)(ae=>this.whenInitialized()),j.then(()=>{j=null,re()}));const ie=()=>{j?(j.cancel(),j=null):this.sendRequest({id:B,type:101}),x(new C.CancellationError)},ne=te.onCancellationRequested(ie);O=(0,m.combinedDisposable)((0,m.toDisposable)(ie),ne),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,z){const te=this.lastRequestId++,H={id:te,type:102,channelName:A,name:W,arg:z};let L=null;const O=new l.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(V=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest(H)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:te,type:103}))}}),_=V=>O.fire(V.data);return this.handlers.set(te,_),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${d(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,d(A.type));return}}}send(A,W=void 0){const z=new h;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new g(A),z=a(W),te=a(W),B=z[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,E(B)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,z[1],0,E(B),te),this.onResponse({type:z[0],id:z[1],data:te})}}onResponse(A){if(A.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([M.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:z})=>{l.Event.once(W.onMessage)(B=>{const H=new g(B),L=a(H),O=new u(W,L),_=new D(W);this.channels.forEach((x,re)=>O.registerChannel(re,x));const V={channelServer:O,channelClient:_,ctx:L};this._connections.add(V),this._onDidAddConnection.fire(V),z(()=>{O.dispose(),_.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const z=this;return{call(te,B,H){let L;if((0,S.isFunction)(W)){const _=(0,v.getRandomElement)(z.connections.filter(W));L=_?Promise.resolve(_):l.Event.toPromise(l.Event.filter(z.onDidAddConnection,W))}else L=W.routeCall(z,te,B);const O=L.then(_=>_.channelClient.getChannel(A));return U(O).call(te,B,H)},listen(te,B){if((0,S.isFunction)(W))return z.getMulticastEvent(A,W,te,B);const H=W.routeEvent(z,te,B).then(L=>L.channelClient.getChannel(A));return U(H).listen(te,B)}}}getMulticastEvent(A,W,z,te){const B=this;let H=new m.DisposableStore;const L=new l.Emitter({onFirstListenerAdd:()=>{H=new m.DisposableStore;const O=new l.EventMultiplexer,_=new Map,V=re=>{const ie=re.channelClient.getChannel(A).listen(z,te),ne=O.add(ie);_.set(re,ne)},x=re=>{const j=_.get(re);!j||(j.dispose(),_.delete(re))};B.connections.filter(W).forEach(V),l.Event.filter(B.onDidAddConnection,W)(V,void 0,H),B.onDidRemoveConnection(x,void 0,H),O.event(L.fire,L,H),H.add(O)},onLastListenerRemove:()=>{H.dispose()}});return L.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(z=>{z.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class N{constructor(A,W,z=null){const te=new h;s(te,W),A.send(te.buffer),this.channelClient=new D(A,z),this.channelServer=new u(A,W,z)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=N;function U(F){return{call(A,W,z){return F.then(te=>te.call(A,W,z))},listen(A,W){const z=new l.Relay;return F.then(te=>z.input=te.listen(A,W)),z.event}}}e.getDelayedChannel=U;function $(F){let A=!1;return{call(W,z,te){return A?F.call(W,z,te):(0,t.timeout)(0).then(()=>A=!0).then(()=>F.call(W,z,te))},listen(W,z){if(A)return F.listen(W,z);const te=new l.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>te.input=F.listen(W,z)),te.event}}}e.getNextTickChannel=$;class Y{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await l.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=Y;var oe;(function(F){function A(B,H){const L=B,O=H&&H.disableMarshalling,_=new Map;for(const V in L)z(V)&&_.set(V,l.Event.buffer(L[V],!0));return new class{listen(V,x,re){const j=_.get(x);if(j)return j;if(te(x)){const ie=L[x];if(typeof ie=="function")return ie.call(L,re)}throw new Error(`Event not found: ${x}`)}call(V,x,re){const j=L[x];if(typeof j=="function"){if(!O&&Array.isArray(re))for(let ie=0;ie<re.length;ie++)re[ie]=(0,I.revive)(re[ie]);return j.apply(L,re)}throw new Error(`Method not found: ${x}`)}}}F.fromService=A;function W(B,H){const L=H&&H.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return H?.properties?.has(_)?H.properties.get(_):te(_)?function(V){return B.listen(_,V)}:z(_)?B.listen(_):async function(...V){let x;H&&!(0,S.isUndefinedOrNull)(H.context)?x=[H.context,...V]:x=V;const re=await B.call(_,x);return L?re:(0,I.revive)(re)};throw new Error(`Property not found: ${String(_)}`)}})}F.toService=W;function z(B){return B[0]==="o"&&B[1]==="n"&&b.isUpperAsciiLetter(B.charCodeAt(2))}function te(B){return/^onDynamic/.test(B)&&b.isUpperAsciiLetter(B.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const A=F.toString();if(A!=="[object Object]")return A}return F}function de(F){return Array.isArray(F)?F.map(se):se(F)}function G(F,A,W,z,te,B,H){H=de(H);const L=ue[te],O=L[z%L.length];let _=[`%c[${F}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(_=_.concat(H),_.push(")")):_.push(H),console.log.apply(console,_)}e.logWithColors=G;class K{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,z,te,B){this._totalOutgoing+=A,G(this._outgoingPrefix,this._totalOutgoing,A,W,z,te,B)}logIncoming(A,W,z,te,B){this._totalIncoming+=A,G(this._incomingPrefix,this._totalIncoming,A,W,z,te,B)}}e.IPCLogger=K}),define(Z[144],ee([0,1,18,3,46]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(l){this.port=l,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",m=>v.VSBuffer.wrap(m.data)),l.start()}send(l){this.port.postMessage(l.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class M extends k.IPCClient{constructor(l,m){const I=new R(l);super(I,m),this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=M}),define(Z[99],ee([0,1,18,3,2,46]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let a=0;function u(D,T){if(!s.has(D)){const N=String(++a);s.set(D,N)}return s.get(D)}function P(D,T,N,U){if(!r.enableDiagnostics)return;const $=u(D,T);if(U instanceof v.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const Y=v.VSBuffer.alloc(U.byteLength);Y.set(U),r.records.push({timestamp:Date.now(),id:$,label:T,type:N,buff:Y})}else r.records.push({timestamp:Date.now(),id:$,label:T,type:N,data:U})}r.traceSocketEvent=P})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var l;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(l=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function I(){return m||(m=v.VSBuffer.alloc(0)),m}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const u=v.VSBuffer.alloc(s);let P=0,D=0;for(;s>0;){const T=this._chunks[D];if(T.byteLength>s){const N=T.slice(0,s);u.set(N,P),P+=s,a&&(this._chunks[D]=T.slice(s),this._totalLength-=s),s-=s}else u.set(T,P),P+=T.byteLength,a?(this._chunks.shift(),this._totalLength-=T.byteLength):D++,s-=T.byteLength}return u}}e.ChunkStream=b;var S;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(S||(S={}));function f(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(s,a,u,P){this.type=s,this.id=a,this.ack=u,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:f(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,P=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new y(u,P,D,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=v.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:f(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(a,s.data)}_bufferAdd(s,a){const u=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,u}_bufferTake(){const s=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class g extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new y(1,0,0,s))}}e.Protocol=g;class h extends R.IPCClient{constructor(s,a,u=null){super(s,a,u),this.protocol=s}static fromSocket(s,a){return new h(new g(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=h;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class c{constructor(s){this.data=s,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let s=0,a=this._first;for(;a;)a=a.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let a=0,u=this._first;for(;u;)s[a++]=u.data,u=u.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new c(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class o{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<o._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=o._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const s=Date.now(),a=(1+o._HISTORY_LENGTH)*1e3;let u=0;for(let P=0;P<o._HISTORY_LENGTH;P++)s-this.lastRuns[P]<=a&&u++;return 1-u/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class i{constructor(s,a=null,u=o.getInstance()){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),a&&this._socketReader.acceptChunk(a),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new y(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new y(7,0,0,I());this._socketWriter.write(s)}sendResume(){const s=new y(8,0,0,I());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,I());this._socketWriter.write(s);const a=this._outgoingUnackMsg.toArray();for(let u=0,P=a.length;u<P;u++)this._socketWriter.write(a[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new y(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let u=0,P=a.length;u<P;u++)this._socketWriter.write(a[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new y(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(s){const a=new y(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime,u=Date.now()-this._socketReader.lastReadTime,P=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&u>=2e4&&P>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:u});return}const D=Math.max(2e4-a,2e4-u,2e4-P,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},D)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,I());this._socketWriter.write(s)}_sendKeepAlive(){const s=new y(9,0,0,I());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(Z[145],ee([0,1,41,18,3,2,46,130]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function l(I,b){const S=k.Event.fromNodeEventEmitter(v.validatedIpcMain,b,(d,y)=>({event:d,message:y})),f=k.Event.filter(S,({event:d})=>d.sender.id===I);return k.Event.map(f,({message:d})=>d&&t.VSBuffer.wrap(d))}class m extends M.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const b=k.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:hello",({sender:S})=>S);return k.Event.map(b,S=>{const f=S.id;m.Clients.get(f)?.dispose();const y=new k.Emitter;m.Clients.set(f,(0,R.toDisposable)(()=>y.fire()));const E=l(f,"vscode:message"),w=k.Event.any(k.Event.signal(l(f,"vscode:disconnect")),y.event);return{protocol:new C.Protocol(S,E),onDidClientDisconnect:w}})}}e.Server=m,m.Clients=new Map}),define(Z[100],ee([0,1,41,3,30,144]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends R.Client{constructor(m,I){super({addEventListener:(b,S)=>m.addListener(b,S),removeEventListener:(b,S)=>m.removeListener(b,S),postMessage:b=>m.postMessage(b),start:()=>m.start(),close:()=>m.close()},I)}}e.Client=M;async function C(l){if(l.isDestroyed()||l.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();l.webContents.send("vscode:createMessageChannel",m);const I=t.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:createMessageChannelResult",(S,f)=>({nonce:f,port:S.ports[0]})),{port:b}=await t.Event.toPromise(t.Event.once(t.Event.filter(I,S=>S.nonce===m)));return b}e.connect=C}),define(Z[146],ee([0,1,45,8,18,22,139,17,3,2,50,82,78,46]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends f.ChannelServer{constructor(w){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},w),process.once("disconnect",()=>this.dispose())}}e.Server=d;class y{constructor(w,g){this.modulePath=w,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new t.Delayer(h),this.child=null,this._client=null}getChannel(w){const g=this;return{call(h,p,c){return g.requestPromise(w,h,p,c)},listen(h,p){return g.requestEvent(w,h,p)}}}requestPromise(w,g,h,p=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(w),n=(0,t.createCancelablePromise)(r=>c.call(g,h,r)),o=p.onCancellationRequested(()=>n.cancel()),i=(0,m.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{o.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(w,g,h){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let p;const c=new l.Emitter({onFirstListenerAdd:()=>{p=this.getCachedChannel(w).listen(g,h)(c.fire,c),this.activeRequests.add(p)},onLastListenerRemove:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,S.removeDangerousEnvVariables)(g.env),this.child=(0,v.fork)(this.modulePath,w,g);const h=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,M.isRemoteConsoleLog)(s)){(0,M.log)(s,`IPC Library: ${this.options.serverName}`);return}h.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const c=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&c.send(s.buffer.toString("base64")),o=h.event,i={send:n,onMessage:o};this._client=new f.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,a)=>{process.removeListener("exit",r),this.activeRequests.forEach(u=>(0,m.dispose)(u)),this.activeRequests.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:a})})}return this._client}getCachedChannel(w){let g=this.channels.get(w);return g||(g=this.client.getChannel(w),this.channels.set(w,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(Z[83],ee([0,1,18,17,3,2,9,4,30,46,99]),function(q,e,v,t,k,R,M,C,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:q.__$__nodeRequire("crypto"),zlib:q.__$__nodeRequire("zlib"),net:q.__$__nodeRequire("net"),os:q.__$__nodeRequire("os")}}class S{constructor(u,P=""){this.debugLabel=P,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}traceSocketEvent(u,P){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const P=D=>{this.traceSocketEvent("read",D),u(v.VSBuffer.wrap(D))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(u){const P=D=>{this.traceSocketEvent("close",{hadError:D}),u({type:0,hadError:D,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(u){const P=()=>{this.traceSocketEvent("nodeEndReceived"),u()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(u){if(!this.socket.destroyed)try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=S;var f;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var d;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(d||(d={}));class y extends R.Disposable{constructor(u,P,D,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:D?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new E(this,P,D,T,this._onData,(N,U)=>this._write(N,U))),this._register(this._flowManager.onError(N=>{console.error(N),(0,t.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(N=>this._onClose.fire(N)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,P){this.socket.traceSocketEvent(u,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._flowManager.writeMessage(u)}_write(u,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let D=2;u.byteLength<126?D+=0:u.byteLength<2**16?D+=2:D+=8;const T=v.VSBuffer.alloc(D);if(P?T.writeUInt8(194,0):T.writeUInt8(130,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let N=1;T.writeUInt8(u.byteLength>>>8&255,++N),T.writeUInt8(u.byteLength>>>0&255,++N)}else{T.writeUInt8(127,1);let N=1;T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(u.byteLength>>>24&255,++N),T.writeUInt8(u.byteLength>>>16&255,++N),T.writeUInt8(u.byteLength>>>8&255,++N),T.writeUInt8(u.byteLength>>>0&255,++N)}this.socket.write(v.VSBuffer.concat([T,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),D=P.readUInt8(0),T=(D&128)>>>7,N=(D&64)>>>6,U=P.readUInt8(1),$=(U&128)>>>7,Y=U&127;this._state.state=2,this._state.readLen=2+($?4:0)+(Y===126?2:0)+(Y===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(N)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),D=P.readUInt8(1),T=(D&128)>>>7;let N=D&127,U=1;N===126?N=P.readUInt8(++U)*2**8+P.readUInt8(++U):N===127&&(N=P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U));let $=0;T&&($=P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U)),this._state.state=3,this._state.readLen=N,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),h(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class E extends R.Disposable{constructor(u,P,D,T,N,U){super(),this._tracer=u,this._onData=N,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new w(this._tracer,T,D,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:v.VSBuffer.alloc(0)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(P,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,P){return new Promise((D,T)=>{u.write(P),u.flush(N=>D(N))})}acceptFrame(u,P,D){this._readQueue.push({data:u,isCompressed:P,isLastFrameOfMessage:D}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1}}_inflateFrame(u,P,D){return new Promise((T,N)=>{u.write(P),D&&u.write(v.VSBuffer.fromByteArray([0,0,255,255])),u.flush(U=>T(U))})}}class w extends R.Disposable{constructor(u,P,D,T){super(),this._tracer=u,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=b().zlib.createInflateRaw(T),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(v.VSBuffer.wrap(N))}),D&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?v.VSBuffer.concat(this._recordedInflateBytes):v.VSBuffer.alloc(0)}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=v.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(P)})}}class g extends R.Disposable{constructor(u,P){super(),this._tracer=u,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=b().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",D=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibDeflate.on("data",D=>{this._tracer.traceSocketEvent("zlibDeflateData",D),this._pendingDeflateData.push(v.VSBuffer.wrap(D))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=v.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),u(P)})}}function h(a,u){if(u===0)return;const P=a.byteLength>>>2;for(let Y=0;Y<P;Y++){const oe=a.readUInt32BE(Y*4);a.writeUInt32BE(oe^u,Y*4)}const D=P*4,T=a.byteLength-D,N=u>>>24&255,U=u>>>16&255,$=u>>>8&255;T>=1&&a.writeUInt8(a.readUInt8(D)^N,D),T>=2&&a.writeUInt8(a.readUInt8(D+1)^U,D+1),T>=3&&a.writeUInt8(a.readUInt8(D+2)^$,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const p={[2]:107,[1]:103};function c(){const a=(0,l.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):u=(0,M.join)(b().os.tmpdir(),`vscode-ipc-${a}.sock`),o(u),u}e.createRandomIPCHandle=c;function n(a,u,P){const D=b().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${P}-${u}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${P}-${u}.sock`):T=(0,M.join)(a,`${P}-${u}.sock`),o(T),T}e.createStaticIPCHandle=n;function o(a){const u=p[C.platform];typeof u=="number"&&a.length>=u&&console.warn(`WARNING: IPC handle "${a}" is longer than ${u} chars, try a shorter --user-data-dir`)}class i extends m.IPCServer{constructor(u){super(i.toClientConnectionEvent(u)),this.server=u}static toClientConnectionEvent(u){const P=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(P,D=>({protocol:new I.Protocol(new S(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function r(a){return new Promise((u,P)=>{const D=b().net.createServer();D.on("error",P),D.listen(a,()=>{D.removeListener("error",P),u(new i(D))})})}e.serve=r;function s(a,u){return new Promise((P,D)=>{const T=b().net.createConnection(a,()=>{T.removeListener("error",D),P(I.Client.fromSocket(new S(T,`ipc-client${u}`),u))});T.once("error",D)})}e.connect=s}),define(Z[101],ee([0,1,8,3,2,12]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function C(b){const S=b;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var l;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(l=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(S,f=Object.create(null)){super(),this.database=S,this.options=f,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((f,d)=>this.accept(d,f)),S.deleted?.forEach(f=>this.accept(f,void 0))}accept(S,f){if(this.state===l.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(f)?d=this.cache.delete(S):this.cache.get(S)!==f&&(this.cache.set(S,f),d=!0),d&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,f){const d=this.cache.get(S);return(0,R.isUndefinedOrNull)(d)?f:d}getBoolean(S,f){const d=this.get(S);return(0,R.isUndefinedOrNull)(d)?f:d==="true"}getNumber(S,f){const d=this.get(S);return(0,R.isUndefinedOrNull)(d)?f:parseInt(d,10)}async set(S,f){if(this.state===l.Closed)return;if((0,R.isUndefinedOrNull)(f))return this.delete(S);const d=String(f);if(this.cache.get(S)!==d)return this.cache.set(S,d),this.pendingInserts.set(S,d),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===l.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((f,d)=>this.items.set(d,f)),S.delete?.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=I}),define(Z[147],ee([0,1,8,3,32,9,23]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class C{constructor(I,b=Object.create(null)){this.path=I,this.options=b,this.name=(0,R.basename)(this.path),this.logger=new l(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const I=await this.whenConnected,b=new Map;return(await this.all(I,"SELECT * FROM ItemTable")).forEach(f=>b.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(I){const b=await this.whenConnected;return this.doUpdateItems(b,I)}doUpdateItems(I,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,k.mapToString)(b.insert):"0"}), delete(${b.delete?(0,k.setToString)(b.delete):"0"})`),this.transaction(I,()=>{const S=b.insert,f=b.delete;if(S&&S.size>0){const d=[];d.push([]);let y=0;S.forEach((E,w)=>{let g=d[y];g.length>C.MAX_HOST_PARAMETERS&&(y++,g=[],d.push(g)),g.push(w,E)}),d.forEach(E=>{this.prepare(I,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,w=>w.run(E),()=>{const w=[];let g=0;return S.forEach((h,p)=>{w.push(p),g+=h.length}),`Keys: ${w.join(", ")} Length: ${g}`})})}if(f&&f.size){const d=[];d.push([]);let y=0;f.forEach(E=>{let w=d[y];w.length>C.MAX_HOST_PARAMETERS&&(y++,w=[],d.push(w)),w.push(E)}),d.forEach(E=>{this.prepare(I,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,w=>w.run(E),()=>{const w=[];return f.forEach(g=>{w.push(g)}),`Keys: ${w.join(", ")}`})})}})}async close(I){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,I)}doClose(I,b){return new Promise((S,f)=>{I.db.close(d=>(d&&this.handleSQLiteError(I,`[storage ${this.name}] close(): ${d}`),this.path===C.IN_MEMORY_PATH?S():!I.isErroneous&&!I.isInMemory?this.backup().then(S,y=>(this.logger.error(`[storage ${this.name}] backup(): ${y}`),S())):typeof b=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(y=>{const E=()=>this.doClose(y,void 0);return this.doUpdateItems(y,{insert:b()}).then(()=>E(),w=>(E(),Promise.reject(w)))})).then(S,f):f(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const I=this.toBackupPath(this.path);return M.Promises.copy(this.path,I,{preserveSymlinks:!1})}toBackupPath(I){return`${I}.backup`}async checkIntegrity(I){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${I})`);const b=await this.whenConnected,S=await this.get(b,I?"PRAGMA integrity_check":"PRAGMA quick_check"),f=I?S.integrity_check:S.quick_check;return b.isErroneous?`${f} (last error: ${b.lastError})`:b.isInMemory?`${f} (in-memory!)`:f}async connect(I,b=!0){this.logger.trace(`[storage ${this.name}] open(${I}, retryOnBusy: ${b})`);try{return await this.doConnect(I)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&b)return await(0,v.timeout)(C.BUSY_OPEN_TIMEOUT),this.connect(I,!1);try{await M.Promises.unlink(I);try{await M.Promises.rename(this.toBackupPath(I),I)}catch{}return await this.doConnect(I)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(C.IN_MEMORY_PATH)}}}handleSQLiteError(I,b){I.isErroneous=!0,I.lastError=b,this.logger.error(b)}doConnect(I){return new Promise((b,S)=>{new Promise((f,d)=>{q(["@vscode/sqlite3"],f,d)}).then(f=>{const d={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(I,y=>y?d.db&&y.code!=="SQLITE_CANTOPEN"?d.db.close(()=>S(y)):S(y):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(d),E=>d.db.close(()=>S(E)))),isInMemory:I===C.IN_MEMORY_PATH};d.db.on("error",y=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${y}`)),this.logger.isTracing&&d.db.on("trace",y=>this.logger.trace(`[storage ${this.name}] Trace (event): ${y}`))},S)})}exec(I,b){return new Promise((S,f)=>{I.db.exec(b,d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] exec(): ${d}`),f(d)):S())})}get(I,b){return new Promise((S,f)=>{I.db.get(b,(d,y)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] get(): ${d}`),f(d)):S(y))})}all(I,b){return new Promise((S,f)=>{I.db.all(b,(d,y)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] all(): ${d}`),f(d)):S(y))})}transaction(I,b){return new Promise((S,f)=>{I.db.serialize(()=>{I.db.run("BEGIN TRANSACTION"),b(),I.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] transaction(): ${d}`),f(d)):S())})})}prepare(I,b,S,f){const d=I.db.prepare(b),y=E=>{this.handleSQLiteError(I,`[storage ${this.name}] prepare(): ${E} (${b}). Details: ${f()}`)};d.on("error",y),S(d),d.finalize(E=>{E&&y(E),d.removeListener("error",y)})}}e.SQLiteStorageDatabase=C,C.IN_MEMORY_PATH=":memory:",C.BUSY_OPEN_TIMEOUT=2e3,C.MAX_HOST_PARAMETERS=256;class l{constructor(I){I&&typeof I.logTrace=="function"&&process.env[l.VSCODE_TRACE_STORAGE]&&(this.logTrace=I.logTrace),I&&typeof I.logError=="function"&&(this.logError=I.logError)}get isTracing(){return!!this.logTrace}trace(I){this.logTrace?.(I)}error(I){this.logError?.(I)}}l.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[148],ee([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(Z[149],ee([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[150],ee([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[151],ee([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(Z[152],ee([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(Z[153],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[154],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[155],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[156],ee([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[157],ee([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[158],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(Z[159],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(Z[160],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(Z[161],ee([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[162],ee([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[163],ee([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[164],ee([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[165],ee([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[166],ee([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(Z[167],ee([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(Z[168],ee([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[169],ee([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[170],ee([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[171],ee([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[172],ee([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[173],ee([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(Z[174],ee([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[175],ee([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[176],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function v(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=v;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(Z[177],ee([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(M){let C=[];try{Array.isArray(M.workspaces)&&(C=M.workspaces.map(l=>({workspace:{id:l.id,configPath:v.URI.parse(l.configURIPath)},remoteAuthority:l.remoteAuthority})))}catch{}return C}e.deserializeWorkspaceInfos=k;function R(M){let C=[];try{Array.isArray(M.folders)&&(C=M.folders.map(l=>({folderUri:v.URI.parse(l.folderUri),remoteAuthority:l.remoteAuthority})))}catch{}return C}e.deserializeFolderInfos=R}),define(Z[178],ee([0,1,3,2]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(C,l,m){switch(l){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(C,l,m){switch(l){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(C){super(),this.channel=C}reload(C){this.channel.call("reload",[C])}get onReload(){return this.channel.listen("reload")}close(C){this.channel.call("close",[C])}get onClose(){return this.channel.listen("close")}attachSession(C,l,m){this.channel.call("attach",[C,l,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(C,l){this.channel.call("terminate",[C,l])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(C,l){return this.channel.call("openExtensionDevelopmentHostWindow",[C,l])}}e.ExtensionHostDebugChannelClient=R}),define(Z[179],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class v{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>q(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=v}),define(Z[180],ee([0,1,133,53,13,9,34,16,7]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(y,E,w){this._args=y,this.paths=E,this.productService=w,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",q).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,C.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return l.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(l.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=M.env.VSCODE_PORTABLE;return y?l.URI.file((0,R.join)(y,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,R.resolve)(y):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,R.resolve)(y):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,R.resolve)(y);const E=M.env.VSCODE_EXTENSIONS;if(E)return E;const w=M.env.VSCODE_PORTABLE;return w?(0,R.join)(w,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(E=>/^[^:/?#]+?:\/\//.test(E)?l.URI.parse(E):l.URI.file((0,R.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?l.URI.parse(y):l.URI.file((0,R.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=M.env.VSCODE_PORTABLE;return y?l.URI.file((0,R.join)(y,"policy.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ve([t.memoize],m.prototype,"appRoot",null),ve([t.memoize],m.prototype,"userHome",null),ve([t.memoize],m.prototype,"userDataPath",null),ve([t.memoize],m.prototype,"appSettingsHome",null),ve([t.memoize],m.prototype,"tmpDir",null),ve([t.memoize],m.prototype,"cacheHome",null),ve([t.memoize],m.prototype,"stateResource",null),ve([t.memoize],m.prototype,"userRoamingDataHome",null),ve([t.memoize],m.prototype,"userDataSyncHome",null),ve([t.memoize],m.prototype,"userDataSyncLogResource",null),ve([t.memoize],m.prototype,"editSessionsLogResource",null),ve([t.memoize],m.prototype,"sync",null),ve([t.memoize],m.prototype,"machineSettingsResource",null),ve([t.memoize],m.prototype,"workspaceStorageHome",null),ve([t.memoize],m.prototype,"localHistoryHome",null),ve([t.memoize],m.prototype,"keyboardLayoutResource",null),ve([t.memoize],m.prototype,"argvResource",null),ve([t.memoize],m.prototype,"isExtensionDevelopment",null),ve([t.memoize],m.prototype,"untitledWorkspacesHome",null),ve([t.memoize],m.prototype,"installSourcePath",null),ve([t.memoize],m.prototype,"builtinExtensionsPath",null),ve([t.memoize],m.prototype,"extensionsPath",null),ve([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],m.prototype,"extensionDevelopmentKind",null),ve([t.memoize],m.prototype,"extensionTestsLocationURI",null),ve([t.memoize],m.prototype,"debugExtensionHost",null),ve([t.memoize],m.prototype,"serviceMachineIdResource",null),ve([t.memoize],m.prototype,"telemetryLogResource",null),ve([t.memoize],m.prototype,"disableWorkspaceTrust",null),ve([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function I(d,y){return f(d["inspect-extensions"],d["inspect-brk-extensions"],5870,y,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=I;function b(d,y){return f(d["inspect-search"],d["inspect-brk-search"],5876,y,d.extensionEnvironment)}e.parseSearchPort=b;function S(d,y){return f(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,y,d.extensionEnvironment)}e.parsePtyHostPort=S;function f(d,y,E,w,g,h){const c=Number(y||d)||(w?null:E),n=c?Boolean(!!y):!1;let o;if(h)try{o=JSON.parse(h)}catch{}return{port:c,break:n,debugId:g,env:o}}}),define(Z[102],ee([0,1,274,4,151]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function C(d,y,E=M){const w={},g=["_"],h=[];for(const o in y){const i=y[o];i.alias&&(w[o]=i.alias),i.type==="string"||i.type==="string[]"?(g.push(o),i.deprecates&&g.push(...i.deprecates)):i.type==="boolean"&&(h.push(o),i.deprecates&&h.push(...i.deprecates))}const p=v(d,{string:g,boolean:h,alias:w}),c={},n=p;c._=p._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in y){const i=y[o];i.alias&&delete n[i.alias];let r=n[o];if(i.deprecates)for(const s of i.deprecates)n.hasOwnProperty(s)&&(r||(r=n[s],r&&E.onDeprecatedOption(s,i.deprecationMessage||(0,k.localize)(35,null,o))),delete n[s]);if(typeof r<"u"){if(i.type==="string[]"){if(Array.isArray(r)||(r=[r]),!i.allowEmptyValue){const s=r.filter(a=>a.length>0);s.length!==r.length&&(E.onEmptyValue(o),r=s.length>0?s:void 0)}}else i.type==="string"&&(Array.isArray(r)?(r=r.pop(),E.onMultipleValues(o,r)):!r&&!i.allowEmptyValue&&(E.onEmptyValue(o),r=void 0));c[o]=r,i.deprecationMessage&&E.onDeprecatedOption(o,i.deprecationMessage)}delete n[o]}for(const o in n)E.onUnknownOption(o);return c}e.parseArgs=C;function l(d,y){let E="";return y.args&&(Array.isArray(y.args)?E=` <${y.args.join("> <")}>`:E=` <${y.args}>`),y.alias?`-${y.alias} --${d}${E}`:`--${d}${E}`}function m(d,y){let E=0;const w=[];for(const c in d){const n=d[c],o=l(c,n);E=Math.max(E,o.length),w.push([o,n.description])}const g=E+2+1;if(y-g<25)return w.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const h=y-g-1,p=[];for(const c of w){const n=c[0],o=b(c[1],h),i=I(g-n.length-2);p.push("  "+n+i+o[0]);for(let r=1;r<o.length;r++)p.push(I(g)+o[r])}return p}e.formatOptions=m;function I(d){return" ".repeat(d)}function b(d,y){const E=[];for(;d.length;){const w=d.length<y?d.length:d.lastIndexOf(" ",y),g=d.slice(0,w).trim();d=d.slice(w),E.push(g)}return E}function S(d,y,E,w,g){const h=process.stdout.isTTY&&process.stdout.columns||80,p=g?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",c=[`${d} ${E}`];c.push(""),c.push(`${(0,k.localize)(37,null)}: ${y} [${(0,k.localize)(38,null)}]${p}`),c.push(""),g?.noPipe!==!0&&(t.isWindows?c.push((0,k.localize)(39,null,y)):c.push((0,k.localize)(40,null,y)),c.push(""));const n={};for(const o in w){const i=w[o];if(i.description&&i.cat){let r=n[i.cat];r||(n[i.cat]=r={}),r[o]=i}}for(const o in n){const i=o,r=n[i];r&&(c.push(R[i]),c.push(...m(r,h)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=S;function f(d,y){return`${d||(0,k.localize)(41,null)}
${y||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=f}),define(Z[181],ee([0,1,77,178,102]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(C,l){super(),this.windowsMainService=C,this.userDataProfilesMainService=l}call(C,l,m){return l==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(C,l,m)}async openExtensionDevelopmentHostWindow(C,l){const m=(0,k.parseArgs)(C,k.OPTIONS);m.debugRenderer=l;const I=m.extensionDevelopmentPath;if(!I)return{success:!1};const b=this.userDataProfilesMainService.checkAndCreateProfileFromCli(m),S=b?await b:void 0,[f]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:m,profile:S});if(!l)return{success:!0};const d=f.win;if(!d)return{success:!0};const y=d.webContents.debugger;let E=y.isAttached()?1/0:0;const w=(0,v.createServer)(g=>{E++===0&&y.attach();let h=!1;const p=o=>{h||g.write(JSON.stringify(o)+"\0")},c=(o,i,r,s)=>p({method:i,params:r,sessionId:s});d.on("close",()=>{y.removeListener("message",c),g.end(),h=!0}),y.addListener("message",c);let n=Buffer.alloc(0);g.on("data",o=>{n=Buffer.concat([n,o]);for(let i=n.indexOf(0);i!==-1;i=n.indexOf(0)){let r;try{const s=n.slice(0,i).toString("utf8");n=n.slice(i+1),r=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}y.sendCommand(r.method,r.params,r.sessionId).then(s=>p({id:r.id,sessionId:r.sessionId,result:s})).catch(s=>p({id:r.id,sessionId:r.sessionId,error:{code:0,message:s.message}}))}}),g.on("error",o=>{console.error("error on cdp pipe:",o)}),g.on("close",()=>{h=!0,--E===0&&y.detach()})});return await new Promise(g=>w.listen(0,g)),d.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[59],ee([0,1,275,152,102]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function M(S,f){const d={onUnknownOption:E=>{console.warn((0,t.localize)(0,null,E))},onMultipleValues:(E,w)=>{console.warn((0,t.localize)(1,null,E,w))},onEmptyValue:E=>{console.warn((0,t.localize)(2,null,E))},onDeprecatedOption:(E,w)=>{console.warn((0,t.localize)(3,null,E,w))}},y=(0,k.parseArgs)(S,k.OPTIONS,f?d:void 0);return y.goto&&y._.forEach(E=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,t.localize)(4,null))),y["max-memory"]&&v(parseInt(y["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),y}function C(S){const f=S.findIndex(d=>!/^-/.test(d));if(f>-1)return[...S.slice(0,f),...S.slice(f+1)]}function l(S){let[,...f]=S;process.env.VSCODE_DEV&&(f=C(f)||[]);const d=!b(process.env);return M(f,d)}e.parseMainProcessArgv=l;function m(S){const[,,...f]=S;return M(f,!0)}e.parseCLIProcessArgv=m;function I(S,...f){const d=S.indexOf("--");return d===-1?S.push(...f):S.splice(d,0,...f),S}e.addArg=I;function b(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function q(e,v,t,k){function R(C){const l=M(C),m=[l];return e.isAbsolute(l)||m.unshift(k),e.resolve(...m)}function M(C){const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,t);const I=C["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(b,"AppData","Roaming")}break;case"darwin":m=e.join(v.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,t)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[182],ee([0,183,29,13,16,34]),function(e,v,t,k,R,M){const C=R.dirname(k.FileAccess.asFileUri("",e)),l=e.__$__nodeRequire(R.joinPath(C,"package.json").fsPath);return q(v,t,l.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),t=require("os");module.exports=q(v,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[184],ee([0,1,29,180,182]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(C,l){super(C,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,k.getUserDataPath)(C)},l)}}e.NativeEnvironmentService=R}),define(Z[185],ee([0,1,28,29,31]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(M){const C=(0,k.randomPath)((0,t.tmpdir)());try{return(0,v.writeFileSync)(C,""),M&&console.log(`Marker file for --wait created: ${C}`),C}catch(l){M&&console.error(`Failed to create marker file for --wait: ${l}`);return}}e.createWaitMarkerFile=R}),define(Z[186],ee([0,1,12,154]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(M,C,l){try{R(M,C,l)}catch{}return M}e.localizeManifest=k;function R(M,C,l){const m=(I,b,S)=>{const f=I[b];if((0,v.isString)(f)){const d=f,y=d.length;if(y>1&&d[0]==="%"&&d[y-1]==="%"){const E=d.substr(1,y-2);let w=C[E];w===void 0&&l&&(w=l[E]);const g=typeof w=="string"?w:w.message;if(g!==void 0){const h=l?.[E],p=typeof h=="string"?h:h?.message;if(S&&(b==="title"||b==="category")&&p&&p!==g){const c={value:g,original:p};I[b]=c}else I[b]=g}else console.warn(`[${M.name}]: ${(0,t.localize)(0,null,E)}`)}}else if((0,v.isObject)(f))for(const d in f)f.hasOwnProperty(d)&&(d==="commands"?m(f,d,!0):m(f,d,S));else if(Array.isArray(f))for(let d=0;d<f.length;d++)m(f,d,S)};for(const I in M)M.hasOwnProperty(I)&&m(M,I)}}),define(Z[187],ee([0,1,16,95,156,188]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function l(w){return w=w.trim(),w==="*"||M.test(w)}e.isValidVersionStr=l;function m(w){if(!l(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=w.match(M);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=m;function I(w){if(!w)return null;const g=w.majorBase,h=w.majorMustEqual,p=w.minorBase;let c=w.minorMustEqual;const n=w.patchBase;let o=w.patchMustEqual;w.hasCaret&&(g===0||(c=!1),o=!1);let i=0;if(w.preRelease){const r=C.exec(w.preRelease);if(r){const[,s,a,u]=r;i=Date.UTC(Number(s),Number(a)-1,Number(u))}}return{majorBase:g,majorMustEqual:h,minorBase:p,minorMustEqual:c,patchBase:n,patchMustEqual:o,isMinimum:w.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function b(w,g,h){let p;typeof w=="string"?p=I(m(w)):p=w;let c;g instanceof Date?c=g.getTime():typeof g=="string"&&(c=new Date(g).getTime());let n;if(typeof h=="string"?n=I(m(h)):n=h,!p||!n)return!1;const o=p.majorBase,i=p.minorBase,r=p.patchBase;let s=n.majorBase,a=n.minorBase,u=n.patchBase;const P=n.notBefore;let D=n.majorMustEqual,T=n.minorMustEqual,N=n.patchMustEqual;return n.isMinimum?o>s?!0:o<s?!1:i>a?!0:i<a||c&&c<P?!1:r>=u:(o===1&&s===0&&(!D||!T||!N)&&(s=1,a=0,u=0,D=!0,T=!1,N=!1),o<s?!1:o>s?!D:i<a?!1:i>a?!T:r<u?!1:r>u?!N:!(c&&c<P))}e.isValidVersion=b;function S(w,g,h,p,c){const n=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return n.push([t.default.Error,k.localize(0,null)]),n;if(typeof p.name!="string")return n.push([t.default.Error,k.localize(1,null,"name")]),n;if(typeof p.version!="string")return n.push([t.default.Error,k.localize(2,null,"version")]),n;if(!p.engines)return n.push([t.default.Error,k.localize(3,null,"engines")]),n;if(typeof p.engines.vscode!="string")return n.push([t.default.Error,k.localize(4,null,"engines.vscode")]),n;if(typeof p.extensionDependencies<"u"&&!E(p.extensionDependencies))return n.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),n;if(typeof p.activationEvents<"u"){if(!E(p.activationEvents))return n.push([t.default.Error,k.localize(6,null,"activationEvents")]),n;if(typeof p.main>"u"&&typeof p.browser>"u")return n.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),n}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&n.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return n.push([t.default.Error,k.localize(9,null,"main")]),n;{const r=(0,v.joinPath)(h,p.main);(0,v.isEqualOrParent)(r,h)||n.push([t.default.Warning,k.localize(10,null,r.path,h.path)])}if(typeof p.activationEvents>"u")return n.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),n}if(typeof p.browser<"u"){if(typeof p.browser!="string")return n.push([t.default.Error,k.localize(12,null,"browser")]),n;{const r=(0,v.joinPath)(h,p.browser);(0,v.isEqualOrParent)(r,h)||n.push([t.default.Warning,k.localize(13,null,r.path,h.path)])}if(typeof p.activationEvents>"u")return n.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),n}if(!R.valid(p.version))return n.push([t.default.Error,k.localize(15,null)]),n;const o=[];if(!f(w,g,p,c,o))for(const r of o)n.push([t.default.Error,r]);return n}e.validateExtensionManifest=S;function f(w,g,h,p,c){return p||typeof h.main>"u"&&typeof h.browser>"u"?!0:y(w,g,h.engines.vscode,c)}e.isValidExtensionVersion=f;function d(w,g,h){return w==="*"||y(g,h,w)}e.isEngineValid=d;function y(w,g,h,p=[]){const c=I(m(h));if(!c)return p.push(k.localize(16,null,h)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return p.push(k.localize(17,null,h)),!1}else if(!c.majorMustEqual)return p.push(k.localize(18,null,h)),!1;return b(w,g,c)?!0:(p.push(k.localize(19,null,w,h)),!1)}function E(w){if(!Array.isArray(w))return!1;for(let g=0,h=w.length;g<h;g++)if(typeof w[g]!="string")return!1;return!0}}),define(Z[189],ee([0,1,18,30]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,M,C){let l=C&&C.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const I=(await M.readFile(R.serviceMachineIdResource)).value.toString();l=(0,t.isUUID)(I)?I:null}catch{l=null}if(!l){l=(0,t.generateUuid)();try{await M.writeFile(R.serviceMachineIdResource,v.VSBuffer.fromString(l))}catch{}}return C?.store("storage.serviceMachineId",l,-1,1),l}e.getServiceMachineId=k}),define(Z[68],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(k,R=[],M=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=v}),define(Z[190],ee([0,1,68]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(C,l,m){l instanceof v.SyncDescriptor||(l=new v.SyncDescriptor(l,[],Boolean(m))),t.push([C,l])}e.registerSingleton=R;function M(){return t}e.getSingletonServiceDescriptors=M}),define(Z[191],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=v;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const M of this._nodes.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const C=this.lookupOrInsertNode(R),l=this.lookupOrInsertNode(M);C.outgoing.set(l.key,l),l.incoming.set(C.key,C)}removeNode(R){const M=this._hashFn(R);this._nodes.delete(M);for(const C of this._nodes.values())C.outgoing.delete(M),C.incoming.delete(M)}lookupOrInsertNode(R){const M=this._hashFn(R);let C=this._nodes.get(M);return C||(C=new v(M,R),this._nodes.set(M,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[M,C]of this._nodes)R.push(`${M}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this._nodes){const C=new Set([R]),l=this._findCycle(M,C);if(l)return l}}_findCycle(R,M){for(const[C,l]of R.outgoing){if(M.has(C))return[...M,C].join(" -> ");M.add(C);const m=this._findCycle(l,M);if(m)return m;M.delete(C)}}}e.Graph=t}),define(Z[5],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function C(l){return l[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=C})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(M,C,l){C[v.DI_TARGET]===C?C[v.DI_DEPENDENCIES].push({id:M,index:l}):(C[v.DI_DEPENDENCIES]=[{id:M,index:l}],C[v.DI_TARGET]=C)}function k(M){if(v.serviceIds.has(M))return v.serviceIds.get(M);const C=function(l,m,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(C,l,I)};return C.toString=()=>M,v.serviceIds.set(M,C),C}e.createDecorator=k;function R(M){return M}e.refineServiceDecorator=R}),define(Z[60],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(Z[19],ee([0,1,12,7,5]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationOverrides=R;function M(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||Array.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var C;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.USER=2]="USER",w[w.USER_LOCAL=3]="USER_LOCAL",w[w.USER_REMOTE=4]="USER_REMOTE",w[w.WORKSPACE=5]="WORKSPACE",w[w.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",w[w.DEFAULT=7]="DEFAULT",w[w.MEMORY=8]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function l(w){switch(w){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=l;function m(w,g){const h=Object.create(null);for(const p in w)I(h,p,w[p],g);return h}e.toValuesTree=m;function I(w,g,h,p){const c=g.split("."),n=c.pop();let o=w;for(let i=0;i<c.length;i++){const r=c[i];let s=o[r];switch(typeof s){case"undefined":s=o[r]=Object.create(null);break;case"object":break;default:p(`Ignoring ${g} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[n]=h}catch{p(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=I;function b(w,g){const h=g.split(".");S(w,h)}e.removeFromValueTree=b;function S(w,g){const h=g.shift();if(g.length===0){delete w[h];return}if(Object.keys(w).indexOf(h)!==-1){const p=w[h];typeof p=="object"&&!Array.isArray(p)&&(S(p,g),Object.keys(p).length===0&&delete w[h])}}function f(w,g,h){function p(o,i){let r=o;for(const s of i){if(typeof r!="object"||r===null)return;r=r[s]}return r}const c=g.split("."),n=p(w,c);return typeof n>"u"?h:n}e.getConfigurationValue=f;function d(w,g,h){Object.keys(g).forEach(p=>{p!=="__proto__"&&(p in w?v.isObject(w[p])&&v.isObject(g[p])?d(w[p],g[p],h):h&&(w[p]=g[p]):w[p]=g[p])})}e.merge=d;function y(w,g,h){const p=w.inspect(g),c=w.inspect(h);return typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:p.defaultValue}e.getMigratedSettingValue=y;function E(w){return w.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Z[69],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,M){return this.secretVault[R]?.[M]??null}async setPassword(R,M,C){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][M]=C}async deletePassword(R,M){return this.secretVault[R]?.[M]?(delete this.secretVault[R][M],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const M=[];for(const C of Object.keys(this.secretVault[R]||{}))M.push({account:C,password:this.secretVault[R][C]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(Z[84],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(M,C){return{}}async getSystemInfo(M,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,C){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=k}),define(Z[103],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(Z[36],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[26],ee([0,1,53,9,83,36,184,5]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,C.refineServiceDecorator)(R.IEnvironmentService);class l extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([v.memoize],l.prototype,"cachedLanguagesPath",null),ve([v.memoize],l.prototype,"backupHome",null),ve([v.memoize],l.prototype,"mainIPCHandle",null),ve([v.memoize],l.prototype,"mainLockfile",null),ve([v.memoize],l.prototype,"disableUpdates",null),ve([v.memoize],l.prototype,"disableKeytar",null),ve([v.memoize],l.prototype,"crossOriginIsolated",null),ve([v.memoize],l.prototype,"codeCachePath",null),ve([v.memoize],l.prototype,"useCodeCache",null),e.EnvironmentMainService=l}),define(Z[192],ee([0,1,153,5]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(w){switch(w){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(w){switch(w){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function M(w,g){switch(w){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function C(w,g){return g==="web"&&!w.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function l(w,g,h){return C(g,h)?!1:w==="undefined"||w==="universal"?!0:w==="unknown"?!1:w===h?!0:m(h).includes(w)}e.isTargetPlatformCompatible=l;function m(w){switch(w){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function I(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=I;var b;(function(w){w[w.NoneOrRelevance=0]="NoneOrRelevance",w[w.LastUpdatedDate=1]="LastUpdatedDate",w[w.Title=2]="Title",w[w.PublisherName=3]="PublisherName",w[w.InstallCount=4]="InstallCount",w[w.PublishedDate=10]="PublishedDate",w[w.AverageRating=6]="AverageRating",w[w.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var S;(function(w){w[w.Default=0]="Default",w[w.Ascending=1]="Ascending",w[w.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var f;(function(w){w.Install="install",w.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var d;(function(w){w[w.None=1]="None",w[w.Install=2]="Install",w[w.Update=3]="Update",w[w.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var y;(function(w){w.Unsupported="Unsupported",w.Deprecated="Deprecated",w.Malicious="Malicious",w.Incompatible="Incompatible",w.IncompatiblePreRelease="IncompatiblePreRelease",w.IncompatibleTargetPlatform="IncompatibleTargetPlatform",w.ReleaseVersionNotFound="ReleaseVersionNotFound",w.Invalid="Invalid",w.Download="Download",w.Extract="Extract",w.Delete="Delete",w.Rename="Rename",w.CorruptZip="CorruptZip",w.IncompleteZip="IncompleteZip",w.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(g,h){super(g),this.code=h,this.name=h}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[193],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Z[194],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[104],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Z[195],ee([0,1,45,13,9,4,78,23,82,157,104]),function(q,e,v,t,k,R,M,C,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=m.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends S{openTerminal(p,c){return this.spawnTerminal(v,p,l.getWindowsShell(),c)}spawnTerminal(p,c,n,o){const i=c.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const r=k.basename(i).toLowerCase();if(r==="cmder"||r==="cmder.exe")return p.spawn(i,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return i.indexOf(" ")>=0&&s.push('""'),s.push(i),(r==="wt"||r==="wt.exe")&&s.push("-d ."),new Promise((a,u)=>{const P=E(process),D=p.spawn(n,s,{cwd:o,env:P});D.on("error",u),D.on("exit",()=>a())})}runInTerminal(p,c,n,o,i){const r="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows();return new Promise((s,a)=>{const u=`"${c} - ${b}"`,P=`""${n.join('" "')}" & pause"`,D=["/c","start",u,"/wait",r,"/c",P],T=Object.assign({},E(process),o);Object.keys(T).filter($=>T[$]===null).forEach($=>delete T[$]);const N={cwd:c,env:T,windowsVerbatimArguments:!0};v.spawn(f.CMD,D,N).on("error",$=>{a(w($))}),s(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class d extends S{openTerminal(p,c){return this.spawnTerminal(v,p,c)}runInTerminal(p,c,n,o,i){const r=i.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{if(r===I.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const u=r===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,q).fsPath,"-t",p||b,"-w",c];for(const U of n)D.push("-a"),D.push(U);if(o){const U=Object.assign({},E(process),o);for(const $ in U){const Y=U[$];Y===null?(D.push("-u"),D.push($)):(D.push("-e"),D.push(`${$}=${Y}`))}}let T="";const N=v.spawn(d.OSASCRIPT,D);N.on("error",U=>{a(w(U))}),N.stderr.on("data",U=>{T+=U.toString()}),N.on("exit",U=>{if(U===0)s(void 0);else if(T){const $=T.split(`
`,1);a(new Error($[0]))}else a(new Error(m.localize(1,null,u,U)))})}else a(new Error(m.localize(2,null,r)))})}spawnTerminal(p,c,n){const o=c.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((i,r)=>{const s=["-a",o];n&&s.push(n);const a=E(process),u=p.spawn("/usr/bin/open",s,{cwd:n,env:a});u.on("error",r),u.on("exit",()=>i())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class y extends S{openTerminal(p,c){return this.spawnTerminal(v,p,c)}runInTerminal(p,c,n,o,i){const r=i.linuxExec?Promise.resolve(i.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{const u=[];r.then(P=>{P.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const D=`${g(n)}; echo; read -p "${y.WAIT_MESSAGE}" -n1;`;u.push(`''${D}''`);const T=Object.assign({},E(process),o);Object.keys(T).filter(Y=>T[Y]===null).forEach(Y=>delete T[Y]);const N={cwd:c,env:T};let U="";const $=v.spawn(P,u,N);$.on("error",Y=>{a(w(Y))}),$.stderr.on("data",Y=>{U+=Y.toString()}),$.on("exit",Y=>{if(Y===0)s(void 0);else if(U){const oe=U.split(`
`,1);a(new Error(oe[0]))}else a(new Error(m.localize(4,null,P,Y)))})})})}static async getDefaultTerminalLinuxReady(){if(!y._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)y._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const p=await C.Promises.exists("/etc/debian_version");y._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{p?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return y._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(p,c,n){const o=c.linuxExec?Promise.resolve(c.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((i,r)=>{o.then(s=>{const a=E(process),u=p.spawn(s,[],{cwd:n,env:a});u.on("error",r),u.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=y,y.WAIT_MESSAGE=m.localize(3,null);function E(h){const p={...h.env};return(0,M.sanitizeProcessEnvironment)(p),p}function w(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(m.localize(5,null,h.path)):h}function g(h){let p="";for(const c of h)c.indexOf(" ")>=0?p+='"'+c+'"':p+=c,p+=" ";return p}}),define(Z[14],ee([0,1,32,9,25,12,7,159,5]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,l.createDecorator)("fileService");function m(G){return G.create===!0}e.isFileOpenForWriteOptions=m;var I;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var b;(function(G){G[G.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var S;(function(G){G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(G){return!!(G.capabilities&2)}e.hasReadWriteCapability=f;function d(G){return!!(G.capabilities&8)}e.hasFileFolderCopyCapability=d;function y(G){return!!(G.capabilities&32768)}e.hasFileCloneCapability=y;function E(G){return!!(G.capabilities&4)}e.hasOpenReadWriteCloseCapability=E;function w(G){return!!(G.capabilities&16)}e.hasFileReadStreamCapability=w;function g(G){return f(G)?!!(G.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var h;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(h=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(K,F){super(K),this.code=F}}e.FileSystemProviderError=p;function c(G,K){const F=new p(G.toString(),K);return o(F,K),F}e.createFileSystemProviderError=c;function n(G){return G||c((0,C.localize)(0,null),h.Unknown)}e.ensureFileSystemProviderError=n;function o(G,K){return G.name=K?`${K} (FileSystemError)`:"FileSystemError",G}e.markAsFileSystemProviderError=o;function i(G){if(!G)return h.Unknown;if(G instanceof p)return G.code;const K=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!K)return h.Unknown;switch(K[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileExceedsMemoryLimit:return h.FileExceedsMemoryLimit;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}e.toFileSystemProviderErrorCode=i;function r(G){if(G instanceof T)return G.fileOperationResult;switch(i(G)){case h.FileNotFound:return 1;case h.FileIsADirectory:return 0;case h.FileNotADirectory:return 10;case h.FileWriteLocked:return 5;case h.NoPermissions:return 6;case h.FileExists:return 4;case h.FileExceedsMemoryLimit:return 9;case h.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(K,F,A){this.resource=K,this.operation=F,this.target=A}isOperation(K){return this.operation===K}}e.FileOperationEvent=a;var u;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class P{constructor(K,F){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=K;const A=new Map;for(const W of K){const z=A.get(W.type);switch(z?z.push([W.resource,W]):A.set(W.type,[[W.resource,W]]),W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}}for(const[W,z]of A)switch(W){case 1:this.added=v.TernarySearchTree.forUris(()=>F),this.added.fill(z);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>F),this.updated.fill(z);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>F),this.deleted.fill(z);break}}contains(K,...F){return this.doContains(K,{includeChildren:!1},...F)}affects(K,...F){return this.doContains(K,{includeChildren:!0},...F)}doContains(K,F,...A){if(!K)return!1;const W=A.length>0;return!!((!W||A.includes(1))&&(this.added?.get(K)||F.includeChildren&&this.added?.findSuperstr(K))||(!W||A.includes(0))&&(this.updated?.get(K)||F.includeChildren&&this.updated?.findSuperstr(K))||(!W||A.includes(2))&&(this.deleted?.findSubstr(K)||F.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=P;function D(G,K,F){return!G||!K||G===K||K.length>G.length?!1:(K.charAt(K.length-1)!==t.sep&&(K+=t.sep),F?(0,k.startsWithIgnoreCase)(G,K):G.indexOf(K)===0)}e.isParent=D;class T extends Error{constructor(K,F,A){super(K),this.fileOperationResult=F,this.options=A}}e.FileOperationError=T;class N extends T{constructor(K,F,A){super(K,2,A),this.stat=F}}e.NotModifiedSinceFileOperationError=N;var U;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",G[G.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})($=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Y(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}e.etag=Y;async function oe(G,K){if(!K.hasProvider(M.URI.from({scheme:G.scheme})))return new Promise(F=>{const A=K.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===G.scheme&&W.added&&(A.dispose(),F())})})}e.whenProviderRegistered=oe,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ue{static formatSize(K){return(0,R.isNumber)(K)||(K=0),K<ue.KB?(0,C.localize)(1,null,K.toFixed(0)):K<ue.MB?(0,C.localize)(2,null,(K/ue.KB).toFixed(2)):K<ue.GB?(0,C.localize)(3,null,(K/ue.MB).toFixed(2)):K<ue.TB?(0,C.localize)(4,null,(K/ue.GB).toFixed(2)):(0,C.localize)(5,null,(K/ue.TB).toFixed(2))}}e.ByteSize=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;var se;(function(G){G[G.IA32=0]="IA32",G[G.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function de(G){return{maxFileSize:G===0?300*ue.MB:16*ue.GB,maxHeapSize:G===0?700*ue.MB:2*700*ue.MB}}e.getPlatformLimits=de}),define(Z[196],ee([0,1,18,44,17,3,2,58,7,30,14]),function(q,e,v,t,k,R,M,C,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends M.Disposable{constructor(f,d){super(),this.channel=f,this.extraCapabilities=d,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,d){const{buffer:y}=await this.channel.call("readFile",[f,d]);return y}readFileStream(f,d,y){const E=(0,C.newWriteableStream)(g=>v.VSBuffer.concat(g.map(h=>v.VSBuffer.wrap(h))).buffer),w=this.channel.listen("readFileStream",[f,d])(g=>{if(g instanceof v.VSBuffer)E.write(g.buffer);else{if(g==="end")E.end();else{let h=g;h instanceof Error||(h=(0,I.createFileSystemProviderError)((0,t.toErrorMessage)(h),I.FileSystemProviderErrorCode.Unknown)),E.error(h),E.end()}w.dispose()}});return y.onCancellationRequested(()=>{E.error((0,k.canceled)()),E.end(),w.dispose()}),E}writeFile(f,d,y){return this.channel.call("writeFile",[f,v.VSBuffer.wrap(d),y])}open(f,d){return this.channel.call("open",[f,d])}close(f){return this.channel.call("close",[f])}async read(f,d,y,E,w){const[g,h]=await this.channel.call("read",[f,d,w]);return y.set(g.buffer.slice(0,h),E),h}write(f,d,y,E,w){return this.channel.call("write",[f,d,v.VSBuffer.wrap(y),E,w])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,d){return this.channel.call("delete",[f,d])}rename(f,d,y){return this.channel.call("rename",[f,d,y])}copy(f,d,y){return this.channel.call("copy",[f,d,y])}cloneFile(f,d){return this.channel.call("cloneFile",[f,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const d=f;this._onDidChange.fire(d.map(y=>({resource:l.URI.revive(y.resource),type:y.type})))}else{const d=f;this._onDidWatchError.fire(d)}}))}watch(f,d){const y=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,y,f,d]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=b}),define(Z[105],ee([0,1,18,17,160,14]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(I,b,S,f,d,y){let E;try{await C(I,b,S,f,d,y)}catch(w){E=w}finally{E&&d.errorTransformer&&(E=d.errorTransformer(E)),typeof E<"u"&&S.error(E),S.end()}}e.readFileIntoStream=M;async function C(I,b,S,f,d,y){l(y);const E=await I.open(b,{create:!1});try{l(y);let w=0,g=0,h=d&&typeof d.length=="number"?d.length:void 0,p=v.VSBuffer.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,n=0;do g=await I.read(E,c,p.buffer,n,p.byteLength-n),c+=g,n+=g,w+=g,typeof h=="number"&&(h-=g),n===p.byteLength&&(await S.write(f(p)),p=v.VSBuffer.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),n=0);while(g>0&&(typeof h!="number"||h>0)&&l(y)&&m(w,d));if(n>0){let o=n;typeof h=="number"&&(o=Math.min(n,h)),S.write(f(p.slice(0,o)))}}catch(w){throw(0,R.ensureFileSystemProviderError)(w)}finally{await I.close(E)}}function l(I){if(I.isCancellationRequested)throw(0,t.canceled)();return!0}function m(I,b){if(b?.limits){if(typeof b.limits.memory=="number"&&I>b.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&I>b.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[70],ee([0,1,96,2,9,4,7,14]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function l(w){return w.recursive===!0}e.isRecursiveWatchRequest=l;class m extends t.Disposable{constructor(g,h,p,c){super(),this.onFileChanges=g,this.onLogMessage=h,this.verboseLogging=p,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new t.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),g.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),g.add(this.watcher.onDidError(h=>this.onError(h)))}onError(g){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class I extends m{constructor(g,h,p){super(g,h,p,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class b extends m{constructor(g,h,p){super(g,h,p,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function S(w){return w.map(g=>({type:g.type,resource:M.URI.file(g.path)}))}e.toFileChanges=S;function f(w){const g=new E;for(const h of w)g.processEvent(h);return g.coalesce()}e.coalesceEvents=f;function d(w,g){return typeof g=="string"&&!g.startsWith(v.GLOBSTAR)&&!(0,k.isAbsolute)(g)?{base:w,pattern:g}:g}e.normalizeWatcherPattern=d;function y(w,g){const h=[];for(const p of g)h.push((0,v.parse)(d(w,p)));return h}e.parseWatcherPatterns=y;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return R.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const h=this.mapPathToChange.get(this.toKey(g));let p=!1;if(h){const c=h.type,n=g.type;h.path!==g.path&&(g.type===2||g.type===1)?p=!0:c===1&&n===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(h)):c===2&&n===1?h.type=0:c===1&&n===0||(h.type=n)}else p=!0;p&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],h=[];return Array.from(this.coalesced).filter(p=>p.type!==2?(g.push(p),!1):!0).sort((p,c)=>p.path.length-c.path.length).filter(p=>h.some(c=>(0,C.isParent)(p.path,c,!R.isLinux))?!1:(h.push(p.path),!0)).concat(g)}}}),define(Z[197],ee([0,1,28,8,22,31,2,80,9,4,97,23,70]),function(q,e,v,t,k,R,M,C,l,m,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends M.Disposable{constructor(E,w,g,h){super(),this.request=E,this.onDidFilesChange=w,this.onLogMessage=g,this.verboseLogging=h,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.onDidFilesChange(p)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(f.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const E=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await b.Promises.stat(E);this._register(await this.doWatch(E,w.isDirectory()))}catch(E){E.code!=="ENOENT"?this.error(E):this.trace(E)}}async normalizePath(E){let w=E.path;try{w=await b.Promises.realpath(E.path),E.path===w&&(w=await(0,I.realcase)(E.path)??E.path),E.path!==w&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${E.path}, real: ${w})`)}catch{}return w}async doWatch(E,w){if(m.isMacintosh&&(0,R.isEqualOrParent)(E,"/Volumes/",!0))return this.error(`Refusing to watch ${E} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const g=new k.CancellationTokenSource(this.cts.token),h=new M.DisposableStore;try{const p=(0,l.basename)(E),c=(0,v.watch)(E);h.add((0,M.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${E}'`);const n=new Set;if(w)try{for(const i of await b.Promises.readdir(E))n.add(i)}catch(i){this.error(i)}const o=new Map;h.add((0,M.toDisposable)(()=>{for(const[,i]of o)i.dispose();o.clear()})),c.on("error",(i,r)=>{this.error(`Failed to watch ${E} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),c.on("change",(i,r)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let s="";if(r&&(s=r.toString(),m.isMacintosh&&(s=(0,C.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(w)if(i==="rename"){o.get(s)?.dispose();const a=setTimeout(async()=>{if(o.delete(s),s===p&&!await b.Promises.exists(E)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,l.join)(E,s));if(g.token.isCancellationRequested)return;let P;u?n.has(s)?P=0:(P=1,n.add(s)):(n.delete(s),P=2),this.onFileChange({path:(0,l.join)(this.request.path,s),type:P})},f.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,M.toDisposable)(()=>clearTimeout(a)))}else{let a;n.has(s)?a=0:(a=1,n.add(s)),this.onFileChange({path:(0,l.join)(this.request.path,s),type:a})}else if(i==="rename"||s!==p){const a=setTimeout(async()=>{const u=await b.Promises.exists(E);g.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),h.add(await this.doWatch(E,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);h.clear(),h.add((0,M.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(p){await b.Promises.exists(E)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${E} for changes using fs.watch() (${p.toString()})`)}return(0,M.toDisposable)(()=>{g.dispose(!0),h.dispose()})}async onFileChange(E,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),!w&&this.excludes.some(g=>g(E.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${E.path}`):!w&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(E.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${E.path}`):this.fileChangesBuffer.push(E);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const h=(0,S.coalesceEvents)(g);if(h.length>0){if(this.verboseLogging)for(const c of h)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(h)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(E){if(m.isLinux)return b.Promises.exists(E);try{const w=(0,l.basename)(E);return(await b.Promises.readdir((0,l.dirname)(E))).some(h=>h===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(E){this.verboseLogging=E}error(E){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${E}`})}warn(E){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${E}`})}trace(E){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.FILE_DELETE_HANDLER_DELAY=100,f.FILE_CHANGES_HANDLER_DELAY=50;async function d(y,E,w,g,h=512){const p=await b.Promises.open(y,"r"),c=Buffer.allocUnsafe(h),n=new k.CancellationTokenSource(g);let o,i=!1;const r={path:y,excludes:[],recursive:!1},s=new f(r,a=>{(async()=>{for(const{type:u}of a)if(u===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:P}=await b.Promises.read(p,c,0,h,null);if(!P||n.token.isCancellationRequested)break;E(c.slice(0,P))}}catch(P){o=new Error(P),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,w(),new Promise((a,u)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await b.Promises.close(p)}catch(P){o=new Error(P)}o?u(o):a()})})}e.watchFileContents=d}),define(Z[198],ee([0,1,3,96,2,4,197]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class C extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const I=this.normalizeRequests(m),b=I.filter(f=>{const d=this.watchers.get(f.path);return d?!(0,t.patternsEquals)(d.request.excludes,f.excludes)||!(0,t.patternsEquals)(d.request.includes,f.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:f})=>!I.find(d=>d.path===f.path&&(0,t.patternsEquals)(d.excludes,f.excludes)&&(0,t.patternsEquals)(d.includes,f.includes))).map(({request:f})=>f.path);b.length&&this.trace(`Request to start watching: ${b.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const f of S)this.stopWatching(f);for(const f of b)this.startWatching(f)}startWatching(m){const I=new M.NodeJSFileWatcherLibrary(m,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),b={request:m,instance:I};this.watchers.set(m.path,b)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const I=this.watchers.get(m);I&&(this.watchers.delete(m),I.instance.dispose())}normalizeRequests(m){const I=new Map;for(const b of m){const S=R.isLinux?b.path:b.path.toLowerCase();I.set(S,b)}return Array.from(I.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,I]of this.watchers)I.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,I){return I?`[File Watcher (node.js)] ${m} (path: ${I.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=C}),define(Z[199],ee([0,1,70,198]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends v.AbstractNonRecursiveWatcherClient{constructor(M,C,l){super(M,C,l),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Z[200],ee([0,1,13,46,146,70]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends R.AbstractUniversalWatcherClient{constructor(l,m,I){super(l,m,I),this.init()}createWatcher(l){const m=l.add(new k.Client(v.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(m.onDidProcessExit(({code:I,signal:b})=>this.onError(`terminated by itself with code ${I}, signal: ${b}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(Z[85],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(const[R,M]of k)this.set(R,M)}set(k,R){const M=this._entries.get(k);return this._entries.set(k,R),M}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(Z[201],ee([0,1,8,17,68,191,5,85]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const l=!1;class m extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class I{constructor(d=new C.ServiceCollection,y=!1,E){this._activeInstantiations=new Set,this._services=d,this._strict=y,this._parent=E,this._services.set(M.IInstantiationService,this)}createChild(d){return new I(d,this._strict,this)}invokeFunction(d,...y){const E=S.traceInvocation(d);let w=!1;try{return d({get:h=>{if(w)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(h,E);if(!p)throw new Error(`[invokeFunction] unknown service '${h}'`);return p}},...y)}finally{w=!0,E.stop()}}createInstance(d,...y){let E,w;return d instanceof k.SyncDescriptor?(E=S.traceCreation(d.ctor),w=this._createInstance(d.ctor,d.staticArguments.concat(y),E)):(E=S.traceCreation(d),w=this._createInstance(d,y,E)),E.stop(),w}_createInstance(d,y=[],E){const w=M._util.getServiceDependencies(d).sort((p,c)=>p.index-c.index),g=[];for(const p of w){const c=this._getOrCreateServiceInstance(p.id,E);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${p.id}.`,!1),g.push(c)}const h=w.length>0?w[0].index:y.length;if(y.length!==h){console.trace(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${y.length} static arguments`);const p=h-y.length;p>0?y=y.concat(new Array(p)):y=y.slice(0,h)}return new d(...y,...g)}_setServiceInstance(d,y){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,y);else if(this._parent)this._parent._setServiceInstance(d,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const y=this._services.get(d);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):y}_getOrCreateServiceInstance(d,y){const E=this._getServiceInstanceOrDescriptor(d);return E instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,E,y.branch(d,!0)):(y.branch(d,!1),E)}_safeCreateAndCacheServiceInstance(d,y,E){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,y,E)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,y,E){const w=new R.Graph(p=>p.id.toString());let g=0;const h=[{id:d,desc:y,_trace:E}];for(;h.length;){const p=h.pop();if(w.lookupOrInsertNode(p),g++>1e3)throw new m(w);for(const c of M._util.getServiceDependencies(p.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(c.id);if(n||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),n instanceof k.SyncDescriptor){const o={id:c.id,desc:n,_trace:p._trace.branch(c.id,!0)};w.insertEdge(p,o),h.push(o)}}}for(;;){const p=w.roots();if(p.length===0){if(!w.isEmpty())throw new m(w);break}for(const{data:c}of p){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const o=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,o)}w.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,y,E=[],w,g){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(y,E,w,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,y,E,w,g);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(d,y=[],E,w){if(E){const g=new v.IdleValue(()=>this._createInstance(d,y,w));return new Proxy(Object.create(null),{get(h,p){if(p in h)return h[p];const c=g.value;let n=c[p];return typeof n!="function"||(n=n.bind(c),h[p]=n),n},set(h,p,c){return g.value[p]=c,!0}})}else return this._createInstance(d,y,w)}_throwIfStrict(d,y){if(y&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=I;var b;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(b||(b={}));class S{constructor(d,y){this.type=d,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return l?new S(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(d){return l?new S(0,d.name):S._None}branch(d,y){const E=new S(2,d.toString());return this._dep.push([d,y,E]),E}stop(){const d=Date.now()-this._start;S._totals+=d;let y=!1;function E(g,h){const p=[],c=new Array(g+1).join("	");for(const[n,o,i]of h._dep)if(o&&i){y=!0,p.push(`${c}CREATES -> ${n}`);const r=E(g+1,i);r&&p.push(r)}else p.push(`${c}uses -> ${n}`);return p.join(`
`)}const w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(d>2||y)&&console.log(w.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(Z[6],ee([0,1,44,3,2,4,5]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function C(){return new Date().toISOString()}var l;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(l=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=l.Info;function m(o,i,r){switch(i){case l.Trace:o.trace(r);break;case l.Debug:o.debug(r);break;case l.Info:o.info(r);break;case l.Warning:o.warn(r);break;case l.Error:o.error(r);break;case l.Critical:o.critical(r);break;default:throw new Error("Invalid log level")}}e.log=m;function I(o){let i="";for(let r=0;r<o.length;r++){let s=o[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(r>0?" ":"")+s}return i}e.format=I;class b extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class S extends b{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...r){this.checkLogLevel(l.Trace)&&this.log(l.Trace,I([i,...r]))}debug(i,...r){this.checkLogLevel(l.Debug)&&this.log(l.Debug,I([i,...r]))}info(i,...r){this.checkLogLevel(l.Info)&&this.log(l.Info,I([i,...r]))}warn(i,...r){this.checkLogLevel(l.Warning)&&this.log(l.Warning,I([i,...r]))}error(i,...r){if(this.checkLogLevel(l.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(l.Error,I(s))}else this.log(l.Error,I([i,...r]))}critical(i,...r){this.checkLogLevel(l.Critical)&&this.log(l.Critical,I([i,...r]))}flush(){}}e.AbstractMessageLogger=S;class f extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!R.isWindows}trace(i,...r){this.getLevel()<=l.Trace&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,i,...r):console.log(`[main ${C()}]`,i,...r))}debug(i,...r){this.getLevel()<=l.Debug&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,i,...r):console.log(`[main ${C()}]`,i,...r))}info(i,...r){this.getLevel()<=l.Info&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,i,...r):console.log(`[main ${C()}]`,i,...r))}warn(i,...r){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,i,...r):console.warn(`[main ${C()}]`,i,...r))}error(i,...r){this.getLevel()<=l.Error&&(this.useColors?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,i,...r):console.error(`[main ${C()}]`,i,...r))}critical(i,...r){this.getLevel()<=l.Critical&&(this.useColors?console.error(`\x1B[90m[main ${C()}]\x1B[0m`,i,...r):console.error(`[main ${C()}]`,i,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class d extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...r){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",i,...r)}debug(i,...r){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...r)}info(i,...r){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",i,...r)}warn(i,...r){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",i,...r)}error(i,...r){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",i,...r)}critical(i,...r){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...r)}dispose(){}flush(){}}e.ConsoleLogger=d;class y extends b{constructor(i,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(r)}trace(i,...r){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(i),...r])}debug(i,...r){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(i),...r])}info(i,...r){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(i),...r])}warn(i,...r){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(i),...r])}error(i,...r){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(i),...r])}critical(i,...r){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(i),...r])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=l.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class E extends b{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const r of this.logServices)r.setLevel(i);super.setLevel(i)}trace(i,...r){for(const s of this.logServices)s.trace(i,...r)}debug(i,...r){for(const s of this.logServices)s.debug(i,...r)}info(i,...r){for(const s of this.logServices)s.info(i,...r)}warn(i,...r){for(const s of this.logServices)s.warn(i,...r)}error(i,...r){for(const s of this.logServices)s.error(i,...r)}critical(i,...r){for(const s of this.logServices)s.critical(i,...r)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=E;class w extends k.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...r){this.logger.trace(i,...r)}debug(i,...r){this.logger.debug(i,...r)}info(i,...r){this.logger.info(i,...r)}warn(i,...r){this.logger.warn(i,...r)}error(i,...r){this.logger.error(i,...r)}critical(i,...r){this.logger.critical(i,...r)}flush(){this.logger.flush()}}e.LogService=w;class g extends k.Disposable{constructor(i,r){super(),this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,r){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,r?.always?l.Trace:this.logLevel,r),this.loggers.set(i.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return l.Info}trace(i,...r){}debug(i,...r){}info(i,...r){}warn(i,...r){}error(i,...r){}critical(i,...r){}dispose(){}flush(){}}e.NullLogService=h;function p(o){if(o.verbose)return l.Trace;if(typeof o.logLevel=="string"){const i=c(o.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function c(o){switch(o){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}e.parseLogLevel=c;function n(o){switch(o){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}e.LogLevelToString=n});var J=this&&this.__param||function(q,e){return function(v,t){e(v,t,q)}};define(Z[202],ee([0,1,69,3,2,6,4]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let C=class vt extends k.Disposable{constructor(m){super(),this.logService=m,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(m,I){let b;try{b=await this.withKeytar()}catch{return null}const S=await b.getPassword(m,I);if(S)try{let{content:f,hasNextChunk:d}=JSON.parse(S);if(!f||!d)return S;let y=1;for(;d;){const E=await b.getPassword(m,`${I}-${y}`),w=JSON.parse(E);f+=w.content,d=w.hasNextChunk,y++}return f}catch{return S}return S}async setPassword(m,I,b){let S;try{S=await this.withKeytar()}catch(y){throw this.surfaceKeytarLoadError?.(y),y}const f=3,d=async(y,E,w)=>{let g=0,h;for(;g<f;)try{await S.setPassword(y,E,w);return}catch(p){h=p,this.logService.warn("Error attempting to set a password: ",p?.message??p),g++,await new Promise(c=>setTimeout(c,200))}throw h};if(M.isWindows&&b.length>vt.MAX_PASSWORD_LENGTH){let y=0,E=0,w=!0;for(;w;){const g=b.substring(y,y+vt.PASSWORD_CHUNK_SIZE);y+=vt.PASSWORD_CHUNK_SIZE,w=b.length-y>0;const h={content:g,hasNextChunk:w};await d(m,E?`${I}-${E}`:I,JSON.stringify(h)),E++}}else await d(m,I,b);this._onDidChangePassword.fire({service:m,account:I})}async deletePassword(m,I){let b;try{b=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const S=await b.getPassword(m,I);if(!S)return!1;const f=await b.deletePassword(m,I);try{let{content:d,hasNextChunk:y}=JSON.parse(S);if(d&&y){let E=1;for(;y;){const w=`${I}-${E}`,g=await b.getPassword(m,w);await b.deletePassword(m,w),y=JSON.parse(g).hasNextChunk,E++}}}catch{}return f&&this._onDidChangePassword.fire({service:m,account:I}),f}async findPassword(m){let I;try{I=await this.withKeytar()}catch{return null}return I.findPassword(m)}async findCredentials(m){let I;try{I=await this.withKeytar()}catch{return[]}return I.findCredentials(m)}clear(){return this._keytarCache instanceof v.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};C.MAX_PASSWORD_LENGTH=2500,C.PASSWORD_CHUNK_SIZE=C.MAX_PASSWORD_LENGTH-100,C=ve([J(0,R.ILogService)],C),e.BaseCredentialsMainService=C}),define(Z[203],ee([0,1,24,8,17,3,2,9,70,6]),function(q,e,v,t,k,R,M,C,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends M.Disposable{constructor(S,f){super(),this.logService=S,this.options=f,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,f):this.watchNonRecursive(S,f)}watchUniversal(S,f){const d={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:f.recursive},y=(0,v.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,k.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,l.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const f of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const f of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(f)&&S.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,f){const d={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:!1},y=(0,v.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,k.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,l.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,C.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(Z[204],ee([0,1,24,8,18,22,3,66,57,2,32,13,71,16,58,158,14,105,6]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let h=class extends m.Disposable{constructor(c){super(),this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,n){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${c}`);const o=new m.DisposableStore;return this.provider.set(c,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:n}),o.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new E.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&o.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),o.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:c}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:n}),this.provider.delete(c),(0,m.dispose)(o)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(o){n.push(o)}}),!this.provider.has(c)&&await t.Promises.settled(n)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,n){const o=this.provider.get(c.scheme);return!!(o&&o.capabilities&n)}listCapabilities(){return l.Iterable.map(this.provider,([c,n])=>({scheme:c,capabilities:n.capabilities}))}async withProvider(c){if(!(0,f.isAbsolutePath)(c))throw new E.FileOperationError((0,y.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const n=this.provider.get(c.scheme);if(!n){const o=new Error;throw o.name="ENOPRO",o.message=(0,y.localize)(1,null,c.toString()),o}return n}async withReadProvider(c){const n=await this.withProvider(c);if((0,E.hasOpenReadWriteCloseCapability)(n)||(0,E.hasReadWriteCapability)(n)||(0,E.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const n=await this.withProvider(c);if((0,E.hasOpenReadWriteCloseCapability)(n)||(0,E.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,n){try{return await this.doResolveFile(c,n)}catch(o){throw(0,E.toFileSystemProviderErrorCode)(o)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,y.localize)(2,null,this.resourceForError(c)),1):(0,E.ensureFileSystemProviderError)(o)}}async doResolveFile(c,n){const o=await this.withProvider(c),i=this.isPathCaseSensitive(o),r=n?.resolveTo,s=n?.resolveSingleChildDescendants,a=n?.resolveMetadata,u=await o.stat(c);let P;return this.toFileStat(o,c,u,void 0,!!a,(D,T)=>(P||(P=I.TernarySearchTree.forUris(()=>!i),P.set(c,!0),r&&P.fill(!0,r)),P.get(D.resource)||P.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?T===1:!1))}async toFileStat(c,n,o,i,r,s){const{providerExtUri:a}=this.getExtUri(c),u={resource:n,name:a.basename(n),isFile:(o.type&E.FileType.File)!==0,isDirectory:(o.type&E.FileType.Directory)!==0,isSymbolicLink:(o.type&E.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&E.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,E.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(u.isDirectory&&s(u,i)){try{const P=await c.readdir(n),D=await t.Promises.settled(P.map(async([T,N])=>{try{const U=a.joinPath(n,T),$=r?await c.stat(U):{type:N};return await this.toFileStat(c,U,$,P.length,r,s)}catch(U){return this.logService.trace(U),null}}));u.children=(0,v.coalesce)(D)}catch(P){this.logService.trace(P),u.children=[]}return u}return u}async resolveAll(c){return t.Promises.settled(c.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(c){const n=await this.withProvider(c),o=await n.stat(c);return this.toFileStat(n,c,o,void 0,!0,()=>!1)}async exists(c){const n=await this.withProvider(c);try{return!!await n.stat(c)}catch{return!1}}async canCreateFile(c,n){try{await this.doValidateCreateFile(c,n)}catch(o){return o}return!0}async doValidateCreateFile(c,n){if(!n?.overwrite&&await this.exists(c))throw new E.FileOperationError((0,y.localize)(3,null,this.resourceForError(c)),3,n)}async createFile(c,n=k.VSBuffer.fromString(""),o){await this.doValidateCreateFile(c,o);const i=await this.writeFile(c,n);return this._onDidRunOperation.fire(new E.FileOperationEvent(c,0,i)),i}async writeFile(c,n,o){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,c,o)||await this.mkdirp(i,r.dirname(c));let a;if((0,E.hasReadWriteCapability)(i)&&!(n instanceof k.VSBuffer))if((0,d.isReadableStream)(n)){const u=await(0,d.peekStream)(n,3);u.ended?a=k.VSBuffer.concat(u.buffer):a=u}else a=(0,d.peekReadable)(n,u=>k.VSBuffer.concat(u),3);else a=n;!(0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)&&a instanceof k.VSBuffer?await this.doWriteUnbuffered(i,c,o,a):await this.doWriteBuffered(i,c,o,a instanceof k.VSBuffer?(0,k.bufferToReadable)(a):a),this._onDidRunOperation.fire(new E.FileOperationEvent(c,4))}catch(s){throw new E.FileOperationError((0,y.localize)(4,null,this.resourceForError(c),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),o)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,n,o){if(!!o?.unlock&&!(c.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(n)));let r;try{r=await c.stat(n)}catch{return}if((r.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,y.localize)(6,null,this.resourceForError(n)),0,o);if(this.throwIfFileIsReadonly(n,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==E.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,E.etag)({mtime:o.mtime,size:r.size}))throw new E.FileOperationError((0,y.localize)(7,null),3,o);return r}async readFile(c,n,o){const i=await this.withReadProvider(c);return n?.atomic?this.doReadFileAtomic(i,c,n,o):this.doReadFile(i,c,n,o)}async doReadFileAtomic(c,n,o,i){return new Promise((r,s)=>{this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,n,o,i);r(a)}catch(a){s(a)}})})}async doReadFile(c,n,o,i){const r=await this.doReadFileStream(c,n,{...o,preferUnbuffered:!0},i);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(c,n,o){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,n,o)}async doReadFileStream(c,n,o,i){const r=new R.CancellationTokenSource(i),s=this.validateReadFile(n,o).then(u=>u,u=>{throw r.cancel(),u});let a;try{return typeof o?.etag=="string"&&o.etag!==E.ETAG_DISABLED&&await s,o?.atomic&&(0,E.hasFileAtomicReadCapability)(c)||!((0,E.hasOpenReadWriteCloseCapability)(c)||(0,E.hasFileReadStreamCapability)(c))||(0,E.hasReadWriteCapability)(c)&&o?.preferUnbuffered?a=this.readFileUnbuffered(c,n,o):(0,E.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,n,r.token,o):a=this.readFileBuffered(c,n,r.token,o),{...await s,value:a}}catch(u){a&&await(0,d.consumeStream)(a);const P=(0,y.localize)(8,null,this.resourceForError(n),(0,E.ensureFileSystemProviderError)(u).toString());throw u instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(P,u.stat,o):new E.FileOperationError(P,(0,E.toFileOperationResult)(u),o)}}readFileStreamed(c,n,o,i=Object.create(null)){const r=c.readFileStream(n,i,o);return(0,d.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new E.FileOperationError((0,y.localize)(9,null,this.resourceForError(n),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),i)},s=>k.VSBuffer.concat(s))}readFileBuffered(c,n,o,i=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,w.readFileIntoStream)(c,n,r,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new E.FileOperationError((0,y.localize)(10,null,this.resourceForError(n),(0,E.ensureFileSystemProviderError)(s).toString()),(0,E.toFileOperationResult)(s),i)},o),r}readFileUnbuffered(c,n,o){const i=(0,d.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;o?.atomic&&(0,E.hasFileAtomicReadCapability)(c)?r=await c.readFile(n,{atomic:!0}):r=await c.readFile(n),typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(n,r.byteLength,o),i.end(k.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(c,n){const o=await this.resolve(c,{resolveMetadata:!0});if(o.isDirectory)throw new E.FileOperationError((0,y.localize)(11,null,this.resourceForError(c)),0,n);if(typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&n.etag===o.etag)throw new E.NotModifiedSinceFileOperationError((0,y.localize)(12,null),o,n);return this.validateReadFileLimits(c,o.size,n),o}validateReadFileLimits(c,n,o){if(o?.limits){let i;if(typeof o.limits.memory=="number"&&n>o.limits.memory&&(i=9),typeof o.limits.size=="number"&&n>o.limits.size&&(i=7),typeof i=="number")throw new E.FileOperationError((0,y.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,n,o){return this.doCanMoveCopy(c,n,"move",o)}async canCopy(c,n,o){return this.doCanMoveCopy(c,n,"copy",o)}async doCanMoveCopy(c,n,o,i){if(c.toString()!==n.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,c,s,n,o,i)}catch(r){return r}return!0}async move(c,n,o){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,c,r,n,"move",!!o),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(c,s==="move"?2:3,a)),a}async copy(c,n,o){const i=await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,c,r,n,"copy",!!o),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(c,s==="copy"?3:2,a)),a}async doMoveCopy(c,n,o,i,r,s){if(n.toString()===i.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(c,n,o,i,r,s);if(a&&!u&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(i)),r==="copy"){if(c===o&&(0,E.hasFileFolderCopyCapability)(c))await c.copy(n,i,{overwrite:s});else{const P=await this.resolve(n);P.isDirectory?await this.doCopyFolder(c,P,o,i):await this.doCopyFile(c,n,o,i)}return r}else return c===o?(await c.rename(n,i,{overwrite:s}),r):(await this.doMoveCopy(c,n,o,i,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(c,n,o,i){if((0,E.hasOpenReadWriteCloseCapability)(c)&&(0,E.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(c,n,o,i);if((0,E.hasOpenReadWriteCloseCapability)(c)&&(0,E.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(c,n,o,i);if((0,E.hasReadWriteCapability)(c)&&(0,E.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(c,n,o,i);if((0,E.hasReadWriteCapability)(c)&&(0,E.hasReadWriteCapability)(o))return this.doPipeUnbuffered(c,n,o,i)}async doCopyFolder(c,n,o,i){await o.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async r=>{const s=this.getExtUri(o).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(c,await this.resolve(r.resource),o,s):this.doCopyFile(c,r.resource,o,s)}))}async doValidateMoveCopy(c,n,o,i,r,s){let a=!1;if(c===o){const{providerExtUri:P,isPathCaseSensitive:D}=this.getExtUri(c);if(D||(a=P.isEqual(n,i)),a&&r==="copy")throw new Error((0,y.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!a&&P.isEqualOrParent(i,n))throw new Error((0,y.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const u=await this.exists(i);if(u&&!a){if(!s)throw new E.FileOperationError((0,y.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(c===o){const{providerExtUri:P}=this.getExtUri(c);if(P.isEqualOrParent(n,i))throw new Error((0,y.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:u,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const n=this.isPathCaseSensitive(c);return{providerExtUri:n?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(n,c);const o=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(c,0,o)),o}async mkdirp(c,n){const o=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(n,i.dirname(n));)try{if(((await c.stat(n)).type&E.FileType.Directory)===0)throw new Error((0,y.localize)(18,null,this.resourceForError(n)));break}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(i.basename(n)),n=i.dirname(n)}for(let r=o.length-1;r>=0;r--){n=i.joinPath(n,o[r]);try{await c.mkdir(n)}catch(s){if((0,E.toFileSystemProviderErrorCode)(s)!==E.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,n){try{await this.doValidateDelete(c,n)}catch(o){return o}return!0}async doValidateDelete(c,n){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!n?.useTrash&&!(o.capabilities&4096))throw new Error((0,y.localize)(19,null,this.resourceForError(c)));let r;try{r=await o.stat(c)}catch{}if(r)this.throwIfFileIsReadonly(c,r);else throw new E.FileOperationError((0,y.localize)(20,null,this.resourceForError(c)),1);if(!!!n?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,y.localize)(21,null,this.resourceForError(c)))}return o}async del(c,n){const o=await this.doValidateDelete(c,n),i=!!n?.useTrash,r=!!n?.recursive;await o.delete(c,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new E.FileOperationEvent(c,1))}async cloneFile(c,n){const o=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(o===i&&this.getExtUri(o).providerExtUri.isEqual(c,n))return;if(o===i&&(0,E.hasFileCloneCapability)(o))return o.cloneFile(c,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const r=this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri);return o===i&&(0,E.hasFileFolderCopyCapability)(o)?r.queue(()=>o.copy(c,n,{overwrite:!0})):r.queue(()=>this.doCopyFile(o,c,i,n))}watch(c,n={recursive:!1,excludes:[]}){const o=new m.DisposableStore;let i=!1,r=()=>{i=!0};return o.add((0,m.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(c,n);i?(0,m.dispose)(s):r=()=>(0,m.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(c,n){const o=await this.withProvider(c),i=(0,C.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(c),n]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:o.watch(c,n)},this.activeWatchers.set(i,r)),r.count+=1,(0,m.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,m.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,m.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,n,o,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{const r=await c.open(n,{create:!0,unlock:o?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,r,i):await this.doWriteReadableBufferedQueued(c,r,i)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await c.close(r)}})}async doWriteStreamBufferedQueued(c,n,o){let i=0,r;if((0,d.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=k.VSBuffer.concat(o.buffer);await this.doWriteBuffer(c,n,s,s.byteLength,i,0),i+=s.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((s,a)=>{(0,d.listenStream)(r,{onData:async u=>{r.pause();try{await this.doWriteBuffer(c,n,u,u.byteLength,i,0)}catch(P){return a(P)}i+=u.byteLength,setTimeout(()=>r.resume())},onError:u=>a(u),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,n,o){let i=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(c,n,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(c,n,o,i,r,s){let a=0;for(;a<i;)a+=await c.write(n,r+a,o.buffer,s+a,i-a)}async doWriteUnbuffered(c,n,o,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,n,o,i))}async doWriteUnbufferedQueued(c,n,o,i){let r;i instanceof k.VSBuffer?r=i:(0,d.isReadableStream)(i)?r=await(0,k.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?r=await(0,k.bufferedStreamToBuffer)(i):r=(0,k.readableToBuffer)(i),await c.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(c,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,n,o,i))}async doPipeBufferedQueued(c,n,o,i){let r,s;try{r=await c.open(n,{create:!1}),s=await o.open(i,{create:!0,unlock:!1});const a=k.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,P=0,D=0;do D=await c.read(r,u,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(o,s,a,D,u,P),u+=D,P+=D,P===a.byteLength&&(P=0);while(D>0)}catch(a){throw(0,E.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,n,o,i))}async doPipeUnbufferedQueued(c,n,o,i){return o.writeFile(i,await c.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,n,o,i))}async doPipeUnbufferedToBufferedQueued(c,n,o,i){const r=await o.open(i,{create:!0,unlock:!1});try{const s=await c.readFile(n);await this.doWriteBuffer(o,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(c,n,o,i){const r=await(0,k.streamToBuffer)(this.readFileBuffered(c,n,R.CancellationToken.None));await this.doWriteUnbuffered(o,i,void 0,r)}throwIfFileSystemIsReadonly(c,n){if(c.capabilities&2048)throw new E.FileOperationError((0,y.localize)(22,null,this.resourceForError(n)),6);return c}throwIfFileIsReadonly(c,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,y.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===b.Schemas.file?c.fsPath:c.toString(!0)}};h=ve([J(0,g.ILogService)],h),e.FileService=h}),define(Z[86],ee([0,1,28,276,8,32,18,3,31,2,9,4,16,58,23,162,14,105,203,44,200,199]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.toErrorMessage)(o)}`)}})();class n extends g.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=C.Event.None,this.resourceLocks=new R.ResourceMap(s=>S.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:s}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(i){try{const r=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async a=>{try{let u;a.isSymbolicLink()?u=(await this.stat((0,S.joinPath)(i,a.name))).type:u=this.toType(a),s.push([a.name,u])}catch(u){this.logService.trace(u)}})),s}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let s;return r?.dangling?s=E.FileType.Unknown:i.isFile()?s=E.FileType.File:i.isDirectory()?s=E.FileType.Directory:s=E.FileType.Unknown,r&&(s|=E.FileType.SymbolicLink),s}async createResourceLock(i){const r=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const a=new k.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),a.open()})}async readFile(i,r){let s;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const a=this.toFilePath(i);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}readFileStream(i,r,s){const a=(0,f.newWriteableStream)(u=>M.VSBuffer.concat(u.map(P=>M.VSBuffer.wrap(P))).buffer);return(0,w.readFileIntoStream)(this,i,a,u=>u.buffer,{...r,bufferSize:256*1024},s),a}async writeFile(i,r,s){let a;try{const u=this.toFilePath(i);if(!s.create||!s.overwrite){if(await d.Promises.exists(u)){if(!s.overwrite)throw(0,E.createFileSystemProviderError)((0,y.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,E.createFileSystemProviderError)((0,y.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(a,0,r,0,r.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){n.canFlush=i}async open(i,r){const s=this.toFilePath(i);let a;(0,E.isFileOpenForWriteOptions)(r)&&(a=await this.createResourceLock(i));let u;try{if((0,E.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:D}=await d.SymlinkSupport.stat(s);D.mode&128||await d.Promises.chmod(s,D.mode|128)}catch(D){this.logService.trace(D)}let P;if((0,E.isFileOpenForWriteOptions)(r)){if(b.isWindows)try{await d.Promises.truncate(s,0),P="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}P||(P="w")}else P="r";u=await d.Promises.open(s,P)}catch(P){throw a?.dispose(),(0,E.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(u,0),(0,E.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(u,i),a){const P=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${s})`),this.mapHandleToLock.set(u,a),P&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${s})`),P.dispose())}return u}async close(i){const r=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&n.canFlush)try{await d.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await d.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}finally{r&&(this.mapHandleToLock.get(i)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,s,a,u){const P=this.normalizePos(i,r);let D=null;try{D=(await d.Promises.read(i,s,a,u,P)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,P,D)}return D}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,s){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof r=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,a+s):this.mapHandleToPos.delete(i)))}async write(i,r,s,a,u){return(0,k.retry)(()=>this.doWrite(i,r,s,a,u),100,3)}async doWrite(i,r,s,a,u){const P=this.normalizePos(i,r);let D=null;try{D=(await d.Promises.write(i,s,a,u,P)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,P,D)}return D}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const s=this.toFilePath(i);r.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,r,s){const a=this.toFilePath(i),u=this.toFilePath(r);if(a!==u)try{await this.validateTargetDeleted(i,r,"move",s.overwrite),await d.Promises.move(a,u)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(2,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(u)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(i,r,s){const a=this.toFilePath(i),u=this.toFilePath(r);if(a!==u)try{await this.validateTargetDeleted(i,r,"copy",s.overwrite),await d.Promises.copy(a,u,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(3,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(u)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(i,r,s,a){const u=this.toFilePath(i),P=this.toFilePath(r);let D=!1;if(!!(this.capabilities&1024)||(D=(0,l.isEqual)(u,P,!0)),D&&s==="copy")throw(0,E.createFileSystemProviderError)((0,y.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!D&&await d.Promises.exists(P)){if(!a)throw(0,E.createFileSystemProviderError)((0,y.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.doCloneFile(i,r,!1)}async doCloneFile(i,r,s){const a=this.toFilePath(i),u=this.toFilePath(r),P=!!(this.capabilities&1024);if((0,l.isEqual)(a,u,!P))return;const D=new m.DisposableStore;try{const[T,N]=await Promise.all([this.createResourceLock(i),this.createResourceLock(r)]);D.add(T),D.add(N),s&&await d.Promises.mkdir((0,I.dirname)(u),{recursive:!0}),await d.Promises.copyFile(a,u)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(i,r,!0);throw this.toFileSystemProviderError(T)}finally{D.dispose()}}createUniversalWatcher(i,r,s){return new p.UniversalWatcherClient(a=>i(a),a=>r(a),s)}createNonRecursiveWatcher(i,r,s){return new c.NodeJSWatcherClient(a=>i(a),a=>r(a),s)}toFileSystemProviderError(i){if(i instanceof E.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=E.FileSystemProviderErrorCode.NoPermissions;break;default:r=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(i,r){let s=this.toFileSystemProviderError(r);if(i&&s.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(s=(0,E.createFileSystemProviderError)(r,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}e.DiskFileSystemProvider=n,n.canFlush=!0}),define(Z[205],ee([0,1,3,86,2,18,58,22]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class l extends k.Disposable{constructor(b,S){super(),this.provider=b,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(b,S,f){const d=this.getUriTransformer(b);switch(S){case"stat":return this.stat(d,f[0]);case"readdir":return this.readdir(d,f[0]);case"open":return this.open(d,f[0],f[1]);case"close":return this.close(f[0]);case"read":return this.read(f[0],f[1],f[2]);case"readFile":return this.readFile(d,f[0],f[1]);case"write":return this.write(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.writeFile(d,f[0],f[1],f[2]);case"rename":return this.rename(d,f[0],f[1],f[2]);case"copy":return this.copy(d,f[0],f[1],f[2]);case"cloneFile":return this.cloneFile(d,f[0],f[1]);case"mkdir":return this.mkdir(d,f[0]);case"delete":return this.delete(d,f[0],f[1]);case"watch":return this.watch(d,f[0],f[1],f[2],f[3]);case"unwatch":return this.unwatch(f[0],f[1])}throw new Error(`IPC Command ${S} not found`)}listen(b,S,f){const d=this.getUriTransformer(b);switch(S){case"fileChange":return this.onFileChange(d,f[0]);case"readFileStream":return this.onReadFileStream(d,f[0],f[1])}throw new Error(`Unknown event ${S}`)}stat(b,S){const f=this.transformIncoming(b,S,!0);return this.provider.stat(f)}readdir(b,S){const f=this.transformIncoming(b,S);return this.provider.readdir(f)}async readFile(b,S,f){const d=this.transformIncoming(b,S,!0),y=await this.provider.readFile(d,f);return R.VSBuffer.wrap(y)}onReadFileStream(b,S,f){const d=this.transformIncoming(b,S,!0),y=new C.CancellationTokenSource,E=new v.Emitter({onLastListenerRemove:()=>{y.cancel()}}),w=this.provider.readFileStream(d,f,y.token);return(0,M.listenStream)(w,{onData:g=>E.fire(R.VSBuffer.wrap(g)),onError:g=>E.fire(g),onEnd:()=>{E.fire("end"),E.dispose(),y.dispose()}}),E.event}writeFile(b,S,f,d){const y=this.transformIncoming(b,S);return this.provider.writeFile(y,f.buffer,d)}open(b,S,f){const d=this.transformIncoming(b,S,!0);return this.provider.open(d,f)}close(b){return this.provider.close(b)}async read(b,S,f){const d=R.VSBuffer.alloc(f),y=0,E=await this.provider.read(b,S,d.buffer,y,f);return[d,E]}write(b,S,f,d,y){return this.provider.write(b,S,f.buffer,d,y)}mkdir(b,S){const f=this.transformIncoming(b,S);return this.provider.mkdir(f)}delete(b,S,f){const d=this.transformIncoming(b,S);return this.provider.delete(d,f)}rename(b,S,f,d){const y=this.transformIncoming(b,S),E=this.transformIncoming(b,f);return this.provider.rename(y,E,d)}copy(b,S,f,d){const y=this.transformIncoming(b,S),E=this.transformIncoming(b,f);return this.provider.copy(y,E,d)}cloneFile(b,S,f){const d=this.transformIncoming(b,S),y=this.transformIncoming(b,f);return this.provider.cloneFile(d,y)}onFileChange(b,S){const f=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(b,f))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return f.event}async watch(b,S,f,d,y){const E=this.sessionToWatcher.get(S);if(E){const w=this.transformIncoming(b,d),g=E.watch(f,w,y);this.watchRequests.set(S+f,g)}}async unwatch(b,S){const f=b+S,d=this.watchRequests.get(f);d&&((0,k.dispose)(d),this.watchRequests.delete(f))}dispose(){super.dispose();for(const[,b]of this.watchRequests)b.dispose();this.watchRequests.clear();for(const[,b]of this.sessionToWatcher)b.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=l;class m extends k.Disposable{constructor(b,S,f,d){super(),this.uriTransformer=b,this.logService=f,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(b){const S=this._register(new v.Emitter);this._register(S.event(f=>{b.fire(f.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(f=>S.fire(f))),this._register(this.fileWatcher.onDidWatchError(f=>b.fire(f)))}getRecursiveWatcherOptions(b){}getExtraExcludes(b){}watch(b,S,f){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(f.excludes=[...f.excludes,...d]),this.watcherRequests.set(b,this.fileWatcher.watch(S,f)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(b)),this.watcherRequests.delete(b)})}dispose(){super.dispose();for(const[,b]of this.watcherRequests)b.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=m}),define(Z[206],ee([0,1,15,161,4,7,14,9,205,140]),function(q,e,v,t,k,R,M,C,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class I extends l.AbstractDiskFileSystemProviderChannel{constructor(f,d,y){super(f,d),this.environmentService=y}getUriTransformer(f){return m.DefaultURITransformer}transformIncoming(f,d){return R.URI.revive(d)}async delete(f,d,y){if(!y.useTrash)return super.delete(f,d,y);const E=this.transformIncoming(f,d),w=(0,C.normalize)(E.fsPath);try{await v.shell.trashItem(w)}catch{throw(0,M.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,C.basename)(w)):(0,t.localize)(1,null,(0,C.basename)(w)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(f,d){return new b(f,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=I;class b extends l.AbstractSessionFileWatcher{watch(f,d,y){if(y.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(f,d,y)}}}),define(Z[106],ee([0,1,6]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,M){switch(M){case v.LogLevel.Trace:return R.trace;case v.LogLevel.Debug:return R.debug;case v.LogLevel.Info:return R.info;case v.LogLevel.Warning:return R.warn;case v.LogLevel.Error:return R.error;case v.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(M=v.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(C=>{this._logger?.setLevel(C)}))}set logger(M){this._logger=M;for(const{level:C,args:l}of this.buffer)t(M,C).apply(M,l);this.buffer=[]}_log(M,...C){this._logger?t(this._logger,M).apply(this._logger,C):this.getLevel()<=M&&this.buffer.push({level:M,args:C})}trace(M,...C){this._log(v.LogLevel.Trace,M,...C)}debug(M,...C){this._log(v.LogLevel.Debug,M,...C)}info(M,...C){this._log(v.LogLevel.Info,M,...C)}warn(M,...C){this._log(v.LogLevel.Warning,M,...C)}error(M,...C){this._log(v.LogLevel.Error,M,...C)}critical(M,...C){this._log(v.LogLevel.Critical,M,...C)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(Z[207],ee([0,1,8,18,16,14,5,106,6]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*R.ByteSize.MB;let I=class extends l.AbstractLogger{constructor(f,d,y,E,w){super(),this.name=f,this.resource=d,this.donotUseFormatters=E,this.fileService=w,this.backupIndex=1,this.setLevel(y),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=l.LogLevel.Trace&&this._log(l.LogLevel.Trace,(0,l.format)(arguments))}debug(){this.getLevel()<=l.LogLevel.Debug&&this._log(l.LogLevel.Debug,(0,l.format)(arguments))}info(){this.getLevel()<=l.LogLevel.Info&&this._log(l.LogLevel.Info,(0,l.format)(arguments))}warn(){this.getLevel()<=l.LogLevel.Warning&&this._log(l.LogLevel.Warning,(0,l.format)(arguments))}error(){if(this.getLevel()<=l.LogLevel.Error){const f=arguments[0];if(f instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=f.stack,this._log(l.LogLevel.Error,(0,l.format)(d))}else this._log(l.LogLevel.Error,(0,l.format)(arguments))}}critical(){this.getLevel()<=l.LogLevel.Critical&&this._log(l.LogLevel.Critical,(0,l.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(f){if(f.fileOperationResult!==3)throw f}}_log(f,d){this.queue.queue(async()=>{await this.initializePromise;let y=await this.loadContent();y.length>m&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(y)),y=""),this.donotUseFormatters?y+=d:y+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(f)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(y))})}getCurrentTimestamp(){const f=E=>E<10?`0${E}`:E,d=E=>E<10?`00${E}`:E<100?`0${E}`:E,y=new Date;return`${y.getFullYear()}-${f(y.getMonth()+1)}-${f(y.getDate())} ${f(y.getHours())}:${f(y.getMinutes())}:${f(y.getSeconds())}.${d(y.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(f){switch(f){case l.LogLevel.Critical:return"critical";case l.LogLevel.Debug:return"debug";case l.LogLevel.Error:return"error";case l.LogLevel.Info:return"info";case l.LogLevel.Trace:return"trace";case l.LogLevel.Warning:return"warning"}return""}};I=ve([J(4,R.IFileService)],I),e.FileLogger=I;let b=class extends l.AbstractLoggerService{constructor(f,d,y){super(f.getLevel(),f.onDidChangeLogLevel),this.instantiationService=d,this.fileService=y}doCreateLogger(f,d,y){const E=new C.BufferLogService(d);return(0,R.whenProviderRegistered)(f,this.fileService).then(()=>E.logger=this.instantiationService.createInstance(I,y?.name||(0,k.basename)(f),f,E.getLevel(),!!y?.donotUseFormatters)),E}};b=ve([J(0,l.ILogService),J(1,M.IInstantiationService),J(2,R.IFileService)],b),e.FileLoggerService=b}),define(Z[208],ee([0,1,3,7,6]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(S){this.service=S,this.onDidChangeLogLevel=v.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,f){switch(f){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${f}`)}async call(S,f,d){switch(f){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${f}`)}}e.LogLevelChannel=R;class M{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){M.setLevel(this.channel,S)}static setLevel(S,f){return S.call("setLevel",f)}}e.LogLevelChannelClient=M;class C{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,f){throw new Error(`Event not found: ${f}`)}async call(S,f,d){switch(f){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${f}`)}createLogger(S,f){this.loggers.set(S.toString(),this.loggerService.createLogger(S,f))}consoleLog(S,f){let d=console.log;switch(S){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...f)}log(S,f){const d=this.loggers.get(S.toString());if(!d)throw new Error("Create the logger before logging");for(const[y,E]of f)(0,k.log)(d,y,E)}}e.LoggerChannel=C;class l extends k.AbstractLoggerService{constructor(S,f,d){super(S,f),this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(S,f)=>{this.channel.call("consoleLog",[S,f])}})}doCreateLogger(S,f,d){return new m(this.channel,S,f,d)}}e.LoggerChannelClient=l;class m extends k.AbstractMessageLogger{constructor(S,f,d,y){super(y?.always),this.channel=S,this.file=f,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[f,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,f){const d=[[S,f]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(S){this.channel.call("log",[this.file,S])}}class I extends k.LogService{constructor(S,f){super(f),this.parent=S,this._register(S.onDidChangeLogLevel(d=>f.setLevel(d)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=I}),define(Z[107],ee([0,1,14,6]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(C,l,m,I,b){try{const S=await new Promise((d,y)=>{q(["spdlog"],d,y)});S.setFlushOn(t.LogLevel.Trace);const f=await S.createAsyncRotatingLogger(C,l,m,I);return b&&f.clearFormatters(),f}catch(S){console.error(S)}return null}function R(C,l,m){switch(l){case t.LogLevel.Trace:C.trace(m);break;case t.LogLevel.Debug:C.debug(m);break;case t.LogLevel.Info:C.info(m);break;case t.LogLevel.Warning:C.warn(m);break;case t.LogLevel.Error:C.error(m);break;case t.LogLevel.Critical:C.critical(m);break;default:throw new Error("Invalid log level")}}class M extends t.AbstractMessageLogger{constructor(l,m,I,b,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(l,m,I,b),this._register(this.onDidChangeLogLevel(f=>{this._logger?.setLevel(f)}))}async _createSpdLogLogger(l,m,I,b){const S=I?6:1,f=30/S*v.ByteSize.MB,d=await k(l,m,f,S,b);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:y,message:E}of this.buffer)R(this._logger,y,E);this.buffer=[]}}log(l,m){this._logger?R(this._logger,l,m):this.getLevel()<=l&&this.buffer.push({level:l,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(Z[209],ee([0,1,13,16,30,14,207,6,107]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends C.AbstractLoggerService{constructor(b,S){super(b.getLevel(),b.onDidChangeLogLevel),this.fileService=S}doCreateLogger(b,S,f){return b.scheme===v.Schemas.file?new l.SpdLogLogger(f?.name||(0,k.generateUuid)(),b.fsPath,!f?.donotRotate,!!f?.donotUseFormatters,S):new M.FileLogger(f?.name??(0,t.basename)(b),b,S,!!f?.donotUseFormatters,this.fileService)}};m=ve([J(0,C.ILogService),J(1,R.IFileService)],m),e.LoggerService=m}),define(Z[210],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(M){return!v(M)&&!t(M)&&!k(M)}e.isMenubarMenuItemAction=R}),define(Z[38],ee([0,1,3,57,2,5]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class M extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(m){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(m),t.Iterable.reduce(this.policies.entries(),(b,[S,f])=>({...b,[S]:f}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[I,b])=>({...m,[I]:{definition:b,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=M;class C{constructor(){this.onDidChange=v.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=C}),define(Z[211],ee([0,1,8,3,57,12,14,6,38]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(b,S){const f=[];for(const d of k.Iterable.concat(b.keys(),S.keys()))b.get(d)!==S.get(d)&&f.push(d);return f}let I=class extends l.AbstractPolicyService{constructor(S,f,d){super(),this.file=S,this.fileService=f,this.logService=d,this.throttledDelayer=this._register(new v.ThrottledDelayer(500));const y=t.Event.filter(f.onDidFilesChange,E=>E.affects(S));this._register(f.watch(S)),this._register(y(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(S){await this.refresh()}async read(){const S=new Map;try{const f=await this.fileService.readFile(this.file),d=JSON.parse(f.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(d))this.policyDefinitions[y]&&S.set(y,d[y])}catch(f){f.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",f)}return S}async refresh(){const S=await this.read(),f=m(this.policies,S);this.policies=S,f.length>0&&this._onDidChange.fire(f)}};I=ve([J(1,M.IFileService),J(2,C.ILogService)],I),e.FilePolicyService=I}),define(Z[212],ee([0,1,3,2,38]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(l){this.service=l,this.disposables=new t.DisposableStore}listen(l,m){switch(m){case"onDidChange":return v.Event.map(this.service.onDidChange,I=>I.reduce((b,S)=>({...b,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(l,m,I){switch(m){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class M extends k.AbstractPolicyService{constructor(l,m){super(),this.channel=m;for(const I in l){const{definition:b,value:S}=l[I];this.policyDefinitions[I]=b,S!==void 0&&this.policies.set(I,S)}this.channel.listen("onDidChange")(I=>{for(const b in I){const S=I[b];S===null?this.policies.delete(b):this.policies.set(b,S)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(l){const m=await this.channel.call("registerPolicyDefinitions",l);for(const I in m)this.policies.set(I,m[I])}}e.PolicyChannelClient=M}),define(Z[54],ee([0,1,13,4,34,16]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const C=t.globals.vscode.context.configuration();if(C)M=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const C=(0,R.dirname)(v.FileAccess.asFileUri("",q));M=q.__$__nodeRequire((0,R.joinPath)(C,"product.json").fsPath);const l=q.__$__nodeRequire((0,R.joinPath)(C,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:l.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(Z[20],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[213],ee([0,1,76,6,20]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(C,l){this.productService=C,this.logService=l,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(C,l){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(l);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",l),!1;const[,I,b]=m;let S=this.trustedExtensionUrlPublicKeys.get(C);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[C],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",C),!1;this.trustedExtensionUrlPublicKeys.set(C,[...S])}const f=Buffer.from(decodeURIComponent(b),"base64");if(f.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",l),!1;const d=f.slice(0,6),y=f.readUIntBE(0,6),E=Date.now()-y;if(E<0||E>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",l),!1;const w=f.slice(6),g=v.createVerify("SHA256");g.write(d),g.write(Buffer.from(I)),g.end();for(let h=0;h<S.length;h++){let p=S[h];if(p!==null){if(typeof p=="string")try{p=v.createPublicKey({key:Buffer.from(p,"base64"),format:"der",type:"spki"}),S[h]=p}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${C}:`,c),S[h]=null;continue}if(g.verify(p,w))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",l),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",l),!1}};R=ve([J(0,k.IProductService),J(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[61],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Z[47],ee([0,1,121,12]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(M,C){v.ok(t.isString(M)),v.ok(t.isObject(C)),v.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,C)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new k}),define(Z[214],ee([0,1,3,47]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,m){this.schemasById[k(l)]=m,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new R;t.Registry.add(e.Extensions.JSONContribution,M)}),define(Z[62],ee([0,1,24,3,12,149,19,214,47]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=l.Registry.as(C.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const i=this.doRegisterConfigurations(n,o);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const o=this.doDeregisterConfigurations(n);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:n,remove:o}){const i=[];i.push(...this.doDeregisterConfigurations(o)),i.push(...this.doRegisterConfigurations(n,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(i)})}registerDefaultConfigurations(n){const o=[],i=[];for(const{overrides:r,source:s}of n)for(const a in r)if(o.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const u=this.configurationDefaultsOverrides.get(a),P=u?.valuesSources??new Map;if(s)for(const U of Object.keys(r[a]))P.set(U,s);const D={...u?.value||{},...r[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:D,valuesSources:P});const T=(0,M.getLanguageTagSettingPlainKey)(a),N={type:"object",default:D,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:k.isString(s)?void 0:s,defaultValueSource:s};i.push(...y(a)),this.configurationProperties[a]=N,this.defaultLanguageConfigurationOverridesNode.properties[a]=N}else{this.configurationDefaultsOverrides.set(a,{value:r[a],source:s});const u=this.configurationProperties[a];u&&(this.updatePropertyDefaultValue(a,u),this.updateSchema(a,u))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const o=[];for(const{overrides:i,source:r}of n)for(const s in i){const a=this.configurationDefaultsOverrides.get(s),u=k.isString(r)?r:r?.id,P=k.isString(a?.source)?a?.source:a?.source?.id;if(u===P)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const D=this.configurationProperties[s];D&&(this.updatePropertyDefaultValue(s,D),this.updateSchema(s,D))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const o of n)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,o){const i=[];return n.forEach(r=>{i.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),i}doDeregisterConfigurations(n){const o=[],i=r=>{if(r.properties)for(const s in r.properties){o.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>i(s))};for(const r of n){i(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(n,o=!0,i,r,s=3){s=k.isUndefinedOrNull(n.scope)?s:n.scope;const a=[],u=n.properties;if(u)for(const D in u){const T=u[D];if(o&&h(D,T)){delete u[D];continue}if(T.source=i,T.defaultDefaultValue=u[D].default,this.updatePropertyDefaultValue(D,T),e.OVERRIDE_PROPERTY_REGEX.test(D)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!r?.includes(D):T.restricted),u[D].hasOwnProperty("included")&&!u[D].included){this.excludedConfigurationProperties[D]=u[D],delete u[D];continue}else this.configurationProperties[D]=u[D],u[D].policy?.name&&this.policyConfigurations.set(u[D].policy.name,D);!u[D].deprecationMessage&&u[D].markdownDeprecationMessage&&(u[D].deprecationMessage=u[D].markdownDeprecationMessage),a.push(D)}const P=n.allOf;if(P)for(const D of P)a.push(...this.validateAndRegisterProperties(D,o,i,r,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const o=i=>{const r=i.properties;if(r)for(const a in r)this.updateSchema(a,r[a]);i.allOf?.forEach(o)};o(n)}updateSchema(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.resourceLanguageSettingsSchema.properties[n]=o;break}}removeFromSchema(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const o=`[${n}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,i),e.allSettings.properties[o]=i,e.applicationSettings.properties[o]=i,e.machineSettings.properties[o]=i,e.machineOverridableSettings.properties[o]=i,e.windowSettings.properties[o]=i,e.resourceSettings.properties[o]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,o){const i=this.configurationDefaultsOverrides.get(n);let r=i?.value,s=i?.source;k.isUndefined(r)&&(r=o.defaultDefaultValue,s=void 0),k.isUndefined(r)&&(r=w(o.type)),o.default=r,o.defaultValueSource=s}}const f="\\[([^\\]]+)\\]",d=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(c){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let o=d.exec(c);for(;o?.length;){const i=o[1].trim();i&&n.push(i),o=d.exec(c)}}return(0,v.distinct)(n)}e.overrideIdentifiersFromKey=y;function E(c){return c.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=E;function w(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const g=new S;l.Registry.add(e.Extensions.Configuration,g);function h(c,n){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):g.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):n.policy?.name&&g.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(9,null,c,n.policy?.name,g.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(6,null)}e.validateProperty=h;function p(){const c=[],n=g.getConfigurationProperties();for(const o of Object.keys(n))c.push([o,n[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=p}),define(Z[108],ee([0,1,24,3,43,2,32,50,12,7,19,62,47]),function(q,e,v,t,k,R,M,C,l,m,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class f{constructor(n={},o=[],i=[]){this._contents=n,this._keys=o,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,o){const i=this.getContentsForOverrideIdentifer(o);return i?n?(0,I.getConfigurationValue)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const i of this.overrides)i.identifiers.includes(n)&&o.push(...i.keys);return v.distinct(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return v.distinct(n)}override(n){let o=this.overrideConfigurations.get(n);return o||(o=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,o)),o}merge(...n){const o=C.deepClone(this.contents),i=C.deepClone(this.overrides),r=[...this.keys];for(const s of n)if(!s.isEmpty()){this.mergeContents(o,s.contents);for(const a of s.overrides){const[u]=i.filter(P=>v.equals(P.identifiers,a.identifiers));u?(this.mergeContents(u.contents,a.contents),u.keys.push(...a.keys),u.keys=v.distinct(u.keys)):i.push(C.deepClone(a))}for(const a of s.keys)r.indexOf(a)===-1&&r.push(a)}return new f(o,r,i)}freeze(){return this.frozen=!0,this}clone(){return new f(C.deepClone(this.contents),[...this.keys],C.deepClone(this.overrides))}createOverrideConfigurationModel(n){const o=this.getContentsForOverrideIdentifer(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const i={};for(const r of v.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[r];const a=o[r];a&&(typeof s=="object"&&typeof a=="object"?(s=C.deepClone(s),this.mergeContents(s,a)):s=a),i[r]=s}return new f(i,this.keys,this.overrides)}mergeContents(n,o){for(const i of Object.keys(o)){if(i in n&&l.isObject(n[i])&&l.isObject(o[i])){this.mergeContents(n[i],o[i]);continue}n[i]=C.deepClone(o[i])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?C.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let o=null,i=null;const r=s=>{s&&(i?this.mergeContents(i,s):i=C.deepClone(s))};for(const s of this.overrides)v.equals(s.identifiers,[n])?o=s.contents:s.identifiers.includes(n)&&r(s.contents);return r(o),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,o){this.addKey(n),(0,I.addToValueTree)(this.contents,n,o,i=>{throw new Error(i)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let o=this.keys.length;for(let i=0;i<o;i++)n.indexOf(this.keys[i])===0&&(o=i);this.keys.splice(o,1,n)}removeKey(n){const o=this.keys.indexOf(n);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=f;class d{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,o){if(!l.isUndefinedOrNull(n)){const i=this.doParseContent(n);this.parseRaw(i,o)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,o){this._raw=n;const{contents:i,keys:r,overrides:s,restricted:a}=this.doParseRaw(n,o);this._configurationModel=new f(i,r,s),this._restrictedConfigurations=a||[]}doParseContent(n){let o={},i=null,r=[];const s=[],a=[];function u(D){Array.isArray(r)?r.push(D):i!==null&&(r[i]=D)}const P={onObjectBegin:()=>{const D={};u(D),s.push(r),r=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const D=[];u(D),s.push(r),r=D,i=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:u,onError:(D,T,N)=>{a.push({error:D,offset:T,length:N})}};if(n)try{k.visit(n,P),o=r[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return o}doParseRaw(n,o){const i=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,i,!0,o);n=r.raw;const s=(0,I.toValuesTree)(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),a=Object.keys(n),u=this.toOverrides(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:s,keys:a,overrides:u,restricted:r.restricted}}filter(n,o,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:n,restricted:[]};const s={},a=[];for(const u in n)if(b.OVERRIDE_PROPERTY_REGEX.test(u)&&i){const P=this.filter(n[u],o,!1,r);s[u]=P.raw,a.push(...P.restricted)}else{const P=o[u],D=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&a.push(u),(D===void 0||r.scopes===void 0||r.scopes.includes(D))&&(r.skipRestricted&&P?.restricted||(s[u]=n[u]))}return{raw:s,restricted:a}}toOverrides(n,o){const i=[];for(const r of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const a in n[r])s[a]=n[r][a];i.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,I.toValuesTree)(s,o)})}return i}}e.ConfigurationModelParser=d;class y extends R.Disposable{constructor(n,o,i,r){super(),this.userSettingsResource=n,this.scopes=o,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&i.isEqual(s.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class E{constructor(n,o,i,r,s=new f,a=new f,u=new M.ResourceMap,P=new f,D=new M.ResourceMap,T=!0){this._defaultConfiguration=n,this._policyConfiguration=o,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=u,this._memoryConfiguration=P,this._memoryConfigurationByResource=D,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(n,o,i){return this.getConsolidatedConfigurationModel(n,o,i).getValue(n)}updateValue(n,o,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new f,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,o===void 0?r.removeValue(n):r.setValue(n,o),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,o,i){const r=this.getConsolidatedConfigurationModel(n,o,i),s=this.getFolderConfigurationModelForResource(o.resource,i),a=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,u=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),P=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),D=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),T=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),N=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),U=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),$=i?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,Y=s?o.overrideIdentifier?s.freeze().override(o.overrideIdentifier).getValue(n):s.freeze().getValue(n):void 0,oe=o.overrideIdentifier?a.override(o.overrideIdentifier).getValue(n):a.getValue(n),ue=r.getValue(n),se=v.distinct(r.overrides.map(de=>de.identifiers).flat()).filter(de=>r.getOverrideValue(n,de)!==void 0);return{defaultValue:u,policyValue:P,applicationValue:D,userValue:T,userLocalValue:N,userRemoteValue:U,workspaceValue:$,workspaceFolderValue:Y,memoryValue:oe,value:ue,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,policy:P!==void 0?{value:P}:void 0,application:D!==void 0?{value:D,override:o.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,workspace:$!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,workspaceFolder:Y!==void 0?{value:s?.freeze().getValue(n),override:o.overrideIdentifier?s?.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,memory:oe!==void 0?{value:a.getValue(n),override:o.overrideIdentifier?a.getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(n){const o=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,o){this._folderConfigurations.set(n,o),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const i=[];if(!o){const{added:r,updated:s,removed:a}=h(this._defaultConfiguration,n);o=[...r,...s,...a]}for(const r of o)for(const s of(0,b.overrideIdentifiersFromKey)(r)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(s),u=n.getKeysForOverrideIdentifier(s),P=[...u.filter(D=>a.indexOf(D)===-1),...a.filter(D=>u.indexOf(D)===-1),...a.filter(D=>!C.equals(this._defaultConfiguration.override(s).getValue(D),n.override(s).getValue(D)))];i.push([s,P])}return this.updateDefaultConfiguration(n),{keys:o,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:i,removed:r}=h(this._policyConfiguration,n),s=[...o,...i,...r];return s.length&&this.updatePolicyConfiguration(n),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=h(this.applicationConfiguration,n),a=[...o,...i,...r];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=h(this.localUserConfiguration,n),a=[...o,...i,...r];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:s}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=h(this.remoteUserConfiguration,n),a=[...o,...i,...r];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:s}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=h(this.workspaceConfiguration,n),a=[...o,...i,...r];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:s}}compareAndUpdateFolderConfiguration(n,o){const i=this.folderConfigurations.get(n),{added:r,updated:s,removed:a,overrides:u}=h(i,o),P=[...r,...s,...a];return(P.length||!i)&&this.updateFolderConfiguration(n,o),{keys:P,overrides:u}}compareAndDeleteFolderConfiguration(n){const o=this.folderConfigurations.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:r,removed:s,overrides:a}=h(o,void 0);return{keys:[...i,...r,...s],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,o,i){let r=this.getConsolidatedConfigurationModelForResource(o,i);return o.overrideIdentifier&&(r=r.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:n},o){let i=this.getWorkspaceConsolidatedConfiguration();if(o&&n){const r=o.getFolder(n);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const s=this._memoryConfigurationByResource.get(n);s&&(i=i.merge(s))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let o=this._foldersConsolidatedConfigurations.get(n);if(!o){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(o=i.merge(r),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(n,o)):o=i}return o}getFolderConfigurationModelForResource(n,o){if(o&&n){const i=o.getFolder(n);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,o)=>{const{contents:i,overrides:r,keys:s}=this._folderConfigurations.get(o);return n.push([o,{contents:i,overrides:r,keys:s}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>n.add(o)),this.userConfiguration.freeze().keys.forEach(o=>n.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(i=>n.add(i))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>o.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>o.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(r=>o.add(r))),[...o.values()]}static parse(n){const o=this.parseConfigurationModel(n.defaults),i=this.parseConfigurationModel(n.policy),r=this.parseConfigurationModel(n.application),s=this.parseConfigurationModel(n.user),a=this.parseConfigurationModel(n.workspace),u=n.folders.reduce((P,D)=>(P.set(m.URI.revive(D[0]),this.parseConfigurationModel(D[1])),P),new M.ResourceMap);return new E(o,i,r,s,new f,a,u,new f,new M.ResourceMap,!1)}static parseConfigurationModel(n){return new f(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=E;function w(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const n=new Set,o=new Map;for(const r of c)r.keys.forEach(s=>n.add(s)),r.overrides.forEach(([s,a])=>{const u=(0,M.getOrSet)(o,s,new Set);a.forEach(P=>u.add(P))});const i=[];return o.forEach((r,s)=>i.push([s,[...r.values()]])),{keys:[...n.values()],overrides:i}}e.mergeChanges=w;class g{constructor(n,o,i,r){this.change=n,this.previous=o,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;n.keys.forEach(u=>s.add(u)),n.overrides.forEach(([,u])=>u.forEach(P=>s.add(P))),this.affectedKeys=[...s.values()];const a=new f;this.affectedKeys.forEach(u=>a.setValue(u,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(o){const i=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(n,o,this.currentWorkspace);return!C.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(n,o){let i=(0,I.toValuesTree)({[o]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(n=n[r],!n)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=g;function h(c,n){const{added:o,removed:i,updated:r}=p(n,c),s=[],a=c?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const P=u.filter(D=>!a.includes(D));for(const D of P)s.push([D,n.getKeysForOverrideIdentifier(D)])}if(c){const P=a.filter(D=>!u.includes(D));for(const D of P)s.push([D,c.getKeysForOverrideIdentifier(D)])}if(n&&c){for(const P of a)if(u.includes(P)){const D=p({contents:c.getOverrideValue(void 0,P)||{},keys:c.getKeysForOverrideIdentifier(P)},{contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)});s.push([P,[...D.added,...D.removed,...D.updated]])}}return{added:o,removed:i,updated:r,overrides:s}}function p(c,n){const o=c?n?c.keys.filter(s=>n.keys.indexOf(s)===-1):[...c.keys]:[],i=n?c?n.keys.filter(s=>c.keys.indexOf(s)===-1):[...n.keys]:[],r=[];if(c&&n){for(const s of n.keys)if(c.keys.indexOf(s)!==-1){const a=(0,I.getConfigurationValue)(n.contents,s),u=(0,I.getConfigurationValue)(c.contents,s);C.equals(a,u)||r.push(s)}}return{added:o,removed:i,updated:r}}}),define(Z[215],ee([0,1,24,3,2,50,12,19,108,62,6,38,47]),function(q,e,v,t,k,R,M,C,l,m,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class f extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:h})=>this.onDidUpdateConfiguration(g,h))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,h){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=f;class d extends l.ConfigurationModel{constructor(g={}){const h=S.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),p=Object.keys(h),c=Object.create(null),n=[];for(const o in h){const i=g[o],r=i!==void 0?i:h[o].default;(0,C.addToValueTree)(c,o,r,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(c))m.OVERRIDE_PROPERTY_REGEX.test(o)&&n.push({identifiers:(0,m.overrideIdentifiersFromKey)(o),keys:Object.keys(c[o]),contents:(0,C.toValuesTree)(c[o],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,p,n)}}e.DefaultConfigurationModel=d;class y{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new l.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let E=class extends k.Disposable{constructor(g,h,p){super(),this.defaultConfiguration=g,this.policyService=h,this.logService=p,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new l.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const h={},p=[],c=S.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const n of g){const o=c[n];if(!o){p.push(n);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}p.push(n),h[o.policy.name]={type:o.type}}}return(0,M.isEmptyObject)(h)||await this.policyService.registerPolicyDefinitions(h),p}onDidChangePolicies(g){const h=S.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),p=(0,v.coalesce)(g.map(c=>h.get(c)));this.update(p,!0)}update(g,h){const p=S.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),c=[],n=this._configurationModel.isEmpty();for(const o of g){const i=p[o]?.policy?.name;if(i){const r=this.policyService.getPolicyValue(i);(n?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(o),r))&&c.push([o,r])}else this._configurationModel.getValue(o)!==void 0&&c.push([o,void 0])}if(c.length){const o=this._configurationModel;this._configurationModel=new l.ConfigurationModel;for(const i of o.keys)this._configurationModel.setValue(i,o.getValue(i));for(const[i,r]of c)r===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,r);h&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};E=ve([J(1,b.IPolicyService),J(2,I.ILogService)],E),e.PolicyConfiguration=E}),define(Z[216],ee([0,1,8,3,2,16,19,108,215,38]),function(q,e,v,t,k,R,M,C,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(S,f,d,y){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new l.DefaultConfiguration),this.policyConfiguration=d instanceof m.NullPolicyService?new l.NullPolicyConfiguration:this._register(new l.PolicyConfiguration(this.defaultConfiguration,d,y)),this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,f)),this.configuration=new C.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new C.ConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:E,properties:w})=>this.onDidDefaultConfigurationChange(E,w))),this._register(this.policyConfiguration.onDidChangeConfiguration(E=>this.onDidPolicyConfigurationChange(E))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,f,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new C.Configuration(S,f,new C.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(S,f){const d=typeof S=="string"?S:void 0,y=(0,M.isConfigurationOverrides)(S)?S:(0,M.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(d,y,void 0)}updateValue(S,f,d,y){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const f=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(d,f,2)}onDidDefaultConfigurationChange(S,f){const d=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(S,f);this.trigger(y,d,7)}onDidPolicyConfigurationChange(S){const f=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(d,f,7)}trigger(S,f,d){const y=new C.ConfigurationChangeEvent(S,{data:f},this.configuration);y.source=d,y.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(Z[217],ee([0,1,17,5]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends v.ErrorNoTelemetry{constructor(C,l=k.Unknown,m){super(C),this._message=C,this._code=l,this._detail=m,this.isHandled=l===k.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(C){return C instanceof R&&C._code===k.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof R&&C._code===k.NoResolverFound}static isHandled(C){return C instanceof R&&C.isHandled}}e.RemoteAuthorityResolverError=R}),define(Z[63],ee([0,1,13]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const I=m.indexOf("+");return I<0?m:m.substr(0,I)}e.getRemoteName=k;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function M(m){const{host:I,port:b}=l(m);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:b}}e.parseAuthorityWithPort=M;function C(m,I){let{host:b,port:S}=l(m);return typeof S>"u"&&(S=I),{host:b,port:S}}e.parseAuthorityWithOptionalPort=C;function l(m){const I=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const b=m.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(Z[109],ee([0,1,25,5,63]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function M(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var l;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(l=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,E){if(typeof y>"u"||y===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof y=="string"||typeof E=="string"){const w=typeof y=="string"?y:y.value,g=typeof E=="string"?E:E.value;return v.equalsIgnoreCase(w,g)}return y._lower===E._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=m;function I(d){return b(d)}e.isApplicationScopedExtension=I;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function S(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function f(d,y){if(y){const E=`onResolveRemoteAuthority:${(0,k.getRemoteName)(y)}`;return d.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[110],ee([0,1,25,192,109,4,7,17,34]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,v.compareIgnoreCase)(o.id,i.id)===0}e.areSameExtensions=m;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{constructor(i,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=i.id}static create(i){const r=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,r,s)}static parse(i){const r=I.exec(i);return r&&r[1]&&r[2]?new b({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const i=S.exec(o);return i&&i[1]?[y(i[1]),i[2]]:[y(o),void 0]}e.getIdAndVersion=f;function d(o,i){return`${o}.${i}`}e.getExtensionId=d;function y(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function E(o,i){return y(d(o,i))}e.getGalleryExtensionId=E;function w(o,i){const r=[],s=a=>{for(const u of r)if(u.some(P=>m(i(P),i(a))))return u;return null};for(const a of o){const u=s(a);u?u.push(a):r.push([a])}return r}e.groupByExtension=w;function g(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function h(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function p(o,i){const r=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&r.every(u=>!m(u.identifier,{id:a}))){const u=o.filter(P=>m(P.identifier,{id:a}));u.length===1&&(r.push(u[0]),s.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=p;async function c(o,i){if(!R.isLinux)return!1;let r;try{r=(await o.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await o.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function n(o,i){const r=await c(o,i),s=(0,t.getTargetPlatform)(r?"alpine":R.platform,l.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(Z[72],ee([0,1,8,18,2,32,7,110,14,5,6]),function(q,e,v,t,k,R,M,C,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let b=class extends k.Disposable{constructor(f,d){super(),this.fileService=f,this.logService=d,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(f){return this.withProfileExtensions(f)}addExtensionsToProfile(f,d){return this.withProfileExtensions(d,y=>(y=y.filter(E=>f.some(([w])=>!(0,C.areSameExtensions)(E.identifier,w.identifier))),y.push(...f.map(([E,w])=>({identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:w}))),y))}removeExtensionFromProfile(f,d){return this.withProfileExtensions(d,y=>y.filter(E=>!(0,C.areSameExtensions)(E.identifier,f)))}async withProfileExtensions(f,d){return this.getResourceAccessQueue(f).queue(async()=>{let y=[];try{const E=await this.fileService.readFile(f),w=JSON.parse(E.value.toString());for(const g of w){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}y.push({identifier:g.identifier,location:M.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(E){E.fileOperationResult!==1&&this.logService.error(E)}if(d){y=d(y);const E=y.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),metadata:w.metadata}));await this.fileService.writeFile(f,t.VSBuffer.fromString(JSON.stringify(E)))}return y})}getResourceAccessQueue(f){let d=this.resourcesAccessQueueMap.get(f);return d||(d=new v.Queue,this.resourcesAccessQueueMap.set(f,d)),d}};b=ve([J(0,l.IFileService),J(1,I.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Z[218],ee([0,1,8,18,22,17,3,2,30,99,217,63]),function(q,e,v,t,k,R,M,C,l,m,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var f;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function d(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function y(B){const H=new k.CancellationTokenSource;return setTimeout(()=>H.cancel(),B),H.token}function E(B,H){if(B.isCancellationRequested||H.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),H.onCancellationRequested(()=>L.cancel()),L.token}class w{constructor(H){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),H.isCancellationRequested?this._timeout():this._disposables.add(H.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(H){this._state==="pending"?this._disposables.add(H):H.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(H))}reject(H){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(H))}}function g(B,H){const L=new w(H);return L.registerDisposable(B.onControlMessage(O=>{const _=JSON.parse(O.toString()),V=F(_);V?L.reject(V):L.resolve(_)})),L.promise}function h(B,H,L,O,_,V,x,re){const j=new w(re);return H.connect(L,O,_,V,x,(ie,ne)=>{j.didTimeout?(ie&&B.error(ie),ne?.dispose()):ie||!ne?j.reject(ie):j.resolve(ne)}),j.promise}function p(B,H){const L=new w(H);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function c(B,H,L,O){const _=z(B,H);B.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let V;try{V=await h(B.logService,B.socketFactory,B.host,B.port,(0,b.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${d(H)}-${B.reconnectionToken}`,O)}catch(ne){throw B.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ne),ne}B.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let x,re;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),x=B.reconnectionProtocol,re=!1):(x=new m.PersistentProtocol(V,null),re=!0),B.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const j=await p(B.signService.createNewMessage((0,l.generateUuid)()),O),ie={type:"auth",auth:B.connectionToken||"00000000000000000000",data:j.data};x.sendControl(t.VSBuffer.fromString(JSON.stringify(ie)));try{const ne=await g(x,E(O,y(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(B.logService.trace(`${_} 4/6. received SignRequest control message.`),!await p(B.signService.validate(j,ne.signedData),O)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const ge=await p(B.signService.sign(ne.data),O),Me={type:"connectionType",commit:B.commit,signedData:ge,desiredConnectionType:H};return L&&(Me.args=L),B.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(t.VSBuffer.fromString(JSON.stringify(Me))),{protocol:x,ownsProtocol:re}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(B.logService.error(`${_} the handshake timed out. Error:`),B.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${_} received error control message when negotiating connection. Error:`),B.logService.error(ne)),re&&K(x),ne}}async function n(B,H,L,O){const _=Date.now(),V=z(B,H),{protocol:x,ownsProtocol:re}=await c(B,H,L,O),j=new w(O);return j.registerDisposable(x.onControlMessage(ie=>{const ne=JSON.parse(ie.toString()),ae=F(ne);ae?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(ae),re&&K(x),j.reject(ae)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${te(_)}!`),j.resolve({protocol:x,firstMessage:ne}))})),j.promise}async function o(B,H){const{protocol:L}=await n(B,1,void 0,H);return{protocol:L}}async function i(B,H,L){const{protocol:O,firstMessage:_}=await n(B,2,H,L),V=_&&_.debugPort;return{protocol:O,debugPort:V}}async function r(B,H,L){const O=Date.now(),_=z(B,3),{protocol:V}=await c(B,3,H,L);return B.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${te(O)}!`),V}async function s(B,H,L){const{host:O,port:_,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:_,connectionToken:V,reconnectionToken:H,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function a(B,H,L){return P(B,async O=>{const{protocol:_}=await o(O,k.CancellationToken.None);return new de(B,H,L,O.reconnectionToken,_)})}e.connectRemoteAgentManagement=a;async function u(B,H){return P(B,async L=>{const{protocol:O,debugPort:_}=await i(L,H,k.CancellationToken.None);return new G(B,H,L.reconnectionToken,O,_)})}e.connectRemoteAgentExtensionHost=u;async function P(B,H){for(let O=1;;O++)try{const _=(0,l.generateUuid)(),V=await s(B,_,null);return await H(V)}catch(_){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(_);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(_),se.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(_)),_}}async function D(B,H,L){const O=await s(B,(0,l.generateUuid)(),null);return await r(O,{host:H,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function T(B){return(0,v.createCancelablePromise)(H=>new Promise((L,O)=>{const _=setTimeout(L,B*1e3);H.onCancellationRequested(()=>{clearTimeout(_),L()})}))}var N;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(H,L){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=U;class ${constructor(H,L,O,_){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=$;class Y{constructor(H,L,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=Y;class oe{constructor(H,L,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=oe;class ue{constructor(H,L,O,_){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=ue;class se extends C.Disposable{constructor(H,L,O,_,V){super(),this._connectionType=H,this._options=L,this.reconnectionToken=O,this.protocol=_,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new oe(this.reconnectionToken,0,0)),this._register(_.onSocketClose(x=>{const re=W(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${re} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${re} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${re} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(x=>{const re=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,C.toDisposable)(()=>{const x=se._instances.indexOf(this);x>=0&&se._instances.splice(x,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}static triggerPermanentFailure(H,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=H,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(H=>H._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(H=>H._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const H=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const _=O<L.length?L[O]:L[L.length-1];try{if(_>0){const x=T(_);this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,x)),this._options.logService.info(`${H} waiting for ${_} seconds before reconnecting...`);try{await x}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${H} resolving connection...`);const V=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${H} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,y(S)),this._options.logService.info(`${H} reconnected!`),this._onDidStateChange.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,R.isCancellationError)(V)){this._options.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,I.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(H,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(H,L,O):this._gotoPermanentFailure(H,L,O)}_gotoPermanentFailure(H,L,O){this._onDidStateChange.fire(new ue(this.reconnectionToken,H,L,O)),K(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class de extends se{constructor(H,L,O,_,V){super(1,H,_,V,!0),this.client=this._register(new m.Client(V,{remoteAuthority:L,clientId:O},H.ipcLogger))}async _reconnect(H,L){await o(H,L)}}e.ManagementPersistentConnection=de;class G extends se{constructor(H,L,O,_,V){super(2,H,O,_,!1),this._startArguments=L,this.debugPort=V}async _reconnect(H,L){await i(H,this._startArguments,L)}}e.ExtensionHostPersistentConnection=G;function K(B){try{B.acceptDisconnect();const H=B.getSocket();B.dispose(),H.dispose()}catch(H){(0,R.onUnexpectedError)(H)}}function F(B){if(B&&B.type==="error"){const H=new Error(`Connection error: ${B.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function A(B,H){for(;B.length<H;)B+=" ";return B}function W(B,H,L){return`[remote-connection][${A(d(B),13)}][${H.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function z(B,H){return`${W(H,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function te(B){return`${Date.now()-B} ms`}}),define(Z[219],ee([0,1,77,83]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,M,C,l,m){const I=S=>m(S,void 0),b=v.createConnection({host:k,port:R},()=>{b.removeListener("error",I);const S=Buffer.alloc(16);for(let E=0;E<16;E++)S[E]=Math.round(Math.random()*256);const f=S.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${M}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];b.write(d.join(`\r
`)+`\r
\r
`);const y=E=>{E.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",y),m(void 0,new t.NodeSocket(b,l)))};b.on("data",y)});b.setNoDelay(!0),b.once("error",I)}}}),define(Z[220],ee([0,1,29,45,28,183]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function C(f=!1){return(M===void 0||f)&&(M=l()),M}e.hasWSLFeatureInstalled=C;async function l(){const f=m();if(f===void 0)return!1;if(f>=22e3){const d=b();if(d)return new Promise(y=>{t.execFile(d,["--status"],E=>y(!E))})}else{const d=S();if(d)try{if((await k.promises.stat(d)).isFile())return!0}catch{}}return!1}function m(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());if(f)return parseInt(f[3])}function I(f){const d=process.env.SystemRoot;if(d){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(d,y?"Sysnative":"System32",f)}}function b(){return I("wsl.exe")}function S(){return I("lxss\\LxssManager.dll")}}),define(Z[55],ee([0,1,18,166,62,5,47]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function C(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=C;function l(y){return y.res.statusCode===204}async function m(y){return l(y)?null:(await(0,v.streamToBuffer)(y.stream)).toString()}e.asText=m;async function I(y){if(!C(y))throw new Error("Server returned "+y.res.statusCode);return m(y)}e.asTextOrError=I;async function b(y){if(!C(y))throw new Error("Server returned "+y.res.statusCode);if(l(y))return null;const w=(await(0,v.streamToBuffer)(y.stream)).toString();try{return JSON.parse(w)}catch(g){throw g.message+=`:
`+w,g}}e.asJson=b;function S(y){d(y)}e.updateProxyConfigurationsScope=S;let f;function d(y){const E=M.Registry.as(k.Extensions.Configuration),w=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[f],remove:w?[w]:[]})}d(2)}),define(Z[221],ee([0,1,18,22]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(C){this.service=C}listen(C,l){throw new Error("Invalid listen")}call(C,l,m,I=t.CancellationToken.None){switch(l){case"request":return this.service.request(m[0],I).then(async({res:b,stream:S})=>{const f=await(0,v.streamToBuffer)(S);return[{statusCode:b.statusCode,headers:b.headers},f]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(C){this.channel=C}async request(C,l){const[m,I]=await this.channel.call("request",[C],l);return{res:m,stream:(0,v.bufferToStream)(I)}}async resolveProxy(C){return this.channel.call("resolveProxy",[C])}}e.RequestChannelClient=R}),define(Z[222],ee([0,1,223,12]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(M,C){return M.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:M.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function R(M,C,l={}){const m=(0,v.parse)(M),I=l.proxyUrl||k(m,C);if(!I)return null;const b=(0,v.parse)(I);if(!/^https?:$/.test(b.protocol||""))return null;const S={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,t.isBoolean)(l.strictSSL)?l.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((f,d)=>{q(["http-proxy-agent"],f,d)}))(S):new(await new Promise((f,d)=>{q(["https-proxy-agent"],f,d)}))(S)}e.getProxyAgent=R}),define(Z[111],ee([0,1,45,9,167,22,44,17,4,30,143,59,8]),function(q,e,v,t,k,R,M,C,l,m,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const f=1e4;let d;async function y(w,g,h){return g["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(h)&&!g["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(h)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=S.Promises.withAsyncBody(async(p,c)=>{const n=new R.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),c(new Error((0,k.localize)(0,null)))},f);try{p(await E(w,n.token))}catch(i){!(0,C.isCancellationError)(i)&&!n.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,M.toErrorMessage)(i)))):p({})}finally{clearTimeout(o),n.dispose()}})),d)}e.getResolvedShellEnv=y;async function E(w,g){const h=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",h);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",p);const c=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};w.trace("getUnixShellEnvironment#env",o);const i=await(0,I.getSystemShell)(l.OS,o);return w.trace("getUnixShellEnvironment#shell",i),new Promise((r,s)=>{if(g.isCancellationRequested)return s((0,C.canceled)());const a=(0,t.basename)(i);let u,P;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(u=`& '${process.execPath}' ${D} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,P=["-Login","-Command"]):(u=`'${process.execPath}' ${D} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?P=["-ic"]:P=["-ilc"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),u);const T=(0,v.spawn)(i,[...P,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});g.onCancellationRequested(()=>(T.kill(),s((0,C.canceled)()))),T.on("error",$=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)($)),s($)});const N=[];T.stdout.on("data",$=>N.push($));const U=[];T.stderr.on("data",$=>U.push($)),T.on("close",($,Y)=>{const oe=Buffer.concat(N).toString("utf8");w.trace("getUnixShellEnvironment#raw",oe);const ue=Buffer.concat(U).toString("utf8");if(ue.trim()&&w.trace("getUnixShellEnvironment#stderr",ue),$||Y)return s(new Error((0,k.localize)(2,null,$,Y)));const se=n.exec(oe),de=se?se[1]:"{}";try{const G=JSON.parse(de);h?G.ELECTRON_RUN_AS_NODE=h:delete G.ELECTRON_RUN_AS_NODE,p?G.ELECTRON_NO_ATTACH_CONSOLE=p:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",G),r(G)}catch(G){w.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(G)),s(G)}})})}}),define(Z[87],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[224],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>q(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),M=new R.validator;if(M){const C=String(v._nextId++);return this.validators.set(C,M),{id:C,data:M.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const M=this.validators.get(k.id);if(!M)return!1;this.validators.delete(k.id);try{return M.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),M=new R.signer;if(M)return M.sign(k)}catch{}return k}}e.SignService=v,v._nextId=1}),define(Z[39],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Z[21],ee([0,1,15,41,8,3,2,4,34,12,5,6,39,26]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var d;(function(w){w[w.QUIT=1]="QUIT",w[w.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var y;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen",w[w.Eventually=4]="Eventually"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let E=class St extends M.Disposable{constructor(g,h,p){super(),this.logService=g,this.stateMainService=h,this.environmentMainService=p,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(St.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(St.QUIT_AND_RESTART_KEY)}registerListeners(){const g=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),C.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};v.app.addListener("before-quit",g);const h=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!C.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",h),v.app.once("will-quit",p=>{this.trace("Lifecycle#app.on(will-quit)"),p.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",g),v.app.removeListener("window-all-closed",h),v.app.quit()})})}fireOnWillShutdown(g){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const h=[];return this._onWillShutdown.fire({reason:g,join(p){h.push(p)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(h)}catch(p){this.logService.error(p)}try{await this.stateMainService.close()}catch(p){this.logService.error(p)}})(),this.pendingWillShutdownPromise}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===g)return;this.trace(`lifecycle (main): phase changed (value: ${g})`),this._phase=g;const h=this.phaseWhen.get(this._phase);h&&(h.open(),this.phaseWhen.delete(this._phase))}async when(g){if(g<=this._phase)return;let h=this.phaseWhen.get(g);h||(h=new k.Barrier,this.phaseWhen.set(g,h)),await h.wait()}registerWindow(g){const h=new M.DisposableStore;this.windowCounter++,h.add(g.onWillLoad(c=>this._onWillLoadWindow.fire({window:g,workspace:c.workspace,reason:c.reason})));const p=(0,m.assertIsDefined)(g.win);p.on("close",c=>{const n=g.id;if(this.windowToCloseRequest.has(n)){this.windowToCloseRequest.delete(n);return}this.trace(`Lifecycle#window.on('close') - window ID ${g.id}`),c.preventDefault(),this.unload(g,1).then(o=>{if(o){this.windowToCloseRequest.delete(n);return}this.windowToCloseRequest.add(n),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${n}`),this._onBeforeCloseWindow.fire(g),g.close()})}),p.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.windowCounter--,h.dispose(),this.windowCounter===0&&(!C.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(g,h){await this.unload(g,3)||g.reload(h)}unload(g,h){const p=this.mapWindowIdToPendingUnload.get(g.id);if(p)return p;const c=this.doUnload(g,h).finally(()=>{this.mapWindowIdToPendingUnload.delete(g.id)});return this.mapWindowIdToPendingUnload.set(g.id,c),c}async doUnload(g,h){if(!g.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${g.id}`);const p=this._quitRequested?2:h,c=await this.onBeforeUnloadWindowInRenderer(g,p);return c?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.handleWindowUnloadVeto(c)):(await this.onWillUnloadWindowInRenderer(g,p),!1)}handleWindowUnloadVeto(g){return g?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(g){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(g),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(g,h){return new Promise(p=>{const c=this.oneTimeListenerTokenGenerator++,n=`vscode:ok${c}`,o=`vscode:cancel${c}`;t.validatedIpcMain.once(n,()=>{p(!1)}),t.validatedIpcMain.once(o,()=>{p(!0)}),g.send("vscode:onBeforeUnload",{okChannel:n,cancelChannel:o,reason:h})})}onWillUnloadWindowInRenderer(g,h){return new Promise(p=>{const n=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(n,()=>p()),g.send("vscode:onWillUnload",{replyChannel:n,reason:h})})}quit(g){return this.trace(`Lifecycle#quit() - begin (willRestart: ${g})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(g&&this.stateMainService.setItem(St.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(h=>{this.pendingQuitPromiseResolve=h,this.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}trace(g){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(g):this.logService.trace(g)}async relaunch(g){this.trace("Lifecycle#relaunch()");const h=process.argv.slice(1);if(g?.addArgs&&h.push(...g.addArgs),g?.removeArgs)for(const n of g.removeArgs){const o=h.indexOf(n);o>=0&&h.splice(o,1)}const p=()=>{try{if(C.isWindows){const n=(0,l.cwd)();n!==process.cwd()&&process.chdir(n)}}catch(n){this.logService.error(n)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:h})};v.app.once("quit",p),await this.quit(!0)&&v.app.removeListener("quit",p)}async kill(g){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const h of v.BrowserWindow.getAllWindows())if(h&&!h.isDestroyed()){let p;h.webContents&&!h.webContents.isDestroyed()?p=new Promise(c=>h.once("closed",c)):p=Promise.resolve(),h.destroy(),await p}})()]),v.app.exit(g)}};E.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",E=ve([J(0,b.ILogService),J(1,S.IStateMainService),J(2,f.IEnvironmentMainService)],E),e.LifecycleMainService=E}),define(Z[225],ee([0,1,4,3,2,5,21]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let C=class extends k.Disposable{constructor(I){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,I.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const I=await new Promise((b,S)=>{q(["native-keymap"],b,S)});this._keyboardLayoutData=l(I),v.isCI||I.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=l(I),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};C=ve([J(0,M.ILifecycleMainService)],C),e.KeyboardLayoutMainService=C;function l(m){const I=m.getKeyMap(),b=m.getCurrentKeyboardLayout();return{keyboardMapping:I,keyboardLayoutInfo:b}}}),define(Z[226],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,v.createDecorator)("stateService")}),define(Z[227],ee([0,1,8,18,12,36,14,6]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class l{constructor(b,S,f){this.storagePath=b,this.logService=S,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}}getItem(b,S){const f=this.storage[b];return(0,k.isUndefinedOrNull)(f)?S:f}setItem(b,S){this.setItems([{key:b,data:S}])}setItems(b){let S=!1;for(const{key:f,data:d}of b)this.storage[f]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.storage[f])||(this.storage[f]=void 0,S=!0):(this.storage[f]=d,S=!0));S&&this.save()}removeItem(b){(0,k.isUndefined)(this.storage[b])||(this.storage[b]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const b=JSON.stringify(this.storage,null,4);if(b!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(b)),this.lastSavedStorageContents=b}catch(S){this.logService.error(S)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=l;let m=class{constructor(b,S,f){this.fileStorage=new l(b.stateResource,S,f)}async init(){await this.fileStorage.init()}getItem(b,S){return this.fileStorage.getItem(b,S)}};m=ve([J(0,R.IEnvironmentService),J(1,C.ILogService),J(2,M.IFileService)],m),e.StateService=m}),define(Z[228],ee([0,1,227]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends v.StateService{setItem(R,M){this.fileStorage.setItem(R,M)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(Z[112],ee([0,1,4,34,7,30]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(m){if(v.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function C(m,I,b,S,f,d,y,E,w,g){const h=Object.create(null);h["common.machineId"]=y,h.sessionID=(0,R.generateUuid)()+Date.now(),h.commitHash=f,h.version=d,h["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,v.PlatformToString)(v.platform),h["common.nodePlatform"]=t.platform,h["common.nodeArch"]=S,h["common.product"]=g||"desktop",E&&(h["common.msftInternal"]=E);let p=0;const c=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),v.isLinuxSnap&&(h["common.snap"]="true");const n=M(b);n&&(h["common.platformDetail"]=n);try{const o=await m.readFile(k.URI.file(w));h["common.source"]=o.value.toString().slice(0,30)}catch{}return h}e.resolveCommonProperties=C;function l(m){const I=t.env.USERDNSDOMAIN;if(!I)return!1;const b=I.toLowerCase();return m.some(S=>b===S)}e.verifyMicrosoftInternalDomain=l}),define(Z[37],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[229],ee([0,1,29,57,8,43,13,9,4,7,81,23,98,84,14,20,37]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const w=new Map;async function g(o,i){const r=`${o}::${i.join(":")}`,s=w.get(r);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,P=new Map,D=2e4;function T(U,$,Y,oe){const ue=$.substring(U.length+1);return k.Promises.withAsyncBody(async se=>{let de;try{de=await b.Promises.readdir($,{withFileTypes:!0})}catch{se();return}if(oe.count>=D){oe.count+=de.length,oe.maxReached=!0,se();return}let G=de.length;if(G===0){se();return}let K=de;oe.count+de.length>D&&(oe.maxReached=!0,G=D-oe.count,K=de.slice(0,G)),oe.count+=de.length;for(const F of K)if(F.isDirectory()){if(Y.includes(F.name)||await T(U,(0,C.join)($,F.name),Y,oe),--G===0){se();return}}else{const A=F.name.lastIndexOf(".");if(A>=0){const W=F.name.substring(A+1);W&&u.set(W,(u.get(W)??0)+1)}for(const W of a)W.relativePathPattern?.test(ue)!==!1&&W.filePattern.test(F.name)&&P.set(W.tag,(P.get(W.tag)??0)+1);if(--G===0){se();return}}})}const N=k.Promises.withAsyncBody(async U=>{const $={count:0,maxReached:!1};await T(o,o,i,$);const Y=await c(o);U({configFiles:h(P),fileTypes:h(u),fileCount:$.count,maxFilesReached:$.maxReached,launchConfigFiles:Y})});return w.set(r,N),N}e.collectWorkspaceStats=g;function h(o){return[...t.Iterable.map(o.entries(),([i,r])=>({name:i,count:r}))].sort((i,r)=>r.count-i.count)}function p(){const o={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(o.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),o}e.getMachineInfo=p;async function c(o){try{const i=new Map,r=(0,C.join)(o,".vscode","launch.json"),s=await b.Promises.readFile(r),a=[],u=(0,R.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(u)==="object"&&u.configurations)for(const P of u.configurations){const D=P.type;D&&(i.has(D)?i.set(D,i.get(D)+1):i.set(D,1))}return h(i)}catch{return[]}}e.collectLaunchConfigs=c;let n=class{constructor(i,r){this.telemetryService=i,this.productService=r}formatMachineInfo(i){const r=[];return r.push(`OS Version:       ${i.os}`),r.push(`CPUs:             ${i.cpus}`),r.push(`Memory (System):  ${i.memory}`),r.push(`VM:               ${i.vmHint}`),r.join(`
`)}formatEnvironment(i){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const s=v.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),l.isWindows||r.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${i.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(i,r){return Promise.all([(0,S.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async s=>{let[a,u]=s,P=this.formatProcessList(i,a);return r.forEach(D=>{if((0,f.isRemoteDiagnosticError)(D))P+=`
${D.errorMessage}`,u+=`
${D.errorMessage}`;else if(P+=`

Remote: ${D.hostName}`,D.processes&&(P+=`
${this.formatProcessList(i,D.processes)}`),D.workspaceMetadata){u+=`
|  Remote: ${D.hostName}`;for(const T of Object.keys(D.workspaceMetadata)){const N=D.workspaceMetadata[T];let U=`${N.fileCount} files`;N.maxFilesReached&&(U=`more than ${U}`),u+=`|    Folder (${T}): ${U}`,u+=this.formatWorkspaceStats(N)}}}),{processInfo:P,workspaceInfo:u}})}async getSystemInfo(i,r){const{memory:s,vmHint:a,os:u,cpus:P}=p(),D={os:u,memory:s,cpus:P,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:r};return l.isWindows||(D.load=`${v.loadavg().map(T=>Math.round(T)).join(", ")}`),l.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(i,r){const s=[];return(0,S.listProcesses)(i.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(i)),s.push(""),s.push(this.formatProcessList(i,a)),i.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(i))),r.forEach(u=>{if((0,f.isRemoteDiagnosticError)(u))s.push(`
${u.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${u.hostName}`),s.push(this.formatMachineInfo(u.machineInfo)),u.processes&&s.push(this.formatProcessList(i,u.processes)),u.workspaceMetadata)for(const P of Object.keys(u.workspaceMetadata)){const D=u.workspaceMetadata[P];let T=`${D.fileCount} files`;D.maxFilesReached&&(T=`more than ${T}`),s.push(`Folder (${P}): ${T}`),s.push(this.formatWorkspaceStats(D))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(i){const r=[];let a=0;const u=(N,U)=>{const $=` ${N}(${U})`;a+$.length>60?(r.push(P),P="|                 ",a=P.length):a+=$.length,P+=$};let P="|      File types:";const D=10,T=i.fileTypes.length>D?D:i.fileTypes.length;for(let N=0;N<T;N++){const U=i.fileTypes[N];u(U.name,U.count)}if(r.push(P),i.configFiles.length>=0&&(P="|      Conf files:",a=0,i.configFiles.forEach(N=>{u(N.name,N.count)}),r.push(P)),i.launchConfigFiles.length>0){let N="|      Launch Configs:";i.launchConfigFiles.forEach(U=>{N+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),r.push(N)}return r.join(`
`)}expandGPUFeatures(i){const r=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${i[s]}`).join(`
                  `)}formatWorkspaceMetadata(i){const r=[],s=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(u=>{const P=m.URI.revive(u);if(P.scheme===M.Schemas.file){const D=P.fsPath;s.push(g(D,["node_modules",".git"]).then(T=>{let N=`${T.fileCount} files`;T.maxFilesReached&&(N=`more than ${N}`),r.push(`|    Folder (${(0,C.basename)(D)}): ${N}`),r.push(this.formatWorkspaceStats(T))}).catch(T=>{r.push(`|      Error: Unable to collect workspace stats for folder ${D} (${T.toString()})`)}))}else r.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,r){const s=new Map;i.windows.forEach(u=>s.set(u.pid,u.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(i.mainPID,s,a,r,0),a.join(`
`)}formatProcessItem(i,r,s,a,u){const P=u===0;let D;P?D=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(D=`${"  ".repeat(u)} ${a.name}`,a.name==="window"&&(D=`${D} (${r.get(a.pid)})`));const T=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(T/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(a.children)&&a.children.forEach(N=>this.formatProcessItem(i,r,s,N,u+1))}async getWorkspaceFileExtensions(i){const r=new Set;for(const{uri:s}of i.folders){const a=m.URI.revive(s);if(a.scheme!==M.Schemas.file)continue;const u=a.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(D=>r.add(D.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(i){for(const{uri:r}of i.folders){const s=m.URI.revive(r);if(s.scheme!==M.Schemas.file)continue;const a=s.fsPath;try{const u=await g(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),u.fileTypes.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),u.launchConfigFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),u.configFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})})}catch{}}}};n=ve([J(0,E.ITelemetryService),J(1,y.IProductService)],n),e.DiagnosticsService=n}),define(Z[230],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(R){this.appenders=R}listen(R,M){throw new Error(`Event not found: ${M}`)}call(R,M,{eventName:C,data:l}){return this.appenders.forEach(m=>m.log(C,l)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class t{constructor(R){this.channel=R}log(R,M){return this.channel.call("log",{eventName:R,data:M}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(Z[73],ee([0,1,50,94,12,19,112,37]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class l{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(n,o){return Promise.resolve(void 0)}publicLog2(n,o){return this.publicLog(n,o)}publicLogError(n,o){return Promise.resolve(void 0)}publicLogError2(n,o){return this.publicLogError(n,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=l,e.NullTelemetryService=new l;class m{async publicLog(n,o,i){}async publicLogError(n,o,i){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(c,n){return n.onDidChangeConfiguration(o=>{o.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(o.source),configurationKeys:w(o.sourceConfig)})})}e.configurationTelemetry=I;function b(c,n){return!(n.disableTelemetry||!c.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=b;function S(c){const n=c.getValue(C.TELEMETRY_SETTING_ID),o=c.getValue("telemetry.enableCrashReporter");if(c.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function f(c){const n={},o={},i={};E(c,i);for(let r in i){r=r.length>150?r.substr(r.length-149):r;const s=i[r];typeof s=="number"?o[r]=s:typeof s=="boolean"?o[r]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${s.length}`),n[r]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(n[r]=s)}return{properties:n,measurements:o}}e.validateTelemetryData=f;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function y(c){if(!c)return"none";for(const n of d)if(c.startsWith(`${n}+`))return n;return"other"}e.cleanRemoteAuthority=y;function E(c,n,o=0,i){if(!!c)for(const r of Object.getOwnPropertyNames(c)){const s=c[r],a=i?i+r:r;Array.isArray(s)?n[a]=(0,v.safeStringify)(s):s instanceof Date?n[a]=s.toISOString():(0,k.isObject)(s)?o<2?E(s,n,o+1,a+"."):n[a]=(0,v.safeStringify)(s):n[a]=s}}function w(c){if(!c)return[];const n=[];return g(n,"",c),n}function g(c,n,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(i=>g(c,n?`${n}.${i}`:i,o[i])):c.push(n)}function h(c,n){const o=c.msftInternalDomains||[],i=n.getValue("telemetry.internalTesting");return(0,M.verifyMicrosoftInternalDomain)(o)||i}e.isInternalTelemetry=h;function p(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=p}),define(Z[231],ee([0,1,189,73]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,M,C,l,m,I,b){const S={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${M.nameShort})`};if((0,t.supportsTelemetry)(M,C)&&(0,t.getTelemetryLevel)(l)===3){const f=await(0,v.getServiceMachineId)(C,m,I),{sessionId:d}=await b.getTelemetryInfo();S["X-Market-User-Id"]=f,S["VSCode-SessionId"]=d}return S}e.resolveMarketplaceHeaders=k}),define(Z[232],ee([0,1,2,50,94,4,25,168,19,62,54,20,47,37,73]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(g,h,p){this._configurationService=h,this._productService=p,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,h){this._experimentProperties[g]=h}_updateTelemetryLevel(){let g=(0,d.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const p=h.usage?3:h.error?2:0;g=Math.min(g,p)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,h=g.sessionID,p=g["common.machineId"],c=g["common.firstSessionDate"],n=g["common.msftInternal"];return{sessionId:h,machineId:p,firstSessionDate:c,msftInternal:n}}dispose(){this._disposables.dispose()}_log(g,h,p,c){return this.telemetryLevel.value<h?Promise.resolve(void 0):this._commonProperties.then(n=>{p=(0,t.mixin)(p,n),p=(0,t.mixin)(p,this._experimentProperties),p=(0,t.cloneAndChange)(p,o=>{if(typeof o=="string")return this._cleanupInfo(o,c)}),this._appenders.forEach(o=>o.log(g,p))},n=>{console.error(n)})}publicLog(g,h,p){return this._log(g,3,h,p)}publicLog2(g,h,p){return this.publicLog(g,h,p)}publicLogError(g,h){return this._sendErrorTelemetry?this._log(g,2,h,!0):Promise.resolve(void 0)}publicLogError2(g,h){return this.publicLogError(g,h)}_anonymizeFilePaths(g){let h=g;const p=[];for(const i of this._cleanupPatterns)for(;;){const r=i.exec(g);if(!r)break;p.push([r.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(h="";;){const i=n.exec(g);if(!i)break;!c.test(i[0])&&p.every(([r,s])=>i.index<r||i.index>=s)&&(h+=g.substring(o,i.index)+"<REDACTED: user-file-path>",o=n.lastIndex)}return o<g.length&&(h+=g.substr(o)),h}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const h=g.toLowerCase(),p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of p)if(c.regex.test(h))return`<REDACTED: ${c.label}>`;return g}_cleanupInfo(g,h){let p=g;h&&(p=this._anonymizeFilePaths(p));for(const c of this._cleanupPatterns)p=p.replace(c,"");return p=this._removePropertiesWithPossibleUserInfo(p),p}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ve([J(1,l.IConfigurationService),J(2,b.IProductService)],y),e.TelemetryService=y;function E(){const w=(0,C.localize)(0,null,I.default.nameLong),g=I.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=R.isWeb?"":(0,C.localize)(3,null),p=(0,C.localize)(4,null),c=(0,C.localize)(5,null),n=(0,C.localize)(6,null),o=(0,C.localize)(7,null),i=`
|       | ${p} | ${c} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${w} ${g} ${h}

&nbsp;

${o}
${i}

&nbsp;

${r}
`}S.Registry.as(m.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[f.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(m.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[f.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,C.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,C.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${f.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[233],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===v.HIGH_CONTRAST_DARK||R===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===v.DARK||R===v.HIGH_CONTRAST_DARK}e.isDark=k}),define(Z[234],ee([0,1,119,3,2,5,47,233]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var l;(function(E){function w(g){return g&&typeof g=="object"&&typeof g.id=="string"}E.isThemeColor=w})(l=e.ThemeColor||(e.ThemeColor={}));function m(E){return{id:E}}e.themeColorFromId=m;var I;(function(E){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||l.isThemeColor(r.color))}E.isThemeIcon=w;const g=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function h(r){const s=g.exec(r);if(!s)return;const[,a]=s;return{id:a}}E.fromString=h;function p(r){return{id:r}}E.fromId=p;function c(r,s){let a=r.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),s&&(a=`${a}~${s}`),{id:a}}E.modify=c;function n(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}E.getModifier=n;function o(r,s){return r.id===s.id&&r.color?.id===s.color?.id}E.isEqual=o;function i(r,s){return{id:r.id,color:s?m(s):void 0}}E.asThemeIcon=i,E.asClassNameArray=v.CSSIcon.asClassNameArray,E.asClassName=v.CSSIcon.asClassName,E.asCSSSelector=v.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function b(E){switch(E){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case C.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,k.toDisposable)(()=>{const g=this.themingParticipants.indexOf(w);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const f=new S;M.Registry.add(e.Extensions.ThemingContribution,f);function d(E){return f.onColorThemeChange(E)}e.registerThemingParticipant=d;class y extends k.Disposable{constructor(w){super(),this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,g){let h=this.theme.getColor(w);return h&&g&&(h=g(h,this.theme)),h?h.toString():null}}e.Themable=y}),define(Z[64],ee([0,1,15,3,2,4,19,5,39]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",I="#1E1E1E",b="#000000",S="#FFFFFF",f="theme",d="themeBackground",y="windowSplash";e.IThemeMainService=(0,C.createDecorator)("themeMainService");let E=class extends k.Disposable{constructor(g,h){super(),this.stateMainService=g,this.configurationService=h,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&v.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const g=this.getColorScheme();if(g.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return g.dark?b:S;let h=this.stateMainService.getItem(d,null);if(!h)switch(this.stateMainService.getItem(f,"vs-dark").split(" ")[0]){case"vs":h=m;break;case"hc-black":h=b;break;case"hc-light":h=S;break;default:h=I}return R.isMacintosh&&h.toUpperCase()===I&&(h="#171717"),h}saveWindowSplash(g,h){this.stateMainService.setItems([{key:f,data:h.baseTheme},{key:d,data:h.colorInfo.background},{key:y,data:h}]),typeof g=="number"&&this.updateBackgroundColor(g,h)}updateBackgroundColor(g,h){for(const p of v.BrowserWindow.getAllWindows())if(p.id===g){p.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(y)}};E=ve([J(0,l.IStateMainService),J(1,M.IConfigurationService)],E),e.ThemeMainService=E}),define(Z[113],ee([0,1,3,4,5,6]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var M;(function(y){y.Http="http",y.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var l;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(l=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const E=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!E)return{address:E[1],port:+E[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=b;function S(y,E){return E?E!==1&&y<1024:!t.isWindows&&y<1024}e.isPortPrivileged=S;class f{constructor(E,w,g){this.remoteAddress=E,this.localAddress=w,this._dispose=g,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let d=class{constructor(E){this.logService=E,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(E){return this._tunnelProvider=E,E?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(E){this._canElevate=E.elevation,this._privacyOptions=E.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const E=[],w=Array.from(this._tunnels.values());for(const g of w){const h=Array.from(g.values());for(const p of h){const c=await p.value;c&&E.push(c)}}return E}async dispose(){for(const E of this._tunnels.values()){for(const{value:w}of E.values())await w.then(g=>g?.dispose());E.clear()}this._tunnels.clear()}openTunnel(E,w,g,h,p=!1,c,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${g} on local port ${h}.`),!E)return;if(w||(w="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(E,w,g,h,p,c,n);return o?o.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(i);return(i.tunnelRemoteHost!==w||i.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(E){return{tunnelRemotePort:E.tunnelRemotePort,tunnelRemoteHost:E.tunnelRemoteHost,tunnelLocalPort:E.tunnelLocalPort,localAddress:E.localAddress,privacy:E.privacy,protocol:E.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${E.tunnelRemoteHost}:${E.tunnelRemotePort} `);const w=this._tunnels.get(E.tunnelRemoteHost);if(w){const g=w.get(E.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(E.tunnelRemoteHost,E.tunnelRemotePort,g))}}}}async tryDisposeTunnel(E,w,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${E}:${w}.`);const h=g.value.then(async p=>{p&&(await p.dispose(!0),this._onTunnelClosed.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this._tunnels.has(E)&&this._tunnels.get(E).delete(w),h}}async closeTunnel(E,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${E}:${w} `);const g=this._tunnels.get(E);if(g&&g.has(w)){const h=g.get(w);h.refcount=0,await this.tryDisposeTunnel(E,w,h)}}addTunnelToMap(E,w,g){this._tunnels.has(E)||this._tunnels.set(E,new Map),this._tunnels.get(E).set(w,{refcount:1,value:g})}async removeEmptyTunnelFromMap(E,w){const g=this._tunnels.get(E);g&&(await g.get(w)||g.delete(w),g.size===0&&this._tunnels.delete(E))}getTunnelFromMap(E,w){const g=[E];I(E)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):b(E)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const h=g.map(p=>this._tunnels.get(p));for(const p of h){const c=p?.get(w);if(c)return c}}canTunnel(E){return!!m(E)}createWithProvider(E,w,g,h,p,c,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${g} on local port ${h}.`);const o=g;this._factoryInProgress.add(o);const r={elevationRequired:p?S(h===void 0?g:h):!1},s={remoteAddress:{host:w,port:g},localAddressPort:h,privacy:c,public:c?c!==C.Private:void 0,protocol:n},a=E.forwardPort(s,r);return a?(this.addTunnelToMap(w,g,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),a}};d=ve([J(0,R.ILogService)],d),e.AbstractTunnelService=d}),define(Z[235],ee([0,1,77,93,219,8,2,19,6,20,218,113,87]),function(q,e,v,t,k,R,M,C,l,m,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function f(g,h,p,c,n){let o;for(let i=3;i&&(o?.dispose(),o=await new d(g,h,p,c,n).waitForReady(),!(n&&t.BROWSER_RESTRICTED_PORTS[n]||!t.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));i--);return o}class d extends M.Disposable{constructor(h,p,c,n,o){super(),this.defaultTunnelHost=p,this.suggestedLocalPort=o,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=h,this._server=v.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(p=>{p()})}async waitForReady(){let h=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),p=null;return this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address(),p||(h=0,this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address()),this.tunnelLocalPort=p.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${p.port}`,this}async _onConnection(h){h.pause();const p=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,I.connectRemoteAgentTunnel)(this._options,p,this.tunnelRemotePort),n=c.getSocket().socket,o=c.readEntireBuffer();c.dispose(),o.byteLength>0&&h.write(o.buffer),h.on("end",()=>{h.localAddress&&this._socketsDispose.delete(h.localAddress),n.end()}),h.on("close",()=>n.end()),h.on("error",()=>{h.localAddress&&this._socketsDispose.delete(h.localAddress),n.destroy()}),n.on("end",()=>h.end()),n.on("close",()=>h.end()),n.on("error",()=>{h.destroy()}),h.pipe(n),n.pipe(h),h.localAddress&&this._socketsDispose.set(h.localAddress,()=>{h.end(),n.end()})}}let y=class extends b.AbstractTunnelService{constructor(h,p,c,n,o){super(p),this.socketFactory=h,this.signService=c,this.productService=n,this.configurationService=o}get defaultTunnelHost(){const h=this.configurationService.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(h,p,c,n,o,i,r){const s=this.getTunnelFromMap(p,c);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,p,c,n,o,i,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${p}:${c} on local port ${n}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:h,signService:this.signService,logService:this.logService,ipcLogger:null},u=f(a,this.defaultTunnelHost,p,c,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(p,c,u),u}}};y=ve([J(1,l.ILogService),J(2,S.ISignService),J(3,m.IProductService),J(4,C.IConfigurationService)],y),e.BaseTunnelService=y;let E=class extends y{constructor(h,p,c,n){super(k.nodeSocketFactory,h,p,c,n)}};E=ve([J(0,l.ILogService),J(1,S.ISignService),J(2,m.IProductService),J(3,C.IConfigurationService)],E),e.TunnelService=E;let w=class extends M.Disposable{constructor(h,p,c,n){super(),this.logService=h,this.productService=p,this.signService=c,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(h,p,c,n,o,i,r,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${n} on local port ${o}.`),!this._tunnelServices.has(h)){const a=new E(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(h,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(h))})}return this._tunnelServices.get(h).openTunnel(p,c,n,o,i,r,s)}};w=ve([J(0,l.ILogService),J(1,m.IProductService),J(2,S.ISignService),J(3,C.IConfigurationService)],w),e.SharedTunnelsService=w}),define(Z[48],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,M)=>({type:"idle",updateType:R,error:M}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Z[236],ee([0,1,4,169,62,47]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[237],ee([0,1,3,48]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(C){this.service=C}listen(C,l){switch(l){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${l}`)}call(C,l,m){switch(l){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(m)}throw new Error(`Call not found: ${l}`)}}e.UpdateChannel=k;class R{constructor(C){this.channel=C,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(l=>this.state=l),this.channel.call("_getInitialState").then(l=>this.state=l)}get state(){return this._state}set state(C){this._state=C,this._onStateChange.fire(C)}checkForUpdates(C){return this.channel.call("checkForUpdates",C)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(C){return this.channel.call("_applySpecificUpdate",C)}}e.UpdateChannelClient=R}),define(Z[88],ee([0,1,8,22,3,19,26,21,6,20,55,48]),function(q,e,v,t,k,R,M,C,l,m,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(d,y,E){return`${E.updateUrl}/api/update/${d}/${y}/${E.commit}`}e.createUpdateURL=S;let f=class{constructor(y,E,w,g,h,p){this.lifecycleMainService=y,this.configurationService=E,this.environmentMainService=w,this.requestService=g,this.logService=h,this.productService=p,this._state=b.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(y){this.logService.info("update#setState",y.type),this._state=y,this._onStateChange.fire(y)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.getUpdateMode(),E=this.getProductQuality(y);if(!E){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(b.State.Idle(this.getUpdateType())),y==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,w=>this.logService.error(w))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(y){return y==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(y=60*60*1e3){return(0,v.timeout)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(y){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(y)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(y){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(y=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(y){}getUpdateType(){return 1}doQuitAndInstall(){}};f=ve([J(0,C.ILifecycleMainService),J(1,R.IConfigurationService),J(2,M.IEnvironmentMainService),J(3,I.IRequestService),J(4,l.ILogService),J(5,m.IProductService)],f),e.AbstractUpdateService=f}),define(Z[238],ee([0,1,15,53,3,2,19,26,21,6,20,55,37,48,88]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let y=class extends d.AbstractUpdateService{constructor(w,g,h,p,c,n,o){super(w,g,p,c,n,o),this.telemetryService=h,this.disposables=new R.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"error",(w,g)=>g)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(w,g,h)=>({url:g,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(w,g,h,p)=>({releaseNotes:g,version:h,productVersion:h,date:p}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(w){this.logService.error("UpdateService error:",w);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?w:void 0;this.setState(f.State.Idle(1,h))}buildUpdateFeedUrl(w){let g;this.productService.darwinUniversalAssetId?g=this.productService.darwinUniversalAssetId:g=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,d.createUpdateURL)(g,w,this.productService);try{v.autoUpdater.setFeedURL({url:h})}catch(p){this.logService.error("Failed to set update feed URL",p);return}return h}doCheckForUpdates(w){this.setState(f.State.CheckingForUpdates(w)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(w){this.state.type==="checking for updates"&&this.setState(f.State.Downloading(w))}onUpdateDownloaded(w){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:w.version}),this.setState(f.State.Ready(w)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(f.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],y.prototype,"onRawError",null),ve([t.memoize],y.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],y.prototype,"onRawUpdateAvailable",null),ve([t.memoize],y.prototype,"onRawUpdateDownloaded",null),y=ve([J(0,l.ILifecycleMainService),J(1,M.IConfigurationService),J(2,S.ITelemetryService),J(3,C.IEnvironmentMainService),J(4,b.IRequestService),J(5,m.ILogService),J(6,I.IProductService)],y),e.DarwinUpdateService=y}),define(Z[239],ee([0,1,45,28,8,3,9,26,21,6,37,48]),function(q,e,v,t,k,R,M,C,l,m,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(y,E,w){if(this.lifecycleMainService=y,this.logService=w,this._state=b.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,g=>this.logService.error(g))}get state(){return this._state}setState(y){this.logService.info("update#setState",y.type),this._state=y,this._onStateChange.fire(y)}scheduleCheckForUpdates(y=60*60*1e3){return(0,k.timeout)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(y){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(y)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(y){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(y=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(y){}};S=ve([J(0,l.ILifecycleMainService),J(1,C.IEnvironmentMainService),J(2,m.ILogService)],S);let f=class extends S{constructor(y,E,w,g,h,p){super(w,g,h),this.snap=y,this.snapRevision=E,this.telemetryService=p;const c=(0,t.watch)(M.dirname(this.snap)),n=R.Event.fromNodeEventEmitter(c,"change",(s,a)=>a),o=R.Event.filter(n,s=>s==="current"),r=R.Event.debounce(o,(s,a)=>a,2e3)(()=>this.checkForUpdates(!1));w.onWillShutdown(()=>{r.dispose(),c.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(y=>{y?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,y.message||y))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const y=await new Promise((w,g)=>(0,t.realpath)(`${M.dirname(this.snap)}/current`,(h,p)=>h?g(h):w(p))),E=M.basename(y);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,y=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=ve([J(2,l.ILifecycleMainService),J(3,C.IEnvironmentMainService),J(4,m.ILogService),J(5,I.ITelemetryService)],f),e.SnapUpdateService=f}),define(Z[51],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,v.createDecorator)("IUriIdentityService")}),define(Z[240],ee([0,1,51,190,14,16,126,3,2]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(S){this.uri=S,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let I=class{constructor(S){this._fileService=S,this._dispooables=new l.DisposableStore,this._limit=2**16;const f=new Map,d=y=>{let E=f.get(y.scheme);return E===void 0&&(E=S.hasProvider(y)&&!this._fileService.hasCapability(y,1024),f.set(y.scheme,E)),E};this._dispooables.add(C.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(y=>{f.delete(y.scheme)})),this.extUri=new R.ExtUri(d),this._canonicalUris=new M.SkipList((y,E)=>this.extUri.compare(y,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,R.normalizePath)(S));const f=this._canonicalUris.get(S);return f?f.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new m(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((d,y)=>d[1].touch<y[1].touch?1:d[1].touch>y[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let d=0;d<f;d++)this._canonicalUris.set(S[d][0],S[d][1].touch())}};I=ve([J(0,k.IFileService)],I),e.UriIdentityService=I,(0,t.registerSingleton)(v.IUriIdentityService,I,!0)}),define(Z[114],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Z[241],ee([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(C){this.handler=C}listen(C,l){throw new Error(`Event not found: ${l}`)}call(C,l,m){switch(l){case"handleURL":return this.handler.handleURL(v.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${l}`)}}e.URLHandlerChannel=t;class k{constructor(C){this.channel=C}handleURL(C,l){return this.channel.call("handleURL",[C.toJSON(),l])}}e.URLHandlerChannelClient=k;class R{constructor(C){this.next=C}async routeCall(C,l,m,I){if(l!=="handleURL")throw new Error(`Call not found: ${l}`);if(m){const b=v.URI.revive(m);if(b&&b.query){const S=/\bwindowId=(\d+)/.exec(b.query);if(S){const f=S[1],d=new RegExp(`window:${f}`),y=C.connections.find(E=>d.test(E.ctx));if(y)return y}}}return this.next.routeCall(C,l,m,I)}routeEvent(C,l){throw new Error(`Event not found: ${l}`)}}e.URLHandlerRouter=R}),define(Z[242],ee([0,1,8,2,7,20]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(m,I){const b=[...this.handlers.values()];return(0,v.first)(b.map(S=>()=>S.handleURL(m,I)),void 0,!1).then(S=>S||!1)}registerHandler(m){return this.handlers.add(m),(0,t.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=M;let C=class extends M{constructor(m){super(),this.productService=m}create(m){let{authority:I,path:b,query:S,fragment:f}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return I&&b&&b.indexOf("/")!==0&&(b=`/${b}`),k.URI.from({scheme:this.productService.urlProtocol,authority:I,path:b,query:S,fragment:f})}};C=ve([J(0,R.IProductService)],C),e.NativeURLService=C}),define(Z[243],ee([0,1,15,8,3,2,4,7]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function l(I){try{return C.URI.parse(I)}catch{return null}}class m{constructor(b,S,f,d,y){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=b,M.isWindows){const g=d.isBuilt?[]:[`"${d.appRoot}"`];g.push("--open-url","--"),v.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,g)}const E=k.Event.map(k.Event.fromNodeEventEmitter(v.app,"open-url",(g,h)=>({event:g,url:h})),({event:g,url:h})=>(g.preventDefault(),h));this.disposables.add(E(g=>{const h=l(g);!h||this.urlService.open(h,{originalUrl:g})})),f.getWindows().filter(g=>g.isReady).length>0?this.flush():k.Event.once(f.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const b=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||b.push(S);b.length!==0&&(this.uris=b,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(Z[244],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Z[245],ee([0,1,15,2,13,7]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const l=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(k.Schemas.vscodeWebview,l)}handleWebviewRequest(l,m){try{const I=R.URI.parse(l.url),b=M.validWebviewFilePaths.get(I.path);if(typeof b=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${b}`,f=k.FileAccess.asFileUri(S,q);return m({path:decodeURIComponent(f.fsPath),headers:{...k.COI.getHeadersFromQuery(l.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(Z[74],ee([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(I){return!!I.workspaceUri}e.isWorkspaceToOpen=t;function k(I){return!!I.folderUri}e.isFolderToOpen=k;function R(I){return!!I.fileUri}e.isFileToOpen=R;function M(I){const b=C(I),S=I.getValue("window.menuBarVisibility");return S==="default"||b==="native"&&S==="compact"||v.isMacintosh&&v.isNative?"classic":S}e.getMenuBarVisibility=M;function C(I){if(v.isWeb)return"custom";const b=I.getValue("window");if(b){if(v.isMacintosh&&b.nativeTabs===!0||v.isMacintosh&&b.nativeFullScreen===!1)return"native";const d=b.titleBarStyle;if(d==="native"||d==="custom")return d}return v.isLinux?"native":"custom"}e.getTitleBarStyle=C;function l(I,b){if(!v.isWindows||v.isWeb||!b.isBuilt||C(I)==="native")return!1;const S=I.getValue("window.experimental.windowControlsOverlay.enabled");return typeof S=="boolean"?S:!0}e.useWindowControlsOverlay=l;function m(I=0){return Math.pow(1.2,I)}e.zoomLevelToZoomFactor=m}),define(Z[115],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var v;(function(C){C[C.INITIAL=1]="INITIAL",C[C.LOAD=2]="LOAD",C[C.RELOAD=3]="RELOAD"})(v=e.LoadReason||(e.LoadReason={}));var t;(function(C){C[C.CLOSE=1]="CLOSE",C[C.QUIT=2]="QUIT",C[C.RELOAD=3]="RELOAD",C[C.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(C=1){return{width:1024,height:768,mode:C}};e.defaultWindowState=k;var R;(function(C){C[C.Maximized=0]="Maximized",C[C.Normal=1]="Normal",C[C.Minimized=2]="Minimized",C[C.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var M;(function(C){C[C.UNRESPONSIVE=1]="UNRESPONSIVE",C[C.PROCESS_GONE=2]="PROCESS_GONE",C[C.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(Z[33],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,v.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(Z[246],ee([0,1,15,22,3,66,2,30,69,103,6,20,33]),function(q,e,v,t,k,R,M,C,l,m,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let d=class extends M.Disposable{constructor(E,w,g,h,p){super(),this.logService=E,this.windowsMainService=w,this.credentialsService=g,this.encryptionMainService=h,this.productService=p,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=f.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const E=k.Event.fromNodeEventEmitter(v.app,"login",(w,g,h,p,c)=>({event:w,webContents:g,req:h,authInfo:p,callback:c}));this._register(E(this.onLogin,this))}async onLogin({event:E,authInfo:w,req:g,callback:h}){if(!w.isProxy)return;if(!this.pendingProxyResolve&&this.state===f.LoginDialogShown&&g.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}E.preventDefault();let p;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),p=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(w);try{p=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(p?.username,p?.password)}async resolveProxyCredentials(E){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.doResolveProxyCredentials(E);if(w)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(E){this.logService.trace("auth#doResolveProxyCredentials - enter",E);const w=String((0,R.hash)({scheme:E.scheme,host:E.host,port:E.port}));let g,h;try{const o=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w);if(o){const i=JSON.parse(await this.encryptionMainService.decrypt(o));g=i.username,h=i.password}}catch(o){this.logService.error(o)}if(this.state!==f.StoredCredentialsUsed&&typeof g=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=f.StoredCredentialsUsed,{username:g,password:h};const p=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!p){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${p.id} to handle proxy login`);const c={authInfo:E,username:this.sessionCredentials?.username??g,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,C.generateUuid)()}`};p.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=f.LoginDialogShown;const n=await new Promise(o=>{const i=async(r,s,a)=>{if(s===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${p.id}`),p.win?.webContents.off("ipc-message",i),a){const u={username:a.username,password:a.password};try{if(a.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(u));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w,P)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w)}catch(P){this.logService.error(P)}o({username:u.username,password:u.password})}else o(void 0)};p.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=n,n}};d=ve([J(0,I.ILogService),J(1,S.IWindowsMainService),J(2,l.ICredentialsMainService),J(3,m.IEncryptionMainService),J(4,b.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[247],ee([0,1,69,6,36,20,33,202]),function(q,e,v,t,k,R,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let l=class extends C.BaseCredentialsMainService{constructor(I,b,S,f){super(I),this.environmentMainService=b,this.productService=S,this.windowsMainService=f,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new v.InMemoryCredentialsProvider,this._keytarCache;const I=await new Promise((b,S)=>{q(["keytar"],b,S)});return await I.findCredentials("test-keytar-loads"),this._keytarCache=I,this._keytarCache}};l=ve([J(0,t.ILogService),J(1,k.INativeEnvironmentService),J(2,R.IProductService),J(3,M.IWindowsMainService)],l),e.CredentialsNativeMainService=l}),define(Z[248],ee([0,1,17,2,3,6,21,79,45,277,8,13,50,4,34,15,33]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const w=y.UtilityProcess,g=typeof w<"u";let h=class Ft{constructor(o,i,r){this._logService=o,this._windowsMainService=r,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(o){const i=this._extHosts.get(o);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(o){return this._getExtHost(o).onStdout}onDynamicStderr(o){return this._getExtHost(o).onStderr}onDynamicMessage(o){return this._getExtHost(o).onMessage}onDynamicError(o){return this._getExtHost(o).onError}onDynamicExit(o){return this._getExtHost(o).onExit}async canUseUtilityProcess(){return g}async createExtensionHost(o){if(this._shutdown)throw(0,v.canceled)();const i=String(++Ft._lastId);let r;if(o){if(!g)throw new Error("Cannot use UtilityProcess!");r=new c(i,this._logService,this._windowsMainService)}else r=new p(i,this._logService);return this._extHosts.set(i,r),r.onExit(({pid:s,code:a,signal:u})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${a}, signal: ${u}.`),setTimeout(()=>{r.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(o,i){if(this._shutdown)throw(0,v.canceled)();return this._getExtHost(o).start(i)}async enableInspectPort(o){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(o);return i?i.enableInspectPort():!1}async kill(o){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(o);!i||i.kill()}async _killAllNow(){for(const[,o]of this._extHosts)o.kill()}async _waitForAllExit(o){const i=[];for(const[,r]of this._extHosts)i.push(r.waitForExit(o));return I.Promises.settled(i).then(()=>{})}};h._lastId=0,h=ve([J(0,R.ILogService),J(1,M.ILifecycleMainService),J(2,E.IWindowsMainService)],h),e.ExtensionHostStarter=h;let p=class extends t.Disposable{constructor(o,i){super(),this.id=o,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){f.isCI&&this._logService.info("Calling fork to start extension host...");const i=C.StopWatch.create(!1);this._process=(0,l.fork)(b.FileAccess.asFileUri("bootstrap-fork",q).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,S.mixin)({cwd:(0,d.cwd)()},o));const r=i.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${r} ms).`);const a=new m.StringDecoder("utf-8");this._process.stdout?.on("data",P=>{const D=typeof P=="string"?P:a.write(P);this._onStdout.fire(D)});const u=new m.StringDecoder("utf-8");this._process.stderr?.on("data",P=>{const D=typeof P=="string"?P:u.write(P);this._onStderr.fire(D)}),this._process.on("message",P=>{this._onMessage.fire(P)}),this._process.on("error",P=>{this._onError.fire({error:(0,v.transformErrorForSerialization)(P)})}),this._process.on("exit",(P,D)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:P,signal:D})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):f.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(o)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${o}ms.`),this._process.kill())}};p=ve([J(1,R.ILogService)],p);let c=class extends t.Disposable{constructor(o,i,r){super(),this.id=o,this._logService=i,this._windowsMainService=r,this.onStdout=k.Event.None,this.onStderr=k.Event.None,this.onError=k.Event.None,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){const i=this._windowsMainService.getWindowById(o.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=i.win;if(!r||r.isDestroyed()||r.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,a=b.FileAccess.asFileUri("bootstrap-fork.js",q).fsPath,u=["--type=extensionHost","--skipWorkspaceStorageLock"],P=o.execArgv||[],D={...o.env};for(const Y of Object.keys(D))D[Y]=String(D[Y]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new w(a,u,{serviceName:s,env:D,execArgv:P}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const T=k.Event.fromNodeEventEmitter(this._process,"exit",(Y,oe)=>oe);this._register(T(Y=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${Y}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:Y,signal:""})}));const N=(Y,oe)=>{oe.type==="Utility"&&oe.name===s&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${oe.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:oe.exitCode,signal:""}))};y.app.on("child-process-gone",N),this._register((0,t.toDisposable)(()=>{y.app.off("child-process-gone",N)}));const{port1:U,port2:$}=new y.MessageChannelMain;this._process.postMessage("port",null,[$]),r.webContents.postMessage(o.responseChannel,o.responseNonce,[U])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):f.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(o)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${o}ms, will kill it now.`),this._process.kill())}};c=ve([J(1,R.ILogService),J(2,E.IWindowsMainService)],c)}),define(Z[249],ee([0,1,15,3,2,245,33]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let C=class extends k.Disposable{constructor(m){super(),this.windowsMainService=m,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,I){let b;if(typeof m.windowId=="number"){const{windowId:S}=m,f=this.windowsMainService.getWindowById(S);if(!f?.win)throw new Error(`Invalid windowId: ${S}`);b=f.win.webContents}else{const{webContentsId:S}=m;if(b=v.webContents.fromId(S),!b)throw new Error(`Invalid webContentsId: ${S}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(I)}async findInFrame(m,I,b,S){const d=this.getFrameByName(m,I);if(typeof d.findInFrame=="function"){d.findInFrame(b,{findNext:S.findNext,forward:S.forward});const y=(E,w)=>{w.finalUpdate&&(this._onFoundInFrame.fire(w),d.removeListener("found-in-frame",y))};d.on("found-in-frame",y)}}async stopFindInFrame(m,I,b){const f=this.getFrameByName(m,I);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,I){const b=this.windowsMainService.getWindowById(m.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${m}`);const S=b.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===I);if(!S)throw new Error(`Unknown frame: ${I}`);return S}};C=ve([J(0,M.IWindowsMainService)],C),e.WebviewMainService=C}),define(Z[250],ee([0,1,8,3,2]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:l,getActiveWindowId:m}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(C,l))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>m()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Z[27],ee([0,1,173,9,32,16,7,5,13]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function m(o){const i=o;return typeof i?.id=="string"&&M.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(o,i){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=o;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=I;function b(o){const i=o;return typeof i?.id=="string"&&M.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function S(o){const i=o;if(i?.uri)return{id:i.id,uri:M.URI.revive(i.uri)};const r=o;if(r?.configPath)return{id:r.id,configPath:M.URI.revive(r.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=S;var f;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function d(o){const i=o;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=d;function y(o){const i=o;return!!(i&&typeof i=="object"&&M.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=y;class E{constructor(i,r,s,a,u){this._id=i,this._transient=s,this._configuration=a,this._ignorePathCasing=u,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class w{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,R.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=w;function g(o){return new w({uri:o,index:0,name:(0,R.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(o,i){return R.extUriBiasedIgnorePathCase.isEqualOrParent(o,i.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function p(o){let i;return M.URI.isUri(o)?i=o:i=o.configuration,i?.scheme===l.Schemas.tmp}e.isTemporaryWorkspace=p;function c(o,i){return!h(o,i)&&!p(o)}e.isSavedWorkspace=c;function n(o){return(typeof o=="string"?(0,t.extname)(o):(0,R.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(Z[56],ee([0,1,15,8,66,35,2,80,4,12,23,150,5,6,27]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let y=class{constructor(w){this.logService=w,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(w,g){return this.doPick({...w,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},g)}pickFolder(w,g){return this.doPick({...w,pickFolders:!0,title:(0,b.localize)(1,null)},g)}pickFile(w,g){return this.doPick({...w,pickFiles:!0,title:(0,b.localize)(2,null)},g)}pickWorkspace(w,g){const h=(0,b.localize)(3,null),p=(0,R.mnemonicButtonLabel)((0,b.localize)(4,null)),c=d.WORKSPACE_FILTER;return this.doPick({...w,pickFiles:!0,title:h,filters:c,buttonLabel:p},g)}async doPick(w,g){const h={title:w.title,buttonLabel:w.buttonLabel,filters:w.filters,defaultPath:w.defaultPath};(typeof w.pickFiles=="boolean"||typeof w.pickFolders=="boolean")&&(h.properties=void 0,w.pickFiles&&w.pickFolders&&(h.properties=["multiSelections","openDirectory","openFile","createDirectory"])),h.properties||(h.properties=["multiSelections",w.pickFolders?"openDirectory":"openFile","createDirectory"]),l.isMacintosh&&h.properties.push("treatPackageAsDirectory");const p=await this.showOpenDialog(h,(0,m.withNullAsUndefined)(g||v.BrowserWindow.getFocusedWindow()));if(p&&p.filePaths&&p.filePaths.length>0)return p.filePaths}getWindowDialogQueue(w){if(w){let g=this.windowDialogQueues.get(w.id);return g||(g=new t.Queue,this.windowDialogQueues.set(w.id,g)),g}else return this.noWindowDialogueQueue}showMessageBox(w,g){return this.getWindowDialogQueue(g).queue(async()=>g?v.dialog.showMessageBox(g,w):v.dialog.showMessageBox(w))}async showSaveDialog(w,g){const h=this.acquireFileDialogLock(w,g);if(!h)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(g).queue(async()=>{let p;return g?p=await v.dialog.showSaveDialog(g,w):p=await v.dialog.showSaveDialog(w),p.filePath=this.normalizePath(p.filePath),p})}finally{(0,M.dispose)(h)}}normalizePath(w){return w&&l.isMacintosh&&(w=(0,C.normalizeNFC)(w)),w}normalizePaths(w){return w.map(g=>this.normalizePath(g))}async showOpenDialog(w,g){w.defaultPath&&(await I.Promises.exists(w.defaultPath)||(w.defaultPath=void 0));const h=this.acquireFileDialogLock(w,g);if(!h)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(g).queue(async()=>{let p;return g?p=await v.dialog.showOpenDialog(g,w):p=await v.dialog.showOpenDialog(w),p.filePaths=this.normalizePaths(p.filePaths),p})}finally{(0,M.dispose)(h)}}acquireFileDialogLock(w,g){if(!g)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",w);let h=this.windowFileDialogLocks.get(g.id);h||(h=new Set,this.windowFileDialogLocks.set(g.id,h));const p=(0,k.hash)(w);if(!h.has(p))return this.logService.trace("[DialogMainService]: new file dialog lock created",w),h.add(p),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",w),h?.delete(p),h?.size===0&&this.windowFileDialogLocks.delete(g.id)})}};y=ve([J(0,f.ILogService)],y),e.DialogMainService=y}),define(Z[251],ee([0,1,3,2,67,27]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends t.Disposable{constructor(l,m){super(),this.logService=l,this.storageMainService=m,this.onDidChangeApplicationStorageEmitter=this._register(new v.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(m.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(l,m){this._register(v.Event.debounce(l.onDidChangeStorage,(I,b)=>(I?I.push(b):I=[b],I),M.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&m.fire(this.serializeStorageChangeEvents(I,l))}))}serializeStorageChangeEvents(l,m){const I=new Map,b=new Set;return l.forEach(S=>{const f=m.get(S.key);typeof f=="string"?I.set(S.key,f):b.add(S.key)}),{changed:Array.from(I.entries()),deleted:Array.from(b.values())}}listen(l,m,I){switch(m){case"onDidChangeStorage":{const b=I.profile?(0,k.revive)(I.profile):void 0;if(!b)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(b.id);return S||(S=this._register(new v.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(b),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(b.id,S)),S.event}}throw new Error(`Event not found: ${m}`)}async call(l,m,I){const b=I.profile?(0,k.revive)(I.profile):void 0,S=(0,R.reviveIdentifier)(I.workspace),f=await this.withStorageInitialized(b,S);switch(m){case"getItems":return Array.from(f.items.entries());case"updateItems":{const d=I;if(d.insert)for(const[y,E]of d.insert)f.set(y,E);d.delete?.forEach(y=>f.delete(y));break}case"isUsed":{const d=I.payload;if(typeof d=="string")return this.storageMainService.isUsed(d)}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(l,m){let I;m?I=this.storageMainService.workspaceStorage(m):l?I=this.storageMainService.profileStorage(l):I=this.storageMainService.applicationStorage;try{await I.init()}catch(b){this.logService.error(`StorageIPC#init: Unable to init ${m?"workspace":l?"profile":"application"} storage due to ${b}`)}return I}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[40],ee([0,1,66,3,2,16,12,7,170,36,14,5,6,27,32,51,8,30,25]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function h(o){const i=o;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&C.URI.isUri(i.location)&&C.URI.isUri(i.globalStorageHome)&&C.URI.isUri(i.settingsResource)&&C.URI.isUri(i.keybindingsResource)&&C.URI.isUri(i.tasksResource)&&C.URI.isUri(i.snippetsHome)&&((0,M.isUndefined)(i.extensionsResource)||C.URI.isUri(i.extensionsResource)))}e.isUserDataProfile=h,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function p(o,i){return{id:o.id,isDefault:o.isDefault,name:o.name,location:C.URI.revive(o.location).with({scheme:i}),globalStorageHome:C.URI.revive(o.globalStorageHome).with({scheme:i}),settingsResource:C.URI.revive(o.settingsResource).with({scheme:i}),keybindingsResource:C.URI.revive(o.keybindingsResource).with({scheme:i}),tasksResource:C.URI.revive(o.tasksResource).with({scheme:i}),snippetsHome:C.URI.revive(o.snippetsHome).with({scheme:i}),extensionsResource:C.URI.revive(o.extensionsResource)?.with({scheme:i}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}e.reviveProfile=p,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(o,i,r,s){return{id:(0,v.hash)(i.path).toString(16),name:o,location:i,isDefault:!1,globalStorageHome:(0,R.joinPath)(i,"globalStorage"),settingsResource:(0,R.joinPath)(i,"settings.json"),keybindingsResource:(0,R.joinPath)(i,"keybindings.json"),tasksResource:(0,R.joinPath)(i,"tasks.json"),snippetsHome:(0,R.joinPath)(i,"snippets"),extensionsResource:(0,R.joinPath)(i,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:r,isTransient:s}}e.toUserDataProfile=c;let n=class extends k.Disposable{constructor(i,r,s,a){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=s,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(u=>c(u.name,u.location,u.useDefaultFlags)):[];let r;const s=new d.ResourceMap,a=c((0,l.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||i.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),i.length){const u=this.getStoredProfileAssociations();if(u.workspaces)for(const[P,D]of Object.entries(u.workspaces)){const T=C.URI.parse(P),N=C.URI.parse(D),U=i.find($=>this.uriIdentityService.extUri.isEqual($.location,N));U&&s.set(T,U)}if(u.emptyWindow){const P=C.URI.parse(u.emptyWindow);r=i.find(D=>this.uriIdentityService.extUri.isEqual(D.location,P))}}this._profilesObject={profiles:i,workspaces:s,emptyWindow:r}}return this._profilesObject}async createTransientProfile(i){const r="Temp",s=new RegExp(`${(0,g.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const P of this.profiles){const D=s.exec(P.name),T=D?parseInt(D[1]):0;a=T>a?T:a}const u=`${r} ${a+1}`;return this.createProfile(u,void 0,i,!0)}async createProfile(i,r,s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.doCreateProfile(i,r,a);return s&&await this.setProfileForWorkspace(s,u),u}async doCreateProfile(i,r,s){let a=this.profileCreationPromises.get(i);return a||(a=(async()=>{try{const u=this.profiles.find(T=>T.name===i);if(u)return u;const P=c(i,(0,R.joinPath)(this.profilesHome,(0,v.hash)((0,w.generateUuid)()).toString(16)),r,s);await this.fileService.createFolder(P.location);const D=[];return this._onWillCreateProfile.fire({profile:P,join(T){D.push(T)}}),await E.Promises.settled(D),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(i)}})(),this.profileCreationPromises.set(i,a)),a}async updateProfile(i,r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(u=>u.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=c(r,a.location,s),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:r,join(a){s.push(a)}}),await E.Promises.settled(s),r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(i,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let s=this.getProfileForWorkspace(i);return s||(s=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,s)),s}async setProfileForWorkspace(i,r){this.setProfileForWorkspaceSync(i,r)}setProfileForWorkspaceSync(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(a=>a.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,s)}unsetWorkspace(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return C.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,f.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,f.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,s){const a=[...this.profiles,...i],u=[];this.transientProfilesObject.profiles=[];for(let P of a)P.isDefault||r.some(D=>P.id===D.id)||(P=s.find(D=>P.id===D.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):u.push({location:P.location,name:P.name,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(u),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,s)}triggerProfilesChanges(i,r,s){this._onDidChangeProfiles.fire({added:i,removed:r,updated:s,all:this.profiles})}updateWorkspaceAssociation(i,r,s){s=r?.isTransient?!0:s,s||this.updateWorkspaceAssociation(i,void 0,!0);const a=this.getWorkspace(i),u=s?this.transientProfilesObject:this.profilesObject;C.URI.isUri(a)?(u.workspaces.delete(a),r&&u.workspaces.set(a,r)):u.emptyWindow=r,s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[s,a]of this.profilesObject.workspaces.entries())i[s.toString()]=a.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",n=ve([J(0,m.IEnvironmentService),J(1,I.IFileService),J(2,y.IUriIdentityService),J(3,S.ILogService)],n),e.UserDataProfilesService=n}),define(Z[89],ee([0,1,24,8,50,18,17,43,136,2,13,9,4,16,188,95,12,7,155,36,110,109,187,14,5,6,20,3,67,72,40,51,186]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c,n,o,i,r,s,a,u,P,D,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(G){function K(F,A){if(F===A)return!0;const W=Object.keys(F),z=new Set;for(const te of Object.keys(A))z.add(te);if(W.length!==z.size)return!1;for(const te of W){if(F[te]!==A[te])return!1;z.delete(te)}return z.size===0}G.equals=K})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let $=class extends m.Disposable{constructor(K,F,A,W,z,te,B,H,L,O,_){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=F,this.extensionsControlLocation=A,this.cacheLocation=W,this.userDataProfilesService=z,this.extensionsProfileScannerService=te,this.fileService=B,this.logService=H,this.environmentService=L,this.productService=O,this.instantiationService=_,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,f.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,f.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,F,A){const[W,z]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(F)]),te=A?await this.scanExtensionsUnderDevelopment(K,[...W,...z]):[];return this.dedupExtensions(W,z,te,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const F=[];F.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),F.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[A,W]=await Promise.all(F);return this.applyScanOptions([...A,...W],0,K,!1)}async scanUserExtensions(K){this.logService.trace("Started scanning user extensions");const F=await this.createExtensionScannerInput(K.profileLocation??this.userExtensionsLocation,!!K.profileLocation,1,!K.includeUninstalled,K.language);let W=await(K.useCache&&!F.devMode&&F.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return W=await this.applyScanOptions(W,1,K,!0),this.logService.trace("Scanned user extensions:",W.length),W}async scanExtensionsUnderDevelopment(K,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===I.Schemas.file).map(async W=>{const z=await this.createExtensionScannerInput(W,!1,1,!0,K.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(B=>(B.type=F.find(H=>(0,p.areSameExtensions)(H.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,z)))}))).flat();return this.applyScanOptions(A,"development",K,!0)}return[]}async scanExistingExtension(K,F,A){const W=await this.createExtensionScannerInput(K,!1,F,!0,A.language),z=await this.extensionsScanner.scanExtension(W);return!z||!A.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(K,F,A){const W=await this.createExtensionScannerInput(K,!1,F,!0,A.language),z=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(z,F,A,!0)}async scanMetadata(K){const F=(0,f.joinPath)(K,"package.json"),A=(await this.fileService.readFile(F)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(K,F){const A=(0,f.joinPath)(K,"package.json"),W=(await this.fileService.readFile(A)).value.toString(),z=JSON.parse(W);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,z.__metadata={...z.__metadata,...F},await this.fileService.writeFile((0,f.joinPath)(K,"package.json"),R.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async applyScanOptions(K,F,A,W){return A.includeAllVersions||(K=this.dedupExtensions(F===0?K:void 0,F===1?K:void 0,F==="development"?K:void 0,await this.getTargetPlatform(),W)),A.includeInvalid||(K=K.filter(z=>z.isValid)),K.sort((z,te)=>{const B=b.basename(z.location.fsPath),H=b.basename(te.location.fsPath);return B<H?-1:B>H?1:0})}dedupExtensions(K,F,A,W,z){const te=(H,L,O)=>{if(H.isValid&&!L.isValid)return!1;if(H.isValid===L.isValid){if(z&&d.gt(H.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(d.eq(H.manifest.version,L.manifest.version)){if(H.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===W)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${H.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${L.location.path}.`),!0},B=new Map;return K?.forEach(H=>{const L=c.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);(!O||te(O,H,!1))&&B.set(L,H)}),F?.forEach(H=>{const L=c.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);if(!O&&K&&H.type===0){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!O||te(O,H,!1))&&B.set(L,H)}),A?.forEach(H=>{const L=c.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);(!O||te(O,H,!0))&&B.set(L,H),B.set(L,H)}),[...B.values()]}async scanDefaultSystemExtensions(K,F){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),z=await(K&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions(K,F){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=F?await this.getBuiltInExtensionControl():{},z=[],te=w.URI.file(b.normalize(b.join(I.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions")));for(const H of A){const L=W[H.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":z.push((0,f.joinPath)(te,H.name));break;default:z.push(w.URI.file(L));break}}const B=await Promise.all(z.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,0,!0,K))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,v.coalesce)(B)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,F,A,W,z,te=!0){const B=await this.getTranslations(z??S.language),H=await this.getMtime(K),L=F?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new Y(K,H,L,O,F,A,W,te,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,B)}async getMtime(K){try{const F=await this.fileService.stat(K);if(typeof F.mtime=="number")return F.mtime}catch{}}};$=ve([J(4,D.IUserDataProfilesService),J(5,P.IExtensionsProfileScannerService),J(6,o.IFileService),J(7,r.ILogService),J(8,h.IEnvironmentService),J(9,s.IProductService),J(10,i.IInstantiationService)],$),e.AbstractExtensionsScannerService=$;class Y{constructor(K,F,A,W,z,te,B,H,L,O,_,V,x,re){this.location=K,this.mtime=F,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=W,this.profile=z,this.type=te,this.excludeObsolete=B,this.validate=H,this.productVersion=L,this.productDate=O,this.productCommit=_,this.devMode=V,this.language=x,this.translations=re}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,F){return(0,f.isEqual)(K.location,F.location)&&K.mtime===F.mtime&&(0,f.isEqual)(K.applicationExtensionslocation,F.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&K.profile===F.profile&&K.type===F.type&&K.excludeObsolete===F.excludeObsolete&&K.validate===F.validate&&K.productVersion===F.productVersion&&K.productDate===F.productDate&&K.productCommit===F.productCommit&&K.devMode===F.devMode&&K.language===F.language&&U.equals(K.translations,F.translations)}}let oe=class extends m.Disposable{constructor(K,F,A,W,z){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=F,this.uriIdentityService=A,this.fileService=W,this.logService=z}async scanExtensions(K){const F=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let A={};if(K.excludeObsolete&&K.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(W)}catch{}return(0,E.isEmptyObject)(A)?F:F.filter(W=>!A[p.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(K){const F=await this.fileService.resolve(K.location);if(!F.children?.length)return[];const A=await Promise.all(F.children.map(async W=>{if(!W.isDirectory||K.type===1&&(0,f.basename)(W.resource).indexOf(".")===0)return null;const z=new Y(W.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(z)}));return(0,v.coalesce)(A).sort((W,z)=>W.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile(K){let F=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){F=F.filter(W=>!W.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,K);F.push(...A)}return F}async scanExtensionsFromProfileResource(K,F,A){const W=await this.extensionsProfileScannerService.scanProfileExtensions(K);if(!W.length)return[];const z=await Promise.all(W.map(async te=>{if(F(te)){const B=new Y(te.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,te.metadata)}return null}));return(0,v.coalesce)(z)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,f.joinPath)(K.location,"package.json"))){const F=await this.scanExtension(K);return F?[F]:[]}else return await this.scanExtensions(K)}catch(F){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,M.getErrorMessage)(F)),[]}}async scanExtension(K,F){try{let A=await this.scanExtensionManifest(K.location);if(A){A.publisher||(A.publisher=c.UNDEFINED_PUBLISHER),F=F??A.__metadata,delete A.__metadata;const W=(0,p.getGalleryExtensionId)(A.publisher,A.name),z=F?.id?{id:W,uuid:F.id}:{id:W},te=F?.isSystem?0:K.type,B=te===0||!!F?.isBuiltin;A=await this.translateManifest(K.location,A,Y.createNlsConfiguration(K));const H={type:te,identifier:z,manifest:A,location:K.location,isBuiltin:B,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return K.validate?this.validate(H,K):H}}catch(A){K.type!==0&&this.logService.error(A)}return null}validate(K,F){let A=!0;const W=(0,n.validateExtensionManifest)(F.productVersion,F.productDate,F.location,K.manifest,K.isBuiltin);for(const[z,te]of W)z===y.default.Error&&(A=!1,this.logService.error(this.formatMessage(F.location,te)));return K.isValid=A,K.validations=W,K}async scanExtensionManifest(K){const F=(0,f.joinPath)(K,"package.json");let A;try{A=(await this.fileService.readFile(F)).value.toString()}catch(z){return(0,o.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage(K,(0,g.localize)(0,null,F.path,z.message))),null}let W;try{W=JSON.parse(A)}catch{const te=[];(0,C.parse)(A,te);for(const B of te)this.logService.error(this.formatMessage(K,(0,g.localize)(1,null,F.path,B.offset,B.length,(0,l.getParseErrorMessage)(B.error))));return null}return(0,C.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(K,(0,g.localize)(2,null,F.path))),null):W}async translateManifest(K,F,A){const W=await this.getLocalizedMessages(K,F,A);if(W)try{const z=[],te=await this.resolveOriginalMessageBundle(W.default,z);if(z.length>0)return z.forEach(H=>{this.logService.error(this.formatMessage(K,(0,g.localize)(3,null,W.default?.path,(0,l.getParseErrorMessage)(H.error))))}),F;if((0,C.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(K,(0,g.localize)(4,null,W.default?.path))),F;const B=W.values||Object.create(null);return(0,N.localizeManifest)(F,B,te)}catch{}return F}async getLocalizedMessages(K,F,A){const W=(0,f.joinPath)(K,"package.nls.json"),z=(L,O)=>{O.forEach(_=>{this.logService.error(this.formatMessage(K,(0,g.localize)(5,null,L?.path,(0,l.getParseErrorMessage)(_.error))))})},te=L=>{this.logService.error(this.formatMessage(K,(0,g.localize)(6,null,L?.path)))},B=`${F.publisher}.${F.name}`,H=A.translations[B];if(H)try{const L=w.URI.file(H),O=(await this.fileService.readFile(L)).value.toString(),_=[],V=(0,C.parse)(O,_);return _.length>0?(z(L,_),{values:void 0,default:W}):(0,C.getNodeType)(V)!=="object"?(te(L),{values:void 0,default:W}):{values:V.contents?V.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let O;try{O=await this.findMessageBundles(K,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const _=(await this.fileService.readFile(O.localized)).value.toString(),V=[],x=(0,C.parse)(_,V);return V.length>0?(z(O.localized,V),{values:void 0,default:O.original}):(0,C.getNodeType)(x)!=="object"?(te(O.localized),{values:void 0,default:O.original}):{values:x,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(K,F){if(K)try{const A=(await this.fileService.readFile(K)).value.toString();return(0,C.parse)(A,F)}catch{}}findMessageBundles(K,F){return new Promise((A,W)=>{const z=te=>{const B=(0,f.joinPath)(K,`package.nls.${te}.json`);this.fileService.exists(B).then(H=>{H&&A({localized:B,original:(0,f.joinPath)(K,"package.nls.json")});const L=te.lastIndexOf("-");L===-1?A({localized:(0,f.joinPath)(K,"package.nls.json"),original:null}):(te=te.substring(0,L),z(te))})};if(F.devMode||F.pseudo||!F.language)return A({localized:(0,f.joinPath)(K,"package.nls.json"),original:null});z(F.language)})}formatMessage(K,F){return`[${K.path}]: ${F}`}};oe=ve([J(1,P.IExtensionsProfileScannerService),J(2,T.IUriIdentityService),J(3,o.IFileService),J(4,r.ILogService)],oe);let ue=class extends oe{constructor(K,F,A,W,z,te){super(F,A,W,z,te),this.cacheFile=K,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const F=await this.readExtensionCache();if(this.input=K,F&&F.input&&Y.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(W=>(W.location=w.URI.revive(W.location),W));const A=await super.scanExtensions(K);return await this.writeExtensionCache({input:K,result:A}),A}async readExtensionCache(){try{const K=await this.fileService.readFile(this.cacheFile),F=JSON.parse(K.value.toString());return{result:F.result,input:(0,u.revive)(F.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,M.getErrorMessage)(K))}return null}async writeExtensionCache(K){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(K)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,M.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const K=await this.readExtensionCache();if(!K)return;const F=K.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}};ue=ve([J(2,P.IExtensionsProfileScannerService),J(3,T.IUriIdentityService),J(4,o.IFileService),J(5,r.ILogService)],ue);function se(G,K){const F=(0,p.getExtensionId)(G.manifest.publisher,G.manifest.name);return{id:F,identifier:new c.ExtensionIdentifier(F),isBuiltin:G.type===0,isUserBuiltin:G.type===1&&G.isBuiltin,isUnderDevelopment:K,extensionLocation:G.location,uuid:G.identifier.uuid,targetPlatform:G.targetPlatform,...G.manifest}}e.toExtensionDescription=se;class de extends ${constructor(K,F,A,W,z,te,B,H,L,O,_){super(K,F,(0,f.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(W,c.MANIFEST_CACHE_FOLDER),z,te,B,H,L,O,_),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const V=await this.fileService.readFile(w.URI.file(S.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=de}),define(Z[252],ee([0,1,7,36,72,89,14,5,6,20,40]),function(q,e,v,t,k,R,M,C,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends R.NativeExtensionsScannerService{constructor(f,d,y,E,w,g,h){super(v.URI.file(w.builtinExtensionsPath),v.URI.file(w.extensionsPath),w.userHome,v.URI.file(w.userDataPath),f,d,y,E,w,g,h)}};b=ve([J(0,I.IUserDataProfilesService),J(1,k.IExtensionsProfileScannerService),J(2,M.IFileService),J(3,l.ILogService),J(4,t.INativeEnvironmentService),J(5,m.IProductService),J(6,C.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(Z[253],ee([0,1,15,41,2,32,13,9,4,7,30,36,6,40]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends k.Disposable{constructor(E,w,g){super(),this.environmentService=E,this.logService=g,this.validRoots=R.TernarySearchTree.forPaths(!l.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(E.appRoot),this.addValidFileRoot(E.extensionsPath),this.addValidFileRoot(w.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(E.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:E}=v.session;E.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(w,g)=>this.handleResourceRequest(w,g)),E.protocol.interceptFileProtocol(M.Schemas.file,(w,g)=>this.handleFileRequest(w,g)),this._register((0,k.toDisposable)(()=>{E.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),E.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(E){const w=(0,C.normalize)(E);return this.validRoots.get(w)?k.Disposable.None:(this.validRoots.set(w,!0),(0,k.toDisposable)(()=>this.validRoots.delete(w)))}handleFileRequest(E,w){const g=m.URI.parse(E.url);return this.logService.error(`Refused to load resource ${g.fsPath} from ${M.Schemas.file}: protocol (original URL: ${E.url})`),w({error:-3})}handleResourceRequest(E,w){const g=this.requestToNormalizedFilePath(E);let h;return this.environmentService.crossOriginIsolated&&(g.endsWith("/workbench.html")?h=M.COI.CoopAndCoep:h=M.COI.getHeadersFromQuery(E.url)),this.validRoots.findSubstr(g)?w({path:g,headers:h}):this.validExtensions.has((0,C.extname)(g).toLowerCase())?w({path:g}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${E.url})`),w({error:-3}))}requestToNormalizedFilePath(E){const w=m.URI.parse(E.url),g=M.FileAccess.asFileUri(w);return(0,C.normalize)(g.fsPath)}createIPCObjectUrl(){let E;const w=m.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),g=w.toString(),h=async()=>E;return t.validatedIpcMain.handle(g,h),this.logService.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:w,update:p=>E=p,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${g}.`),t.validatedIpcMain.removeHandler(g)}}}};d=ve([J(0,b.INativeEnvironmentService),J(1,f.IUserDataProfilesService),J(2,S.ILogService)],d),e.ProtocolMainService=d}),define(Z[254],ee([0,1,15,41,8,3,2,13,12,100,26,21,6,54,61,64,44,40,38]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let h=class extends M.Disposable{constructor(c,n,o,i,r,s,a,u,P){super(),this.machineId=c,this.userEnv=n,this.environmentMainService=o,this.userDataProfilesService=i,this.lifecycleMainService=r,this.logService=s,this.policyService=a,this.themeMainService=u,this.protocolMainService=P,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,n)=>this.onWindowConnection(c,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,n)=>this.onWorkerConnection(c,n)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,n){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(c.sender.isDestroyed())return o.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[o])}onWorkerConnection(c,n){this.logService.trace("SharedProcess: onWorkerConnection",n);const o=new M.DisposableStore,i=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,n),o.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",n))},r=v.BrowserWindow.fromId(n.reply.windowId);if(!r||r.isDestroyed()||r.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}o.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===r)(()=>i("load"))),o.add(R.Event.fromNodeEventEmitter(r,"closed")(()=>i("closed"))),r.webContents.postMessage(n.reply.channel,n.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...n){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...n)}catch(o){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,E.toErrorMessage)(o)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:f.default,policiesData:this.policyService.serialize()}),this.window.loadURL(C.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,n)=>this._onDidError.fire({type:2,details:n})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,n,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:n}})))}async connect(){await this.whenIpcReady;const c=(0,l.assertIsDefined)(this.window);return(0,m.connect)(c)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};h=ve([J(2,I.IEnvironmentMainService),J(3,w.IUserDataProfilesService),J(4,b.ILifecycleMainService),J(5,S.ILogService),J(6,g.IPolicyService),J(7,y.IThemeMainService),J(8,d.IProtocolMainService)],h),e.SharedProcess=h}),define(Z[116],ee([0,1,8,3,2,71,12,101,5,40]),function(q,e,v,t,k,R,M,C,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,l.createDecorator)("storageService");var b;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var f;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(h={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super(),this.options=h,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(h,p){if(p===I){switch(h){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:h})}else this._onDidChangeValue.fire({scope:h,key:p,target:this.getKeyTargets(h)[p]})}emitWillSaveState(h){this._onWillSaveState.fire({reason:h})}get(h,p,c){return this.getStorage(p)?.get(h,c)}getBoolean(h,p,c){return this.getStorage(p)?.getBoolean(h,c)}getNumber(h,p,c){return this.getStorage(p)?.getNumber(h,c)}store(h,p,c,n){if((0,M.isUndefinedOrNull)(p)){this.remove(h,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(h,c,n),this.getStorage(c)?.set(h,p)})}remove(h,p){this.withPausedEmitters(()=>{this.updateKeyTarget(h,p,void 0),this.getStorage(p)?.delete(h)})}withPausedEmitters(h){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{h()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(h,p){const c=[],n=this.getKeyTargets(h);for(const o of Object.keys(n))n[o]===p&&c.push(o);return c}updateKeyTarget(h,p,c){const n=this.getKeyTargets(p);typeof c=="number"?n[h]!==c&&(n[h]=c,this.getStorage(p)?.set(I,JSON.stringify(n))):typeof n[h]=="number"&&(delete n[h],this.getStorage(p)?.set(I,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(h){switch(h){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(h){const p=this.get(I,h);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}isNew(h){return this.getBoolean(e.IS_NEW_KEY,h)===!0}async flush(h=b.NONE){this._onWillSaveState.fire({reason:h});const p=this.getStorage(-1),c=this.getStorage(0),n=this.getStorage(1);switch(h){case b.NONE:await v.Promises.settled([p?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await v.Promises.settled([p?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return w(h,p,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(h,p){return this.emitWillSaveState(b.NONE),(0,m.isUserDataProfile)(h)?this.switchToProfile(h,p):this.switchToWorkspace(h,p)}canSwitchProfile(h,p){return!(h.id===p.id||y(p)&&y(h))}switchData(h,p,c,n){this.withPausedEmitters(()=>{if(n)for(const[o,i]of h)p.set(o,i);else{const o=new Set;for(const[i,r]of h)o.add(i),p.get(i)!==r&&this.emitDidChangeValue(c,i);for(const[i]of p.items)o.has(i)||this.emitDidChangeValue(c,i)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function y(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class E extends d{constructor(){super(),this.applicationStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.profileStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(h=>this.emitDidChangeValue(1,h))),this._register(this.profileStorage.onDidChangeStorage(h=>this.emitDidChangeValue(0,h))),this._register(this.applicationStorage.onDidChangeStorage(h=>this.emitDidChangeValue(-1,h)))}getStorage(h){switch(h){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=E;async function w(g,h,p,c,n,o){const i=U=>{try{return JSON.parse(U)}catch{return U}},r=new Map,s=new Map;g.forEach((U,$)=>{r.set($,U),s.set($,i(U))});const a=new Map,u=new Map;h.forEach((U,$)=>{a.set($,U),u.set($,i(U))});const P=new Map,D=new Map;p.forEach((U,$)=>{P.set($,U),D.set($,i(U))}),console.group(c!==n?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const T=[];if(r.forEach((U,$)=>{T.push({key:$,value:U})}),console.table(T),console.groupEnd(),console.log(s),c!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const U=[];a.forEach(($,Y)=>{U.push({key:Y,value:$})}),console.table(U),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${o})`);const N=[];P.forEach((U,$)=>{N.push({key:$,value:U})}),console.table(N),console.groupEnd(),console.log(D)}e.logStorage=w}),define(Z[255],ee([0,1,24,8,3,2,9,79,7,23,101,147,6,116,37,27]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class E extends R.Disposable{constructor(o,i){super(),this.logService=o,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=I.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===I.StorageState.None)try{const o=await this.doCreate();this._storage.dispose(),this._storage=o,this._register(o.onDidChangeStorage(r=>this._onDidChangeStorage.fire({key:r}))),await this.doInit(o);const i=o.getBoolean(f.IS_NEW_KEY);i===void 0?o.set(f.IS_NEW_KEY,!0):i&&o.set(f.IS_NEW_KEY,!1)}catch(o){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.state=I.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this._storage.items}get(o,i){return this._storage.get(o,i)}set(o,i){return this._storage.set(o,i)}delete(o){return this._storage.delete(o)}async close(){const o=new C.StopWatch(!1);await this.doClose(),o.stop(),o.elapsed()>E.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(o),this._onDidCloseStorage.fire()}async logSlowClose(o){if(!!this.path)try{const i=(0,v.top)(Array.from(this._storage.items.entries()).map(([s,a])=>({key:s,length:a.length})),(s,a)=>a.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),r=(await this.fileService.stat(l.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${r}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=I.StorageState.Closed,await this._storage.close()}}E.LOG_SLOW_CLOSE_THRESHOLD=2e3;class w extends E{constructor(o,i,r,s){super(r,s),this.profile=o,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.fsPath,w.STORAGE_NAME)}async doCreate(){return new I.Storage(new b.SQLiteStorageDatabase(this.path??b.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}w.STORAGE_NAME="state.vscdb";class g extends w{constructor(o,i,r,s){super(o,i,r,s)}}e.ProfileStorageMain=g;class h extends w{constructor(o,i,r,s){super(i.defaultProfile,o,r,s)}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(d.firstSessionDateStorageKey,void 0)===void 0&&o.set(d.firstSessionDateStorageKey,new Date().toUTCString());const r=o.get(d.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();o.set(d.lastSessionDateStorageKey,typeof r>"u"?null:r),o.set(d.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=h;class p extends E{constructor(o,i,r,s,a){super(r,a),this.workspace=o,this.options=i,this.environmentService=s}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,p.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:o,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new b.SQLiteStorageDatabase(o,{logging:this.createLoggingOptions()}),{hint:i?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:b.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,M.join)(o,p.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(o)?{storageFilePath:i,wasCreated:!1}:(await m.Promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let i;if((0,y.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,y.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const r=(0,M.join)(o,p.WORKSPACE_META_NAME);await m.Promises.exists(r)||await m.Promises.writeFile(r,JSON.stringify(i,void 0,2))}catch(r){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.WorkspaceStorageMain=p,p.WORKSPACE_STORAGE_NAME="state.vscdb",p.WORKSPACE_META_NAME="workspace.json";class c extends E{get path(){}async doCreate(){return new I.Storage(new I.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(Z[256],ee([0,1,67,36,14,6,226,51,40]),function(q,e,v,t,k,R,M,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class Dt extends l.UserDataProfilesService{constructor(b,S,f,d,y){super(f,d,S,y),this.stateService=b}getStoredProfiles(){return(0,v.revive)(this.stateService.getItem(Dt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,v.revive)(this.stateService.getItem(Dt.PROFILE_ASSOCIATIONS_KEY,{}))}};m=ve([J(0,M.IStateService),J(1,C.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,R.ILogService)],m),e.UserDataProfilesService=m}),define(Z[42],ee([0,1,7,36,14,5,6,39,51,40,256]),function(q,e,v,t,k,R,M,C,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let b=class lt extends I.UserDataProfilesService{constructor(f,d,y,E,w){super(f,d,y,E,w),this.stateMainService=f}setEnablement(f){super.setEnablement(f),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(f){if(!!this.isEnabled()){if(f.profile){const d=this.profiles.find(y=>y.name===f.profile);return d?Promise.resolve(d):this.createProfile(f.profile)}if(f["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(f){f.length?this.stateMainService.setItem(lt.PROFILES_KEY,f):this.stateMainService.removeItem(lt.PROFILES_KEY)}saveStoredProfileAssociations(f){f.emptyWindow||f.workspaces?this.stateMainService.setItem(lt.PROFILE_ASSOCIATIONS_KEY,f):this.stateMainService.removeItem(lt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const f="workspaceAndProfileInfo",d=this.stateMainService.getItem(f,void 0);if(d){this.stateMainService.removeItem(f);const y=d.reduce((E,{workspace:w,profile:g})=>(E[v.URI.revive(w).toString()]=v.URI.revive(g).toString(),E),{});this.stateMainService.setItem(lt.PROFILE_ASSOCIATIONS_KEY,{workspaces:y})}return super.getStoredProfileAssociations()}};b=ve([J(0,C.IStateMainService),J(1,l.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,M.ILogService)],b),e.UserDataProfilesMainService=b}),define(Z[257],ee([0,1,2,16,72,89,14,6,40,42]),function(q,e,v,t,k,R,M,C,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let I=class extends v.Disposable{constructor(S,f,d,y,E){super(),this.userDataProfilesService=S,this.fileService=f,this.extensionsScannerService=d,this.extensionsProfileScannerService=y,S.isEnabled()?(this._register(S.onWillCreateProfile(w=>{S.profiles.length===1&&w.join(this.initialize())})),this._register(S.onDidChangeProfiles(w=>{S.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,w=>E.error(w))}async initialize(){const S=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(S)}catch{}const f=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(f.map(d=>[d,d.metadata]),S)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,l.EXTENSIONS_RESOURCE_NAME)}};I=ve([J(0,m.IUserDataProfilesMainService),J(1,M.IFileService),J(2,R.IExtensionsScannerService),J(3,k.IExtensionsProfileScannerService),J(4,C.ILogService)],I),e.DefaultExtensionsProfileInitHandler=I}),define(Z[258],ee([0,1,15,24,4,7,23,19,59,5,6,114,33,42]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let d=class{constructor(E,w,g,h,p){this.logService=E,this.windowsMainService=w,this.urlService=g,this.configurationService=h,this.userDataProfilesMainService=p}async start(E,w){this.logService.trace("Received data from other instance: ",E,w),k.isMacintosh&&v.app.focus({steal:!0});const g=this.parseOpenUrl(E);if(g.length){let h=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(h=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),h.then(()=>{for(const{uri:p,url:c}of g)this.urlService.open(p,{originalUrl:c})})}else return this.startOpenWindow(E,w)}parseOpenUrl(E){return E["open-url"]&&E._urls&&E._urls.length>0?(0,t.coalesce)(E._urls.map(w=>{try{return{uri:R.URI.parse(w),url:w}}catch{return null}})):[]}async startOpenWindow(E,w){const g=(0,l.isLaunchedFromCli)(w)?0:4;let h=[];const p=E.wait&&E.waitMarkerFilePath?R.URI.file(E.waitMarkerFilePath):void 0,c=E.remote||void 0,n=this.userDataProfilesMainService.checkAndCreateProfileFromCli(E),o=n?await n:void 0,i={context:g,cli:E,userEnv:w,waitMarkerFileURI:p,remoteAuthority:c,profile:o};if(E.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(E.extensionDevelopmentPath,i);else if(!E._.length&&!E["folder-uri"]&&!E["file-uri"]){let r=!1;if(E["new-window"]||E["unity-launch"]||o)r=!0;else if(E["reuse-window"])r=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":r=!0;break;case"off":r=!1;break;default:r=!k.isMacintosh}if(r)h=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const s=this.windowsMainService.getLastActiveWindow();s?(this.windowsMainService.openExistingWindow(s,i),h=[s]):h=this.windowsMainService.open({...i,forceEmpty:!0})}}else h=this.windowsMainService.open({...i,forceNewWindow:E["new-window"],preferNewWindow:!E["reuse-window"]&&!E.wait,forceReuseWindow:E["reuse-window"],diffMode:E.diff,mergeMode:E.merge,addMode:E.add,noRecentEntry:!!E["skip-add-to-recently-opened"],gotoLineMode:E.goto});if(p&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,M.whenDeleted)(p.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};d=ve([J(0,I.ILogService),J(1,S.IWindowsMainService),J(2,b.IURLService),J(3,C.IConfigurationService),J(4,f.IUserDataProfilesMainService)],d),e.LaunchMainService=d}),define(Z[90],ee([0,1,7,49,2,36,14,5,21,6,116,255,40,42,51]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,C.createDecorator)("storageMainService");let y=class extends k.Disposable{constructor(g,h,p,c,n,o){super(),this.logService=g,this.environmentService=h,this.userDataProfilesService=p,this.lifecycleMainService=c,this.fileService=n,this.uriIdentityService=o,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(g=>{g.window.profile&&this.profileStorage(g.window.profile).init(),g.workspace&&this.workspaceStorage(g.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(g=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=g.reason,g.join(this.applicationStorage.close());for(const[,h]of this.mapProfileToStorage)g.join(h.close());for(const[,h]of this.mapWorkspaceToStorage)g.join(h.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(g=>{g.join((async()=>{await this.fileService.exists(g.profile.globalStorageHome)||await this.fileService.createFolder(g.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(g=>{const h=this.mapProfileToStorage.get(g.profile.id);h&&g.join(h.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const g=new b.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(g.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),g}profileStorage(g){if((0,I.isProfileUsingDefaultStorage)(g))return this.applicationStorage;let h=this.mapProfileToStorage.get(g.id);return h||(this.logService.trace(`StorageMainService: creating profile storage (${g.name})`),h=this.createProfileStorage(g),this.mapProfileToStorage.set(g.id,h),(0,t.once)(h.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${g.name})`),this.mapProfileToStorage.delete(g.id)})),h}createProfileStorage(g){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.ProfileStorageMain(g,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(g){let h=this.mapWorkspaceToStorage.get(g.id);return h||(this.logService.trace(`StorageMainService: creating workspace storage (${g.id})`),h=this.createWorkspaceStorage(g),this.mapWorkspaceToStorage.set(g.id,h),(0,t.once)(h.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${g.id})`),this.mapWorkspaceToStorage.delete(g.id)})),h}createWorkspaceStorage(g){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.WorkspaceStorageMain(g,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(g){const h=v.URI.file(g);for(const p of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!p.path&&this.uriIdentityService.extUri.isEqualOrParent(v.URI.file(p.path),h))return!0;return!1}};y=ve([J(0,m.ILogService),J(1,R.IEnvironmentService),J(2,f.IUserDataProfilesMainService),J(3,l.ILifecycleMainService),J(4,M.IFileService),J(5,d.IUriIdentityService)],y),e.StorageMainService=y,e.IApplicationStorageMainService=(0,C.createDecorator)("applicationStorageMainService");let E=class extends I.AbstractStorageService{constructor(g,h){super(),this.userDataProfilesService=g,this.storageMainService=h,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(g){if(g===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(g){if(g===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};E=ve([J(0,S.IUserDataProfilesService),J(1,e.IStorageMainService)],E),e.ApplicationStorageMainService=E}),define(Z[259],ee([0,1,2,21,42]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends v.Disposable{constructor(C,l){super(),this.userDataProfilesService=l,this._register(C.onWillLoadWindow(m=>{m.reason===2&&this.unsetTransientProfileForWorkspace(m.window.openedWorkspace??"empty-window")})),this._register(C.onBeforeCloseWindow(m=>this.unsetTransientProfileForWorkspace(m.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(C){this.userDataProfilesService.getOrSetProfileForWorkspace(C).isTransient&&(this.userDataProfilesService.unsetWorkspace(C,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([J(0,t.ILifecycleMainService),J(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(Z[117],ee([0,1,16,7,27]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(l,m,I){for(const S of l){const f=S.openedWorkspace;if((0,k.isWorkspaceIdentifier)(f)){const d=I(f);if(d){if(d.folders.some(y=>v.extUriBiasedIgnorePathCase.isEqualOrParent(m,y.uri)))return S}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(m,f.configPath))return S}}const b=l.filter(S=>(0,k.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(m,S.openedWorkspace.uri));if(b.length)return b.sort((S,f)=>-(S.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function M(l,m){for(const I of l)if((0,k.isWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.uri,m))return I}e.findWindowOnWorkspaceOrFolder=M;function C(l,m){const I=b=>m.some(S=>v.extUriBiasedIgnorePathCase.isEqual(t.URI.file(S),t.URI.file(b)));for(const b of l)if(b.config?.extensionDevelopmentPath?.some(S=>I(S)))return b}e.findWindowOnExtensionDevelopmentPath=C}),define(Z[260],ee([0,1,15,2,4,16,7,19,21,6,39,33,115,27]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Rt extends t.Disposable{constructor(p,c,n,o,i){super(),this.windowsMainService=p,this.stateMainService=c,this.lifecycleMainService=n,this.logService=o,this.configurationService=i,this._state=y(this.stateMainService.getItem(Rt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(p=>this.onBeforeCloseWindow(p)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(p=>{p.newCount-p.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(p=>this.onBeforeCloseWindow(p))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const p=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),i&&(c.lastActiveWindow=this.toWindowState(i),c.lastActiveWindow.uiState.mode===3&&p.add(c.lastActiveWindow.uiState.display))}const n=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);n&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(n),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(p.has(c.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!n.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=1):p.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const r=this.toWindowState(i);return r.uiState.mode===3&&(p.has(r.uiState.display)?k.isMacintosh&&r.windowId!==c.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(r.uiState.mode=1):p.add(r.uiState.display)),r}));const o=w(c);this.stateMainService.setItem(Rt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(p){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(p);p.isExtensionDevelopmentHost&&!p.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!p.isExtensionDevelopmentHost&&p.openedWorkspace&&this._state.openedWindows.forEach(n=>{const o=(0,f.isWorkspaceIdentifier)(p.openedWorkspace)&&n.workspace?.id===p.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&n.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(n.folderUri,p.openedWorkspace.uri);(o||i)&&(n.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(p){return{windowId:p.id,workspace:(0,f.isWorkspaceIdentifier)(p.openedWorkspace)?p.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)?p.openedWorkspace.uri:void 0,backupPath:p.backupPath,remoteAuthority:p.remoteAuthority,uiState:p.serializeWindowState()}}getNewWindowState(p){const c=this.doGetNewWindowState(p),n=this.configurationService.getValue("window");if(c.mode===3){let o;c.hasDefaultState?o=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||n?.restoreFullscreen),o||(c.mode=1)}return c}doGetNewWindowState(p){const c=this.windowsMainService.getLastActiveWindow();if(!p.extensionTestsPath){if(!!p.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=p.workspace;if((0,f.isWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===a.id).map(D=>D.uiState);if(P.length)return P[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(D=>D.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(D.folderUri,a.uri)).map(D=>D.uiState);if(P.length)return P[0]}else if(p.backupPath){const P=this.state.openedWindows.filter(D=>D.backupPath===p.backupPath).map(D=>D.uiState);if(P.length)return P[0]}const u=this.lastClosedState||this.state.lastActiveWindow;if(!c&&u)return u.uiState}let n;const o=v.screen.getAllDisplays();if(o.length===1)n=o[0];else{if(k.isMacintosh){const a=v.screen.getCursorScreenPoint();n=v.screen.getDisplayNearestPoint(a)}!n&&c&&(n=v.screen.getDisplayMatching(c.getBounds())),n||(n=v.screen.getPrimaryDisplay()||o[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")i.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")i.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&c){const a=c.serializeWindowState();a.mode===3?i.mode=3:i=a,s=i.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(p){if(this.windowsMainService.getWindows().length===0)return p;p.x=typeof p.x=="number"?p.x:0,p.y=typeof p.y=="number"?p.y:0;const c=this.windowsMainService.getWindows().map(n=>n.getBounds());for(;c.some(n=>n.x===p.x||n.y===p.y);)p.x+=30,p.y+=30;return p}};d.windowsStateStorageKey="windowsState",d=ve([J(0,b.IWindowsMainService),J(1,I.IStateMainService),J(2,l.ILifecycleMainService),J(3,m.ILogService),J(4,C.IConfigurationService)],d),e.WindowsStateHandler=d;function y(h){const p={openedWindows:[]},c=h||{openedWindows:[]};return c.lastActiveWindow&&(p.lastActiveWindow=E(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(p.lastPluginDevelopmentHostWindow=E(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(p.openedWindows=c.openedWindows.map(n=>E(n))),p}e.restoreWindowsState=y;function E(h){const p={uiState:h.uiState};return h.backupPath&&(p.backupPath=h.backupPath),h.remoteAuthority&&(p.remoteAuthority=h.remoteAuthority),h.folder&&(p.folderUri=M.URI.parse(h.folder)),h.workspaceIdentifier&&(p.workspace={id:h.workspaceIdentifier.id,configPath:M.URI.parse(h.workspaceIdentifier.configURIPath)}),p}function w(h){return{lastActiveWindow:h.lastActiveWindow&&g(h.lastActiveWindow),lastPluginDevelopmentHostWindow:h.lastPluginDevelopmentHostWindow&&g(h.lastPluginDevelopmentHostWindow),openedWindows:h.openedWindows.map(p=>g(p))}}e.getWindowsStateStoreData=w;function g(h){return{workspaceIdentifier:h.workspace&&{id:h.workspace.id,configURIPath:h.workspace.configPath.toString()},folder:h.folderUri&&h.folderUri.toString(),backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.uiState}}}),define(Z[91],ee([0,1,31,43,123,35,13,9,4,16,7,5,63,27]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function d(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function y(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=y;function E(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=E;function w(D){return g(D)||h(D)}e.isStoredWorkspaceFolder=w;function g(D){const T=D;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function h(D){const T=D;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function p(D,T,N,U,$){if(D.scheme!==U.scheme)return{name:N,uri:D.toString(!0)};let Y=T?void 0:$.relativePath(U,D);if(Y!==void 0)Y.length===0?Y=".":l.isWindows&&(Y=c(Y));else if(D.scheme===M.Schemas.file)Y=D.fsPath,l.isWindows&&(Y=c(Y));else if($.isEqualAuthority(D.authority,U.authority))Y=D.path;else return{name:N,uri:D.toString(!0)};return{name:N,path:Y}}e.getStoredWorkspaceFolder=p;function c(D){return D=(0,R.normalizeDriveLetter)(D),(0,v.isUNC)(D)||(D=(0,v.toSlashes)(D)),D}function n(D,T,N){const U=[],$=new Set,Y=N.dirname(T);for(const oe of D){let ue;if(g(oe))oe.path&&(ue=N.resolvePath(Y,oe.path));else if(h(oe))try{ue=I.URI.parse(oe.uri),ue.path[0]!==C.posix.sep&&(ue=ue.with({path:C.posix.sep+ue.path}))}catch(se){console.warn(se)}if(ue){const se=N.getComparisonKey(ue);if(!$.has(se)){$.add(se);const de=oe.name||N.basenameOrAuthority(ue);U.push(new f.WorkspaceFolder({uri:ue,name:de,index:U.length},oe))}}}return U}e.toWorkspaceFolders=n;function o(D,T,N,U,$){const Y=i(T,D),oe=$.dirname(T),ue=$.dirname(U),se=[];for(const F of Y.folders){const A=g(F)?$.resolvePath(oe,F.path):I.URI.parse(F.uri);let W;N?W=!1:W=!g(F)||(0,C.isAbsolute)(F.path),se.push(p(A,W,F.name,ue,$))}const de={insertSpaces:!1,tabSize:4,eol:l.isLinux||l.isMacintosh?`
`:`\r
`},G=k.setProperty(D,["folders"],se,de);let K=k.applyEdits(D,G);return(0,m.isEqualAuthority)(Y.remoteAuthority,(0,S.getRemoteAuthority)(U))&&(K=k.applyEdits(K,k.removeProperty(K,["remoteAuthority"],de))),K}e.rewriteWorkspaceFileForNewLocation=o;function i(D,T){const N=t.parse(T);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(U=>w(U));else throw new Error(`${D} looks like an invalid workspace file.`);return N}function r(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function s(D){return typeof D.folderUri=="string"}function a(D){return typeof D.fileUri=="string"}function u(D,T){const N={workspaces:[],files:[]};if(D){const U=function(Y,oe){for(let ue=0;ue<Y.length;ue++)try{oe(Y[ue],ue)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(Y[ue])}: ${se.toString()}. Skip entry.`)}},$=D;Array.isArray($.entries)&&U($.entries,Y=>{const oe=Y.label,ue=Y.remoteAuthority;r(Y)?N.workspaces.push({label:oe,remoteAuthority:ue,workspace:{id:Y.workspace.id,configPath:I.URI.parse(Y.workspace.configPath)}}):s(Y)?N.workspaces.push({label:oe,remoteAuthority:ue,folderUri:I.URI.parse(Y.folderUri)}):a(Y)&&N.files.push({label:oe,remoteAuthority:ue,fileUri:I.URI.parse(Y.fileUri)})})}return N}e.restoreRecentlyOpened=u;function P(D){const T={entries:[]};for(const N of D.workspaces)y(N)?T.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):T.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of D.files)T.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return T}e.toStoreData=P}),define(Z[92],ee([0,1,76,28,13,4,16]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function C(I){function b(){let S=I.scheme===k.Schemas.file?(0,M.originalFSPath)(I):I.toString();return R.isLinux||(S=S.toLowerCase()),(0,v.createHash)("md5").update(S).digest("hex")}return{id:b(),configPath:I}}e.getWorkspaceIdentifier=C;function l(I,b){function S(){if(I.scheme!==k.Schemas.file)return(0,v.createHash)("md5").update(I.toString()).digest("hex");if(!b)try{b=(0,t.statSync)(I.fsPath)}catch{return}let d;return R.isLinux?d=b.ino:R.isMacintosh?d=b.birthtime.getTime():R.isWindows&&(typeof b.birthtimeMs=="number"?d=Math.floor(b.birthtimeMs):d=b.birthtime.getTime()),(0,v.createHash)("md5").update(I.fsPath).update(d?String(d):"").digest("hex")}const f=S();if(typeof f=="string")return{id:f,uri:I}}e.getSingleFolderWorkspaceIdentifier=l;function m(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=m}),define(Z[261],ee([0,1,76,28,31,13,9,4,16,23,177,19,26,39,14,6,176,27,92]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let h=class Lt{constructor(c,n,o,i){this.environmentMainService=c,this.configurationService=n,this.logService=o,this.stateMainService=i,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=l.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,s)=>(0,k.isEqual)(r,s,!C.isLinux)}}async initialize(){const c=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWindows),this.workspaces=await this.validateWorkspaces((0,I.deserializeWorkspaceInfos)(c)),this.folders=await this.validateFolders((0,I.deserializeFolderInfos)(c)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let c=this.stateMainService.getItem(Lt.backupWorkspacesMetadataStorageKey);if(!c)try{const n=(0,M.join)(this.backupHome,"workspaces.json"),o=await m.Promises.readFile(n,"utf8");try{await m.Promises.unlink(n)}catch{}const i=JSON.parse(o);c={workspaces:Array.isArray(i.rootURIWorkspaces)?i.rootURIWorkspaces:[],folders:Array.isArray(i.folderWorkspaceInfos)?i.folderWorkspaceInfos:[],emptyWindows:Array.isArray(i.emptyWorkspaceInfos)?i.emptyWorkspaceInfos:[]}}catch(n){n.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${n.toString()}`)}return c??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(c,n){this.workspaces.some(i=>c.workspace.id===i.workspace.id)||(this.workspaces.push(c),this.storeWorkspacesMetadata());const o=(0,M.join)(this.backupHome,c.workspace.id);return n&&this.moveBackupFolderSync(o,n),o}moveBackupFolderSync(c,n){if(t.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),t.existsSync(n))try{t.renameSync(n,c)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(c){return this.folders.some(n=>this.backupUriComparer.isEqual(c.folderUri,n.folderUri))||(this.folders.push(c),this.storeWorkspacesMetadata()),(0,M.join)(this.backupHome,this.getFolderHash(c))}registerEmptyWindowBackup(c){return this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,c.backupFolder))||(this.emptyWindows.push(c),this.storeWorkspacesMetadata()),(0,M.join)(this.backupHome,c.backupFolder)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const n=new Set,o=[];for(const i of c){const r=i.workspace;if(!(0,w.isWorkspaceIdentifier)(r))return[];if(!n.has(r.id)){n.add(r.id);const s=(0,M.join)(this.backupHome,r.id);await this.doHasBackups(s)?r.configPath.scheme!==R.Schemas.file||await m.Promises.exists(r.configPath.fsPath)?o.push(i):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateFolders(c){if(!Array.isArray(c))return[];const n=[],o=new Set;for(const i of c){const r=i.folderUri,s=this.backupUriComparer.getComparisonKey(r);if(!o.has(s)){o.add(s);const a=(0,M.join)(this.backupHome,this.getFolderHash(i));await this.doHasBackups(a)?r.scheme!==R.Schemas.file||await m.Promises.exists(r.fsPath)?n.push(i):await this.convertToEmptyWindowBackup(a):await this.deleteStaleBackup(a)}}return n}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const n=[],o=new Set;for(const i of c){const r=i.backupFolder;if(typeof r!="string")return[];if(!o.has(r)){o.add(r);const s=(0,M.join)(this.backupHome,r);await this.doHasBackups(s)?n.push(i):await this.deleteStaleBackup(s)}}return n}async deleteStaleBackup(c){try{await m.Promises.rm(c,m.RimRafMode.MOVE)}catch(n){this.logService.error(`Backup: Could not delete stale backup: ${n.toString()}`)}}prepareNewEmptyWindowBackup(){let c=(0,g.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,c.id));)c=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:c.id}}async convertToEmptyWindowBackup(c){const n=this.prepareNewEmptyWindowBackup(),o=(0,M.join)(this.backupHome,n.backupFolder);try{await m.Promises.rename(c,o)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push(n),!0}convertToEmptyWindowBackupSync(c){const n=this.prepareNewEmptyWindowBackup(),o=(0,M.join)(this.backupHome,n.backupFolder);try{t.renameSync(c,o)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push(n),!0}async getDirtyWorkspaces(){const c=[];for(const n of this.workspaces)await this.hasBackups(n)&&c.push(n);for(const n of this.folders)await this.hasBackups(n)&&c.push(n);return c}hasBackups(c){let n;return(0,I.isEmptyWindowBackupInfo)(c)?n=(0,M.join)(this.backupHome,c.backupFolder):(0,E.isFolderBackupInfo)(c)?n=(0,M.join)(this.backupHome,this.getFolderHash(c)):n=(0,M.join)(this.backupHome,c.workspace.id),this.doHasBackups(n)}async doHasBackups(c){try{const n=await m.Promises.readdir(c);for(const o of n)try{if((await m.Promises.readdir((0,M.join)(c,o))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const c={workspaces:this.workspaces.map(({workspace:n,remoteAuthority:o})=>{const i={id:n.id,configURIPath:n.configPath.toString()};return o&&(i.remoteAuthority=o),i}),folders:this.folders.map(({folderUri:n,remoteAuthority:o})=>{const i={folderUri:n.toString()};return o&&(i.remoteAuthority=o),i}),emptyWindows:this.emptyWindows.map(({backupFolder:n,remoteAuthority:o})=>{const i={backupFolder:n};return o&&(i.remoteAuthority=o),i})};this.stateMainService.setItem(Lt.backupWorkspacesMetadataStorageKey,c)}getFolderHash(c){const n=c.folderUri;let o;return n.scheme===R.Schemas.file?o=C.isLinux?n.fsPath:n.fsPath.toLowerCase():o=n.toString().toLowerCase(),(0,v.createHash)("md5").update(o).digest("hex")}};h.backupWorkspacesMetadataStorageKey="backupWorkspaces",h=ve([J(0,S.IEnvironmentMainService),J(1,b.IConfigurationService),J(2,y.ILogService),J(3,f.IStateMainService)],h),e.BackupMainService=h}),define(Z[52],ee([0,1,15,28,3,43,35,2,13,9,16,12,23,175,60,56,26,5,6,20,42,117,27,91,92]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c,n,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let r=class extends C.Disposable{constructor(a,u,P,D,T,N){super(),this.environmentMainService=a,this.logService=u,this.userDataProfilesMainService=P,this.backupMainService=D,this.dialogMainService=T,this.productService=N,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,u=>(0,t.readFileSync)(u,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,u=>S.Promises.readFile(u,"utf8"))}doResolveLocalWorkspace(a,u){if(!!this.isWorkspacePath(a)&&a.scheme===l.Schemas.file)try{const P=u(a.fsPath);return P instanceof Promise?P.then(D=>this.doResolveWorkspace(a,D),D=>{}):this.doResolveWorkspace(a,P)}catch{return}}isWorkspacePath(a){return(0,n.isUntitledWorkspace)(a,this.environmentMainService)||(0,n.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,u){try{const P=this.doParseStoredWorkspace(a,u),D=(0,i.getWorkspaceIdentifier)(a);return{id:D.id,configPath:D.configPath,folders:(0,o.toWorkspaceFolders)(P.folders,D.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority,transient:P.transient}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(a,u){const P=(0,R.parse)(u);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(D=>(0,o.isStoredWorkspaceFolder)(D));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(a,u){const{workspace:P,storedWorkspace:D}=this.newUntitledWorkspace(a,u),T=P.configPath.fsPath;return await S.Promises.mkdir((0,m.dirname)(T),{recursive:!0}),await S.Promises.writeFile(T,JSON.stringify(D,null,"	")),P}createUntitledWorkspaceSync(a,u){const{workspace:P,storedWorkspace:D}=this.newUntitledWorkspace(a,u),T=P.configPath.fsPath;return(0,t.mkdirSync)((0,m.dirname)(T),{recursive:!0}),(0,S.writeFileSync)(T,JSON.stringify(D,null,"	")),P}newUntitledWorkspace(a=[],u){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,I.joinPath)(this.untitledWorkspacesHome,P),T=(0,I.joinPath)(D,n.UNTITLED_WORKSPACE_NAME),N=[];for(const U of a)N.push((0,o.getStoredWorkspaceFolder)(U.uri,!0,U.name,D,I.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(T),storedWorkspace:{folders:N,remoteAuthority:u}}}async getWorkspaceIdentifier(a){return(0,i.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,n.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const u=(0,I.originalFSPath)(a.configPath);try{(0,S.rimrafSync)((0,m.dirname)(u));const P=(0,m.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,t.existsSync)(P)&&(0,S.writeFileSync)((0,m.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${u} (${P}).`)}}getUntitledWorkspacesSync(){const a=[];try{const u=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,I.joinPath)(this.untitledWorkspacesHome,P,n.UNTITLED_WORKSPACE_NAME));for(const P of u){const D=(0,i.getWorkspaceIdentifier)(P),T=this.resolveLocalWorkspaceSync(P);T?a.push({workspace:D,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(u){u.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${u}).`)}return a}async enterWorkspace(a,u,P){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,u,P))return;const T=this.doEnterWorkspace(a,(0,i.getWorkspaceIdentifier)(P));if(!!T)return this._onDidEnterWorkspace.fire({window:a,workspace:T.workspace}),T}async isValidTargetWorkspacePath(a,u,P){if(!P)return!0;if((0,n.isWorkspaceIdentifier)(a.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,P))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(u,P)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,f.localize)(0,null))],message:(0,f.localize)(1,null,(0,I.basename)(P)),detail:(0,f.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,b.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,u){if(!a.config)return;a.focus();let P;return a.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackup({workspace:u,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,n.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=u,a.config.backupPath=P,{workspace:u,backupPath:P}}};r=ve([J(0,E.IEnvironmentMainService),J(1,g.ILogService),J(2,p.IUserDataProfilesMainService),J(3,d.IBackupMainService),J(4,y.IDialogMainService),J(5,h.IProductService)],r),e.WorkspacesManagementMainService=r}),define(Z[118],ee([0,1,15,41,22,5,33,27,52,12,6]),function(q,e,v,t,k,R,M,C,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let b=class{constructor(f,d,y){this.windowsMainService=f,this.workspacesManagementMainService=d,this.logService=y}async getRemoteDiagnostics(f){const d=this.windowsMainService.getWindows();return(await Promise.all(d.map(E=>new Promise(w=>{const g=E.remoteAuthority;if(g){const h=`vscode:getDiagnosticInfoResponse${E.id}`,p={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?this.getFolderURIs(E):void 0};E.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:h,args:p}),t.validatedIpcMain.once(h,(c,n)=>{n||w({hostName:g,errorMessage:`Unable to resolve connection to '${g}'.`}),w(n)}),setTimeout(()=>{w({hostName:g,errorMessage:`Connection to '${g}' could not be established`})},5e3)}else w(void 0)})))).filter(E=>!!E)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const f=[];for(const d of v.BrowserWindow.getAllWindows()){const y=this.windowsMainService.getWindowById(d.id);y?f.push(this.codeWindowToInfo(y)):f.push(this.browserWindowToInfo(d))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}codeWindowToInfo(f){const d=this.getFolderURIs(f),y=(0,m.assertIsDefined)(f.win);return this.browserWindowToInfo(y,d,f.remoteAuthority)}browserWindowToInfo(f,d=[],y){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:d,remoteAuthority:y}}getFolderURIs(f){const d=[],y=f.openedWorkspace;if((0,C.isSingleFolderWorkspaceIdentifier)(y))d.push(y.uri);else if((0,C.isWorkspaceIdentifier)(y)){const E=this.workspacesManagementMainService.resolveLocalWorkspaceSync(y.configPath);E&&E.folders.forEach(g=>{d.push(g.uri)})}return d}};b=ve([J(0,M.IWindowsMainService),J(1,l.IWorkspacesManagementMainService),J(2,I.ILogService)],b),e.DiagnosticsMainService=b}),define(Z[65],ee([0,1,45,15,29,141,53,3,35,2,13,9,4,7,97,81,23,93,165,56,26,5,21,6,20,64,33,27,52,18,220]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c,n,o,i,r,s,a,u,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let T=class extends m.Disposable{constructor(U,$,Y,oe,ue,se,de,G,K){super(),this.sharedProcess=U,this.windowsMainService=$,this.dialogMainService=Y,this.lifecycleMainService=oe,this.environmentMainService=ue,this.logService=se,this.productService=de,this.themeMainService=G,this.workspacesManagementMainService=K,this.onDidOpenWindow=C.Event.map(this.windowsMainService.onDidOpenWindow,F=>F.id),this.onDidTriggerSystemContextMenu=C.Event.filter(C.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:F,x:A,y:W})=>({windowId:F.id,x:A,y:W})),({windowId:F})=>!!this.windowsMainService.getWindowById(F)),this.onDidMaximizeWindow=C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidUnmaximizeWindow=C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidBlurWindow=C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidFocusWindow=C.Event.any(C.Event.map(C.Event.filter(C.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),F=>!!F),F=>F.id),C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F))),this.onDidResumeOS=C.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new C.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=C.Event.debounce(C.Event.any(C.Event.filter(C.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(F,A,W)=>W),F=>!(Array.isArray(F)&&F.length===1&&F[0]==="workArea")),C.Event.fromNodeEventEmitter(t.screen,"display-added"),C.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map($=>({id:$.id,workspace:$.openedWorkspace??(0,a.toWorkspaceIdentifier)($.backupPath,$.isExtensionDevelopmentHost),title:$.win?.getTitle()??"",filename:$.getRepresentedFilename(),dirty:$.isDocumentEdited()}))}async getWindowCount(U){return this.windowsMainService.getWindowCount()}async getActiveWindowId(U){const $=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if($)return $.id}openWindow(U,$,Y){return Array.isArray($)?this.doOpenWindow(U,$,Y):this.doOpenEmptyWindow(U,$)}async doOpenWindow(U,$,Y=Object.create(null)){$.length>0&&this.windowsMainService.open({context:5,contextWindowId:U,urisToOpen:$,cli:this.environmentMainService.args,forceNewWindow:Y.forceNewWindow,forceReuseWindow:Y.forceReuseWindow,preferNewWindow:Y.preferNewWindow,diffMode:Y.diffMode,mergeMode:Y.mergeMode,addMode:Y.addMode,gotoLineMode:Y.gotoLineMode,noRecentEntry:Y.noRecentEntry,waitMarkerFileURI:Y.waitMarkerFileURI,remoteAuthority:Y.remoteAuthority||void 0})}async doOpenEmptyWindow(U,$){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:U},$)}async toggleFullScreen(U){this.windowById(U)?.toggleFullScreen()}async handleTitleDoubleClick(U){this.windowById(U)?.handleTitleDoubleClick()}async isMaximized(U){const $=this.windowById(U);return $?.win?$.win.isMaximized():!1}async maximizeWindow(U){const $=this.windowById(U);$?.win&&$.win.maximize()}async unmaximizeWindow(U){const $=this.windowById(U);$?.win&&$.win.unmaximize()}async minimizeWindow(U){const $=this.windowById(U);$?.win&&$.win.minimize()}async updateWindowControls(U,$){const Y=this.windowById(U);Y&&Y.updateWindowControls($)}async focusWindow(U,$){$&&typeof $.windowId=="number"&&(U=$.windowId),this.windowById(U)?.focus({force:$?.force??!1})}async setMinimumSize(U,$,Y){const oe=this.windowById(U);if(oe?.win){const[ue,se]=oe.win.getSize(),[de,G]=oe.win.getMinimumSize(),[K,F]=[$??de,Y??G],[A,W]=[Math.max(ue,K),Math.max(se,F)];(de!==K||G!==F)&&oe.win.setMinimumSize(K,F),(ue!==A||se!==W)&&oe.win.setSize(A,W)}}async saveWindowSplash(U,$){this.themeMainService.saveWindowSplash(U,$)}async installShellCommand(U){const{source:$,target:Y}=await this.getShellCommandLink();try{const{symbolicLink:oe}=await E.SymlinkSupport.stat($);if(oe&&!oe.dangling){const ue=await(0,d.realpath)($);if(Y===ue)return}await E.Promises.unlink($)}catch(oe){if(oe.code!=="ENOENT")throw oe}try{await E.Promises.symlink(Y,$)}catch(oe){if(oe.code!=="EACCES"&&oe.code!=="ENOENT")throw oe;const{response:ue}=await this.showMessageBox(U,{title:this.productService.nameLong,type:"info",message:(0,g.localize)(0,null,this.productService.nameShort),buttons:[(0,l.mnemonicButtonLabel)((0,g.localize)(1,null)),(0,l.mnemonicButtonLabel)((0,g.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ue===0)try{const se=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Y}' '${$}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(se)}catch{throw new Error((0,g.localize)(3,null,$))}}}async uninstallShellCommand(U){const{source:$}=await this.getShellCommandLink();try{await E.Promises.unlink($)}catch(Y){switch(Y.code){case"EACCES":{const{response:oe}=await this.showMessageBox(U,{title:this.productService.nameLong,type:"info",message:(0,g.localize)(4,null,this.productService.nameShort),buttons:[(0,l.mnemonicButtonLabel)((0,g.localize)(5,null)),(0,l.mnemonicButtonLabel)((0,g.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const ue=`osascript -e "do shell script \\"rm '${$}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(ue)}catch{throw new Error((0,g.localize)(7,null,$))}break}case"ENOENT":break;default:throw Y}}}async getShellCommandLink(){const U=(0,b.resolve)(this.environmentMainService.appRoot,"bin","code"),$=`/usr/local/bin/${this.productService.applicationName}`;if(!await E.Promises.exists(U))throw new Error((0,g.localize)(8,null,U));return{source:$,target:U}}async showMessageBox(U,$){return this.dialogMainService.showMessageBox($,this.toBrowserWindow(U))}async showSaveDialog(U,$){return this.dialogMainService.showSaveDialog($,this.toBrowserWindow(U))}async showOpenDialog(U,$){return this.dialogMainService.showOpenDialog($,this.toBrowserWindow(U))}toBrowserWindow(U){const $=this.windowById(U);if($?.win)return $.win}async pickFileFolderAndOpen(U,$){const Y=await this.dialogMainService.pickFileFolder($);Y&&this.doOpenPicked(await Promise.all(Y.map(async oe=>await E.SymlinkSupport.existsDirectory(oe)?{folderUri:f.URI.file(oe)}:{fileUri:f.URI.file(oe)})),$,U)}async pickFolderAndOpen(U,$){const Y=await this.dialogMainService.pickFolder($);Y&&this.doOpenPicked(Y.map(oe=>({folderUri:f.URI.file(oe)})),$,U)}async pickFileAndOpen(U,$){const Y=await this.dialogMainService.pickFile($);Y&&this.doOpenPicked(Y.map(oe=>({fileUri:f.URI.file(oe)})),$,U)}async pickWorkspaceAndOpen(U,$){const Y=await this.dialogMainService.pickWorkspace($);Y&&this.doOpenPicked(Y.map(oe=>({workspaceUri:f.URI.file(oe)})),$,U)}doOpenPicked(U,$,Y){this.windowsMainService.open({context:3,contextWindowId:Y,cli:this.environmentMainService.args,urisToOpen:U,forceNewWindow:$.forceNewWindow})}async showItemInFolder(U,$){t.shell.showItemInFolder($)}async setRepresentedFilename(U,$){this.windowById(U)?.setRepresentedFilename($)}async setDocumentEdited(U,$){this.windowById(U)?.setDocumentEdited($)}async openExternal(U,$){return S.isLinuxSnap?this.safeSnapOpenExternal($):t.shell.openExternal($),!0}safeSnapOpenExternal(U){const $=process.env.GDK_PIXBUF_MODULE_FILE,Y=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(U),process.env.GDK_PIXBUF_MODULE_FILE=$,process.env.GDK_PIXBUF_MODULEDIR=Y}moveItemToTrash(U,$){return t.shell.trashItem($)}async isAdmin(){let U;return S.isWindows?U=(await new Promise(($,Y)=>{q(["native-is-elevated"],$,Y)}))():U=process.getuid()===0,U}async writeElevated(U,$,Y,oe){const ue=await new Promise((se,de)=>{q(["@vscode/sudo-prompt"],se,de)});return new Promise((se,de)=>{const G=[`"${this.cliPath}"`];oe?.unlock&&G.push("--file-chmod"),G.push("--file-write",`"${$.fsPath}"`,`"${Y.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ue.exec(G.join(" "),K,(F,A,W)=>{A&&this.logService.trace(`[sudo-prompt] received stdout: ${A}`),W&&this.logService.trace(`[sudo-prompt] received stderr: ${W}`),F?de(F):se(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,b.join)(this.environmentMainService.appRoot,"bin","code"):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return S.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(U,$,Y){process.kill($,Y)}async readClipboardText(U,$){return t.clipboard.readText($)}async writeClipboardText(U,$,Y){return t.clipboard.writeText($,Y)}async readClipboardFindText(U){return t.clipboard.readFindText()}async writeClipboardFindText(U,$){return t.clipboard.writeFindText($)}async writeClipboardBuffer(U,$,Y,oe){return t.clipboard.writeBuffer($,Buffer.from(Y.buffer),oe)}async readClipboardBuffer(U,$){return P.VSBuffer.wrap(t.clipboard.readBuffer($))}async hasClipboard(U,$,Y){return t.clipboard.has($,Y)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(U,$){this.windowById(U)?.updateTouchBar($)}async notifyReady(U){this.windowById(U)?.setReady()}async relaunch(U,$){return this.lifecycleMainService.relaunch($)}async reload(U,$){const Y=this.windowById(U);if(Y){if((0,a.isWorkspaceIdentifier)(Y.openedWorkspace)){const oe=Y.openedWorkspace.configPath;if(oe.scheme===I.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(oe))?.transient)return this.openWindow(Y.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Y,$?.disableExtensions!==void 0?{_:[],"disable-extensions":$.disableExtensions}:void 0)}}async closeWindow(U){this.closeWindowById(U,U)}async closeWindowById(U,$){const Y=this.windowById($);if(Y?.win)return Y.win.close()}async quit(U){const $=this.windowsMainService.getLastActiveWindow();$?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&$.win?$.win.close():this.lifecycleMainService.quit()}async exit(U,$){await this.lifecycleMainService.kill($)}async resolveProxy(U,$){const oe=this.windowById(U)?.win?.webContents?.session;if(oe)return oe.resolveProxy($)}findFreePort(U,$,Y,oe,ue=1){return(0,w.findFreePort)($,Y,oe,ue)}async openDevTools(U,$){const Y=this.windowById(U);Y?.win&&Y.win.webContents.openDevTools($)}async toggleDevTools(U){const $=this.windowById(U);$?.win&&$.win.webContents.toggleDevTools()}async sendInputEvent(U,$){const Y=this.windowById(U);Y?.win&&($.type==="mouseDown"||$.type==="mouseUp")&&Y.win.webContents.sendInputEvent($)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(U,$,Y,oe){if(!S.isWindows)return;const ue=await new Promise((se,de)=>{q(["@vscode/windows-registry"],se,de)});try{return ue.GetStringRegKey($,Y,oe)}catch{return}}windowById(U){if(typeof U=="number")return this.windowsMainService.getWindowById(U)}};ve([M.memoize],T.prototype,"cliPath",null),T=ve([J(1,s.IWindowsMainService),J(2,h.IDialogMainService),J(3,n.ILifecycleMainService),J(4,p.IEnvironmentMainService),J(5,o.ILogService),J(6,i.IProductService),J(7,r.IThemeMainService),J(8,u.IWorkspacesManagementMainService)],T),e.NativeHostMainService=T}),define(Z[262],ee([0,1,15,41,29,35,2,13,4,98,163,84,118,56,26,5,6,65,54,20,61,74,31,12]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let i=class _t{constructor(s,a,u,P,D,T,N,U,$){this.userEnv=s,this.environmentMainService=a,this.logService=u,this.diagnosticsService=P,this.diagnosticsMainService=D,this.dialogMainService=T,this.nativeHostMainService=N,this.protocolMainService=U,this.productService=$,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[a,u]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),P=await this.diagnosticsService.getSystemInfo(a,u);this.safeSend(s,"vscode:issueSystemInfoResponse",P)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const a=[];try{a.push({name:(0,I.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(P=>{(0,b.isRemoteDiagnosticError)(P)?a.push({name:P.hostName,rootProcess:P}):P.processes&&a.push({name:P.hostName,rootProcess:P.processes})})}catch(u){this.logService.error(`Listing processes failed: ${u}`)}this.safeSend(s,"vscode:listProcessesResponse",a)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const a={title:this.productService.nameLong,message:(0,I.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const u=await this.dialogMainService.showMessageBox(a,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",u.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const a=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",a)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,I.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,a)=>{const{id:u,from:P,args:D}=a;let T;switch(P){case"issueReporter":T=this.issueReporterParentWindow;break;case"processExplorer":T=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${P}`)}T?.webContents.send("vscode:runAction",{id:u,from:P,args:D})}),t.validatedIpcMain.on("vscode:openExternal",(s,a)=>{this.nativeHostMainService.openExternal(void 0,a)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const a=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(s,"vscode:windowsInfoResponse",a.windows)})}safeSend(s,a,...u){s.sender.isDestroyed()||s.sender.send(a,...u)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const a=new M.DisposableStore,u=a.add(this.protocolMainService.createIPCObjectUrl()),P=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(P,u,{backgroundColor:s.styles.backgroundColor,title:(0,I.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),u.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:g.default}),this.issueReporterWindow.loadURL(C.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,a.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,a.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const a=new M.DisposableStore,u=a.add(this.protocolMainService.createIPCObjectUrl()),P=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(P,u,{backgroundColor:s.styles.backgroundColor,title:(0,I.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),u.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:g.default}),this.processExplorerWindow.loadURL(C.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,a.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,a.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,a,u,P){const D=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:u.title,backgroundColor:u.backgroundColor||_t.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${a.resource.toString()}`,`--vscode-window-kind=${P}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.zoomLevelToZoomFactor)(u.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:u.alwaysOnTop,experimentalDarkMode:!0});return D.setMenuBarVisibility(!1),D}async getSystemStatus(){const[s,a]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,a)}getWindowPosition(s,a,u){let P;const D=v.screen.getAllDisplays();if(D.length===1)P=D[0];else{if(l.isMacintosh){const U=v.screen.getCursorScreenPoint();P=v.screen.getDisplayNearestPoint(U)}!P&&s&&(P=v.screen.getDisplayMatching(s.getBounds())),P||(P=v.screen.getPrimaryDisplay()||D[0])}const T={width:a,height:u},N=P.bounds;return T.x=N.x+N.width/2-T.width/2,T.y=N.y+N.height/2-T.height/2,N.width>0&&N.height>0&&(T.x<N.x&&(T.x=N.x),T.y<N.y&&(T.y=N.y),T.x>N.x+N.width&&(T.x=N.x),T.y>N.y+N.height&&(T.y=N.y),T.width>N.width&&(T.width=N.width),T.height>N.height&&(T.height=N.height)),T}async getPerformanceInfo(){try{const[s,a]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,a)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const s=await v.contentTracing.stopRecording(`${(0,n.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,I.localize)(9,null),detail:(0,I.localize)(10,null,s),buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(11,null))],defaultId:0,noLink:!0},(0,o.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,s)}};i.DEFAULT_BACKGROUND_COLOR="#1E1E1E",i=ve([J(1,d.IEnvironmentMainService),J(2,E.ILogService),J(3,b.IDiagnosticsService),J(4,S.IDiagnosticsMainService),J(5,f.IDialogMainService),J(6,w.INativeHostMainService),J(7,p.IProtocolMainService),J(8,h.IProductService)],i),e.IssueMainService=i}),define(Z[263],ee([0,1,22,19,26,21,6,65,20,55,37,48,88]),function(q,e,v,t,k,R,M,C,l,m,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends S.AbstractUpdateService{constructor(y,E,w,g,h,p,c,n){super(y,E,g,h,p,n),this.telemetryService=w,this.nativeHostMainService=c}buildUpdateFeedUrl(y){return(0,S.createUpdateURL)(`linux-${process.arch}`,y,this.productService)}doCheckForUpdates(y){!this.url||(this.setState(b.State.CheckingForUpdates(y)),this.requestService.request({url:this.url},v.CancellationToken.None).then(m.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y});const w=y?E.message||E:void 0;this.setState(b.State.Idle(1,w))}))}async doDownloadUpdate(y){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):y.update.url&&this.nativeHostMainService.openExternal(void 0,y.update.url),this.setState(b.State.Idle(1))}};f=ve([J(0,R.ILifecycleMainService),J(1,t.IConfigurationService),J(2,I.ITelemetryService),J(3,k.IEnvironmentMainService),J(4,m.IRequestService),J(5,M.ILogService),J(6,C.INativeHostMainService),J(7,l.IProductService)],f),e.LinuxUpdateService=f}),define(Z[264],ee([0,1,45,28,29,8,22,53,9,7,127,23,19,26,14,21,6,65,20,55,37,48,88]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(a,u=1e3){for(;!a();)await(0,R.timeout)(u)}let i;function r(){return typeof i>"u"&&(i=t.existsSync(l.join(l.dirname(process.execPath),"unins000.exe"))?0:1),i}let s=class extends n.AbstractUpdateService{constructor(u,P,D,T,N,U,$,Y,oe){super(u,P,T,N,U,oe),this.telemetryService=D,this.fileService=$,this.nativeHostMainService=Y}get cachePath(){const u=l.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return b.Promises.mkdir(u,{recursive:!0}).then(()=>u)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(u){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),r()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,n.createUpdateURL)(P,u,this.productService)}doCheckForUpdates(u){!this.url||(this.setState(c.State.CheckingForUpdates(u)),this.requestService.request({url:this.url},M.CancellationToken.None).then(h.asJson).then(P=>{const D=r();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u}),this.setState(c.State.Idle(D)),Promise.resolve(null)):D===1?(this.setState(c.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(c.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(T=>b.Promises.exists(T).then(N=>{if(N)return Promise.resolve(T);const U=P.url,$=P.hash,Y=`${T}.tmp`;return this.requestService.request({url:U},M.CancellationToken.None).then(oe=>this.fileService.writeFile(m.URI.file(Y),oe.stream)).then($?()=>(0,I.checksum)(Y,P.hash):()=>{}).then(()=>b.Promises.rename(Y,T)).then(()=>T)})).then(T=>{const N=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},N&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(P)):this.setState(c.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u});const D=u?P.message||P:void 0;this.setState(c.State.Idle(r(),D))}))}async doDownloadUpdate(u){u.update.url&&this.nativeHostMainService.openExternal(void 0,u.update.url),this.setState(c.State.Idle(r()))}async getUpdatePackagePath(u){const P=await this.cachePath;return l.join(P,`CodeSetup-${this.productService.quality}-${u}.exe`)}async cleanup(u=null){const P=u?U=>!new RegExp(`${this.productService.quality}-${u}\\.exe$`).test(U):()=>!0,D=await this.cachePath,N=(await b.Promises.readdir(D)).filter(P).map(async U=>{try{await b.Promises.unlink(l.join(D,U))}catch{}});await Promise.all(N)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const u=this.state.update;this.setState(c.State.Updating(u));const P=await this.cachePath;this.availableUpdate.updateFilePath=l.join(P,`CodeSetup-${this.productService.quality}-${u.version}.flag`),await b.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(r()))});const T=`${this.productService.win32MutexName}-ready`,N=await new Promise((U,$)=>{q(["windows-mutex"],U,$)});o(()=>N.isActive(T)).then(()=>this.setState(c.State.Ready(u)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}async _applySpecificUpdate(u){if(this.state.type!=="idle")return;const P=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!P};this.setState(c.State.Downloading(D)),this.availableUpdate={packagePath:u},P?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(D)):this.setState(c.State.Ready(D))}};ve([C.memoize],s.prototype,"cachePath",null),s=ve([J(0,y.ILifecycleMainService),J(1,S.IConfigurationService),J(2,p.ITelemetryService),J(3,f.IEnvironmentMainService),J(4,h.IRequestService),J(5,E.ILogService),J(6,d.IFileService),J(7,w.INativeHostMainService),J(8,g.IProductService)],s),e.Win32UpdateService=s}),define(Z[265],ee([0,1,15,8,22,44,3,35,2,13,9,71,4,7,171,60,19,56,26,59,14,21,6,20,61,231,90,37,234,64,74,33,27,52,115,120,38,39,54,42]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c,n,o,i,r,s,a,u,P,D,T,N,U,$,Y,oe,ue,se,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(F){F[F.NONE=0]="NONE",F[F.NAVIGATING=1]="NAVIGATING",F[F.READY=2]="READY"})(G||(G={}));let K=class At extends l.Disposable{constructor(A,W,z,te,B,H,L,O,_,V,x,re,j,ie,ne,ae,ge,Me,Le){super(),this.logService=W,this.environmentMainService=z,this.policyService=te,this.userDataProfilesService=B,this.fileService=H,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=_,this.themeMainService=V,this.workspacesManagementMainService=x,this.backupMainService=re,this.telemetryService=j,this.dialogMainService=ie,this.lifecycleMainService=ne,this.productService=ae,this.protocolMainService=ge,this.windowsMainService=Me,this.stateMainService=Le,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ke,Ae]=this.restoreWindowState(A.state);this.windowState=ke,this.logService.trace("window#ctor: using window state",ke);const Ve=this.windowState.mode===0||this.windowState.mode===3,me=this.configurationService.getValue("window");let we=!1;typeof me?.experimental?.useSandbox=="boolean"?we=me.experimental.useSandbox:we=typeof se.default.quality=="string"&&se.default.quality!=="stable";const Ee={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!Ve,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(me?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...we?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};S.isLinux?Ee.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(Ee.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(Ee.fullscreenable=!1),S.isMacintosh&&(Ee.acceptFirstMouse=!0,me?.clickThroughInactive===!1&&(Ee.acceptFirstMouse=!1));const X=S.isMacintosh&&me?.nativeTabs===!0;X&&(Ee.tabbingIdentifier=this.productService.nameShort);const ce=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(ce&&(Ee.titleBarStyle="hidden",S.isMacintosh||(Ee.frame=!1),(0,D.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const he=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),be=Y.Color.fromHex(he).isDarker()?"#FFFFFF":"#000000";Ee.titleBarOverlay={height:29,color:he,symbolColor:be},this.hasWindowControlOverlay=!0}if((0,b.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(Ee),(0,b.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,S.isMacintosh&&ce&&this._win.setSheetOffset(22),ce&&(S.isWindows&&(0,D.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||S.isMacintosh)){const he=this.stateMainService.getItem(At.windowControlHeightStateStorageKey);he&&this.updateWindowControls({height:he})}S.isWindows&&ce&&this._win.hookWindowMessage(278,()=>{const[be,Ce]=this._win.getPosition(),Te=v.screen.getCursorScreenPoint(),We=Te.x-be,Ne=Te.y-Ce;return(()=>!(We>30&&Ne>=0&&Ne<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:We,y:Ne})),0}),(S.isMacintosh||S.isWindows)&&Ae&&(!X||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),Ve&&((0,b.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(A){S.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return S.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){S.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){S.isMacintosh&&A?.force&&v.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function W(){z.dispose(),te.dispose(),A()}const z=this.onDidClose(()=>W()),te=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(W,z,te)=>this.onWindowError(3,{reason:te,exitCode:z})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),v.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),v.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,z)=>{const te=await this.getMarketplaceHeaders();z({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,te)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,r.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,W){switch(A){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:W?.reason,code:W?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,C.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,C.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(z.response!==1){const te=z.response===0;this.destroyWindow(te,z.checkboxChecked)}}else if(A===2){let z;W?z=(0,d.localize)(7,null,W.reason,W.exitCode??"<unknown>"):z=(0,d.localize)(6,null);const te=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,C.mnemonicButtonLabel)((0,d.localize)(9,null))],message:z,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),B=te.response===0;this.destroyWindow(B,te.checkboxChecked)}break}}async destroyWindow(A,W){const z=this._config?.workspace;if(W&&z)try{const te=this.storageMainService.workspaceStorage(z);await te.init(),te.delete("memento/workbench.parts.editor"),await te.close()}catch(te){this.logService.error(te)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let te,B;(0,N.isSingleFolderWorkspaceIdentifier)(z)?te={folderUri:z.uri}:(0,N.isWorkspaceIdentifier)(z)?te={workspaceUri:z.configPath}:B=!0;const[H]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:te?[te]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});H.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const te=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.currentHttpProxy||te!==this.currentNoProxy)){this.currentHttpProxy=z,this.currentNoProxy=te;const B=z||"",H=te?`${te},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${H}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:H,pacScript:""})}}addTabbedWindow(A){S.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,W),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",q).toString(!0));const z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:W.isReload?3:z?2:1})}updateConfiguration(A,W){const z=(this._config??this.pendingLoadConfig)?.userEnv;if(z){const te=(0,h.isLaunchedFromCli)(z)&&!(0,h.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(te||B)&&(A.userEnv={...z,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(A["disable-extensions"]=W.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),A.perfMarks=(0,b.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&A&&(W.verbose=A.verbose,W.debugId=A.debugId,W.extensionEnvironment=A.extensionEnvironment,W["inspect-extensions"]=A["inspect-extensions"],W["inspect-brk-extensions"]=A["inspect-brk-extensions"],W["extensions-dir"]=A["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,N.isWorkspaceIdentifier)(A.workspace)){const W=A.workspace.configPath;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}else if((0,N.isSingleFolderWorkspaceIdentifier)(A.workspace)){const W=A.workspace.uri;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,$.defaultWindowState)();if(this.isFullScreen){let z;try{z=v.screen.getDisplayMatching(this.getBounds())}catch{}const te=(0,$.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||te.width,height:this.windowState.height||te.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let W;if(!S.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?A.mode=0:A.mode=1,W===1||W===0){let z;W===1?z=this.getBounds():z=this._win.getNormalBounds(),A.x=z.x,A.y=z.y,A.width=z.width,A.height=z.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(At.windowControlHeightStateStorageKey,A.height),S.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):S.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,b.mark)("code/willRestoreCodeWindowState");let W=!1;if(A)try{const z=v.screen.getAllDisplays();W=z.length>1,A=this.validateWindowState(A,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[A||(0,$.defaultWindowState)(),W]}validateWindowState(A,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const B=this.getWorkingArea(W[0]);if(B){let H=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),H(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),H()}return A}if(A.display&&A.mode===3){const B=W.find(H=>H.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const H=(0,$.defaultWindowState)(3);return H.x=B.bounds.x,H.y=B.bounds.y,H}}let z,te;try{z=v.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),te=this.getWorkingArea(z)}catch{}if(z&&te&&A.x+A.width>te.x&&A.y+A.height>te.y&&A.x<te.x+te.width&&A.y<te.y+te.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",te),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,W]=this._win.getPosition(),[z,te]=this._win.getSize();return{x:A,y:W,width:z,height:te}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return S.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){S.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,W=!0){S.isMacintosh||(A==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const W=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(S.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,W,...z){this.isReady?this.send(A,...z):this.ready().then(()=>{W.isCancellationRequested||this.send(A,...z)})}send(A,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...W)}catch(z){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(z)}`)}}}updateTouchBar(A){!S.isMacintosh||this.touchBarGroups.forEach((W,z)=>{const te=A[z];W.segments=this.createTouchBarGroupSegments(te)})}createTouchBar(){if(!!S.isMacintosh){for(let A=0;A<10;A++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const W=this.createTouchBarGroupSegments(A),z=new v.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:te=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:z.segments[te].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(A=[]){return A.map(z=>{let te;z.icon&&!u.ThemeIcon.isThemeIcon(z.icon)&&z.icon?.dark?.scheme===m.Schemas.file&&(te=v.nativeImage.createFromPath(f.URI.revive(z.icon.dark).fsPath),te.isEmpty()&&(te=void 0));let B;return typeof z.title=="string"?B=z.title:B=z.title.value,{id:z.id,label:te?void 0:B,icon:te}})}dispose(){super.dispose(),this._win=null}};K.windowControlHeightStateStorageKey="windowControlHeight",K=ve([J(1,n.ILogService),J(2,g.IEnvironmentMainService),J(3,oe.IPolicyService),J(4,de.IUserDataProfilesMainService),J(5,p.IFileService),J(6,s.IApplicationStorageMainService),J(7,s.IStorageMainService),J(8,E.IConfigurationService),J(9,P.IThemeMainService),J(10,U.IWorkspacesManagementMainService),J(11,y.IBackupMainService),J(12,a.ITelemetryService),J(13,w.IDialogMainService),J(14,c.ILifecycleMainService),J(15,o.IProductService),J(16,i.IProtocolMainService),J(17,T.IWindowsMainService),J(18,ue.IStateMainService)],K),e.CodeWindow=K}),define(Z[75],ee([0,1,15,24,8,3,35,2,13,4,16,7,23,174,5,21,6,90,91,27,52]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let c=class nt extends C.Disposable{constructor(o,i,r,s){super(),this.logService=o,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this.applicationStorageMainService=s,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){const i=[],r=[];for(const s of o)if((0,g.isRecentWorkspace)(s))!this.workspacesManagementMainService.isUntitledWorkspace(s.workspace)&&this.indexOfWorkspace(i,s.workspace)===-1&&i.push(s);else if((0,g.isRecentFolder)(s))this.indexOfFolder(i,s.folderUri)===-1&&i.push(s);else{const a=this.indexOfFile(r,s.fileUri)>=0,u=s.fileUri.scheme===l.Schemas.file&&nt.COMMON_FILES_FILTER.indexOf((0,I.basename)(s.fileUri))>=0;!a&&!u&&(r.push(s),m.isWindows&&s.fileUri.scheme===l.Schemas.file&&v.app.addRecentDocument(s.fileUri.fsPath))}await this.addEntriesFromStorage(i,r),i.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=nt.MAX_TOTAL_RECENT_ENTRIES),r.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(r.length=nt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:r}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(o){const i=u=>{const P=this.location(u);for(const D of o)if(I.extUriBiasedIgnorePathCase.isEqual(D,P))return!1;return!0},r=await this.getRecentlyOpened(),s=r.workspaces.filter(i),a=r.files.filter(i);(s.length!==r.workspaces.length||a.length!==r.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:s}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const o=[],i=[];return await this.addEntriesFromStorage(o,i),{workspaces:o,files:i}}async addEntriesFromStorage(o,i){const r=await this.getRecentlyOpenedFromStorage();for(const s of r.workspaces){const a=(0,g.isRecentFolder)(s)?this.indexOfFolder(o,s.folderUri):this.indexOfWorkspace(o,s.workspace);a>=0?o[a].label=o[a].label||s.label:o.push(s)}for(const s of r.files){const a=this.indexOfFile(i,s.fileUri);a>=0?i[a].label=i[a].label||s.label:i.push(s)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let o;const i=this.applicationStorageMainService.get(nt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{o=JSON.parse(i)}catch(r){this.logService.error("Unexpected error parsing opened paths list",r)}return(0,g.restoreRecentlyOpened)(o,this.logService)}async saveRecentlyOpened(o){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(nt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,g.toStoreData)(o)),-1,1)}location(o){return(0,g.isRecentFolder)(o)?o.folderUri:(0,g.isRecentFile)(o)?o.fileUri:o.workspace.configPath}indexOfWorkspace(o,i){return o.findIndex(r=>(0,g.isRecentWorkspace)(r)&&r.workspace.id===i.id)}indexOfFolder(o,i){return o.findIndex(r=>(0,g.isRecentFolder)(r)&&I.extUriBiasedIgnorePathCase.isEqual(r.folderUri,i))}indexOfFile(o,i){return o.findIndex(r=>I.extUriBiasedIgnorePathCase.isEqual(r.fileUri,i))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const a of v.app.getJumpListSettings().removedItems){const u=a.args;if(u){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(u);P&&i.push(b.URI.parse(P[2]))}}await this.removeRecentlyOpened(i);let r=!1;const s=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const u=(0,g.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:P,description:D}=this.getWindowsJumpListLabel(u,a.label);let T;return b.URI.isUri(u)?T=`--folder-uri "${u.toString()}"`:(r=!0,T=`--file-uri "${u.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:D.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));s.length>0&&o.push({type:"custom",name:r?(0,f.localize)(2,null):(0,f.localize)(3,null),items:s})}o.push({type:"recent"});try{const i=v.app.setJumpList(o);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(o,i){if(i)return{title:(0,M.splitName)(i).name,description:i};if(b.URI.isUri(o))return{title:(0,I.basename)(o),description:this.renderJumpListPathDescription(o)};if(this.workspacesManagementMainService.isUntitledWorkspace(o))return{title:(0,f.localize)(4,null),description:""};let r=(0,I.basename)(o.configPath);return r.endsWith(h.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-h.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,r),description:this.renderJumpListPathDescription(o.configPath)}}renderJumpListPathDescription(o){return o.scheme==="file"?(0,M.normalizeDriveLetter)(o.fsPath):o.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;v.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),i=[];let r=0;for(let a=0;a<o.workspaces.length&&r<nt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const u=this.location(o.workspaces[a]);if(u.scheme===l.Schemas.file){const P=(0,I.originalFSPath)(u);await S.Promises.exists(P)&&(i.push(P),r++)}}const s=[];for(let a=0;a<o.files.length&&r<nt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const u=this.location(o.files[a]);if(u.scheme===l.Schemas.file){const P=(0,I.originalFSPath)(u);if(nt.COMMON_FILES_FILTER.includes((0,I.basename)(u))||i.includes(P))continue;await S.Promises.exists(P)&&(s.push(P),r++)}}s.reverse().forEach(a=>v.app.addRecentDocument(a)),i.reverse().forEach(a=>v.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=ve([J(0,E.ILogService),J(1,p.IWorkspacesManagementMainService),J(2,y.ILifecycleMainService),J(3,w.IApplicationStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(Z[266],ee([0,1,15,8,22,35,4,7,164,19,26,21,6,210,65,20,39,37,48,74,33,75]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let o=class Tt{constructor(s,a,u,P,D,T,N,U,$,Y,oe){this.updateService=s,this.configurationService=a,this.windowsMainService=u,this.environmentMainService=P,this.telemetryService=D,this.workspacesHistoryMainService=T,this.stateMainService=N,this.lifecycleMainService=U,this.logService=$,this.nativeHostMainService=Y,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Tt.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,N,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,N,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,N,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,N,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,N,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const u=this.productService.reportIssueUrl;u&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(u,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const T=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${T}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const D=this.productService.privacyStatementUrl;D&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(D,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,a){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Tt.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!M.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=v.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(M.isMacintosh?new v.Menu:null);return}const a=new v.Menu;let u;if(M.isMacintosh){const D=new v.Menu;u=new v.MenuItem({label:this.productService.nameShort,submenu:D}),this.setMacApplicationMenu(D),a.append(u)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const D=new v.Menu;D.append(new v.MenuItem({label:this.mnemonicLabel(l.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(D)}if(this.shouldDrawMenu("File")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(1,null)),submenu:D});this.setMenuById(D,"File"),a.append(T)}if(this.shouldDrawMenu("Edit")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(2,null)),submenu:D});this.setMenuById(D,"Edit"),a.append(T)}if(this.shouldDrawMenu("Selection")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(3,null)),submenu:D});this.setMenuById(D,"Selection"),a.append(T)}if(this.shouldDrawMenu("View")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(4,null)),submenu:D});this.setMenuById(D,"View"),a.append(T)}if(this.shouldDrawMenu("Go")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(5,null)),submenu:D});this.setMenuById(D,"Go"),a.append(T)}if(this.shouldDrawMenu("Run")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(6,null)),submenu:D});this.setMenuById(D,"Run"),a.append(T)}if(this.shouldDrawMenu("Terminal")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(7,null)),submenu:D});this.setMenuById(D,"Terminal"),a.append(T)}let P;if(this.shouldDrawMenu("Window")){const D=new v.Menu;P=new v.MenuItem({label:this.mnemonicLabel(l.localize(8,null)),submenu:D,role:"window"}),this.setMacWindowMenu(D)}if(P&&a.append(P),this.shouldDrawMenu("Help")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(9,null)),submenu:D,role:"help"});this.setMenuById(D,"Help"),a.append(T)}a.items&&a.items.length>0?v.Menu.setApplicationMenu(a):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const a=this.createMenuItem(l.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),u=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const ue=new v.Menu;this.setMenuById(ue,"Preferences"),P=new v.MenuItem({label:this.mnemonicLabel(l.localize(11,null)),submenu:ue})}const D=new v.Menu,T=new v.MenuItem({label:l.localize(12,null),role:"services",submenu:D}),N=new v.MenuItem({label:l.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new v.MenuItem({label:l.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),$=new v.MenuItem({label:l.localize(15,null),role:"unhide"}),Y=new v.MenuItem(this.likeAction("workbench.action.quit",{label:l.localize(16,null,this.productService.nameLong),click:async(ue,se,de)=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&await this.confirmBeforeQuit(de)&&this.nativeHostMainService.quit(void 0)}})),oe=[a];oe.push(...u),P&&oe.push(i(),P),oe.push(i(),T,i(),N,U,$,i(),Y),oe.forEach(ue=>s.append(ue))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(s)){const u={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(l.localize(17,null)),(0,R.mnemonicButtonLabel)(l.localize(18,null))],message:l.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:P}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,u);return P===0}return!0}shouldDrawMenu(s){if(!M.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,a){a.forEach(u=>{if((0,f.isMenubarMenuItemSeparator)(u))s.append(i());else if((0,f.isMenubarMenuItemSubmenu)(u)){const P=new v.Menu,D=new v.MenuItem({label:this.mnemonicLabel(u.label),submenu:P});this.setMenu(P,u.submenu.items),s.append(D)}else(0,f.isMenubarMenuItemRecentAction)(u)?s.append(this.createOpenRecentMenuItem(u)):(0,f.isMenubarMenuItemAction)(u)&&(u.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[u.id]?s.append(new v.MenuItem(this.likeAction(u.id,{label:this.mnemonicLabel(u.label),click:this.fallbackMenuHandlers[u.id]}))):s.append(this.createMenuItem(u.label,u.id,!1,u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)))})}setMenuById(s,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(s,this.menubarMenus[a].items)}insertCheckForUpdatesItems(s){const a=this.getUpdateMenuItems();a.length&&(a.forEach(u=>s.append(u)),s.append(i()))}createOpenRecentMenuItem(s){const a=C.URI.revive(s.uri),u=s.id,P=u==="openRecentFile"?{fileUri:a}:u==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new v.MenuItem(this.likeAction(u,{label:s.label,click:(D,T,N)=>{const U=this.isOptionClick(N);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(s){return!!(s&&(!M.isMacintosh&&(s.ctrlKey||s.shiftKey)||M.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,a,u){const P={label:this.mnemonicLabel(s),role:u,enabled:!0};return new v.MenuItem(this.withKeybinding(a,P))}setMacWindowMenu(s){const a=new v.MenuItem({label:l.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),u=new v.MenuItem({label:l.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new v.MenuItem({label:l.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),D=this.createMenuItem(l.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(i()),T.push(this.createMenuItem(l.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(l.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(l.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(l.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(l.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,u,i(),D,...T,i(),P].forEach(N=>s.append(N))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:l.localize(30,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:l.localize(32,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:l.localize(34,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,a,u,P){const D=this.mnemonicLabel(s),T=typeof a=="function"?a:(oe,ue,se)=>{const de=oe?oe.userSettingsLabel:null;let G=a;Array.isArray(a)&&(G=this.isOptionClick(se)?a[1]:a[0]),de&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:de}):this.runActionInRenderer({type:"commandId",commandId:G})},N=typeof u=="boolean"?u:this.windowsMainService.getWindowCount()>0,U=typeof P=="boolean"?P:!1,$={label:D,click:T,enabled:N};U&&($.type="checkbox",$.checked=U);let Y;return typeof a=="string"?Y=a:Array.isArray(a)&&(Y=a[0]),M.isMacintosh&&(Y==="editor.action.clipboardCutAction"?$.role="cut":Y==="editor.action.clipboardCopyAction"?$.role="copy":Y==="editor.action.clipboardPasteAction"&&($.role="paste"),Y==="undo"?$.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):Y==="redo"?$.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):Y==="editor.action.selectAll"&&($.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(Y,$))}makeContextAwareClickHandler(s,a){return(u,P,D)=>{const T=v.BrowserWindow.getFocusedWindow();if(!T)return a.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return a.inDevTools(T.webContents.devToolsWebContents);s(u,P||T,D)}}runActionInRenderer(s){let a=v.BrowserWindow.getFocusedWindow();if(!a){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(a=P.win)}const u=a?this.windowsMainService.getWindowById(a.id):void 0;if(u){if(this.logService.trace("menubar#runActionInRenderer",s),M.isMacintosh&&!this.environmentMainService.isBuilt&&!u.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const P={id:s.commandId,from:"menu"};u.sendWhenReady("vscode:runAction",k.CancellationToken.None,P)}else{const P={userSettingsLabel:s.userSettingsLabel};u.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,a){const u=typeof s=="string"?this.keybindings[s]:void 0;if(u?.label){if(u.isNative!==!1)a.accelerator=u.label,a.userSettingsLabel=u.userSettingsLabel;else if(typeof a.label=="string"){const P=a.label.indexOf("[");P>=0?a.label=`${a.label.substr(0,P)} [${u.label}]`:a.label=`${a.label} [${u.label}]`}}else a.accelerator=void 0;return a}likeAction(s,a,u=!a.accelerator){u&&(a=this.withKeybinding(s,a));const P=a.click;return a.click=(D,T,N)=>{this.reportMenuActionTelemetry(s),P?.(D,T,N)},a}openUrl(s,a){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:n})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=ve([J(0,g.IUpdateService),J(1,m.IConfigurationService),J(2,p.IWindowsMainService),J(3,I.IEnvironmentMainService),J(4,w.ITelemetryService),J(5,c.IWorkspacesHistoryMainService),J(6,E.IStateMainService),J(7,b.ILifecycleMainService),J(8,S.ILogService),J(9,d.INativeHostMainService),J(10,y.IProductService)],o),e.Menubar=o;function i(){return new v.MenuItem({type:"separator"})}}),define(Z[267],ee([0,1,5,21,6,266]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let M=class{constructor(l,m,I){this.instantiationService=l,this.lifecycleMainService=m,this.logService=I,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(l,m){this.logService.trace("menubarService#updateMenubar",l),(await this.menubar).updateMenu(m,l)}};M=ve([J(0,v.IInstantiationService),J(1,t.ILifecycleMainService),J(2,k.ILogService)],M),e.MenubarMainService=M}),define(Z[268],ee([0,1,15,28,29,24,22,3,31,49,35,2,13,9,71,4,34,16,12,7,172,60,19,56,26,14,5,21,6,54,20,61,63,39,74,265,117,260,27,92,75,52,64,38,42]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c,n,o,i,r,s,a,u,P,D,T,N,U,$,Y,oe,ue,se,de,G,K,F,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(H){return(0,se.isWorkspaceIdentifier)(H?.workspace)}function te(H){return(0,se.isSingleFolderWorkspaceIdentifier)(H?.workspace)}let B=class ut extends b.Disposable{constructor(L,O,_,V,x,re,j,ie,ne,ae,ge,Me,Le,ke,Ae,Ve,me,we){super(),this.machineId=L,this.initialUserEnv=O,this.logService=_,this.stateMainService=V,this.policyService=x,this.environmentMainService=re,this.userDataProfilesMainService=j,this.lifecycleMainService=ie,this.backupMainService=ne,this.configurationService=ae,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=Me,this.instantiationService=Le,this.dialogMainService=ke,this.fileService=Ae,this.productService=Ve,this.protocolMainService=me,this.themeMainService=we,this._onDidOpenWindow=this._register(new C.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new C.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new C.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new C.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new C.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ue.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new b.DisposableStore;if(O.add(C.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const _ of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(_));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const _=this.environmentMainService.args,V=O?.remoteAuthority||void 0,x=!0,re=O?.forceReuseWindow,j=!re;return this.open({...L,cli:_,forceEmpty:x,forceNewWindow:j,forceReuseWindow:re,remoteAuthority:V})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],_=[],V=[],x=[],re=[];let j,ie=0;const ne=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const ke of ne)te(ke)?L.addMode?O.push(ke):_.push(ke):z(ke)?V.push(ke):ke.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),j.filesToOpenOrCreate.push(ke)):ke.backupPath?re.push({backupFolder:(0,f.basename)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):ie++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(x.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...x),re.push(...this.backupMainService.getEmptyWindowBackups())):re.length=0;const{windows:ae,filesOpenedInWindow:ge}=this.doOpen(L,V,_,re,ie,j,O);if(this.logService.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${_.length}, emptyToRestore: ${re.length}, emptyToOpen: ${ie})`),ae.length>1)if(ge)ge.focus();else{const ke=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,Ve=!0;if(ke){const me=ae.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ae=!1,Ve=!1)}if(Ae)for(let me=ae.length-1;me>=0;me--){const we=ae[me];if(!(we.openedWorkspace&&x.some(Ee=>we.openedWorkspace&&Ee.workspace.id===we.openedWorkspace.id)||we.backupPath&&re.some(Ee=>we.backupPath&&Ee.backupFolder===(0,f.basename)(we.backupPath)))){we.focus(),Ve=!1;break}}Ve&&ae[ae.length-1].focus()}const Me=j&&j.filesToDiff.length>0,Le=j&&j.filesToMerge.length>0;if(!ae.some(ke=>ke.isExtensionDevelopmentHost)&&!Me&&!Le&&!L.noRecentEntry){const ke=[];for(const Ae of ne)z(Ae)&&!Ae.transient?ke.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):te(Ae)?ke.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&ke.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ke)}return this.handleWaitMarkerFile(L,ae),ae}handleWaitMarkerFile(L,O){const _=L.waitMarkerFileURI;L.context===0&&_&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch{}})()}doOpen(L,O,_,V,x,re,j){const ie=[];let ne;function ae(me,we){ie.push(me),we&&(ne=me,re=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Me}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&j.length>0){const me=j[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(me);we&&ae(this.doAddFoldersToExistingWindow(we,j.map(Ee=>Ee.workspace.uri)))}const Le=_.length+O.length+V.length;if(re&&Le===0){const me=re.filesToOpenOrCreate[0]||re.filesToDiff[0]||re.filesToMerge[3],we=this.getWindows().filter(X=>re&&(0,w.isEqualAuthority)(X.remoteAuthority,re.remoteAuthority));let Ee;me?.fileUri&&!Me&&((L.context===4||L.context===0||L.context===1)&&(Ee=(0,oe.findWindowOnFile)(we,me.fileUri,X=>X.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(X.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(we))),Ee?(0,se.isWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?_.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ae(this.doOpenFilesInExistingWindow(L,Ee,re),!0):ae(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:re,forceNewWindow:!0,remoteAuthority:re.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const ke=(0,R.distinct)(O,me=>me.workspace.id);if(ke.length>0){const me=(0,R.coalesce)(ke.map(we=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],Ee=(0,w.isEqualAuthority)(re?.remoteAuthority,we.remoteAuthority)?re:void 0;ae(this.doOpenFilesInExistingWindow(L,we,Ee),!!Ee),ge=!0}for(const we of ke){if(me.some(ce=>ce.openedWorkspace&&ce.openedWorkspace.id===we.workspace.id))continue;const Ee=we.remoteAuthority,X=(0,w.isEqualAuthority)(re?.remoteAuthority,Ee)?re:void 0;ae(this.doOpenFolderOrWorkspace(L,we,ge,X),!!X),ge=!0}}const Ae=(0,R.distinct)(_,me=>w.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(Ae.length>0){const me=(0,R.coalesce)(Ae.map(we=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],Ee=(0,w.isEqualAuthority)(re?.remoteAuthority,we.remoteAuthority)?re:void 0;ae(this.doOpenFilesInExistingWindow(L,we,Ee),!!Ee),ge=!0}for(const we of Ae){if(me.some(ce=>(0,se.isSingleFolderWorkspaceIdentifier)(ce.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(ce.openedWorkspace.uri,we.workspace.uri)))continue;const Ee=we.remoteAuthority,X=(0,w.isEqualAuthority)(re?.remoteAuthority,Ee)?re:void 0;ae(this.doOpenFolderOrWorkspace(L,we,ge,X),!!X),ge=!0}}const Ve=(0,R.distinct)(V,me=>me.backupFolder);if(Ve.length>0)for(const me of Ve){const we=me.remoteAuthority,Ee=(0,w.isEqualAuthority)(re?.remoteAuthority,we)?re:void 0;ae(this.doOpenEmpty(L,!0,we,Ee,me),!!Ee),ge=!0}if(ie.length===0||re){re&&!x&&x++;const me=re?re.remoteAuthority:L.remoteAuthority;for(let we=0;we<x;we++)ae(this.doOpenEmpty(L,ge,me,re),!!re),ge=!0}return{windows:(0,R.distinct)(ie),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(L,O,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),O.focus();const V={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",M.CancellationToken.None,V),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const _={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",M.CancellationToken.None,_),L}doOpenEmpty(L,O,_,V,x){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:_,filesToOpen:V,forceNewWindow:O});let re;return!O&&typeof L.contextWindowId=="number"&&(re=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:_,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:re,emptyWindowBackupInfo:x,profile:L.profile})}doOpenFolderOrWorkspace(L,O,_,V,x){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:V}),!_&&!x&&typeof L.contextWindowId=="number"&&(x=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:x,profile:L.profile})}getPathsToOpen(L){let O,_=!1,V=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(L),_=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),_=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),V=!0),!L.addMode&&_){const x=O.filter(re=>te(re));if(x.length>1){const re=x[0].remoteAuthority;if(x.every(j=>(0,w.isEqualAuthority)(j.remoteAuthority,re))){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(x.map(ie=>({uri:ie.workspace.uri})));O.push({workspace:j,remoteAuthority:re}),O=O.filter(ie=>!te(ie))}}}return L.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(x=>z(x)||te(x)||x.backupPath)),O}doExtractPathsFromAPI(L){const O=[],_={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const V of(0,R.coalesce)(L.urisToOpen||[])){const x=this.resolveOpenable(V,_);if(x)x.label=V.label,O.push(x);else{const re=this.resourceFromOpenable(V),j={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,p.localize)(0,null))],defaultId:0,message:re.scheme===S.Schemas.file?(0,p.localize)(1,null):(0,p.localize)(2,null),detail:re.scheme===S.Schemas.file?(0,p.localize)(3,null,(0,I.getPathLabel)(re,{os:y.OS,tildify:this.environmentMainService})):(0,p.localize)(4,null,re.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(j,(0,g.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(L){const O=[],_={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},V=L["folder-uri"];if(V)for(const j of V){const ie=this.cliArgToUri(j);if(ie){const ne=this.resolveOpenable({folderUri:ie},_);ne&&O.push(ne)}}const x=L["file-uri"];if(x)for(const j of x){const ie=this.cliArgToUri(j);if(ie){const ne=this.resolveOpenable((0,se.hasWorkspaceFileExtension)(j)?{workspaceUri:ie}:{fileUri:ie},_);ne&&O.push(ne)}}const re=L._;for(const j of re){const ie=_.remoteAuthority?this.doResolvePathRemote(j,_):this.doResolveFilePath(j,_);ie&&O.push(ie)}return O}cliArgToUri(L){try{const O=h.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const V of O)if(V.workspace){const x=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});z(x)&&_.push(x)}else if(V.folderUri){const x=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});te(x)&&_.push(x)}else L!=="folders"&&V.backupPath&&_.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return _}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,O=Object.create(null)){const _=this.resourceFromOpenable(L);return _.scheme===S.Schemas.file?((0,$.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let _=this.resourceFromOpenable(L);const V=(0,N.getRemoteAuthority)(_)||O.remoteAuthority;if(_=(0,w.removeTrailingPathSeparator)((0,w.normalizePath)(_)),(0,$.isFileToOpen)(L)){if(O.gotoLineMode){const{path:x,line:re,column:j}=(0,l.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:x}),options:{selection:re?{startLineNumber:re,startColumn:j||1}:void 0},remoteAuthority:V}}return{fileUri:_,remoteAuthority:V}}else if((0,$.isWorkspaceToOpen)(L))return{workspace:(0,de.getWorkspaceIdentifier)(_),remoteAuthority:V};return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:V}}resourceFromOpenable(L){return(0,$.isWorkspaceToOpen)(L)?L.workspaceUri:(0,$.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,O){let _,V;O.gotoLineMode&&({path:L,line:_,column:V}=(0,l.parseLineAndColumnAware)(L)),L=(0,l.sanitizeFilePath)((0,f.normalize)(L),(0,E.cwd)());try{const x=(0,t.statSync)(L);if(x.isFile()){if(!O.forceOpenWorkspaceAsFile){const re=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(L));if(re)return re.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:re.id,configPath:re.configPath},type:r.FileType.File,exists:!0,remoteAuthority:re.remoteAuthority,transient:re.transient}}return{fileUri:h.URI.file(L),type:r.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:V||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(h.URI.file(L),x),type:r.FileType.Directory,exists:!0};if(!y.isWindows&&L==="/dev/null")return{fileUri:h.URI.file(L),type:r.FileType.File,exists:!0}}}catch{const re=h.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([re]),O.ignoreFileNotFound)return{fileUri:re,type:r.FileType.File,exists:!1}}}doResolvePathRemote(L,O){const _=L.charCodeAt(0),V=O.remoteAuthority;let x,re;O.gotoLineMode&&({path:L,line:x,column:re}=(0,l.parseLineAndColumnAware)(L)),_!==47&&((0,l.isWindowsDriveLetter)(_)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,l.toSlashes)(L)),L=`/${L}`);const j=h.URI.from({scheme:S.Schemas.vscodeRemote,authority:V,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:x?{startLineNumber:x,startColumn:re||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,de.getWorkspaceIdentifier)(j),remoteAuthority:V};if(O.gotoLineMode||f.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:x?{startLineNumber:x,startColumn:re||1}:void 0},remoteAuthority:V}}return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:V}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),_=O?.openFoldersInNewWindow||"default",V=O?.openFilesInNewWindow||"off";let x=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(_==="on"||_==="off")&&(x=_==="on");let re=!1;return L.forceNewWindow||L.forceReuseWindow?re=!!L.forceNewWindow&&!L.forceReuseWindow:(y.isMacintosh?L.context===1&&(re=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(re=!0),!L.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(re=V==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:re}}openExtensionDevelopmentHostWindow(L,O){const _=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(_)return this.lifecycleMainService.reload(_,O.cli),_.focus(),[_];let V=O.cli["folder-uri"]||[],x=O.cli["file-uri"]||[],re=O.cli._;if(!re.length&&!V.length&&!x.length&&!O.cli.extensionTestsPath){const ne=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ae=ne?.workspace??ne?.folderUri;ae&&(h.URI.isUri(ae)?ae.scheme===S.Schemas.file?re=[ae.fsPath]:V=[ae.toString()]:ae.configPath.scheme===S.Schemas.file?re=[(0,w.originalFSPath)(ae.configPath)]:x=[ae.configPath.toString()])}let j=O.remoteAuthority;for(const ne of L)if(ne.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=h.URI.parse(ne),ge=(0,N.getRemoteAuthority)(ae);ge&&(j?(0,w.isEqualAuthority)(ge,j)||this.logService.error("more than one extension development path authority"):j=ge)}re=re.filter(ne=>{const ae=h.URI.file(ne);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,w.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j)}),V=V.filter(ne=>{const ae=this.cliArgToUri(ne);return ae&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,w.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j):!1}),x=x.filter(ne=>{const ae=this.cliArgToUri(ne);return ae&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,w.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j):!1}),O.cli._=re,O.cli["folder-uri"]=V,O.cli["file-uri"]=x;const ie={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!re.length&&!V.length&&!x.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:j,profile:O.profile};return this.open(ie)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,f.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:L.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize()};let V;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const x=V.config;!_.extensionDevelopmentPath&&x?.extensionDevelopmentPath&&(_.extensionDevelopmentPath=x.extensionDevelopmentPath,_.extensionDevelopmentKind=x.extensionDevelopmentKind,_["enable-proposed-api"]=x["enable-proposed-api"],_.verbose=x.verbose,_["inspect-extensions"]=x["inspect-extensions"],_["inspect-brk-extensions"]=x["inspect-brk-extensions"],_.debugId=x.debugId,_.extensionEnvironment=x.extensionEnvironment,_["extensions-dir"]=x["extensions-dir"],_["disable-extensions"]=x["disable-extensions"])}else{const x=this.windowsStateHandler.getNewWindowState(_);(0,d.mark)("code/willCreateCodeWindow");const re=V=this.instantiationService.createInstance(Y.CodeWindow,{state:x,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(re),ut.WINDOWS.push(re),this._onDidOpenWindow.fire(re),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(re.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(re)),(0,m.once)(re.onDidClose)(()=>this.onWindowClosed(re)),(0,m.once)(re.onDidDestroy)(()=>this._onDidDestroyWindow.fire(re)),re.onDidTriggerSystemContextMenu(({x:ie,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:re,x:ie,y:ne}));const j=(0,g.assertIsDefined)(re.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(re)),this.lifecycleMainService.registerWindow(re)}return _.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(x=>{x||this.doOpenInBrowserWindow(V,_,L)}):this.doOpenInBrowserWindow(V,_,L),V}doOpenInBrowserWindow(L,O,_){O.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,de.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),L.load(O)}resolveProfileForBrowserWindow(L){let O=L.profile;return O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}onWindowClosed(L){const O=ut.WINDOWS.indexOf(L);ut.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=v.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,w.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(_=>_.lastFocusTime));return L.find(_=>_.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,M.CancellationToken.None,...O)}sendToAll(L,O,_){for(const V of this.getWindows())_&&_.indexOf(V.id)>=0||V.sendWhenReady(L,M.CancellationToken.None,O)}getWindows(){return ut.WINDOWS}getWindowCount(){return ut.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(_=>_.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=v.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ve([J(2,u.ILogService),J(3,U.IStateMainService),J(4,A.IPolicyService),J(5,i.IEnvironmentMainService),J(6,W.IUserDataProfilesMainService),J(7,a.ILifecycleMainService),J(8,c.IBackupMainService),J(9,n.IConfigurationService),J(10,G.IWorkspacesHistoryMainService),J(11,K.IWorkspacesManagementMainService),J(12,s.IInstantiationService),J(13,o.IDialogMainService),J(14,r.IFileService),J(15,D.IProductService),J(16,T.IProtocolMainService),J(17,F.IThemeMainService)],B),e.WindowsMainService=B}),define(Z[269],ee([0,1,60,33,75,52]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(l,m,I,b){this.workspacesManagementMainService=l,this.windowsMainService=m,this.workspacesHistoryMainService=I,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(l,m){const I=this.windowsMainService.getWindowById(l);if(I)return this.workspacesManagementMainService.enterWorkspace(I,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(l,m,I){return this.workspacesManagementMainService.createUntitledWorkspace(m,I)}deleteUntitledWorkspace(l,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(l,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(l){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(l,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(l,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(l){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ve([J(0,R.IWorkspacesManagementMainService),J(1,t.IWindowsMainService),J(2,k.IWorkspacesHistoryMainService),J(3,v.IBackupMainService)],M),e.WorkspacesMainService=M}),define(Z[270],ee([0,1,15,41,28,29,18,44,17,31,49,43,35,2,13,9,4,12,7,30,81,131,46,145,100,246,148,60,261,19,69,181,84,118,56,103,179,26,59,111,193,213,194,248,104,195,196,14,206,86,68,5,85,262,225,258,21,6,208,267,65,20,63,254,87,39,251,90,112,37,230,232,73,48,237,238,263,239,264,114,241,242,243,244,249,33,268,250,27,91,75,269,52,247,38,212,42,257,221,55,72,89,252,259,8]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c,n,o,i,r,s,a,u,P,D,T,N,U,$,Y,oe,ue,se,de,G,K,F,A,W,z,te,B,H,L,O,_,V,x,re,j,ie,ne,ae,ge,Me,Le,ke,Ae,Ve,me,we,Ee,X,ce,he,be,Ce,Te,We,Ne,_e,ze,Be,He,Q,le,pe,fe,Se,De,Fe,Ge,et,Ke,xe,it,st,dt,Ut,Nt,yt,Bt,zt,$t,Ot,qt,Ht,jt,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let bt=class extends f.Disposable{constructor(ye,Pe,Re,Ie,Oe,$e,Je,tt,qe,je,Ue){super(),this.mainProcessNodeIpcServer=ye,this.userEnv=Pe,this.mainInstantiationService=Re,this.logService=Ie,this.environmentMainService=Oe,this.lifecycleMainService=$e,this.configurationService=Je,this.stateMainService=tt,this.fileService=qe,this.productService=je,this.userDataProfilesMainService=Ue,this.configureSession(),this.registerListeners()}configureSession(){const ye=qe=>qe?.startsWith(`${d.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((qe,je,Ue,Ye)=>ye(Ye.requestingUrl)?Ue(Pe.has(je)):Ue(!1)),v.session.defaultSession.setPermissionCheckHandler((qe,je,Ue,Ye)=>ye(Ye.requestingUrl)?Pe.has(je):!1);const Re=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Ie=qe=>{for(let je=qe;je;je=je.parent)if(je.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},Oe=qe=>qe.resourceType==="xhr"||Ie(qe.frame),$e=qe=>{const je=qe.frame;if(!je||!this.windowsMainService)return!1;const Ue=v.BrowserWindow.getAllWindows();for(const Ye of Ue)if(je.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Je=(qe,je)=>{if(qe.path!=="/index.html")return!0;const Ue=je.frame;if(!Ue||!this.windowsMainService)return!1;for(const Ye of this.windowsMainService.getWindows())if(Ye.win&&Ue.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};v.session.defaultSession.webRequest.onBeforeRequest((qe,je)=>{const Ue=g.URI.parse(qe.url);return Ue.scheme===d.Schemas.vscodeWebview&&!Je(Ue,qe)?(this.logService.error("Blocked vscode-webview request",qe.url),je({cancel:!0})):Ue.scheme===d.Schemas.vscodeFileResource&&!$e(qe)?(this.logService.error("Blocked vscode-file request",qe.url),je({cancel:!0})):Ue.path.endsWith(".svg")&&!Re.has(Ue.scheme)?je({cancel:!Oe(qe)}):je({cancel:!1})}),v.session.defaultSession.webRequest.onHeadersReceived((qe,je)=>{const Ue=qe.responseHeaders,Ye=Ue["content-type"]||Ue["Content-Type"];if(Ye&&Array.isArray(Ye)){const ot=g.URI.parse(qe.url);if(ot.path.endsWith(".svg")&&Re.has(ot.scheme))return Ue["Content-Type"]=["image/svg+xml"],je({cancel:!1,responseHeaders:Ue});if(!ot.path.endsWith(d.Schemas.vscodeRemoteResource)&&Ye.some(ht=>ht.toLowerCase().includes("image/svg")))return je({cancel:!Oe(qe)})}return je({cancel:!1})});const tt=v.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,y.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,l.setUnexpectedErrorHandler)(Re=>this.onUnexpectedError(Re)),process.on("uncaughtException",Re=>(0,l.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,l.onUnexpectedError)(Re)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Re,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),v.app.on("activate",(Re,Ie)=>{this.logService.trace("app#activate"),Ie||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Re,Ie)=>{Ie.on("will-navigate",Oe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Oe.preventDefault()}),Ie.setWindowOpenHandler(({url:Oe})=>(this.nativeHostMainService?.openExternal(void 0,Oe),{action:"deny"}))});let ye=[],Pe;v.app.on("open-file",(Re,Ie)=>{this.logService.trace("app#open-file: ",Ie),Re.preventDefault(),ye.push(this.getWindowOpenableFromPathSync(Ie)),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ye,gotoLineMode:!1,preferNewWindow:!0}),ye=[],Pe=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Ie=this.windowsMainService?.getWindowByWebContents(Re.sender);let Oe,$e;return Ie?.config?(Oe=Ie.config,$e={...process.env,...Ie.config.userEnv}):(Oe=this.environmentMainService.args,$e=process.env),this.resolveShellEnvironment(Oe,$e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Ie,Oe)=>{const $e=this.validateNlsPath([Ie]);if(!$e||typeof Oe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile($e,M.VSBuffer.fromString(Oe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Ie)=>{const Oe=this.validateNlsPath(Ie);if(!Oe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Oe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}validateNlsPath(ye){let Pe;for(const Re of ye)typeof Re=="string"&&(typeof Pe!="string"?Pe=Re:Pe=(0,y.join)(Pe,Re));if(!(typeof Pe!="string"||!(0,y.isAbsolute)(Pe)||!(0,m.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!E.isLinux)))return g.URI.file(Pe)}onUnexpectedError(ye){if(ye){const Pe={message:`[uncaught exception in main]: ${ye.message}`,stack:ye.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${ye}`),ye.stack&&this.logService.error(ye.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ye=this.productService.win32AppUserModelId;E.isWindows&&ye&&v.app.setAppUserModelId(ye);try{E.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.logService.error(Ue)}const Pe=new o.Server;this.lifecycleMainService.onWillShutdown(Ue=>{Ue.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const Re=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Ie,sharedProcessReady:Oe,sharedProcessClient:$e}=this.setupSharedProcess(Re),Je=await this.initServices(Re,Ie,Oe);this.setUpHandlers(Je);const tt=this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args),qe=tt?await tt:void 0;Je.invokeFunction(Ue=>this.initChannels(Ue,Pe,$e)),Je.invokeFunction(Ue=>this.openFirstWindow(Ue,qe,Pe)),Je.invokeFunction(Ue=>this.afterWindowOpen(Ue,Ie)),this._register(new Wt.RunOnceScheduler(()=>{this._register((0,Wt.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(ye){this._register(ye.createInstance(r.ProxyAuthHandler)),this._register(ye.createInstance(Bt.DefaultExtensionsProfileInitHandler)),this._register(ye.createInstance(jt.UserDataTransientProfilesHandler))}async resolveMachineId(){let ye=this.stateMainService.getItem(ce.machineIdKey);return(!ye||E.isMacintosh&&ye==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(ye=await(0,p.getMachineId)(),this.stateMainService.setItem(ce.machineIdKey,ye)),ye}setupSharedProcess(ye){const Pe=this._register(this.mainInstantiationService.createInstance(Ae.SharedProcess,ye,this.userEnv)),Re=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Oe=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(Oe,"main")})(),Ie=(async()=>(await Pe.whenReady(),Re))();return{sharedProcess:Pe,sharedProcessReady:Ie,sharedProcessClient:Re}}async initServices(ye,Pe,Re){const Ie=new V.ServiceCollection;switch(process.platform){case"win32":Ie.set(Te.IUpdateService,new O.SyncDescriptor(Be.Win32UpdateService));break;case"linux":E.isLinuxSnap?Ie.set(Te.IUpdateService,new O.SyncDescriptor(ze.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(Te.IUpdateService,new O.SyncDescriptor(_e.LinuxUpdateService));break;case"darwin":Ie.set(Te.IUpdateService,new O.SyncDescriptor(Ne.DarwinUpdateService));break}Ie.set(De.IWindowsMainService,new O.SyncDescriptor(Fe.WindowsMainService,[ye,this.userEnv],!1)),Ie.set($.IDialogMainService,new O.SyncDescriptor($.DialogMainService,void 0,!0)),Ie.set(j.ILaunchMainService,new O.SyncDescriptor(j.LaunchMainService,void 0,!1)),Ie.set(U.IDiagnosticsMainService,new O.SyncDescriptor(U.DiagnosticsMainService,void 0,!1)),Ie.set(N.IDiagnosticsService,n.ProxyChannel.toService((0,n.getDelayedChannel)(Re.then($e=>$e.getChannel("diagnostics"))))),Ie.set(x.IIssueMainService,new O.SyncDescriptor(x.IssueMainService,[this.userEnv])),Ie.set(Y.IEncryptionMainService,new O.SyncDescriptor(oe.EncryptionMainService,[ye])),Ie.set(re.IKeyboardLayoutMainService,new O.SyncDescriptor(re.KeyboardLayoutMainService)),Ie.set(Me.INativeHostMainService,new O.SyncDescriptor(Me.NativeHostMainService,[Pe],!1)),Ie.set(D.ICredentialsMainService,new O.SyncDescriptor(dt.CredentialsNativeMainService)),Ie.set(fe.IWebviewManagerService,new O.SyncDescriptor(Se.WebviewMainService)),Ie.set(Ke.IWorkspacesService,new O.SyncDescriptor(it.WorkspacesMainService,void 0,!1)),Ie.set(st.IWorkspacesManagementMainService,new O.SyncDescriptor(st.WorkspacesManagementMainService,void 0,!0)),Ie.set(xe.IWorkspacesHistoryMainService,new O.SyncDescriptor(xe.WorkspacesHistoryMainService,void 0,!1)),Ie.set(ge.IMenubarMainService,new O.SyncDescriptor(ge.MenubarMainService)),Ie.set(G.IExtensionUrlTrustService,new O.SyncDescriptor(K.ExtensionUrlTrustService)),Ie.set(F.IExtensionHostStarter,new O.SyncDescriptor(A.ExtensionHostStarter)),Ie.set(Ee.IStorageMainService,new O.SyncDescriptor(Ee.StorageMainService)),Ie.set(Ee.IApplicationStorageMainService,new O.SyncDescriptor(Ee.ApplicationStorageMainService)),E.isWindows?Ie.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.WindowsExternalTerminalService)):E.isMacintosh?Ie.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.MacExternalTerminalService)):E.isLinux&&Ie.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.LinuxExternalTerminalService));const Oe=new u.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);if(Ie.set(a.IBackupMainService,Oe),Ie.set(He.IURLService,new O.SyncDescriptor(le.NativeURLService,void 0,!1)),(0,Ce.supportsTelemetry)(this.productService,this.environmentMainService)){const $e=(0,Ce.isInternalTelemetry)(this.productService,this.configurationService),Je=(0,n.getDelayedChannel)(Re.then(Ye=>Ye.getChannel("telemetryAppender"))),tt=new he.TelemetryAppenderClient(Je),qe=(0,X.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,ye,$e,this.environmentMainService.installSourcePath),je=(0,Ce.getPiiPathsFromEnvironment)(this.environmentMainService),Ue={appenders:[tt],commonProperties:qe,piiPaths:je,sendErrorTelemetry:!0};Ie.set(ce.ITelemetryService,new O.SyncDescriptor(be.TelemetryService,[Ue],!1))}else Ie.set(ce.ITelemetryService,Ce.NullTelemetryService);return Ie.set(Ot.IExtensionsProfileScannerService,new O.SyncDescriptor(Ot.ExtensionsProfileScannerService,void 0,!0)),Ie.set(qt.IExtensionsScannerService,new O.SyncDescriptor(Ht.ExtensionsScannerService,void 0,!0)),await Oe.initialize(),this.mainInstantiationService.createChild(Ie)}initChannels(ye,Pe,Re){const Ie=n.ProxyChannel.fromService(ye.get(j.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ie);const Oe=n.ProxyChannel.fromService(ye.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Oe);const $e=new Nt.PolicyChannel(ye.get(Ut.IPolicyService));Pe.registerChannel("policy",$e),Re.then(Ze=>Ze.registerChannel("policy",$e));const Je=this.fileService.getProvider(d.Schemas.file);(0,w.assertType)(Je instanceof L.DiskFileSystemProvider);const tt=new H.DiskFileSystemProviderChannel(Je,this.logService,this.environmentMainService);Pe.registerChannel(te.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Re.then(Ze=>Ze.registerChannel(te.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const qe=n.ProxyChannel.fromService(ye.get(yt.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",qe),Re.then(Ze=>Ze.registerChannel("userDataProfiles",qe));const je=new zt.RequestChannel(ye.get($t.IRequestService));Re.then(Ze=>Ze.registerChannel("request",je));const Ue=new We.UpdateChannel(ye.get(Te.IUpdateService));Pe.registerChannel("update",Ue);const Ye=n.ProxyChannel.fromService(ye.get(x.IIssueMainService));Pe.registerChannel("issue",Ye);const ot=n.ProxyChannel.fromService(ye.get(Y.IEncryptionMainService));Pe.registerChannel("encryption",ot);const ht=n.ProxyChannel.fromService(ye.get(D.ICredentialsMainService));Pe.registerChannel("credentials",ht);const Et=n.ProxyChannel.fromService(ye.get(Ve.ISignService));Pe.registerChannel("sign",Et);const Ct=n.ProxyChannel.fromService(ye.get(re.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Ct),this.nativeHostMainService=ye.get(Me.INativeHostMainService);const Xe=n.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",Xe),Re.then(Ze=>Ze.registerChannel("nativeHost",Xe));const pt=n.ProxyChannel.fromService(ye.get(Ke.IWorkspacesService));Pe.registerChannel("workspaces",pt);const ft=n.ProxyChannel.fromService(ye.get(ge.IMenubarMainService));Pe.registerChannel("menubar",ft);const wt=n.ProxyChannel.fromService(ye.get(He.IURLService));Pe.registerChannel("url",wt);const It=n.ProxyChannel.fromService(ye.get(G.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",It);const Pt=n.ProxyChannel.fromService(ye.get(fe.IWebviewManagerService));Pe.registerChannel("webview",Pt);const at=this._register(new we.StorageDatabaseChannel(this.logService,ye.get(Ee.IStorageMainService)));Pe.registerChannel("storage",at),Re.then(Ze=>Ze.registerChannel("storage",at));const gt=n.ProxyChannel.fromService(ye.get(W.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",gt);const mt=new ae.LogLevelChannel(ye.get(ne.ILogService));Pe.registerChannel("logLevel",mt),Re.then(Ze=>Ze.registerChannel("logLevel",mt));const Qe=new ae.LoggerChannel(ye.get(ne.ILoggerService));Pe.registerChannel("logger",Qe),Re.then(Ze=>Ze.registerChannel("logger",Qe));const rt=new T.ElectronExtensionHostDebugBroadcastChannel(ye.get(De.IWindowsMainService),ye.get(yt.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",rt);const ct=n.ProxyChannel.fromService(ye.get(F.IExtensionHostStarter));Pe.registerChannel(F.ipcExtensionHostStarterChannelName,ct)}openFirstWindow(ye,Pe,Re){const Ie=this.windowsMainService=ye.get(De.IWindowsMainService),Oe=ye.get(He.IURLService),$e=ye.get(Me.INativeHostMainService);this.lifecycleMainService.phase=2;const Je=[],tt=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Qe=>{try{return{uri:g.URI.parse(Qe),url:Qe}}catch{return}}).filter(Qe=>{if(!Qe||this.shouldBlockURI(Qe.uri))return!1;const rt=this.getWindowOpenableFromProtocolLink(Qe.uri);return rt?(Je.push(rt),!1):!0}),qe=this,je=this.environmentMainService,Ue=this.productService,Ye=this.logService;Oe.registerHandler({async handleURL(Qe,rt){if(Ye.trace("app#handleURL: ",Qe.toString(!0),rt),Qe.scheme===Ue.urlProtocol&&Qe.path==="workspace"&&(Qe=Qe.with({authority:"file",path:g.URI.parse(Qe.query).path,query:""})),qe.shouldBlockURI(Qe))return!0;let ct=!1;const Ze=new URLSearchParams(Qe.query);Ze.get("windowId")==="_blank"&&(Ze.delete("windowId"),Qe=Qe.with({query:Ze.toString()}),ct=!0),ct||=E.isMacintosh&&Ie.getWindowCount()===0;const kt=qe.getWindowOpenableFromProtocolLink(Qe);if(Ye.trace("app#handleURL: windowOpenableFromProtocolLink = ",kt),kt){const[Mt]=Ie.open({context:5,cli:{...je.args},urisToOpen:[kt],forceNewWindow:ct,gotoLineMode:!0});return Mt.focus(),!0}if(ct){const[Mt]=Ie.open({context:5,cli:{...je.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(Qe)});return await Mt.ready(),Oe.open(Qe,rt)}return!1}});const ot=this._register(new Ge.ActiveWindowManager({onDidOpenWindow:$e.onDidOpenWindow,onDidFocusWindow:$e.onDidFocusWindow,getActiveWindowId:()=>$e.getActiveWindowId(-1)})),ht=new n.StaticRouter(Qe=>ot.getActiveClientId().then(rt=>Qe===rt)),Et=new Q.URLHandlerRouter(ht),Ct=Re.getChannel("urlHandler",Et);Oe.registerHandler(new Q.URLHandlerChannelClient(Ct)),this._register(new pe.ElectronURLListener(tt,Oe,Ie,this.environmentMainService,this.productService));const Xe=this.environmentMainService.args,pt=global.macOpenFiles,ft=(0,se.isLaunchedFromCli)(process.env)?0:4,wt=Xe._.length,It=!!Xe["folder-uri"],Pt=!!Xe["file-uri"],at=Xe["skip-add-to-recently-opened"]===!0,gt=Xe.wait&&Xe.waitMarkerFilePath?g.URI.file(Xe.waitMarkerFilePath):void 0,mt=Xe.remote||void 0;if(Je.length>0)return Ie.open({context:ft,cli:Xe,urisToOpen:Je,gotoLineMode:!0,initialStartup:!0});if(!wt&&!It&&!Pt){if(Xe["new-window"]||Pe)return Ie.open({context:ft,cli:Xe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:at,waitMarkerFileURI:gt,initialStartup:!0,remoteAuthority:mt,profile:Pe});if(pt.length)return Ie.open({context:1,cli:Xe,urisToOpen:pt.map(Qe=>this.getWindowOpenableFromPathSync(Qe)),noRecentEntry:at,waitMarkerFileURI:gt,initialStartup:!0})}return Ie.open({context:ft,cli:Xe,forceNewWindow:Xe["new-window"]||!wt&&Xe["unity-launch"],diffMode:Xe.diff,mergeMode:Xe.merge,noRecentEntry:at,waitMarkerFileURI:gt,gotoLineMode:Xe.goto,initialStartup:!0,remoteAuthority:mt,profile:Pe})}shouldBlockURI(ye){return!!(ye.authority===d.Schemas.file&&E.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,S.getPathLabel)(ye,{os:E.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(ye){if(!!ye.path){if(ye.authority===d.Schemas.file){const Pe=g.URI.file(ye.fsPath);return(0,et.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(ye.authority===d.Schemas.vscodeRemote){const Pe=ye.path.indexOf(y.posix.sep,1);if(Pe!==-1){const Re=ye.path.substring(1,Pe),Ie=ye.path.substring(Pe),Oe=g.URI.from({scheme:d.Schemas.vscodeRemote,authority:Re,path:Ie,query:ye.query,fragment:ye.fragment});return(0,et.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Oe}:/:[\d]+$/.test(Ie)?{fileUri:Oe}:{folderUri:Oe}}}}}getWindowOpenableFromPathSync(ye){try{if((0,k.statSync)(ye).isDirectory())return{folderUri:g.URI.file(ye)};if((0,et.hasWorkspaceFileExtension)(ye))return{workspaceUri:g.URI.file(ye)}}catch{}return{fileUri:g.URI.file(ye)}}afterWindowOpen(ye,Pe){const Re=ye.get(ce.ITelemetryService),Ie=ye.get(Te.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(Re,Pe),this.installMutex(),v.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(Oe,$e)=>{$e({url:Oe.url.replace(/^vscode-remote-resource:/,"http:"),method:Oe.method})}),(Ie instanceof Be.Win32UpdateService||Ie instanceof _e.LinuxUpdateService||Ie instanceof Ne.DarwinUpdateService)&&Ie.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const ye=this.productService.win32MutexName;if(E.isWindows&&ye)try{const Pe=await new Promise((Ie,Oe)=>{q(["windows-mutex"],Ie,Oe)}),Re=new Pe.Mutex(ye);(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(ye,Pe){let Re=!1;(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>Re=!0),this._register(Pe.onDidError(({type:Ie,details:Oe})=>{let $e;switch(Ie){case 1:$e="SharedProcess: detected unresponsive window";break;case 2:$e=`SharedProcess: renderer process gone (detail: ${Oe?.reason??"<unknown>"}, code: ${Oe?.exitCode??"<unknown>"})`;break;case 3:$e=`SharedProcess: failed to load (detail: ${Oe?.reason??"<unknown>"}, code: ${Oe?.exitCode??"<unknown>"})`;break}(0,l.onUnexpectedError)(new Error($e)),ye.publicLog2("sharedprocesserror",{type:Ie,reason:Oe?.reason,code:Oe?.exitCode,visible:Pe.isVisible(),shuttingdown:Re})}))}async resolveShellEnvironment(ye,Pe,Re){try{return await(0,de.getResolvedShellEnv)(this.logService,ye,Pe)}catch(Ie){const Oe=(0,C.toErrorMessage)(Ie);Re?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Oe):this.logService.error(Oe)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Re=JSON.parse((0,b.stripComments)(Pe)),Oe=(0,Ce.getTelemetryLevel)(this.configurationService)>=1;if(Re["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Oe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.generateUuid)()}"`,"}"],Je=Pe.substring(0,Pe.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Je))}else{const $e=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Oe},`);$e!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString($e))}}catch(ye){this.logService.error(ye)}}};bt=ve([J(2,_.IInstantiationService),J(3,ne.ILogService),J(4,ue.IEnvironmentMainService),J(5,ie.ILifecycleMainService),J(6,P.IConfigurationService),J(7,me.IStateMainService),J(8,B.IFileService),J(9,Le.IProductService),J(10,yt.IUserDataProfilesMainService)],bt),e.CodeApplication=bt}),define(Z[271],ee([0,1,38,8,278,2]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class M extends v.AbstractPolicyService{constructor(l){super(),this.productName=l,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(l){await this.throttler.queue(()=>new Promise((m,I)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,l,b=>{for(const S in b){const f=b[S];f===void 0?this.policies.delete(S):this.policies.set(S,f)}this._onDidChange.fire(Object.keys(b)),m()})}catch(b){I(b)}}))}}e.NativePolicyService=M}),define(Z[272],ee([0,1,223,8,18,17,2,12,19,36,111,6,222,279]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends M.Disposable{constructor(E,w,g){super(),this.environmentService=w,this.logService=g,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,w){this.logService.trace("RequestService#request (node) - begin",E.url);const{proxyUrl:g,strictSSL:h}=this;let p;try{p=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const c={...process.env,...p},n=E.agent?E.agent:await(0,S.getProxyAgent)(E.url||"",c,{proxyUrl:g,strictSSL:h});E.agent=n,E.strictSSL=h,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(E,w);return this.logService.trace("RequestService#request (node) - success",E.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",E.url,o),o}}async getNodeRequest(E){return((0,v.parse)(E.url).protocol==="https:"?await new Promise((h,p)=>{q(["https"],h,p)}):await new Promise((h,p)=>{q(["http"],h,p)})).request}_request(E,w){return t.Promises.withAsyncBody(async(g,h)=>{const p=(0,v.parse)(E.url),c=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),n={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,C.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(n.auth=E.user+":"+E.password);const o=c(n,i=>{const r=(0,C.isNumber)(E.followRedirects)?E.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this._request({...E,url:i.headers.location,followRedirects:r-1},w).then(g,h);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,f.createGunzip)())),g({res:i,stream:(0,k.streamToBufferReadableStream)(s)})}});o.on("error",h),E.timeout&&o.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&o.write(E.data),o.end(),w.onCancellationRequested(()=>{o.abort(),h(new R.CancellationError)})})}async resolveProxy(E){}};d=ve([J(0,l.IConfigurationService),J(1,m.INativeEnvironmentService),J(2,b.ILogService)],d),e.RequestService=d}),define(Z[273],ee([0,1,15,272]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(M){return v.net.request}class R extends t.RequestService{request(C,l){return super.request({...C||{},getRawRequest:k},l)}}e.RequestMainService=R}),define(Z[280],ee([0,1,15,28,7,24,8,44,17,31,49,35,13,9,71,4,34,25,23,46,83,270,10,19,216,229,26,59,185,14,204,86,68,201,85,21,106,6,209,107,54,20,61,253,113,235,55,273,87,224,39,228,73,64,42,38,271,211,2,51,240,40,236]),function(q,e,v,t,k,R,M,C,l,m,I,b,S,f,d,y,E,w,g,h,p,c,n,o,i,r,s,a,u,P,D,T,N,U,$,Y,oe,ue,se,de,G,K,F,A,W,z,te,B,H,L,O,_,V,x,re,j,ie,ne,ae,ge,Me,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.startup()}catch(me){console.error(me.message),v.app.exit(1)}}async startup(){(0,l.setUnexpectedErrorHandler)(Te=>console.error(Te));const[me,we,Ee,X,ce,he,be,Ce]=this.createServices();try{try{await this.initServices(Ee,Ce,X,ce,be)}catch(Te){throw this.handleStartupDataDirError(Ee,be.nameLong,Te),Te}await me.invokeFunction(async Te=>{const We=Te.get(ue.ILogService),Ne=Te.get(Y.ILifecycleMainService),_e=Te.get(P.IFileService),ze=await this.claimInstance(We,Ee,Ne,me,be,!0);return g.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(Be=>{We.warn(`Error writing main lockfile: ${Be.stack}`)}),he.logger=new de.SpdLogLogger("main",(0,f.join)(Ee.logsPath,"main.log"),!0,!1,he.getLevel()),(0,I.once)(Ne.onWillShutdown)(Be=>{_e.dispose(),X.dispose(),Be.join(g.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),me.createInstance(c.CodeApplication,ze,we).startup()})}catch(Te){me.invokeFunction(this.quit,Te)}}createServices(){const me=new $.ServiceCollection,we=new ae.DisposableStore;process.once("exit",()=>we.dispose());const Ee={_serviceBrand:void 0,...G.default};me.set(K.IProductService,Ee);const X=new s.EnvironmentMainService(this.resolveArgs(),Ee),ce=this.patchEnvironment(X);me.set(s.IEnvironmentMainService,X);const he=new oe.BufferLogService,be=we.add(new ue.MultiplexLogService([new ue.ConsoleMainLogger((0,ue.getLogLevel)(X)),he]));me.set(ue.ILogService,be);const Ce=new D.FileService(be);me.set(P.IFileService,Ce);const Te=new T.DiskFileSystemProvider(be);Ce.registerProvider(S.Schemas.file,Te);const We=new Me.UriIdentityService(Ce);me.set(ge.IUriIdentityService,We),me.set(ue.ILoggerService,new se.LoggerService(be,Ce));const Ne=new _.StateMainService(X,be,Ce);me.set(O.IStateMainService,Ne);const _e=new re.UserDataProfilesMainService(Ne,We,X,Ce,be);me.set(re.IUserDataProfilesMainService,_e);const ze=y.isWindows&&Ee.win32RegValueName?we.add(new ie.NativePolicyService(Ee.win32RegValueName)):X.policyFile?we.add(new ne.FilePolicyService(X.policyFile,Ce,be)):new j.NullPolicyService;me.set(j.IPolicyService,ze);const Be=new i.ConfigurationService(_e.defaultProfile.settingsResource,Ce,ze,be);return me.set(o.IConfigurationService,Be),me.set(Y.ILifecycleMainService,new N.SyncDescriptor(Y.LifecycleMainService,void 0,!1)),me.set(te.IRequestService,new N.SyncDescriptor(B.RequestMainService,void 0,!0)),me.set(x.IThemeMainService,new N.SyncDescriptor(x.ThemeMainService)),me.set(H.ISignService,new N.SyncDescriptor(L.SignService,void 0,!1)),me.set(W.ITunnelService,new N.SyncDescriptor(z.TunnelService)),me.set(F.IProtocolMainService,new A.ProtocolMainService(X,_e,be)),[new U.InstantiationService(me,!0),ce,X,Be,Ne,he,Ee,_e]}patchEnvironment(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const X=process.env[Ee];typeof X=="string"&&(we[Ee]=X)}),Object.assign(process.env,we),we}async initServices(me,we,Ee,X,ce){await M.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsPath,we.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(he=>he?g.Promises.mkdir(he,{recursive:!0}):void 0)),X.init(),Ee.initialize()]),we.setEnablement(ce.quality!=="stable"||Ee.getValue(Le.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(me,we,Ee,X,ce,he){let be;try{(0,d.mark)("code/willStartMainServer"),be=await(0,p.serve)(we.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,I.once)(Ee.onWillShutdown)(()=>be.dispose())}catch(Ce){if(Ce.code!=="EADDRINUSE")throw this.handleStartupDataDirError(we,ce.nameLong,Ce),Ce;let Te;try{Te=await(0,p.connect)(we.mainIPCHandle,"main")}catch(ze){if(!he||y.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,n.localize)(0,null,ce.nameShort),(0,n.localize)(1,null),ce.nameLong),ze;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(Be){throw me.warn("Could not delete obsolete instance handle",Be),Be}return this.claimInstance(me,we,Ee,X,ce,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw me.error(ze),Te.dispose(),new Error(ze)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.showStartupWarningDialog((0,n.localize)(2,null,ce.nameShort),(0,n.localize)(3,null),ce.nameLong)},1e4));const Ne=h.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),_e=h.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return X.invokeFunction(async()=>{const ze=new r.DiagnosticsService(V.NullTelemetryService,ce),Be=await _e.getMainDiagnostics(),He=await _e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Q=await ze.getDiagnostics(Be,He);throw console.log(Q),new l.ExpectedError});throw y.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,me),me.trace("Sending env to running instance..."),await Ne.start(we.args,process.env),Te.dispose(),We&&clearTimeout(We),new l.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw me.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new l.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),be}handleStartupDataDirError(me,we,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const X=(0,R.coalesce)([me.userDataPath,me.extensionsPath,p.XDG_RUNTIME_DIR]).map(ce=>(0,b.getPathLabel)(k.URI.file(ce),{os:y.OS,tildify:me}));this.showStartupWarningDialog((0,n.localize)(4,null),(0,n.localize)(5,null,(0,C.toErrorMessage)(Ee),X.join(`
`)),we)}}showStartupWarningDialog(me,we,Ee){v.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,n.localize)(6,null))],message:me,detail:we,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(me,we){if(y.isWindows){const Ee=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((X,ce)=>{q(["windows-foreground-love"],X,ce)})).allowSetForegroundWindow(Ee)}catch(X){we.error(X)}}}quit(me,we){const Ee=me.get(ue.ILogService),X=me.get(Y.ILifecycleMainService);let ce=0;we&&(we.isExpected?we.message&&Ee.trace(we.message):(ce=1,we.stack?Ee.error(we.stack):Ee.error(`Startup error: ${we.toString()}`))),X.kill(ce)}resolveArgs(){const me=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,u.createWaitMarkerFile)(me.verbose);we&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.doValidatePaths(me._,me.goto);me._=we}return me}doValidatePaths(me,we){const Ee=(0,E.cwd)(),X=me.map(be=>{let Ce=String(be),Te;we&&(Te=(0,m.parseLineAndColumnAware)(Ce),Ce=Te.path),Ce&&(Ce=this.preparePath(Ee,Ce));const We=(0,m.sanitizeFilePath)(Ce,Ee),Ne=(0,f.basename)(We);return Ne&&!(0,m.isValidBasename)(Ne)?null:we&&Te?(Te.path=We,this.toPath(Te)):We}),ce=y.isWindows||y.isMacintosh,he=(0,R.distinct)(X,be=>be&&ce?be.toLowerCase():be||"");return(0,R.coalesce)(he)}preparePath(me,we){return y.isWindows&&(we=(0,w.rtrim)(we,'"')),we=(0,w.trim)((0,w.trim)(we," "),"	"),y.isWindows&&(we=(0,f.resolve)(me,we),we=(0,w.rtrim)(we,".")),we}toPath(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5cecbf4746a7b95dedaf9fc4534b9786b9a30ace/core/vs/code/electron-main/main.js.map
